#include <stdlib.h>
#include <string.h>
#include "types.h"
#include "decls.h"

const DWORD ROM_IS_ZERO         = 1;
const DWORD ROM_LZH_COMPRESSION = 2;
const DWORD ROM_ZIP_COMPRESSION = 3;
const DWORD ROM_ENTRY           = 4;

void enable_cache(void);
void disable_cache(void);
int inflate(void);
void off_led(void);
void error_led(void);
BYTE *addr;
BYTE *dst;

//+****************************************************************************
int get_byte()
{
    return *addr++;
}
void write_buf(int fd, BYTE *buf, unsigned int cnt)
{
    memcpy(dst, buf, cnt);
    dst += cnt;
}

extern int apctlGPIORead(int gpioNum);
extern int apctlGPIOWrite(int gpioNum, int state);
void delay();
extern int flag;

void
decompress()
{
    DWORD state;
    union {
        void (*branch) (void);
        int hackfest;
    } u;

    addr = (BYTE *)flashbase;
    for(;;)
    {
        // Read address
        dst = *(BYTE **)addr;
        addr += 4;
        // state 
        state = *(DWORD *)addr;
        addr += 4;
        if(state == ROM_ZIP_COMPRESSION)
        {
            inflate();
            if((DWORD)addr & 3)
            { // Align up
                addr += 4-((DWORD)addr & 3);
            }
        }
        else if(state == ROM_ENTRY)
        {
            disable_cache();
            //off_led();
#if 0
	if(flag == 1)
	{
		flag = 0;
		//delay();
        	if(apctlGPIORead(5) == 0)
        	{}
		else{
		flashbase = 0xffff6000;
		decompress();
		}
	}
#endif
	apctlGPIOWrite(12,0);
	apctlGPIOWrite(11,0);
            u.hackfest = (int)dst;
            u.branch();
        }
        else
        {
            //error_led();
            // what to do here...
            for(;;);
        }
    }
}


void delay()
{
	int i;
	
	for(i=0;i<10000;i++)
	{;}	
}