#define MAIN
#include "decls.h"

union {
    void (*branch) (void);
    int hackfest;
} u;

extern void apctlGPIOInit(unsigned long dirMap);
extern int apctlGPIOWrite(int gpioNum, int state);

char pkt[]={
0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
0x55, 0x55, 0x55, 0x55, 0x12, 0x34, 
0x08, 0x06, 0x00, 0x01, 0x08, 0x00, 
0x06, 0x04, 0x00, 0x01, 0x00, 0x55, 
0x55, 0x55, 0x55, 0x12, 0x34, 0x0a, 
0x0a, 0x0a, 0x0a, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x0a, 0x0a, 0x0a, 0x64, 
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

#define         NVRAMSIZE         64*1024
static unsigned char NVRamBuff[NVRAMSIZE];

typedef unsigned char BYTE;
void LEDtest();
void LEDinit();

#define CPU_REG_BASE	0x80002000
#define SYS_CLOCK_REG_OFF	0x00000030
#define MD_PAD_REG_OFF		0x00000044
#define REGS32(x)            (*(volatile unsigned long *)(x))

void
etherboot()
{
    char buf[2000];
    int len,i;
    int eth_poll(char *buffer);

//Enable external crystall clock
    REGS32(CPU_REG_BASE + MD_PAD_REG_OFF) = 0x00E0000E;
    REGS32(CPU_REG_BASE + SYS_CLOCK_REG_OFF) = 0x00007131;

    initcode();
//for(i=0;i<5;i++)
//    eth_transmit(pkt, sizeof(pkt));
apctlGPIOInit(0xF320);
LEDinit();
    for(;;) {
	if(len=eth_poll(buf)) {
		if ((buf[12] == 0) && (memcmp(&buf[24], "PMTIAZ", 6) == 0))
		{
		unsigned char * ptr;

    		//apctlGPIOWrite(0, 1);
    			     	
    		GetBootFromFlash();
    
    		ptr = (unsigned char *)&NVRamBuff[0xFFB0];
    		
    		for(i=0;i<6;i++)
			ptr[i] = buf[14+i];
		
    		PutBootToFlash();
    		
    		//Jump Bootloader
		u.hackfest=0xffff0000;
    		u.branch();	
	     }	//end if check "PMTIAZ"   
	     
	}
	LEDtest();  
	
    }//end for loop
}
void LEDinit();
int
main()
{
    apctlGPIOInit(0xF320);
    LEDinit();
    LEDtest();
    etherboot();
}

void LEDinit()
{
	apctlGPIOWrite(0, 0);
	apctlGPIOWrite(11, 0);
	//apctlGPIOWrite(0, 0);
}


void LEDtest()
{
	int x;

		for(x=0;x<=1000000;x++)
		{
			if(x==500000)
			{
				apctlGPIOWrite(0, 1);
				apctlGPIOWrite(11, 1);
			}
			else if(x==1000000)
			{
				apctlGPIOWrite(0, 0);
				apctlGPIOWrite(11, 0);
			}
		}
	
}

int GetBootFromFlash(void)
{
    unsigned char * ptr;

    unsigned long int i;
    ptr = (unsigned char *)(0xFFFF0000);

    for (i=0;i<NVRAMSIZE ; i++) {
       NVRamBuff[i] = ptr[i];
    } /* endfor */
   
    return 0;
}


#define BOOT_OFFSET 0xF0000

//extern Boolean apctlFlashEraseSector(int sectorNum);
extern void amdFlashWriteWord( int offset, unsigned short dat);
extern void amdEraseChip(int sblk, int nblks);

int PutBootToFlash(void)
{

   unsigned long int i;
   unsigned short nvword;
   unsigned char *nvdata;

   int dwReturnCode=0;

   //dwReturnCode = apctlFlashEraseSector(15);//erase config Sector
   amdEraseChip(15,1);

   nvdata = NVRamBuff;
   
   for(i=0;i*2 < NVRAMSIZE;i++)
   {
	nvword = *(unsigned short *)nvdata;
	amdFlashWriteWord((BOOT_OFFSET+(i*2)),nvword);

	nvdata = nvdata + 0x2;
   }

   return 0;
}

