
struct physical_header_s {
    char dst_mac[6];
    char src_mac[6];
    //int  type;
    unsigned short type;
};
#define      DLC_LEN         14

struct ip_header_s {
    unsigned char  vlen;
    unsigned char  tos;
    unsigned short   tlen;
    unsigned short   id;
    unsigned short   frag;
    unsigned char  ttl;
    unsigned char  proto;
    unsigned short   chksum;
    char           sip[4];
    char           tip[4];
    unsigned char  data[1];
};

#define       IPH_LEN        20
#define       IP_VER         4    /* current IP protocol version */
#define       IP_DEF_TTL     64
#define       TP_UDP         17

//pseudo header
struct pseudo_header_s {
    char           ssip[4];
    char           stip[4];
    unsigned char  zero;
    unsigned char  spro;
    unsigned short   slen;
};

#define       PSH_LEN        12
//mbuf
/*
struct mbuf_s {
   char *buf;
   int len;
   int off;
};
*/
//struct pseudo_header_s *makepseudo(struct mbuf_s *mbuf);  //temp comment it

struct udp_header_s {
    unsigned short  src_port;
    unsigned short  dst_port;
    unsigned short  len;
    unsigned short  chksum;
};

#define       UDP_LEN        8

struct arp_header_s {
    unsigned short  htype;
    unsigned short  ptype;
    unsigned char hlen;
    unsigned char plen;
    unsigned short  fun;
    char          sha[6];
    char          spa[4];
    char          tha[6];
    char          tpa[4];
};

#define       AR_HW_ETHER    1
#define       ARP_REQUEST    1         /* ARP operation code */
#define       ARP_REPLY      2
#define       ARPH_LEN       28

//TFTP
#define       TFTP_RETRY_TIME   1000
#define       TFTP_PORT         69

#define       T_INIT            0
#define       T_RRQ             1
#define       T_WRQ             2
#define       T_DATA            3
#define       T_ACK             4
#define       T_ERR             5
#define       T_SPECIAL         100

// timer
struct dl_timer_s {
   unsigned char  state;
   unsigned short duration;
   unsigned long setting;
};

/*
int dl_time_out(struct dl_timer_s *timer_p);
void dl_set_timer(struct dl_timer_s *timer_p, unsigned int duration);
void dl_stop_timer(struct dl_timer_s *timer_p);
*/


#define BIT_PCBA        0x0100
#define BIT_PROD_ID     0x0200
#define BIT_PROT_ID     0x0400
#define BIT_FUNC_ID     0x0800

#define PID_ABS_ADDR    0xFFFFFFC1

struct pid_s {
   unsigned short         version_control;
   unsigned short         upgrade_control;
   unsigned char        hw_id[32];
   unsigned short         hw_version;
   unsigned short        product_id;   //it is meaningful
   unsigned int         protocol_id;   //it is meaningful , make data be 'packed'
   unsigned char        function_id[6];
   unsigned short         fw_version;
   unsigned short         start_code_seg;
   unsigned short         code_size;
   unsigned char        signature[7];
   unsigned short         control_no;
   unsigned short         download_flag;
};
/*
struct pid_s {
	INT16 version_control;
	INT16 upgrade_control;
	BYTE  hw_id[32];
	INT16 hw_version;
	DWORD product_id;
	INT16 protocol_id;
	CHAR  function_id[6];
	INT16 fw_version;
	INT16 start_code_seg;////????
	INT16 code_size;////????
	CHAR  signature[7];
	INT16 control_no;
	INT16 download_flag;	
}PACKED ;
*/


struct reference_s {
   unsigned char        device_ip[4];
   struct pid_s /*far*/ * pid;
};



// dvari struct
struct dvari_s {
   //--- Routine ---
   long main_routine;                 // download main program
   int fsh_routine;                   // flash programmer
   int prog_routine;                  // flash writer
   int recv_routine;                  // lan receive
   int send_routine;                  // lan transmit
   //--- programming state --------
   char state;
   int sequence;
   //--- flash writer parameter ---
   unsigned int dest_seg;
   unsigned int dest_off;
   unsigned int src_seg;
   unsigned int src_off;
   unsigned int count;
   unsigned int erase;
   char erase_type;
   //--- timer & LED parameter
   unsigned long tme_of_day;
   char led_ctr_byte;
   //--- LAN parameter
   char lan_curr;
   char lan_addr[6];
   unsigned int DataBit;
   unsigned int flashseg[15];
   //==================
   char *snd1_buf;
   char *rcv_buf;
   char *snd2_buf;
   int snd1_off;
   int snd1_len;
   int rcv_off;
   int rcv_len;
   int snd2_off;
   int snd2_len;
   char ip_addr[4];  // device ip
   char src_ip[4];   // client ip
   char second_src_ip[4];   // the 2nd client ip
   char src_ip_flag; // has another session
   unsigned short ip_idval;
   char tftp_error;
   char tftp_state;
   unsigned short curr_block_no;
   char final;
   char start;
   struct dl_timer_s dl_timer;
   unsigned int ab_addr;
   char reset;          /* reset flag, rise it to reset device */
   char from;
   unsigned int old_pid_offset;
   char dl_mode;
#define NORMAL_DL   0
#define NONE_ADM_DL 1
#define ALL_DL      2
   char my_ip[4];
   char protect_block[7];
   unsigned char dst_mac[6];
   unsigned char dst_ip[4];
   unsigned short dst_port;
   struct pid_s pid;
};

/*
#define  MaskInterrupts()    {             \
                               _asm pushf  \
                               _asm cli    \
                             }
#define  UnmaskInterrupts()  { _asm popf }
*/
//unsigned int checksum(char *m, int len); //temp to comment it

#define MAXIUM(x,y)    ((x)>(y)?(x):(y))
extern struct dvari_s DVARI;