#include "dl_c.h"
#include "iob.h"

#define BLOCK_SIZE      7
#define DL_ALL_MAGIC 0x77

#define RESET_MAGIC 0x77
#define DEVICE_RESET(x) {(x)->reset=RESET_MAGIC;}

/*
#define  BYTE  unsigned char
#define  WORD  unsigned short
#define  INT16 short
#define  DWORD (unsigned int)
#define  CHAR  char
#define  VOID  void
*/

#define IOBOFF(x) ((x)->dwOffset)
#define IOBLEN(x) ((x)->dwLength)
#define IOBDATA(x) (&((x)->dbData[(x)->dwOffset]))
/*
changelist:
1.change the driver's functions to dummy functions.
2.change the Assembly in x86 to the other implementation way.

3.change the BIN tftp to compressed IMG tftp download.
    a.) Add an decode function which named tftp_decode_img()
        to decode the stored img file.
*/
extern int FlashDriver(
int ,
unsigned char *,
int ,
unsigned long
);

static int task1(struct dvari_s *dvari);
static int task2(struct dvari_s *dvari);
static int ip_recv(struct dvari_s *dvari);
static int ip_send(struct dvari_s *dvari, char flag);
static struct pseudo_header_s *makepseudo(struct dvari_s *dvari);
static int udp_recv(struct dvari_s *dvari);
static int udp_send(struct dvari_s *dvari, char flag);
static int init_process(int opcode, struct dvari_s *dvari);
static int wrq_process(int opcode, struct dvari_s *dvari);
static int tftp_server(struct dvari_s *dvari);
static int is_wrq_correct(char *p, int len);
static int is_error_correct(char *p, int len);
static int is_data_correct(char *p, int len, struct dvari_s *dvari);
//static int dl_time_out(struct dl_timer_s *timer_p, unsigned long nowtime);
static void dl_set_timer(struct dl_timer_s *timer_p, unsigned int duration,unsigned long nowtime);
//static void dl_stop_timer(struct dl_timer_s *timer_p);
static unsigned short tftp_checksum(char *m, int len);
//static long tftp_ntohl (long x);
static unsigned short tftp_ntohs (unsigned short x);
//static int dl_stricmp(char *dst, char *src);
static int dl_memcmp(char *dst, char *src, int len);
static int dl_memcpy(char *dst, char *src, int len);
static int dl_memset(char *dst, char ch, int len);
//static int is_in_block(unsigned int seg,char blk_num,struct dvari_s *dvari);

//actual para.
struct dvari_s DVARI;
char * iob_recv=0;
int iob_len=0,iob_off=0;
char SEND1[100],SEND2[100],test[100]={0x00,0xff,0xff,0xff,0xff,0x9a,0x00,0xc0,0x02,0x33,0x33,0x33},lan_mac[6] = {0x00,0xc0,0x02,0x15,0x51,0x55};
unsigned long erase_val=4,wrt_val=0;
int beg_addr=0;

unsigned int img_len =0;

#define FILE_SIZE 0x100000
char bin_room[FILE_SIZE+512];

static void tftp_store_file(int bin_off,unsigned char *p , int len);
static void tftp_wrt_flash();

//
//define MACROS PART
static void tftp_decode_img();
/*It will decode the img file from bin_room[], use len which is img_len*/
//

extern void dl_lan_send(char * dt,int len);
extern unsigned char NodeAddress[8];
extern void eth_transmit(char *, int);
extern int apctlGPIOWrite(int gpioNum, int state);
//actual para.

/*dl_c_init will do some initializations*/
void dl_c_init(struct dvari_s * dvari)
{
	dvari->snd1_buf = SEND1;
	dvari->snd2_buf = SEND2;
	dl_memcpy( (char *)dvari->lan_addr, (char *)NodeAddress, 6); //here lan_mac need use NodeAddress

    dvari->start =1;
	dvari->ip_idval=1;
	dvari->tftp_error=dvari->tftp_state=dvari->final=dvari->dl_timer.state=0;
	dl_memset(dvari->src_ip , 0, 4);
	dvari->curr_block_no = 0;

	dvari->reset=0;
	dvari->dl_mode=NORMAL_DL;
	
	dvari->tftp_state = T_WRQ;
	dvari->ip_addr[0] = 192;
	dvari->ip_addr[1] = 168;
	dvari->ip_addr[2] = 0;
	dvari->ip_addr[3] = 1;
	dvari->protect_block[0]=0;
       /* resetore PID */
	dl_memcpy( (char *)&dvari->pid,
		  ((char *)(dvari->main_routine))+dvari->old_pid_offset,
		  sizeof(struct pid_s) );
	dvari->from = 0;

}
//

/* dl_c_process will process every packet coming from others */
int dl_c_process(char * dt,int len,struct dvari_s * dvari)  //here IOBDATA(dt) should point at the MAC_LEVEL header
{
	struct physical_header_s *ph_p;

	if(!dt||!len)
		return 0; //0 means not valid parameters.

	dvari->rcv_buf = dt;

    ph_p = (struct physical_header_s *)dvari->rcv_buf;
    dvari->rcv_len = len;

    switch (tftp_ntohs(ph_p->type)) 
	{

		case 0x0806:
		dvari->rcv_off = DLC_LEN;
	    dvari->rcv_len -= dvari->rcv_off;

	    task1(dvari);
	    break;

		case 0x0800:

	    dvari->rcv_off = DLC_LEN;
	    dvari->rcv_len -= dvari->rcv_off;
	    task2(dvari);
//  move do_reset here for let tftp get the ACK for the last data packet
	    if(1 == dvari->final)
	    {                    
            //here to do wrt flash
//          tftp_wrt_flash();

//dl_lan_send(test,81);

            tftp_decode_img();
	    }
	    break;

	  default:
	    break;
	}
	return 1; //means have execute over.

}
//
/*dl_lan_send. */
void dl_lan_send(char * dt,int len)
{
	eth_transmit(dt,len);
}


static int task1(struct dvari_s *dvari) {
    struct arp_header_s *arp_p;

    arp_p = (struct arp_header_s *)(dvari->rcv_buf+dvari->rcv_off);
    arp_p->htype = tftp_ntohs(arp_p->htype);
    arp_p->fun   = tftp_ntohs(arp_p->fun  );

    if (arp_p->htype != AR_HW_ETHER)
	return 0;             /* invalid */
    if (arp_p->htype == AR_HW_ETHER)
 //     if (!dl_memcmp(arp_p->sha, etherbroadcastaddr, 6) || (arp_p->sha[0] & 1))
	if ((arp_p->sha[0] & 1))
	    return 0;  // invalid

    if (arp_p->fun == ARP_REQUEST) {

	if (dl_memcmp(arp_p->tpa, dvari->ip_addr, arp_p->plen)) {
	    return 0;
	}
	arp_p = (struct arp_header_s *)(dvari->snd2_buf+dvari->rcv_off);
	dl_memcpy(dvari->snd2_buf,dvari->rcv_buf,dvari->rcv_off+dvari->rcv_len);

	arp_p->fun   = tftp_ntohs(ARP_REPLY);   /* use this buffer to send reply */
	arp_p->htype = tftp_ntohs(arp_p->htype);
	dl_memcpy(arp_p->tpa, arp_p->spa, arp_p->plen);
	dl_memcpy(arp_p->tha, arp_p->sha, arp_p->hlen);
	dl_memcpy(arp_p->spa, dvari->ip_addr, arp_p->plen); /* normal ARP */
	dl_memcpy(arp_p->sha, dvari->lan_addr, arp_p->hlen);
	dl_memcpy(dvari->snd2_buf,dvari->rcv_buf+6,6);
	dl_memcpy(dvari->snd2_buf+6,dvari->lan_addr,6);

	dvari->snd2_len = ARPH_LEN + DLC_LEN;
	dvari->snd2_off = 0;

	//lansend(dvari->snd2_buf, MAXIUM(64,dvari->snd2_len));
	dl_lan_send(dvari->snd2_buf, MAXIUM(64,dvari->snd2_len));
    }
    return 1;
}




static int task2(struct dvari_s *dvari) {
    struct pseudo_header_s *q;
    int flag;

//dl_lan_send(test,70);

    if (!ip_recv(dvari))
       return 0;

    q = makepseudo(dvari);
    q->spro = TP_UDP;

//dl_lan_send(test,80);

    if (!udp_recv(dvari))
       return 0;

//dl_lan_send(test,82);

    flag = tftp_server(dvari);

    if (flag == 1) {

//dl_lan_send(test,85);

       if (!udp_send(dvari,flag))
	  return 0;

//dl_lan_send(test,90);

       if (!ip_send(dvari,flag))
	  return 0;

//dl_lan_send(test,114);

       //lansend(dvari->snd1_buf, MAXIUM(64,dvari->snd1_len));
	   dl_lan_send(dvari->snd1_buf, MAXIUM(64,dvari->snd1_len));

     //  dl_set_timer(&dvari->dl_timer, TFTP_RETRY_TIME,dvari->tme_of_day);

    } else {

       if (flag == 2) {

//dl_lan_send(test,110);

	  if (!udp_send(dvari,flag))
	     return 0;

//dl_lan_send(test,120);

	  if (!ip_send(dvari,flag))
	     return 0;


//dl_lan_send(test,130);
//          lansend(dvari->snd2_buf, MAXIUM(64,dvari->snd2_len));
			dl_lan_send(dvari->snd2_buf, MAXIUM(64,dvari->snd2_len));
       } else {
        
//dl_lan_send(test,140);
	  
	  return 0;
       }
    }
    return 1;
}

static int ip_recv(struct dvari_s *dvari) {
    struct ip_header_s *p;
    unsigned short hlen,len;

    p = (struct ip_header_s *)(dvari->rcv_buf+dvari->rcv_off);
    hlen = ((p->vlen & 0x0f) << 2);
    len = dvari->rcv_len;

    if (len < IPH_LEN) {
       // ip header too small
	return 0;
    }

    if (((p->vlen >> 4) & 0x0f) != IP_VER) {      /* version invalid */
       // bad version
	return 0;
    }
//  if (IP_CLASSD(p->tip) || IP_CLASSE(p->tip)) { /* address invalid */
//
//      return 0;
//  }
//    if ( (hlen < IPH_LEN) || (hlen > IOBLEN(m)) ) {
//        return 0;
//    }

//dl_lan_send(test,170);

    /* cc = cksum(m, hlen); */
    if (tftp_checksum(dvari->rcv_buf+dvari->rcv_off, hlen)) {
	return 0;
    }

//dl_lan_send(test,180);

    p->id   = tftp_ntohs(p->id);
    p->tlen = tftp_ntohs(p->tlen);
    p->frag = tftp_ntohs(p->frag);

    if (len < p->tlen) {
	// length too short
	return 0;                            /* data length invalid */
    }

//dl_lan_send(test,190);
/*
    if (*(unsigned int *)(p->tip) != *(unsigned int *)dvari->ip_addr) {
	return 0;
    }
*/
    if(dl_memcmp(p->tip,dvari->ip_addr,4))  //maybe should be taked place by d_cmp....
		return 0;

//dl_lan_send(test,200);

    if (p->proto != TP_UDP)
       return 0;

//dl_lan_send(test,210);

    return 1;
}

static int ip_send(struct dvari_s *dvari, char flag) {
    struct ip_header_s *q;
    struct pseudo_header_s *p;
    unsigned char proto;
    char *snd_buf;
    int *snd_len, *snd_off;

    if (flag == 1) {
       snd_buf = dvari->snd1_buf;
       snd_len = &dvari->snd1_len;
       snd_off = &dvari->snd1_off;
    } else {
       snd_buf = dvari->snd2_buf;
       snd_len = &dvari->snd2_len;
       snd_off = &dvari->snd2_off;
    }

    p = (struct pseudo_header_s *)(snd_buf+(*snd_off));
    q = (struct ip_header_s *)((char *)p - 8);
    (*snd_len) += (IPH_LEN - PSH_LEN);
    (*snd_off) -= (IPH_LEN - PSH_LEN);
    q->tos = 0;
    q->tlen = tftp_ntohs(p->slen) + IPH_LEN;
    proto = p->spro;
/*
    *(unsigned long *)q->tip = *(unsigned long *)p->stip;
    *(unsigned long *)q->sip = *(unsigned long *)p->ssip;
*/
    dl_memcpy(q->tip , p->stip ,4);
    dl_memcpy(q->sip , p->ssip ,4);
     
    q->proto = proto;

    q = (struct ip_header_s *)(snd_buf+(*snd_off));
    q->vlen = (IP_VER<<4) | (IPH_LEN>>2);
    q->id = dvari->ip_idval++;
    q->frag = 0;
    q->ttl = IP_DEF_TTL;

    q->id   = tftp_ntohs(q->id);
    q->tlen = tftp_ntohs(q->tlen);
    q->frag = tftp_ntohs(q->frag);

    q->chksum = 0;
    q->chksum = tftp_checksum((char *)q, IPH_LEN);

    if ((*snd_len) < 14)
       return 0;

    (*snd_len) += 14;
    (*snd_off) -= 14;
    dl_memcpy(snd_buf,dvari->from ? (char *)dvari->dst_mac:(char *)(dvari->rcv_buf+6),6);  //change the ?: char type to unsigned char.
    dl_memcpy(snd_buf+6,dvari->lan_addr,6);
    dl_memcpy(snd_buf+12,dvari->rcv_buf+12,2);
    if (dvari->from)
	*(unsigned int *)(snd_buf+12) = 0x0008;
    return 1;
}


static struct pseudo_header_s *makepseudo(struct dvari_s *dvari)
{
    struct ip_header_s *p;
    struct pseudo_header_s *q;
    int hlen;

    p = (struct ip_header_s *)(dvari->rcv_buf+dvari->rcv_off);
    hlen = ((p->vlen & 0x0f) << 2);
    q = (struct pseudo_header_s *)((unsigned char *)p + hlen - PSH_LEN);
    if ((hlen - IPH_LEN) > 4) {
       
		/*
		*(unsigned int *)q->stip = *(unsigned int *)p->tip;
	*(unsigned int *)q->ssip = *(unsigned int *)p->sip;
		*/
	dl_memcpy(q->stip,p->tip,4);
		dl_memcpy(q->ssip,p->sip,4);

    } else if ((hlen - IPH_LEN) < 4) {
	/*
		*(unsigned int *)q->ssip = *(unsigned int *)p->sip;
	*(unsigned int *)q->stip = *(unsigned int *)p->tip;
		*/
		dl_memcpy(q->ssip,p->sip,4);
		dl_memcpy(q->stip,p->tip,4);
		

    }
    q->zero = 0;
    q->spro = TP_UDP;
    q->slen = tftp_ntohs(p->tlen - hlen);
    dvari->rcv_len -= hlen - PSH_LEN;
    dvari->rcv_off += hlen - PSH_LEN;
    return(q);
}

static int udp_recv(struct dvari_s *dvari) {
    struct udp_header_s *udp_p;
    struct pseudo_header_s *pseudo_p;
    /*int i;*/

    pseudo_p= (struct pseudo_header_s *)(dvari->rcv_buf+dvari->rcv_off);
    udp_p= (struct udp_header_s *)(dvari->rcv_buf+dvari->rcv_off+PSH_LEN);

//dl_lan_send(test,220);

    if (udp_p->chksum &&
	tftp_checksum(dvari->rcv_buf+dvari->rcv_off,tftp_ntohs(pseudo_p->slen)+PSH_LEN))
    {   /* tftp_checksum error */
	return 0;
    }

//dl_lan_send(test,230);

    /* convert all fields in net form to host form,
       Note, udp pseudo header and udp header have been motify in IOB ! */
    pseudo_p->slen=tftp_ntohs(pseudo_p->slen);
    udp_p->src_port = tftp_ntohs(udp_p->src_port);
    udp_p->dst_port = tftp_ntohs(udp_p->dst_port);
    udp_p->len = tftp_ntohs(udp_p->len);

    if (udp_p->dst_port != TFTP_PORT)
       return 0;

//dl_lan_send(test,240);

    if (*(unsigned long *)dvari->src_ip == 0) {
       *(unsigned long *)dvari->src_ip = *(unsigned long *)pseudo_p->ssip;
       dvari->src_ip_flag = 0;
    } else {

       if (*(unsigned long *)dvari->src_ip != *(unsigned long *)pseudo_p->ssip) {
	  *(unsigned long *)dvari->second_src_ip = *(unsigned long *)pseudo_p->ssip;
	  dvari->src_ip_flag = 1;
       }
    }
    dvari->rcv_len = udp_p->len-UDP_LEN;
    dvari->rcv_off +=(PSH_LEN+UDP_LEN);

    return 1;

}

static int udp_send(struct dvari_s *dvari, char flag) {
    struct udp_header_s *udp_p, *udp_rcv_p;
    struct pseudo_header_s *pseudo_p, *pseudo_rcv_p;
    int len;
    char *snd_buf;
    int *snd_len, *snd_off;

    if (flag == 1) {
       snd_buf = dvari->snd1_buf;
       snd_len = &dvari->snd1_len;
       snd_off = &dvari->snd1_off;
    } else {
       snd_buf = dvari->snd2_buf;
       snd_len = &dvari->snd2_len;
       snd_off = &dvari->snd2_off;
    }

    len=(*snd_len);
    (*snd_off) -= (UDP_LEN+PSH_LEN);
    (*snd_len) += (UDP_LEN+PSH_LEN);
    if((*snd_off)<0) return 0;

    pseudo_p=(struct pseudo_header_s *)(snd_buf+(*snd_off));
    udp_p= (struct udp_header_s *)(snd_buf+(*snd_off)+PSH_LEN);

    dvari->rcv_off -= (UDP_LEN+PSH_LEN);
    dvari->rcv_len += (UDP_LEN+PSH_LEN);
    pseudo_rcv_p=(struct pseudo_header_s *)(dvari->rcv_buf+dvari->rcv_off);
    udp_rcv_p= (struct udp_header_s *)(dvari->rcv_buf+dvari->rcv_off+PSH_LEN);

    /* make UDP header */
    udp_p->src_port = TFTP_PORT;
    udp_p->dst_port = dvari->from ? dvari->dst_port : udp_rcv_p->src_port;
    udp_p->len = len + UDP_LEN;
    udp_p->chksum = 0;
    udp_p->src_port = tftp_ntohs(udp_p->src_port);
    udp_p->dst_port = tftp_ntohs(udp_p->dst_port);
    udp_p->len = tftp_ntohs(udp_p->len);

    /* make UDP pseudo header */
    pseudo_p->spro = TP_UDP;
    pseudo_p->zero = 0;
    pseudo_p->slen = udp_p->len;  /* alreay converted to network order */

/*
    *(unsigned long *)pseudo_p->stip = dvari->from ? *(unsigned long *)dvari->dst_ip
			  : *(unsigned long *)pseudo_rcv_p->ssip;
    *(unsigned long *)pseudo_p->ssip = dvari->from ? *(unsigned long *)dvari->ip_addr
			  : *(unsigned long *)pseudo_rcv_p->stip;
*/
    dl_memcpy(pseudo_p->stip , dvari->from ? (char *)dvari->dst_ip : (char *)pseudo_rcv_p->ssip,4);
    dl_memcpy(pseudo_p->ssip , dvari->from ? dvari->ip_addr : pseudo_rcv_p->stip,4);

    if (tftp_checksum((char *)pseudo_p,(int)tftp_ntohs(pseudo_p->slen)+PSH_LEN) == 0)
       udp_p->chksum = 0xffff;
    else
       udp_p->chksum = 0;
    return 1;
}

static int special_process(struct dvari_s *dvari) {
   // char *p;
   // int len;

    dvari->tftp_state = T_WRQ;
    dvari->curr_block_no = 0;
    dvari->tftp_error = 0;
    return 1;
}

static int init_process(int opcode, struct dvari_s *dvari) {
    char *p;
    int len;

    p = dvari->rcv_buf+dvari->rcv_off;
    len = dvari->rcv_len;
    switch (opcode) {
    case T_WRQ:
       if (is_wrq_correct(p,len)) {
	  dvari->tftp_state = T_WRQ;
	  dvari->curr_block_no = 0;
       } else {
	  dvari->tftp_state = T_INIT;
	  dvari->tftp_error = 4;
       }
       break;
    case T_RRQ:
       break;
    default:
       dvari->tftp_error = 2;
       break;
    }
    return 1;
}

static int wrq_process(int opcode, struct dvari_s *dvari) {
    char *p;
    int len;

    p = dvari->rcv_buf+dvari->rcv_off;
    len = dvari->rcv_len;
    switch (opcode) {
    case T_WRQ:
       if (is_wrq_correct(p,len)) {
	  if (dvari->src_ip_flag) {
	     dvari->tftp_error = 2;
	     break;
	  }
       } else {
	  if (dvari->src_ip_flag) {
	     dvari->tftp_error = 4;
	     break;
	  } else {
	     dvari->tftp_state = T_INIT;
	     dvari->tftp_error = 4;
	     break;
	  }
       }
       break;
    case T_ERR:
       if (is_error_correct(p,len)) {
	  if (dvari->src_ip_flag) {
	     dvari->tftp_error = 3;
	  } else {
	     dvari->tftp_error = 3;
	     dvari->tftp_state = T_INIT;
	  }
       }
       break;
    case T_DATA:

       if (dvari->src_ip_flag) {
	  dvari->tftp_error = 3;

	  break;
       }
       if (!is_data_correct(p,len, dvari)) {
	  dvari->tftp_error = 3;

	  dvari->tftp_state = T_INIT;
       }
       break;
    default:
       if (dvari->src_ip_flag) {
	  dvari->tftp_error = 3;

       }
       break;
    }
    return 1;
}

static int tftp_server(struct dvari_s *dvari) {
  //  struct tftp_data_s *data_p;
  //  struct tftp_request_s *request_p;
    char *p;
    unsigned short opcode;

    if (dvari->rcv_len < 4)
       return 0;
    p = dvari->rcv_buf+dvari->rcv_off;
    opcode = tftp_ntohs(*(unsigned short *)p);
    switch (dvari->tftp_state) {
    case T_INIT:

	init_process(opcode, dvari);
	break;
    case T_SPECIAL:
	special_process(dvari);
	break;
    case T_WRQ:

	wrq_process(opcode, dvari);
	break;
    case T_RRQ:
    case T_DATA:
    case T_ERR:
    default:
	break;
    }
    if (dvari->tftp_error) {
       if (dvari->src_ip_flag) {
	  dvari->snd2_len = 5;
	  dvari->snd2_off = 42;
	  *((unsigned short *)((char *)(dvari->snd2_buf)+42)) = tftp_ntohs(5); // error cmd
	  *((unsigned short *)((char *)(dvari->snd2_buf)+44)) = tftp_ntohs(dvari->tftp_error-1); // error no
	  *((char *)((char *)(dvari->snd2_buf)+46)) = 0; // null end
	  dvari->src_ip_flag = 0;
	  dvari->tftp_error = 0;
	  return 2;
       } else {
	  dvari->snd1_len = 5;
	  dvari->snd1_off = 42;
	  *((unsigned short *)((char *)(dvari->snd1_buf)+42)) = tftp_ntohs(5); // error cmd
	  *((unsigned short *)((char *)(dvari->snd1_buf)+44)) = tftp_ntohs(dvari->tftp_error-1); // error no
	  *((char *)((char *)(dvari->snd1_buf)+46)) = 0; // null end
	  /*
		  *(unsigned long *)dvari->src_ip = 0;
	  */
	  dl_memset(dvari->src_ip,0,4);

	  dvari->tftp_error = 0;
	  DEVICE_RESET(dvari);
	  return 1;
       }
    } else {



       dvari->snd1_len = 4;
       dvari->snd1_off = 42;
       *((unsigned short *)((char *)(dvari->snd1_buf)+42)) = tftp_ntohs(4); // ack cmd
       *((unsigned short *)((char *)(dvari->snd1_buf)+44)) = tftp_ntohs(dvari->curr_block_no); // block no#
       return 1;
    }
}

static int is_wrq_correct(char *p, int len) {
    int i;

    p+=2;               //op code
    len-=2;
    for(i=0;*p && (i<len);i++,p++);  //filename
    i++;
    len -= i;
    p++;

    if (len <= 0)
       return 0;
    if (p[len-1] != 0)
       return 0;

    /* check if octet mode TFTP */
    if ( ((p[0]|0x20)!='o') ||
	 ((p[1]|0x20)!='c') ||
	 ((p[2]|0x20)!='t') )
       return 0;

    return 1;
}

static int is_error_correct(char *p, int len) {
    int no;

    p+=2;               //op code
    len-=2;
    no = *(unsigned int *)p;
    no = tftp_ntohs(no);
    p+=2;
    len-=2;
    if ((len == 1) && (*p == 0))
       return 1;
    else
       return 0;
}

static int is_data_correct(char *p, int len, struct dvari_s *dvari) {
    unsigned short no;
    
    struct pid_s dev_tmp_pid;
//    struct pid_s *dev_pid;
    struct pid_s *file_pid; 
 
    p+=2;               //op code
    len-=2;
    no = *(unsigned short *)p;
    no = tftp_ntohs(no);
    if (no < dvari->curr_block_no)
       return 0;
    p+=2;
    len-=2;

//dl_lan_send(test,302);

    if (len < 512) {

       dvari->final = 1;
       dvari->tftp_state = T_INIT;
//       DEVICE_RESET(dvari);

//dl_lan_send(test,82);

    }


    if (no == dvari->curr_block_no)
    {    
//    dl_lan_send(test,303);
       return 1;

    }
    else
       dvari->curr_block_no = no;

    // flash program
    if (no == 1) 
    {
	/* check packet length, must be 512 bytes in block 1 */
	    if(len != 512)
	    {
	        return 0;
	    }
//check pid here
//          dev_pid = (struct pid_s *)(char *)(PID_ABS_ADDR);
        file_pid = (struct pid_s *)p;
        memcpy((char *)&dev_tmp_pid,(char *)(PID_ABS_ADDR),sizeof(struct pid_s));
            
//    dl_lan_send(test,80);

	if ((file_pid->signature[0] != 'a')
	     || (file_pid->signature[1] != 'D')
	     || (file_pid->signature[2] != 'm')
	     || (file_pid->signature[3] != 'B')
	     || (file_pid->signature[4] != 'l')
	     || (file_pid->signature[5] != 'K')
	     || (file_pid->signature[6] != '='))
    {
	    return 0;
    }
    

//#define V_C_OFF 0

    if ((0x0001 == tftp_ntohs(dev_tmp_pid.version_control)) /*||(0x0100 == tftp_ntohs(dev_tmp_pid.version_control))*/)
//    if ((0x0001 == *(unsigned short *)(( (char *)&dev_tmp_pid)+V_C_OFF)) ||(0x0100 == *(unsigned short *)((char * dev_pid)+V_C_OFF)))
    {
        if (dl_memcmp((char *)dev_tmp_pid.hw_id,(char *)file_pid->hw_id,6)) 
        {
		    return 0;
	    }
    }

//    dl_lan_send((char *)&dev_tmp_pid,77);
    
    if ((0x0002 == tftp_ntohs(dev_tmp_pid.version_control)) /*||(0x0200 == tftp_ntohs(dev_tmp_pid.version_control))*/)
    {
        
        if (dev_tmp_pid.version_control != file_pid->version_control)
	       return 0;
	    if (dev_tmp_pid.upgrade_control != 0)
	       return 1;
	    if (dev_tmp_pid.upgrade_control & BIT_PCBA)
	       if (dl_memcmp((char *)dev_tmp_pid.hw_id,(char *)file_pid->hw_id,32)) {
		   return 0;
	       }
	    if (dev_tmp_pid.upgrade_control & BIT_FUNC_ID)
	       if (dl_memcmp((char *)dev_tmp_pid.function_id,(char *)file_pid->function_id,6)) {
		   return 0;
	       }
	    if (dev_tmp_pid.upgrade_control & BIT_PROD_ID)
	       if ( *(unsigned int *)(char *)&(dev_tmp_pid.product_id) != 
                *(unsigned int *)(char *)&(file_pid->product_id))
           {
		        return 0;
	       }

        
    }
/*	    
	switch (tftp_ntohs(dev_pid->version_control))
    {
    dl_lan_send((char *)dev_pid,99);

	case 0x0100:
    case 0x0001:
    dl_lan_send((char *)dev_pid,82);

	    if (dl_memcmp((char *)dev_pid->hw_id,(char *)file_pid->hw_id,6)) {

    dl_lan_send((char *)dev_pid,84);

		return 0;
	    }
	    break;
	case 0x0200:
    case 0x0002:
    dl_lan_send((char *)dev_pid,83);

	    if (dev_pid->version_control != file_pid->version_control)
	       return 0;
	    if (dev_pid->upgrade_control == 0)
	       break;
	    if (dev_pid->upgrade_control & BIT_PCBA)
	       if (dl_memcmp((char *)dev_pid->hw_id,(char *)file_pid->hw_id,32)) {
		   return 0;
	       }
	    if (dev_pid->upgrade_control & BIT_FUNC_ID)
	       if (dl_memcmp((char *)dev_pid->function_id,(char *)file_pid->function_id,6)) {
		   return 0;
	       }
	    if (dev_pid->upgrade_control & BIT_PROD_ID)
	       if ( *(unsigned int *)(char *)&(dev_pid->product_id) != 
                *(unsigned int *)(char *)&(file_pid->product_id))
           {
		        return 0;
	       }

//	    if (dev_pid->upgrade_control & BIT_PROT_ID)
//	       if (dev_pid->protocol_id !=file_pid->protocol_id) {
//		   return 0;
	       }
 //tmp to comment it
	    break;
    default:
        dl_lan_send(test,89);
        
	}
*/
/*
       if(dev_pid->control_no == file_pid->control_no)
	    dvari->dl_mode=NONE_ADM_DL;
       if(file_pid->download_flag == DL_ALL_MAGIC)
	    dvari->dl_mode=ALL_DL;
*/     //upgrade MODE tmp ignored
//check pid over
//dl_lan_send(test,301);
        img_len = 0; //to init the img_len every time of Download beginning
        return 1;
    }

//the first realy bin is start from block_no=2
//dl_lan_send(test,83);


    tftp_store_file(beg_addr,(unsigned char *)p,len);
	beg_addr+=len;          

    img_len+=len;  //to count for img file len.

	return 1;
}

#define  T_OPEN   1
#define  T_CLOSE  0
/*
static int dl_time_out(struct dl_timer_s *timer_p, unsigned long nowtime)
{
    if(timer_p->state != T_OPEN)
	return 0;   // default with no timeout ! 
    if((nowtime-timer_p->setting)>timer_p->duration)
    {
	timer_p->state=T_CLOSE;
	return 1;
    }
    return 0;
}
*/

static void dl_set_timer(struct dl_timer_s *timer_p, unsigned int duration,unsigned long nowtime)
{
    timer_p->state=T_OPEN;
    timer_p->duration=duration;
    timer_p->setting=nowtime;
}

/*
static void dl_stop_timer(struct dl_timer_s *timer_p)
{
    timer_p->state=T_CLOSE;
}
*/

static unsigned short tftp_checksum(char *m, int len)
{
	unsigned short    *sptr, temp;
	unsigned int   tcksum;
	int             i;
	char            oddflag;

	tcksum = 0;

	sptr = (unsigned short *)m;
	oddflag = 0;
	if (len % 2) {
	   oddflag = 1;
	}
	len >>= 1;

	for (i=0; i<len; ++i)
		tcksum += *sptr++;
	if (oddflag) {
	      temp = *sptr;
	      tcksum += (temp & 0x00ff);
	}
/*      tcksum = (tcksum >> 16) + (tcksum & 0xffff); WILL USE C LIBRARY !!!
	tcksum += (tcksum >> 16);
 */     
		/*
		_asm{
	    mov    ax,word ptr [tcksum]
	    mov    dx,word ptr [tcksum+2]
	    adc    ax,dx
	    xor    dx,dx
	    mov    word ptr [tcksum],ax
	    mov    word ptr [tcksum+2],dx
	}
		*/

		*(unsigned short *)&tcksum = *(unsigned short *)&tcksum + *(unsigned short *)((char *)&tcksum+2);

	return (unsigned short)(~(*(unsigned short *)&tcksum) & 0xffff);
}

#define _LITTLE_ENDIAN_

#ifdef _LITTLE_ENDIAN_
/*
static long tftp_ntohl (long x)
{
      long t = x;
      //
      //_asm{
      //          mov     ax,word ptr [t]
      //          xchg    al,ah
      //          mov     dx,word ptr [t+2]
      //          xchg    dl,dh
      //          xchg    ax,dx
      //          mov     word ptr [t],ax
      //          mov     word ptr [t+2],dx
      //    };
      //
      *((char *)&t) = *((char *)&x+3);
      *((char *)&t+3) = *((char *)&x+1);
      *((char *)&t+2) = *((char *)&x+2);
      *((char *)&t+1) = *((char *)&x+3);
      return(t);
}
*/

#else
/*
static long tftp_ntohl (long x)
{
	return (x);
}
*/
#endif

#ifdef _LITTLE_ENDIAN_
static unsigned short tftp_ntohs (unsigned short x)
{
    unsigned short t = x;
	/*
	_asm{
	      mov       ax,[t]
	      xchg      al,ah
	      mov       [t],ax
	    };
	*/
	*((char *)&t) = *((char *)&x+1);
	*((char *)&t+1) = *((char *)&x) ;
      return(t);
}
#else
static unsigned short tftp_ntohs (unsigned short x)
{
	return (x);
}
#endif

/*
static int dl_stricmp(char *dst, char *src)
{
    for(;(*dst|0x20)==(*src|0x20);dst++,src++)
	if(*dst==0)
	    return 0;
    return 1;
}
*/

static int dl_memcmp(char *dst, char *src, int len)
{   int i;

    for(i=1;(*dst == *src);dst++,src++,i++)
       if (i==len)
	  return 0;
    return 1;
}

static int dl_memcpy(char *dst, char *src, int len)
{   int i;
    for(i=0;i<len;dst++,src++,i++)
	*dst = *src;
    return 1;
}


static int dl_memset(char *dst, char ch, int len)
{   int i;
    for(i=0;i<len;dst++,i++)
	*dst = ch;
    return 1;
}


static void tftp_store_file(int bin_off,unsigned char * p ,int len)
{       
        
        memcpy((unsigned char *)bin_room+bin_off,p,len);
}

/*
static void tftp_wrt_flash()
{
    int addr=0;

    apctlGPIOWrite(12, 1);
    apctlGPIOWrite(11, 0);    
    
    FlashDriver(0,0,0,4);
//  FlashDriver(0,0,0,4);//erase the main bin  
    
    for (;addr< FILE_SIZE;)
    {
        static int cnt= 0,led_flag = 0;
        FlashDriver(addr,(unsigned char *)bin_room+addr,512,0);  
////    FlashDriver(beg_addr,(unsigned char *)p,len,0);  
        addr = addr+512;
        
        if(++cnt > 16)
        {
            cnt = 0;
            led_flag = 1- led_flag;
            if(led_flag)
            {
                apctlGPIOWrite(11,0);
                apctlGPIOWrite(12,1);
            }
            else
            {
                apctlGPIOWrite(12,0);
                apctlGPIOWrite(11,1);
             
            }
        }

    }
    
//    dvari->final = 1;

}
*/


unsigned char  p_collect_buf[550]; //to store the every 512 decoded data before written to Flash.
void tftp_decode_img()
{

//variables DECLARATION PART
	unsigned char    *p_char, *p_tmp;
	unsigned int   source_file_pos=0,source_file_len=0;
	int   dlAddress=0x0000;
	unsigned int   pos_in_iob=0x0000;
	unsigned int   last_none_zero_len=0x0000;
	unsigned int   last_file_pos=0x0000;
	unsigned short    collect_buf_data_len=0;
	unsigned int   now_file_pos=0, i_temp=0;
	unsigned short    num=0;

//LED variables
    int cnt=0, led_flag = 0;

//variables INIT PART
	p_char=(unsigned char *)bin_room; 
//bin_room has pointed to the first BIN block, for img head has been got rid of , when do authentications
	p_tmp =(unsigned char *)bin_room; 
    source_file_len = img_len;
	//point at the really data

//sprintf(test+14,"*** Here will begin decode : img_len=%lu***",img_len);
//dl_lan_send(test,88);


    apctlGPIOWrite(12, 1);
    apctlGPIOWrite(11, 0);    
    
    FlashDriver(0,0,0,4);
    /*Erase the MAIN.BIN, not erased all*/
				
	while(source_file_pos<source_file_len)
	{

		if(pos_in_iob+5>511)
		{
//			printf("\n *** do in if>511****");

			switch (pos_in_iob)
			{
			case 512:
				//p_temp=p_temp->psNextIOB;
				//p_char=pbIOBData(p_temp);
				//p_char = &(file_con[++iCnt][0]);
				p_tmp +=512 ;
				p_char = p_tmp;

				pos_in_iob=0;
				now_file_pos=(*(BYTE *)(p_char+pos_in_iob))*0x1000000+(*(BYTE *)(p_char+1+pos_in_iob))*0x10000+(*(BYTE *)(p_char+2+pos_in_iob))*0x100+*(BYTE *)(p_char+3+pos_in_iob);
				pos_in_iob+=4;
				num=(*(BYTE *)(p_char+pos_in_iob))*0x100+*(BYTE *)(p_char+1+pos_in_iob);
				pos_in_iob+=2;
			break;
			case 511:
				now_file_pos=(*(BYTE *)(p_char+pos_in_iob))*0x1000000;
				//p_temp=p_temp->psNextIOB;
				//p_char=pbIOBData(p_temp);
//				p_char = &(file_con[++iCnt][0]);
				p_tmp +=512 ;
				p_char = p_tmp;

				pos_in_iob=0;
				now_file_pos=now_file_pos+(*(BYTE *)(p_char+pos_in_iob))*0x10000+(*(BYTE *)(p_char+1+pos_in_iob))*0x100+*(BYTE *)(p_char+2+pos_in_iob);
				pos_in_iob+=3;
				num=(*(BYTE *)(p_char+pos_in_iob))*0x100+*(BYTE *)(p_char+1+pos_in_iob);
				pos_in_iob+=2;
			break;
			case 510:
				now_file_pos=(*(BYTE *)(p_char+pos_in_iob))*0x1000000+(*(BYTE *)(p_char+1+pos_in_iob))*0x10000;
				//p_temp=p_temp->psNextIOB;
				//p_char=pbIOBData(p_temp);
//				p_char = &(file_con[++iCnt][0]);
				p_tmp +=512 ;
				p_char = p_tmp;

				pos_in_iob=0;
				now_file_pos=now_file_pos+(*(BYTE *)(p_char+pos_in_iob))*0x100+*(BYTE *)(p_char+1+pos_in_iob);
				pos_in_iob+=2;
				num=(*(BYTE *)(p_char+pos_in_iob))*0x100+*(BYTE *)(p_char+1+pos_in_iob);
				pos_in_iob+=2;
			break;
			case 509:
				now_file_pos=(*(BYTE *)(p_char+pos_in_iob))*0x1000000+(*(BYTE *)(p_char+1+pos_in_iob))*0x10000+(*(BYTE *)(p_char+2+pos_in_iob))*0x100;
				//p_temp=p_temp->psNextIOB;
				//p_char=pbIOBData(p_temp);
//				p_char = &(file_con[++iCnt][0]);
				p_tmp +=512 ;
				p_char = p_tmp;
				
				pos_in_iob=0;
				now_file_pos=now_file_pos+*(BYTE *)(p_char+pos_in_iob);
				pos_in_iob+=1;
				num=(*(BYTE *)(p_char+pos_in_iob))*0x100+*(BYTE *)(p_char+1+pos_in_iob);
				pos_in_iob+=2;
			break;
			case 508:
				now_file_pos=(*(BYTE *)(p_char+pos_in_iob))*0x1000000+(*(BYTE *)(p_char+1+pos_in_iob))*0x10000+(*(BYTE *)(p_char+2+pos_in_iob))*0x100+*(BYTE *)(p_char+3+pos_in_iob);
				//p_temp=p_temp->psNextIOB;
				//p_char=pbIOBData(p_temp);
//				p_char = &(file_con[++iCnt][0]);
				p_tmp +=512 ;
				p_char = p_tmp;

				pos_in_iob=0;
				num=(*(BYTE *)(p_char+pos_in_iob))*0x100+*(BYTE *)(p_char+1+pos_in_iob);
				pos_in_iob+=2;
			break;
			case 507:
				now_file_pos=(*(BYTE *)(p_char+pos_in_iob))*0x1000000+(*(BYTE *)(p_char+1+pos_in_iob))*0x10000+(*(BYTE *)(p_char+2+pos_in_iob))*0x100+*(BYTE *)(p_char+3+pos_in_iob);
				pos_in_iob+=4;
				num=(*(BYTE *)(p_char+pos_in_iob))*0x100;
				//p_temp=p_temp->psNextIOB;
				//p_char=pbIOBData(p_temp);
//				p_char = &(file_con[++iCnt][0]);
				p_tmp +=512 ;
				p_char = p_tmp;

				pos_in_iob=0;
				num=num+*(BYTE *)(p_char+pos_in_iob);
				pos_in_iob+=1;
			break;
			}
		
		}
		else
		{
			now_file_pos=(*(BYTE *)(p_char+pos_in_iob))*0x1000000+(*(BYTE *)(p_char+1+pos_in_iob))*0x10000+(*(BYTE *)(p_char+2+pos_in_iob))*0x100+*(BYTE *)(p_char+3+pos_in_iob);
			pos_in_iob+=4;
			num=(*(BYTE *)(p_char+pos_in_iob))*0x100+*(BYTE *)(p_char+1+pos_in_iob);
			pos_in_iob+=2;
		
		}
		
		source_file_pos+=6;
		
		i_temp=now_file_pos-last_none_zero_len-last_file_pos;

//printf("\n *** bef hangup here 1, now_file_pos=%u,last_none_zero_len=%u,,last_file_pos=%u****"
//	   ,now_file_pos,last_none_zero_len,last_file_pos);
		
		for(;i_temp>0;i_temp--)//filled in 0
		{	
			*((BYTE *)p_collect_buf+collect_buf_data_len)=(BYTE)0;
			collect_buf_data_len++;
			
			if(collect_buf_data_len==512)
			{

/*
				if(Len_Ctrl_Int==40)
				{
					Led_POST(1); 
#ifndef _MIPS_					
					Led_LAN(0);
#else
					Led_Power(0);
#endif					
				}
				else if(Len_Ctrl_Int==80)
				{
					Led_POST(0);
#ifndef _MIPS_					
					Led_LAN(1);
#else
					Led_Power(1);
#endif					
					Len_Ctrl_Int=0;
				}
				Len_Ctrl_Int++;
*/
                if(++cnt > 16)
                {
                    cnt = 0;
                    led_flag = 1- led_flag;
                    if(led_flag)
                    {
                        apctlGPIOWrite(11,0);
                        apctlGPIOWrite(12,1);
                    }
                    else
                    {
                        apctlGPIOWrite(12,0);
                        apctlGPIOWrite(11,1); 
                    }
                } 
                /*To control the LED part.*/
				
				FlashDriver( dlAddress, p_collect_buf,512, 0);

//printf("\n *** i will write file , in 512.1**** ");

//				fwrite(p_collect_buf,1,BLOCK_LEN,fp1);

			
				dlAddress+=512;
				collect_buf_data_len=0;
			}
			
		}	

//printf(" \n*** aft hangup here 1****");
		
		for(i_temp=num;i_temp>0;i_temp--,source_file_pos++,pos_in_iob++)//filled in none zero value
		{
			if(pos_in_iob==512)
			{
				//p_temp=p_temp->psNextIOB;
				//p_char=pbIOBData(p_temp);
//				p_char = &(file_con[++iCnt][0]);
				p_tmp +=512 ;
				p_char = p_tmp;

				pos_in_iob=0;
			}
			
			*((BYTE *)p_collect_buf+collect_buf_data_len)=*((BYTE *)p_char+pos_in_iob);collect_buf_data_len++;
			
			if(collect_buf_data_len==512)
			{
/*
				if(Len_Ctrl_Int==40)
				{
					Led_POST(1);
#ifndef _MIPS_					
					Led_LAN(0);
#else
					Led_Power(0);
#endif					
				}
				else if(Len_Ctrl_Int==80)
				{
					Led_POST(0);
					Len_Ctrl_Int=0;
#ifndef _MIPS_					
					Led_LAN(1);
#else
					Led_Power(1);
#endif					
				}
				Len_Ctrl_Int++;
*/
                

                if(++cnt > 16)
                {
                    cnt = 0;
                    led_flag = 1- led_flag;
                    if(led_flag)
                    {
                        apctlGPIOWrite(11,0);
                        apctlGPIOWrite(12,1);
                    }
                    else
                    {
                        apctlGPIOWrite(12,0);
                        apctlGPIOWrite(11,1); 
                    }
                } 
                //To control the LED part.

				FlashDriver( dlAddress, p_collect_buf,512,0);

//printf("\n *** i will write file , in 512.2**** ");
//				fwrite(p_collect_buf,1,BLOCK_LEN,fp1);				
//printf(" \n*** hangup here 2****");

				dlAddress+=512;
				collect_buf_data_len=0;
			}	
		}
		last_file_pos=now_file_pos;last_none_zero_len=num;
	}	

}