#define MAIN
#include "decls.h"
#include "iob.h"
#include "download.h"
#include "dl_c.h"
union {
    void (*branch) (void);
    int hackfest;
} u;

extern void apctlGPIOInit(unsigned long dirMap);
extern int apctlGPIOWrite(int gpioNum, int state);

char pkt[]={
0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
0x55, 0x55, 0x55, 0x55, 0x12, 0x34, 
0x08, 0x06, 0x00, 0x01, 0x08, 0x00, 
0x06, 0x04, 0x00, 0x01, 0x00, 0x55, 
0x55, 0x55, 0x55, 0x12, 0x34, 0x0a, 
0x0a, 0x0a, 0x0a, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x0a, 0x0a, 0x0a, 0x64, 
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};


//#define         NVRAMSIZE         64*1024
//static unsigned char NVRamBuff[NVRAMSIZE];
extern struct dvari_s DVARI;
void LEDinit();
static CBQ dsRecvQLan;

#define IOBOFF(x) ((x)->dwOffset)
#define IOBLEN(x) ((x)->dwLength)
#define IOBDATA(x) (&((x)->dbData[(x)->dwOffset]))

extern int FreeIOB ( IOB * psIOB );
extern IOB * DriverGetIOB ( unsigned int dwSize );
extern void putCBToQ(CBQ *psCBQ,void * psCB,unsigned char dbOrder);
extern void * getCBFromQ(CBQ *psCBQ,unsigned int zeroSize);
IOB * Lan_Receive ();

void LEDtest();
static int led=0;
//download main define
DCB_BUF    dcb;
VCI_TABLE vci;
unsigned char NodeAddress[8] = {0x00,0xc0,0x02,0xe0,0x72,0x16};
char sendbuf[1024];
unsigned char temp_mac[6];
//unsigned char cal_tab[32];

#define ADR_BASE 0xfff00000

#define CAL_OFFSET0 0x000ff000
#define CAL_SIZE0   (0x000ff0c0-0x000ff000+1) 

#define CAL_OFFSET1 0x000ff150
#define CAL_SIZE1   (0x000ff200-0x000ff150) 

#define CAL_OFFSET2 0x000ff200
#define CAL_SIZE2   1 


unsigned char cal_tab0[CAL_SIZE0];
unsigned char cal_tab1[CAL_SIZE1];
unsigned char cal_tab2[CAL_SIZE2];

unsigned char wlan_domain[2];


#define PIDDATA     0xFFFDFFE0

extern void amdFlashWriteWord( int offset, unsigned short dat);
extern void amdEraseChip(int sblk, int nblks);

#define CPU_REG_BASE	0x80002000
#define SYS_CLOCK_REG_OFF	0x00000030
#define MD_PAD_REG_OFF		0x00000044
#define REGS32(x)            (*(volatile unsigned long *)(x))
int loopled=0;


unsigned char debugbuf[1600];
void report_error(unsigned char *str, int len)
{
	memcpy(debugbuf, "\xFF\xFF\xFF\xFF\xFF\xFF",6);
	memcpy(debugbuf+6, "\x34\x12\x78\x56\x12\x12",6);
	debugbuf[12]=debugbuf[13]=0x44;
	debugbuf[14]=debugbuf[15]=0x55;
	memcpy(&debugbuf[16], str , len);
	eth_transmit(debugbuf ,len+16);
}


void
etherboot()
{
    char buf[2000];
    int len;
    int eth_poll(char *buffer);
    IOB *psIOB,*pIOB;
    int ledtime=0;
    
   DLC * psDLCHead;
   DLC * psDLCHead1;
   BYTE * psPID;
   unsigned short * dwTemp;
   ULONG  i,j;
   ULONG  ulAddress;
   ULONG  ulCount;
   BYTE * ptr;
   BYTE   domain;
   unsigned long temp;
   
   unsigned char *ptr1;
   unsigned char PIDdata[16];

   if((memcmp(PIDDATA,"\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff",16) == 0)
   	|| (memcmp(PIDDATA,"\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00",16) == 0)
     )
     {}
   else
   {
   ptr1 = (unsigned char *)PIDDATA;
   memcpy(PIDdata,ptr1,16);
   
   amdEraseChip(13,1);
   
   ProgramChip(0x0DFFF0,PIDdata,16);
   }

   psPID = (BYTE *)(PID_OFFSET+FLASH_ADRS);
   //memcpy ((BYTE *)&vci,psPID,sizeof(VCI_TABLE));
   memcpy ((BYTE *)&vci,(unsigned char *)0xFFFFFFC1,sizeof(VCI_TABLE));
   dwTemp = (unsigned short *)(PRODUCT_ID_OFFSET+FLASH_ADRS);
   vci.ProdID = *dwTemp;
   dwTemp = (unsigned short *)(PROTOCOL_ID_OFFSET+FLASH_ADRS);
   vci.ProtID = *dwTemp;
   dwTemp = (unsigned short *)(FW_VERSION_OFFSET+FLASH_ADRS);
   vci.Fver = *dwTemp;

   ptr = (unsigned char *) (DOMAIN_ADDRESS+FLASH_ADRS);
   domain = *ptr;

   memcpy(cal_tab0, (BYTE *)(CAL_OFFSET0+ADR_BASE), CAL_SIZE0);
   memcpy(cal_tab1, (BYTE *)(CAL_OFFSET1+ADR_BASE), CAL_SIZE1);
   memcpy(cal_tab2, (BYTE *)(CAL_OFFSET2+ADR_BASE), CAL_SIZE2);

   memcpy(temp_mac,(unsigned char *)0xFFFFFFB0,6);
   //memcpy(cal_tab,(unsigned char *)0xFFFFFF70,32);

   //memcpy(wlan_domain,(unsigned char *)0xFFFFFFA0,2);
   memcpy(wlan_domain,(unsigned char *)0xFFFFFF60,2);
    
//Enable external crystall clock
    REGS32(CPU_REG_BASE + MD_PAD_REG_OFF) = 0x00E0000E;
    REGS32(CPU_REG_BASE + SYS_CLOCK_REG_OFF) = 0x00007131;
//    	*(unsigned short *)0x80002026 = 0x00ff;
//	*(unsigned short *)0x8000202c = 0x0004;
//	*(unsigned short *)0x80002030 = 0x7131;
//	*(unsigned short *)0x80002044 = 0x000e;

    initcode();
//    dl_c_init(&DVARI);  //for TFTP download init.
//    eth_transmit(pkt, sizeof(pkt));
apctlGPIOInit(0xF320);
LEDinit();
    while(1) {
	if(len=eth_poll(buf)) 
	{
#if 0
	{
		pIOB = DriverGetIOB(len);
		IOBOFF(pIOB) = 0;
		IOBLEN(pIOB) = len;
		memcpy(IOBDATA(pIOB),buf,len);
		putCBToQ((CBQ *)&dsRecvQLan,(void *)pIOB,TAIL);
		FreeIOB(pIOB);
	}
#endif
           	 ledtime++;
         if(ledtime >= 100)
         {          LEDtest();
         	ledtime=0;
         }

         psDLCHead = (DLC *)buf;
         if (psDLCHead->sap == 0 ||
             psDLCHead->sap == 0x8888) {
            memset (sendbuf,0x00,sizeof(DLC));
            psDLCHead1 = (DLC *)sendbuf;
            memcpy ((BYTE *)psDLCHead1->DestAddress,(BYTE *)psDLCHead->SrcAddress,6);
            
            if(memcmp(temp_mac,"\xff\xff\xff\xff\xff\xff",6) == 0)
            	memcpy ((BYTE *)psDLCHead1->SrcAddress,NodeAddress,6);//device MAC address
            else
            	memcpy ((BYTE *)psDLCHead1->SrcAddress,temp_mac,6);//device MAC address
            
            //LEDtest();
            psDLCHead1->wcmd = psDLCHead->wcmd;
            psDLCHead1->sap = psDLCHead->sap;
            psDLCHead1->wsequence = psDLCHead->wsequence;
            psDLCHead1->woffset = psDLCHead->woffset;
            psDLCHead1->wsegment = psDLCHead->wsegment;
            switch (psDLCHead->wcmd) {
            case GET_VERSION_INFO:               // get version//OK  Ricky modify 2003/01/03
                 psDLCHead1->wLen=0x0038;
                 memcpy((BYTE *)psDLCHead1->bData,(BYTE *)&vci.VerControl,VCI_LEN);
                 eth_transmit((BYTE *)psDLCHead1,(VCI_LEN+24));
                 break;
            case DOWN_ERASE_ALL:
            case DOWN_REQUEST:               // download//OK  Ricky modify 2003/01/03
                 dcb.state=PROG;
                 dcb.sequn=((psDLCHead->wsequence+1) & 0xffff);
                 if((psDLCHead->wcmd)==DOWN_REQUEST){
                       dcb.erase=4;
                 }
                 else{
                       dcb.erase=3;
                 }
                 dcb.no = 0;
                 psDLCHead1->wLen=0x0002;
                 eth_transmit((BYTE *)psDLCHead1,64);
                 break;
            case DOWN_DATA :
            	 loopled=1;
                 switch (dcb.state) {
                 case PROG:

                      if (dcb.sequn==(psDLCHead->wsequence)) {
                         ulAddress = ((psDLCHead->wsegment) << 4)+(psDLCHead->woffset);
                         if (ulAddress == 0) {
                            dcb.no ++;
                         } /* endif */
                         ulAddress += (0x100000*(dcb.no-1));
                         ulCount = (ULONG)(psDLCHead->wLen);
                         
                         if (ulAddress==0xFF000)
                         {
                            memcpy((unsigned char*)&psDLCHead->bData[0],cal_tab0, CAL_SIZE0);
                            memcpy((unsigned char*)&psDLCHead->bData[0x150], cal_tab1, CAL_SIZE1);
                         }
                         if(ulAddress==0xFF200)
                         {
                            memcpy((unsigned char*)&psDLCHead->bData[0], cal_tab2, CAL_SIZE2);                            
                         }
                         if (ulAddress==0xFFE00) 
                         {
                            //memcpy((unsigned char*)&psDLCHead->bData[368],cal_tab,32);
			    memcpy((unsigned char*)&psDLCHead->bData[432],temp_mac,6);
			    //memcpy((unsigned char*)&psDLCHead->bData[416],wlan_domain,2);
			    memcpy((unsigned char*)&psDLCHead->bData[352],wlan_domain,2);
                         } /* endif */
                         if ( FlashDriver(ulAddress,(unsigned short *)psDLCHead->bData,ulCount,dcb.erase) == 0)
                          {
                            if(dcb.erase==4){
                                 dcb.erase = 0;
                            }
                            else if(dcb.erase==3){
                                 dcb.erase=5;
                            }
                            dcb.sequn += 1;
                            *((unsigned short *) &psDLCHead1->bData[0])=0;
                         } else {
                            dcb.state=PROGERR;
                            *((unsigned short *) &psDLCHead1->bData[0])=xchg(PROG_ERR);
                         }
                      } else {
                        if (dcb.sequn >= (psDLCHead->wsequence)) {
                           *((unsigned short *) &psDLCHead1->bData[0])=0;
                        } else {
                           *((unsigned short *) &psDLCHead1->bData[0])=xchg(SEQ_NUM_ERR);
                        } /* endif */
                      } /* endif */
                      psDLCHead1->wLen=LToLs(2);

                      break;
                 case IDLE://OK  Ricky modify 2003/01/03
                      psDLCHead1->wLen=0x0002;
                      *((unsigned short *) &psDLCHead1->bData[0])=xchg(COM_SEQ_ERR);
                      break;
                 }
                 eth_transmit((BYTE *)psDLCHead1,64);
                 break;
            case DOWN_RESET://OK  Ricky modify 2003/01/03
                 psDLCHead1->wLen=0x0000;
                 *((unsigned short *)& psDLCHead1->bData[0])=0;
                 eth_transmit((unsigned char*)psDLCHead1,64);
                 u.hackfest = 0xffff0000;
                 u.branch();
                 break;
            case DOWN_VERIFY:  //OK  Ricky modify 2003/01/04
                 switch (dcb.state) {
                 case PROG:
                      if (dcb.sequn==psDLCHead->wsequence)
		      {
		      	if ((dcb.erase == WRITE_EALL)||(dcb.erase ==WRITE_UPGRADE))
		        {
                            dcb.erase = ERASE_VERIFY;		//just for reset flag
                            dcb.no = 0;
                        } /* endif */
                        ulAddress = (psDLCHead->wsegment << 4)+ psDLCHead->woffset;
                        if (ulAddress == 0)
                        {
                           dcb.no++;
                        }
                        ulAddress += (0x100000*(dcb.no-1));
                        ulCount = ((ULONG)(psDLCHead->wLen));
                                                       
                        psDLCHead1->bData[0]=0;
                        psDLCHead1->bData[1]=0;
                        ulCount=(ulCount+1)>>1;
                        //if (ulAddress<0xfB000)
                        if(ulAddress<0xE0000)
                        {
                            for(i=0;i<ulCount;i++)
                            {
                            	unsigned short *p;
                            	
                               p =(unsigned short *) (ulAddress + 0xFFF00000+i*2);  
                               if(*p !=*(unsigned short *)&psDLCHead->bData[i*2])
                               {
                                   dcb.state=PROGERR;
                                   *((unsigned short *) &psDLCHead1->bData[0])=xchg(VERIFY_ERR);	
                                   break;
                               }
                             }
                         }
                         ++dcb.sequn;
                       }
                      else {
                        if ((dcb.sequn-1)==psDLCHead->wsequence) {
                           *((unsigned short *) &psDLCHead1->bData[0])=0;
                        } else {
                           *((unsigned short *) &psDLCHead1->bData[0])=xchg(SEQ_NUM_ERR);
                        } /* endif */
                      } /* endif */
                      psDLCHead1->wLen=0x0002;
                      eth_transmit((BYTE *)psDLCHead1,64);
                      break;
                 } /* endswitch */
                 break;
            case DOWN_REPLY:  //OK  Ricky modify 2003/01/04
                 switch (dcb.state) {
                 case PROG:
                      if (dcb.sequn==psDLCHead->wsequence) {
                         if (dcb.erase == 0) {
                            dcb.erase = 4;
                            dcb.no = 0;
                         } /* endif */
                         ulAddress = ((psDLCHead->wsegment) << 4)+ (psDLCHead->woffset);
                         if (ulAddress == 0) {
                            dcb.no ++;
                         } /* endif */
                         ulAddress += 0x100000*(dcb.no-1);
                         ptr = ( unsigned char *)(ulAddress+FLASH_ADRS);
                         ulCount = (ULONG)(psDLCHead->wLen);
                         memcpy ( (unsigned char *)&psDLCHead->bData[0],ptr,ulCount);
                         psDLCHead1->wLen=psDLCHead->wLen;
                         eth_transmit((BYTE *)psDLCHead1,(ulCount+24));
                      } else {
                        if ((dcb.sequn-1)==(psDLCHead->wsequence)) {
                           *((unsigned short *) &psDLCHead1->bData[0])=0;
                        } else {
                           *((unsigned short *) &psDLCHead1->bData[0])=xchg(SEQ_NUM_ERR);
                        } /* endif */
                        psDLCHead1->wLen=0x0002;
                        eth_transmit((BYTE *)psDLCHead1,64);
                      } /* endif */
                      break;//emd switch(dcb.stats)
                 }
                 break;
            }
         } /* endif */
        else 
		{
            dl_c_process((char*)buf,len,&DVARI);  //IOBDATA(psIOB) should be that char * which point at the MAC-LEVEL header
		    if(1== DVARI.final)
		    {
        	    u.hackfest = 0xffff0000;
                u.branch(); 	
 		    }

		}
          /*Will be dealt with our TFTP download.*/
        // FreeIOB (psIOB);
      } /* endif */
//ledtime++
//	LEDtest();
    }//end for loop
}

int
main()
{
    apctlGPIOInit(0xF320);
    LEDinit();
    etherboot();
}


IOB * Lan_Receive ()
{
	IOB *pIOB;

	pIOB=(IOB *)getCBFromQ(&dsRecvQLan,1);
	return pIOB;
}

void LEDinit()
{
	apctlGPIOWrite(0, 0);
	apctlGPIOWrite(11, 0);
	//apctlGPIOWrite(0, 0);
}
int  xxx=0;
void LEDtest()
{
	xxx++;
	//apctlGPIOInit(0xF320);
	for(led=0;led<=1000;led++)
		{
		if(led==1000)
			{
			if(xxx%2){
				apctlGPIOWrite(0, 1);
				apctlGPIOWrite(11, 0);
			}else{
				apctlGPIOWrite(0, 0);
				apctlGPIOWrite(11, 1);
			}
		}
	}
}



int ProgramChip(int dlAddress,BYTE *dbData,int dlLength);
int eall_flag;

int FlashDriver(
int dlAddress,
BYTE *dbData,
int dlLength,
unsigned long dlFlag
)
{
   int dwReturnCode=0;
   int i;
   //ULONG mask;

   switch (dlFlag) {
   case 0:
        if (eall_flag == 0) {//boot config  none write
           if ((dlAddress >=  0x0000)&&(dlAddress < (0x100000 - 0x020000))) {
              dwReturnCode = ProgramChip(dlAddress,dbData, dlLength);
                   //sysFlashWrite(dbData, dlLength, dlAddress);
           } else {
              dwReturnCode = 0;
           } /* endif */
        } else {
           dwReturnCode = ProgramChip(dlAddress,dbData, dlLength);
        }
        break;
   case 1:
        break;
   case 2:
        break;
   case 3: //erase all
        for (i=0;i< 16 ;i ++ ) {
          amdEraseChip(i,1);
           //ResetChip(0);
        }
        if ((dlAddress >=  0x00000)&&(dlAddress < 0x100000)) {
           dwReturnCode = ProgramChip(dlAddress,dbData, dlLength);
        } else {
           dwReturnCode = 0;
        } /* endif */
        eall_flag = 1;
        break;
   case 4://normal erase
        for (i=0;i< 14 ;i ++ ) {
           amdEraseChip(i,1);
           //ResetChip(0);
        } /* endfor */
        if ((dlAddress >=  0x0000)&&(dlAddress < (0x100000-0x20000))) {
           dwReturnCode = ProgramChip(dlAddress,dbData, dlLength);
        } else {
           dwReturnCode = 0;
        } /* endif */
        break;
   case 5:
        if ((dlAddress >= 0x00000)&&(dlAddress < 0x100000)) {
           dwReturnCode = ProgramChip(dlAddress,dbData, dlLength);
        } else {
           dwReturnCode = 0;
        } /* endif */
        break;
   } /* endswitch */
   return dwReturnCode;
}

int ProgramChip(int dlAddress,BYTE *dbData,int dlLength)
{
	int mask;
	int i=0;
	uint16 nvword;
	int dwReturnCode=0;
	
//	mask = intLock();
	
	for(i=0;i*2 < dlLength;i++)
 	{
   		nvword = *(unsigned short *)dbData;
   		amdFlashWriteWord((dlAddress + (i*0x02)),nvword);

   		dbData=dbData+2;
	}
		
//	intUnlock(mask);
	
	return 0;
	
}
