#include "gtTftp.h"
#include "gtEther.h"
#include "gtDesc.h"
#include "msApiDefs.h"
#include "msApiPrototype.h"
#include "gtDrvSwRegs.h"
#include "MvCore.h"

void os_TaskDelay(int x);

unsigned int gtInternalRegBaseAddr = 0x0; 

#define EAGLE_MAC_READ(x,y) *y = *(volatile unsigned int *) (0x80008000 + x)
#define EAGLE_MAC_WRITE(x,y) *(volatile unsigned int *) (0x80008000 + x) = y;
#define EAGLE_MAC_READ_IMM(x) * (volatile unsigned int *) (0x80008000 + x)

#define W81_WRITE_BYTE(x,y) * (unsigned char *) x = y;
#define W81_WRITE_HWORD(x,y) * (unsigned short *) x = y;
#define W81_WRITE_WORD(x,y) * (unsigned int *) x = y;

unsigned long CurrRxDesc; /* Rx current Descriptor Number*/
TX_DESC *eth0_tx_desc;             //pointer to desc in tx descs memory space
RX_DESC *eth0_rx_desc;             //pointer to desc in rx descs memory space
char *eth0_tx_buffer;              //pointer to tx buffer in memory space (not really needed...)
char *eth0_rx_buffer[NR];          //pointers to allinged rx bufs in rx bufs memory space 
unsigned int macLow=0x55123456;
unsigned int macHigh=0x5555;
unsigned int hashTableBase;
void os_TaskDelay(int x) 
{
  int i;
  for (i = 0 ; i < x * 10000 ; i++) {}
}

int WritePhy(unsigned int offset, unsigned int data)
{
  unsigned int rdata;
  EAGLE_MAC_WRITE(0x10, (offset <<21) | (0 <<16) | (data &0xffff));
  EAGLE_MAC_READ(0x10, &rdata);
  while( (rdata >>28) & 1)
    {
      os_TaskDelay(2);
      EAGLE_MAC_READ(0x10, &rdata);
    }
  return 0;
}
int ReadPhy(unsigned int offset)
{
  unsigned int rdata;
  EAGLE_MAC_WRITE(0x10, (offset <<21) | (1<<26)| (0 <<16) );
  EAGLE_MAC_READ(0x10, &rdata);
  while( (rdata >>28) & 1)
    {
      os_TaskDelay(2);
      EAGLE_MAC_READ(0x10, &rdata);
    }
  return( rdata & 0xffff);
}
void
initcode()
{
    int i;
    unsigned int temp;
    int portNum = 0;
    void etherswitch_init(void);
    HASH_TABLE_ENTRY_DATA hashData;
    unsigned int phydata;
    unsigned int originalSDCR;

    eth0_tx_desc = (TX_DESC *)calloc(sizeof(TX_DESC), NT+1);
    eth0_rx_desc = (RX_DESC *)calloc(sizeof(RX_DESC), NR+1);
    (long)eth0_tx_desc = ((long)eth0_tx_desc + 15) & ~0xf;
    eth0_tx_buffer = (char *)calloc(1, 2048);
    (long)eth0_tx_buffer = ((long)eth0_tx_buffer + 15) & ~15;
    (long)eth0_rx_desc = ((long)eth0_rx_desc + 15) & ~0xf;
    for(i=0;i < NR;i++) {
	eth0_rx_buffer[i] = (char *)calloc(1, 2048);
	(long)eth0_rx_buffer[i]	= ((long)eth0_rx_buffer[i] + 15) & ~15;
    }


    os_TaskDelay(100);

    // Enable clocks going to all modules
    W81_WRITE_HWORD(0x8000200c, 0xffff);
    
    W81_WRITE_WORD(0x8000604c, 0xe00156);
//    os_TaskDelay(100);
    W81_WRITE_WORD(0x8000604c, 0xe00357);

    hashTableBase = calloc(1, 1024);

    W81_WRITE_WORD(0x80006050,0x7fe87a00);
    W81_WRITE_WORD(0x80006050,0x7fe83080); //FEU analog reset
    os_TaskDelay(100);

    W81_WRITE_WORD(0x80006050,0x7fe8b080); // FEU reset
    os_TaskDelay(100);

    //WritePhy(0,0xa100);   /* power up in 100Mbit mode FDX */
    //phydata = ReadPhy(0);
    /* initialize registers */  
#ifdef SWITCH_INIT
    etherswitch_init();
#endif
    // EAGLE_MAC_WRITE(ETH_SDMA_CONFIG_REG(portNum), 0x000032fc); 
    EAGLE_MAC_WRITE(ETH_SDMA_CONFIG_REG(portNum),
        ETH_BURST_SIZE_64B |
        ETH_RECEIVE_INTERRUPT_ON_FRAME |
        ETH_LITTLE_ENDIAN_TX |
        ETH_LITTLE_ENDIAN_RX);

    /* Enable port and reset promiscuous bit */
    EAGLE_MAC_READ(ETH_PORT_CONFIG_REG(portNum), &temp);
    temp = (temp)
        | ETH_HASH_FUNCTION_0
        | ETH_HASH_SIZE_16KB
        | ETH_PORT_ENABLE
        | ETH_PROMISCUOUS_MODE 
        | ETH_PASS_BAD_FRAMES
#ifdef TESTMODE
        | ETH_INTERNAL_LOOPBACK
#endif
        ;
    EAGLE_MAC_WRITE (ETH_PORT_CONFIG_REG(portNum), temp);
   
#ifdef MII_MODE		     
	EAGLE_MAC_WRITE (ETH_PORT_CONFIG_EXTEND_REG(portNum),
        ETH_MAX_FRAME_LENGTH_1536B |
        ETH_DISABLE_802_3_FLOW_CONTROL |
        ETH_DISABLE_AUTO_NEG_FOR_DUPLEX_MODE |
        ETH_DISABLE_AUTO_NEG_FOR_FLOW_CONTROL |
        ETH_DISABLE_AUTO_NEG_FOR_SPEED);
#else        
        
         EAGLE_MAC_WRITE (ETH_PORT_CONFIG_EXTEND_REG(0) + (portNum << 10), 
		     ETH_OVERRIDE_PRIORITY_FOR_RX_PACKETS | 
		     ETH_MAX_FRAME_LENGTH_1536B | ETH_RMII_ENABLE |
//		     BIT19 /* Work in 10MBps only !!! */ | 
		     BIT20);
		     
#endif
    CurrRxDesc=0;
    eth0_tx_desc[0].cmd_sts = 0; /*for first transmit*/

    /* initialize rx desc chain*/

    gtDescInitRxChain(NR, (unsigned int)eth0_rx_desc,
                      (unsigned int)eth0_rx_buffer[0], 1536, 
		      DESC_OWNED_BY_GT, 
		      CREATE_CYCLIC_CHAIN);
  
#if 1
   /* initialize rx buffers array */
    for (temp = 0; temp < NR; temp++)  
    {
        eth0_rx_buffer[temp] = (char*)eth0_rx_desc[temp].buf_ptr;
    }   
#endif

    gtDescInitTxChain(NT, (unsigned int)eth0_tx_desc,
                      (unsigned int) eth0_tx_buffer[0], 1536, 
		      DESC_OWNED_BY_GT | DESC_GENERATE_ERROR_CODE_TX | DESC_ADD_PADDING , 
		      NO_CYCLIC_CHAIN, 1); 


    eth0_tx_desc->buf_ptr = (unsigned int)eth0_tx_buffer;

    hashData.prio = 0;
    hashData.rdBit = 1;
    hashData.macLow = 0x5555;
    hashData.macHigh = 0x5555;
    gtEtherInitHashTable(portNum, ETH_HASH_MODE_0, _512_ADDRESSES_TABLE, 
                         hashTableBase, 1, &hashData); 
    gtEtherEnableReception(portNum, (unsigned int) eth0_rx_desc, ETH_RX_PRIO0); 

    os_TaskDelay (100);

    // Check link is up
    
    EAGLE_MAC_READ(ETH_PORT_STATUS_REG(0), &temp);

//    etherswitch_init();
}

/*******************************************************************************
*                   Copyright 2002, GALILEO TECHNOLOGY, LTD.                   *
* THIS CODE CONTAINS CONFIDENTIAL INFORMATION OF MARVELL.                      *
* NO RIGHTS ARE GRANTED HEREIN UNDER ANY PATENT, MASK WORK RIGHT OR COPYRIGHT  *
* OF MARVELL OR ANY THIRD PARTY. MARVELL RESERVES THE RIGHT AT ITS SOLE        *
* DISCRETION TO REQUEST THAT THIS CODE BE IMMEDIATELY RETURNED TO MARVELL.     *
* THIS CODE IS PROVIDED "AS IS". MARVELL MAKES NO WARRANTIES, EXPRESSED,       *
* IMPLIED OR OTHERWISE, REGARDING ITS ACCURACY, COMPLETENESS OR PERFORMANCE.   *
*                                                                              *
* MARVELL COMPRISES MARVELL TECHNOLOGY GROUP LTD. (MTGL) AND ITS SUBSIDIARIES, *
* MARVELL INTERNATIONAL LTD. (MIL), MARVELL TECHNOLOGY, INC. (MTI), MARVELL    *
* SEMICONDUCTOR, INC. (MSI), MARVELL ASIA PTE LTD. (MAPL), MARVELL JAPAN K.K.  *
* (MJKK), GALILEO TECHNOLOGY LTD. (GTL) AND GALILEO TECHNOLOGY, INC. (GTI).    *
********************************************************************************
* gtEther.c  
*
* DESCRIPTION:                                                                
*       Ethernet related functions.
*
* DEPENDENCIES:
*
*******************************************************************************/

/* includes */
#include "gtEther.h"
#include "EagleReg.h"
                              

/*******************************************************************************
* gtEtherStartTransmit - start transmit from the given port 
*
* DESCRIPTION:
*       Write first tx desc address in current tx descriptor register for the
*       given priority queue, and start transmitting through this queue.
*
* INPUT:
*       port - port to transmit from                                       
*       firstTxDescAddr - address of first desc                            
*       prio - priority queue to transmit from  
*
* OUTPUT:
*       None.
*
* RETURN:
*       None.
*
*******************************************************************************/
void gtEtherStartTransmit(ETH_PORT port, unsigned int firstTxDescAddr, 
                          ETH_TX_PRIO prio)
{
  unsigned int buff, i;
    /* write the first tx desc address to  CDP register */
    EAGLE_MAC_WRITE(ETH_CURRENT_TX_DESCRIPTOR_POINTER(port, prio),
                                               VIRTUAL_TO_PHY(firstTxDescAddr));
    buff = * (unsigned int *) ((unsigned int)firstTxDescAddr + 8);

    /* start tx command */
    gtEtherStartTx(port, prio);
}

/*******************************************************************************
* gtEtherEnableReception - enables rx queue for reception 
*
* DESCRIPTION:
*       Write first rx desc address in current rx descriptor register and
*       first rx desc register for the given priority queue, and enables
*       reception through this queue.
*
* INPUT:
*       port - port to transmit from                                       
*       firstRxDescAddr - address of first desc                            
*       prio - priority queue to transmit from  
*
* OUTPUT:
*       None.
*
* RETURN:
*       None.
*
*******************************************************************************/
void gtEtherEnableReception(ETH_PORT port, unsigned int firstRxDescAddr, 
                            ETH_RX_PRIO prio)
{
    /* write the first rx desc address to  FDP and CDP registers */
    EAGLE_MAC_WRITE(ETH_CURRENT_RX_DESCRIPTOR_POINTER(port, prio),
                                               VIRTUAL_TO_PHY(firstRxDescAddr));
    EAGLE_MAC_WRITE(ETH_FIRST_RX_DESCRIPTOR_POINTER(port, prio),
                                               VIRTUAL_TO_PHY(firstRxDescAddr));
    /* enable rx command */
    EAGLE_MAC_WRITE(ETH_SDMA_COMMAND_REG(port), ETH_ENABLE_RX); 
}


/*******************************************************************************
* gtEtherStartTx - set start tx bit
*
* DESCRIPTION:
*       Set start tx bit for a given port and priority queue. User should 
*       initialize current tx descriptor register before calling this function. 
*
* INPUT:
*       port - port to transmit from                                       
*       prio - priority queue to transmit from  
*
* OUTPUT:
*       None.
*
* RETURN:
*       None.
*
*******************************************************************************/
void gtEtherStartTx(ETH_PORT port, ETH_TX_PRIO prio)
{
    /* start tx command */
    GT_SET_REG_BITS(0x80008000 + ETH_SDMA_COMMAND_REG(port), ETH_START_TX_PRIO0 >> prio); 
}

/*******************************************************************************
* gtEtherEnableRx - enables rx quere for reception 
*
* DESCRIPTION:
*       Set enable rx bit for a given port and priority queue. User should 
*       initialize current and first rx descriptor registers before calling this 
*       function. 
*
* INPUT:
*       port - port to transmit from                                       
*       prio - priority queue to transmit from  
*
* OUTPUT:
*       None.
*
* RETURN:
*       None.
*
*******************************************************************************/
void gtEtherEnableRx(ETH_PORT port, ETH_RX_PRIO prio)
{
    /* enable rx command */
    GT_SET_REG_BITS(0x80008000 + ETH_SDMA_COMMAND_REG(port), ETH_ENABLE_RX); 
}

/*******************************************************************************
* gtEtherStopTx - stop transmission 
*   
* DESCRIPTION:
*       Stops transmission in a given priority queue of a given port
*
* INPUT:
*       port - the transmitting port
*       prio - pririty of transmitting queue to be stopped
*
* OUTPUT:
*       None.
*
* RETURN:
*       None.
*
*******************************************************************************/
void gtEtherStopTx(ETH_PORT port, ETH_TX_PRIO prio)
{
    int prioBit;
    if(prio == ETH_TX_PRIO0)
    {
        prioBit = ETH_STOP_TRANSMIT_PRIO0;
    }
    else prioBit = ETH_STOP_TRANSMIT_PRIO1;
    GT_SET_REG_BITS(0x80008000 + ETH_SDMA_COMMAND_REG(port), prioBit); 
}

/*******************************************************************************
* gtEtherAbortTx - abort transmission 
*   
* DESCRIPTION:
*       Aborts transmission in a given port.
*
* INPUT:
*       port - the transmitting port.
*      
* OUTPUT:
*       None.
*
* RETURN:
*       None.
*
*******************************************************************************/
void gtEtherAbortTx(ETH_PORT port)
{
    GT_SET_REG_BITS(0x80008000 + ETH_SDMA_COMMAND_REG(port), ETH_ABORT_TX); 
}

/*******************************************************************************
* gtEtherIsAbortTxEnded - Checks if Tx abort sequence has finished.
*   
* DESCRIPTION:
*       Checks if ABORT_TX bit is reset (after being set for abort command).
*
* INPUT:
*       port - the transmitting port 
*
* OUTPUT:
*       None.
*
* RETURN:
*       true - abort sequence has finished, ABORT_TX bit is reset.
*       false - ABORT_TX bit is still set
*
*******************************************************************************/
bool gtEtherIsAbortTxEnded(ETH_PORT port)
{
    if(EAGLE_MAC_READ_IMM(ETH_SDMA_COMMAND_REG(port)) & ETH_ABORT_TX)
    {
        return false;
    }
    return true;
}

/*******************************************************************************
* gtEtherAbortRx - Abort reception.
*   
* DESCRIPTION:
*       Aborts reception in a given port.
*
* INPUT:
*       port - the receiving port
*      
* OUTPUT:
*       None.
*
* RETURN:
*       None.
*
*******************************************************************************/
void gtEtherAbortRx(ETH_PORT port)
{
    GT_SET_REG_BITS(0x80008000 + ETH_SDMA_COMMAND_REG(port), ETH_ABORT_RX); 
}

/*******************************************************************************
* gtEtherIsAbortRxEnded - Checks if Rx abort sequence has finished.
*   
* DESCRIPTION:
*       Checks if ABORT_RX bit is reset (after being set for abort command).
*
* INPUT:
*       port - the receiving port 
*
* OUTPUT:
*       None.
*
* RETURN:
*       true - abort sequence has finished, ABORT_RX bit is reset.
*       false - ABORT_RX bit is still set
*
*******************************************************************************/
bool gtEtherIsAbortRxEnded(ETH_PORT port)
{
    if(EAGLE_MAC_READ_IMM(ETH_SDMA_COMMAND_REG(port)) & ETH_ABORT_RX)
    {
        return false;
    }
    return true;
}

/*******************************************************************************
* gtEtherInitHashTable - initialize the hash table
*
* DESCRIPTION:
*        This function initializes the hash table of the given eth port,  
*        according to inputs from the user: sets the size and mode in the port's
*        configuration register, and clears memory area for table from
*        hashTableBase.
*
* INPUT:
*         port - the eth port
*         mode - hash function mode
*         size - hash table size
*         hashTableBase - base address of hash table
*         numOfEntries - num of entries in entries array (can be 0)
*         entries - array of entries to insert in table. If no entries are 
*                   entered in initialization put NULL and put numOfEntries = 0. 
*                   If numOfEntries>0 the function calls gtEtherAddAddress() for
*                   every entry.
*
* OUTPUT:
*        None.
*
* RETURN: 
*         HASH_TABLE_SUCCESS - If initialization succeeded
*         HASH_TABLE_BASE_NOT_ALIGNED - If hash base address is not aligned to
*                                       0x1000    
*         UNABLE_TO_ADD_ADDRESS - If unable to add address from entries array
*
*******************************************************************************/
ETH_HASH_TABLE_STATUS gtEtherInitHashTable(ETH_PORT port, ETH_HASH_MODE mode, 
                                           ETH_HASH_TABLE_SIZE size, 
                                           unsigned int hashTableBase, 
                                           unsigned int numOfEntries, 
                                           HASH_TABLE_ENTRY_DATA* entries)
{
    unsigned int i, tableSizeInBytes;

    if((hashTableBase & 0x7) != 0)
    {
        return HASH_TABLE_BASE_NOT_ALIGNED;
    }

    EAGLE_MAC_WRITE(ETH_HASH_TABLE_POINTER_REG(port), 
                                                VIRTUAL_TO_PHY(hashTableBase));
    if(mode == ETH_HASH_MODE_0) 
    {
        GT_RESET_REG_BITS(0x80008000 + ETH_PORT_CONFIG_REG(port), ETH_HASH_FUNCTION_BIT);
    }
    else
    {
        GT_SET_REG_BITS(0x80008000 + ETH_PORT_CONFIG_REG(port), ETH_HASH_FUNCTION_BIT);
    }

    if(size == _8K_ADDRESSES_TABLE)
    {
        tableSizeInBytes=256 * _1K;
        GT_RESET_REG_BITS(0x80008000 + ETH_PORT_CONFIG_REG(port), ETH_HASH_SIZE_BIT);
    }
    else
    {
        tableSizeInBytes=16 * _1K;
        GT_SET_REG_BITS(0x80008000 + ETH_PORT_CONFIG_REG(port), ETH_HASH_SIZE_BIT);
    }
   /* clear hash table */
    for(i = 0; i < tableSizeInBytes; i+=4)
    {
        GT_WRITE_WORD(PHY_TO_VIRTUAL(hashTableBase + i), 0);
    }
   for(i = 0; i < numOfEntries; i++)
    {
        if ((gtEtherAddEntryToHash(port, &(entries[i]))) == 
                                                        UNABLE_TO_ADD_ADDRESS)
        {
            return UNABLE_TO_ADD_ADDRESS;
        }
    }
    return HASH_TABLE_SUCCESS;
}

/*******************************************************************************
* gtEtherAddEntryToHash - Adds a new entry to the hash table
*
* DESCRIPTION:
*       The function calculates the entry address to a given mac address, 
*       according to hash size and mode, as set in port configuration register.
*       The function will try ETH_HASH_HOP_NUMBER times to find an empty entry
*       and if fails returns UNABLE_TO_ADD_ADDRESS.
*       
* INPUT:  
*           port.
*           entryData - entry to be add to table with the fields macLow, 
                        macHigh, prio and rdBit. 
*                       priority field and rd bit will be set as defined 
*                       in entryData. Valid bit will be set and skip bit reset.
*
* OUTPUT:
*       None.
*
* RETURN:
*       HASH_TABLE_SUCCESS - if succeeded
*       UNABLE_TO_ADD_ADDRESS - if after ETH_HASH_HOP_NUMBER unable to find an
*                               empty entry for new address
*
*******************************************************************************/
ETH_HASH_TABLE_STATUS gtEtherAddEntryToHash(ETH_PORT port, 
                                              HASH_TABLE_ENTRY_DATA* entryData)
{
    unsigned int     hashTableBase;
    unsigned int     size, tableOffset;
    /* low - bits 31:0, high - 47:32 */                    
    unsigned int     ethAddressLow, ethAddressHigh;  
    unsigned int     ethAddressLowInversed, ethAddressHighInversed;
    /* for hash function calculation */
    unsigned int     ethAdd0,ethAdd1,ethAdd2,ethAdd3; 
    unsigned int     hashResult;  /* only bits 14:0 matter! */
    unsigned int     i;
    unsigned int     entryAddress;
    HASH_TABLE_ENTRY *entry;
    /* calculate entry data (same for any hash mode or size of table) */
    ethAddressLow = ((entryData->macHigh >> 8) & 0x000000ff) |  /* bits 7:0 */
                    ((entryData->macHigh << 8) & 0x0000ff00) |  /* bits 15:8 */
                    ((entryData->macLow >> 8) & 0x00ff0000)  |  /* bits 23:16 */
                    ((entryData->macLow << 8) & 0xff000000);    /* bits 31:24 */
    
    ethAddressHigh = ((entryData->macLow >> 8) & 0x000000ff) |  /* bits 39:32 */
                     ((entryData->macLow << 8) & 0x0000ff00);   /* bits 47:40 */
         
    /* calculate entry address: */
    ethAddressLowInversed = (SWAP_NIBBLES(entryData->macLow) |
                            (SWAP_NIBBLES(entryData->macLow >> 8) << 8) | 
                            (SWAP_NIBBLES(entryData->macLow >> 16) << 16) | 
                            (SWAP_NIBBLES(entryData->macLow >> 24) << 24));

    ethAddressHighInversed = (SWAP_NIBBLES(entryData->macHigh) |
                             (SWAP_NIBBLES(entryData->macHigh >> 8) << 8)); 

    ethAddressLowInversed = (INVERSE_NIBBLE(ethAddressLowInversed) |
                           (INVERSE_NIBBLE(ethAddressLowInversed >> 4) << 4) |  
                           (INVERSE_NIBBLE(ethAddressLowInversed >> 8) << 8) |  
                           (INVERSE_NIBBLE(ethAddressLowInversed >> 12) << 12) |  
                           (INVERSE_NIBBLE(ethAddressLowInversed >> 16) << 16) |  
                           (INVERSE_NIBBLE(ethAddressLowInversed >> 20) << 20) |  
                           (INVERSE_NIBBLE(ethAddressLowInversed >> 24) << 24) |  
                           (INVERSE_NIBBLE(ethAddressLowInversed >> 28) << 28));

   ethAddressHighInversed = (INVERSE_NIBBLE(ethAddressHighInversed) |
                            (INVERSE_NIBBLE(ethAddressHighInversed >> 4) << 4) |  
                            (INVERSE_NIBBLE(ethAddressHighInversed >> 8) << 8) |  
                          (INVERSE_NIBBLE(ethAddressHighInversed >> 12) << 12)); 

    hashTableBase=EAGLE_MAC_READ_IMM(ETH_HASH_TABLE_POINTER_REG(port));
    if((EAGLE_MAC_READ_IMM(ETH_PORT_CONFIG_REG(port))) & ETH_HASH_FUNCTION_1)
    {
        ethAdd0 =  INVERSE_6_BITS(ethAddressLowInversed) << 9;  /* bits 14:9 */
        /* bits 6:14 of ethAdd */
		ethAdd1 =  INVERSE_9_BITS(((ethAddressLowInversed >> 6)));  
        /* bits 15:23 of ethAdd */
		ethAdd2 =  INVERSE_9_BITS((ethAddressLowInversed >> 15));   
        i = (ethAddressLowInversed >> 24) | 
                        (0x100 & (ethAddressHighInversed << 8)); 
		ethAdd3 =  INVERSE_9_BITS(i); /* bits 24:32  of ethAdd */
    }
    else    /* HASH FUNCTION 0 */
    {
        ethAdd0 = (ethAddressLowInversed << 7) & 0x7e00;   /* bits 14:9 */
        ethAdd1 = ((ethAddressLowInversed >> 6) & 0x1fc) | 
                   (ethAddressLowInversed & 0x3); 
        ethAdd2 = (ethAddressLowInversed >> 15) & 0x1ff;
        ethAdd3 = (ethAddressLowInversed >>24) |
                  (0x100 & (ethAddressHighInversed << 8));
    }
    hashResult = ethAdd0 ^ ethAdd1 ^ ethAdd2 ^ ethAdd3;
    if((EAGLE_MAC_READ_IMM(ETH_PORT_CONFIG_REG(port))) & ETH_HASH_SIZE_16KB)
    {
        size = 16*_1K;
        tableOffset = (hashResult << 3) & 0x3ff8;
    }
    else
    {
        size = 256*_1K;
        tableOffset = (hashResult << 3) & 0x3fff8;
    }
    for(i = 0; i < ETH_HASH_HOP_NUMBER; i++)
    {
        if((tableOffset + i*8) >= size)
        {
            /* start from hash table base */
            entryAddress = hashTableBase + tableOffset + i*8 - size;
        }
        else
        {
            entryAddress = hashTableBase + tableOffset + i*8;
        }

        entry = (HASH_TABLE_ENTRY*)PHY_TO_VIRTUAL(entryAddress);
        if((entry->lowWord & ETH_HASH_SKIP_BIT) || 
           (entry->lowWord & ETH_HASH_VALID_BIT)) continue;
        /* skip=0, valid=1: */
        entry->lowWord =  
            (ETH_HASH_VALID_BIT | (ethAddressLow << 3)) & 0xfffffff9; 
        if(entryData->rdBit)  /* set RD bit */
        {
            entry->lowWord = entry->lowWord | ETH_HASH_RD_BIT;
        }
        entry->highWord = ((ethAddressLow >> 29) & 0x7) | 
                           (ethAddressHigh << 3) | (entryData->prio << 19);
        break;
    }
    if (i == ETH_HASH_HOP_NUMBER) 
        return UNABLE_TO_ADD_ADDRESS;
    return HASH_TABLE_SUCCESS;
} 

/*******************************************************************************
* gtEtherRemoveEntryFromHash - removes an address from hash table
*
* DESCRIPTION:
*       The function calculates the entry address to a given mac address, 
*       according to hash size and mode, as set in port configuration register.
*       the function will try ETH_HASH_HOP_NUMBER times to remove the address.
*       If address is found in hash table its fields will be reset to zero and
*       skip bit will be set.
*       
* INPUT:  
*           port.
*           entryData - a pointer to a HASH_TABLE_ENTRY_DATA representing the 
*                       entry to be removed. Only macLow and macHigh fields are 
*                       relevant to this function.
*
* OUTPUT:
*       None.
*
* RETURN:
*       HASH_TABLE_SUCCESS - If succeeded.
*       ADDRESS_NOT_IN_TABLE - If after ETH_HASH_HOP_NUMBER unable to find the
*                              address in table.
*
*******************************************************************************/
ETH_HASH_TABLE_STATUS gtEtherRemoveEntryFromHash(ETH_PORT port, 
                                               HASH_TABLE_ENTRY_DATA* entryData)
{
    unsigned int     hashTableBase;
    unsigned int     size, tableOffset;
    /* low - bits 31:0, high - 47:32 */
    unsigned int     ethAddressLow, ethAddressHigh;  
    unsigned int     ethAddressLowInversed, ethAddressHighInversed;
    /* for hash function calculation */
    unsigned int     ethAdd0,ethAdd1,ethAdd2,ethAdd3; 
    unsigned int     hashResult;  /* only bits 14:0 matter! */
    unsigned int     i;
    unsigned int     entryAddress;
    HASH_TABLE_ENTRY *entry;
    /* calculate entry data (same for any hash mode or size of table): */
    ethAddressLow = ((entryData->macHigh >> 8) & 0x000000ff) |  /* bits 7:0 */
                    ((entryData->macHigh << 8) & 0x0000ff00) |  /* bits 15:8 */
                    ((entryData->macLow >> 8) & 0x00ff0000)  |  /* bits 23:16 */
                    ((entryData->macLow << 8) & 0xff000000);    /* bits 31:24 */
    
    ethAddressHigh = ((entryData->macLow>>8) & 0x000000ff) |    /* bits 39:32 */
                     ((entryData->macLow<<8) & 0x0000ff00);     /* bits 47:40 */
         
    /* calculate entry address: */
    ethAddressLowInversed = (SWAP_NIBBLES(entryData->macLow) |
                            (SWAP_NIBBLES(entryData->macLow >> 8) << 8) | 
                            (SWAP_NIBBLES(entryData->macLow >> 16) << 16) | 
                            (SWAP_NIBBLES(entryData->macLow >> 24) << 24));

    ethAddressHighInversed = (SWAP_NIBBLES(entryData->macHigh) |
                             (SWAP_NIBBLES(entryData->macHigh >> 8) << 8)); 

    ethAddressLowInversed = (INVERSE_NIBBLE(ethAddressLowInversed) |
                           (INVERSE_NIBBLE(ethAddressLowInversed >> 4) << 4) |  
                           (INVERSE_NIBBLE(ethAddressLowInversed >> 8) << 8) |  
                           (INVERSE_NIBBLE(ethAddressLowInversed >> 12) << 12) |  
                           (INVERSE_NIBBLE(ethAddressLowInversed >> 16) << 16) |  
                           (INVERSE_NIBBLE(ethAddressLowInversed >> 20) << 20) |  
                           (INVERSE_NIBBLE(ethAddressLowInversed >> 24) << 24) |  
                           (INVERSE_NIBBLE(ethAddressLowInversed >> 28) << 28));

   ethAddressHighInversed = (INVERSE_NIBBLE(ethAddressHighInversed) |
                            (INVERSE_NIBBLE(ethAddressHighInversed >> 4) << 4) |  
                            (INVERSE_NIBBLE(ethAddressHighInversed >> 8) << 8) |  
                          (INVERSE_NIBBLE(ethAddressHighInversed >> 12) << 12)); 

    hashTableBase=EAGLE_MAC_READ_IMM(ETH_HASH_TABLE_POINTER_REG(port));
    if(EAGLE_MAC_READ_IMM(ETH_PORT_CONFIG_REG(port)) & ETH_HASH_FUNCTION_1)
    {
        ethAdd0 =  INVERSE_6_BITS(ethAddressLowInversed) << 9;  /* bits 14:9 */
        /* bits 6:14 of ethAdd */
        ethAdd1 =  INVERSE_9_BITS(((ethAddressLowInversed >> 6)));  
        /* bits 15:23 of ethAdd */
        ethAdd2 =  INVERSE_9_BITS((ethAddressLowInversed >> 15));  
        i = (ethAddressLowInversed >> 24) | 
            (0x100 & ( ethAddressHighInversed << 8)); 
		ethAdd3 =  INVERSE_9_BITS(i); /* bits 24:32  of ethAdd */
    }
    else    /* HASH FUNCTION 0 */
    {
        ethAdd0 = (ethAddressLowInversed << 7) & 0x7e00;   /* bits 14:9 */
        ethAdd1 = ((ethAddressLowInversed >> 6) & 0x1fc) | 
                   (ethAddressLowInversed & 0x3); 
        ethAdd2 = (ethAddressLowInversed >> 15) & 0x1ff;
        ethAdd3 = (ethAddressLowInversed >> 24) |
                  (0x100 & (ethAddressHighInversed << 8));
    }
    hashResult = ethAdd0 ^ ethAdd1 ^ ethAdd2 ^ ethAdd3;
    if((EAGLE_MAC_READ_IMM(ETH_PORT_CONFIG_REG(port))) & ETH_HASH_SIZE_16KB)
    {
        size = 16*_1K;
        tableOffset = (hashResult << 3) & 0x3ff8;
    }
    else
    {
        size=256*_1K;
        tableOffset = (hashResult << 3) & 0x3fff8;
    }
    for(i = 0; i < ETH_HASH_HOP_NUMBER; i++)
    {
        if((tableOffset + i*8) >= size)
        {
            /* start from hash table base: */
            entryAddress = hashTableBase + tableOffset + i*8 - size;
        }
        else
        {
            entryAddress = hashTableBase + tableOffset + i*8;
        }
        entry = (HASH_TABLE_ENTRY*)PHY_TO_VIRTUAL(entryAddress);
        if(entry->lowWord & ETH_HASH_SKIP_BIT) continue;
        if((entry->lowWord & 0xfffffff8) != (ethAddressLow << 3) ||
           (entry->highWord & 0x7ffff) != (((ethAddressLow >> 29) & 0x7) | 
                                          (ethAddressHigh << 3)))
        {
            return ADDRESS_NOT_IN_TABLE;
        }
        entry->highWord = 0x0;
        entry->lowWord = ETH_HASH_SKIP_BIT;
        break;
    }
    if (i == ETH_HASH_HOP_NUMBER) return ADDRESS_NOT_IN_TABLE;
    return HASH_TABLE_SUCCESS;
}

/*****************************************************************************
* etherReadPHYReg - reads a PHY register
*
* DESCRIPTION: 
*       This function will access the given PHY register through the GT SMI
*       register and will read it's value.
* INPUT:
*       port - port's number.
*       PHYReg - the PHY register offset.
*
* OUTPUT: 
*       value - pointer to unsigned int which will receive the value.
*
* RETURN:
*       true - If succeeded.
*       false -  If failed to make the assignment - SMI busy bit is set.
******************************************************************************/
bool gtEtherReadPHYReg(ETH_PORT port, unsigned int PHYReg, unsigned int* value)
{
    unsigned int phyAddr, regValue;
    int          timeOut = 10, i;

    /* first check that it is not busy */
    regValue = EAGLE_MAC_READ_IMM(ETH_SMI_REG);
    while(regValue & ETH_SMI_IS_BUSY)
    {
        for(i = 0; i < 10000000; i++);
        if(timeOut-- < 0)
        {
            return false;
        }
        regValue = EAGLE_MAC_READ_IMM(ETH_SMI_REG);
    }
    /* not busy */
    regValue = EAGLE_MAC_READ_IMM(ETH_PHY_ADDR_REG);
    switch(port)
    {
        case ETH0:
            phyAddr = regValue & 0x1f;
            break;
        case ETH1:
            phyAddr = (regValue >> 5) & 0x1f;
            break;
#ifdef INCLUDE_ETH_PORT_2
        case ETH2:
            phyAddr = (regValue >> 10) & 0x1f;
            break;
#endif /* INCLUDE_ETH_PORT_2 */
        default:
            return false;
    }
    EAGLE_MAC_WRITE(ETH_SMI_REG, (phyAddr << 16) | (PHYReg << 21) | ETH_SMI_READ);

    timeOut = 10; /* initialize the time out var again */ 
    regValue = EAGLE_MAC_READ_IMM(ETH_SMI_REG);
    while(!(regValue & ETH_SMI_READ_VALID))
    {

        for(i = 0; i < 10000000; i++);
        if(timeOut-- < 0 )
        {
            return false;
        }
        regValue = EAGLE_MAC_READ_IMM(ETH_SMI_REG);
    }
    *value = (regValue & 0xffff);
    return true;

}

/*****************************************************************************
* gtEtherWritePHYReg - writes to a PHY register
*
* DESCRIPTION: 
*       This function will access the given PHY register through the GT SMI
*       register and will write a given value to it.
*
* INPUT:
*       port - one of the 3 possible Ethernet ports (0-2).
*       PHYReg - the PHY register offset.
*       value - the value to be written (only bits 0-15!!! PHY regs are 2 bytes)
*
* OUTPUT: 
*       None.
*
* RETURN:
*       true - If succeeded.
*       false -  If failed to make the assignment - SMI busy bit is set.
******************************************************************************/
bool gtEtherWritePHYReg(ETH_PORT port, unsigned int PHYReg, unsigned int value)
{
    unsigned int phyAddr, regValue; 
    int          timeOut = 10, i;

    /* first check that it is not busy */
    regValue = EAGLE_MAC_READ_IMM(ETH_SMI_REG);
    while(regValue & ETH_SMI_IS_BUSY)
    {
        for(i = 0; i < 10000000; i++);
        if(timeOut-- < 1 )
        {
            return false;
        }
    }

    /* not busy */
    regValue = EAGLE_MAC_READ_IMM(ETH_PHY_ADDR_REG);
    switch(port)
    {
        case ETH0:
            phyAddr = regValue & 0x1f;
            break;
        case ETH1:
            phyAddr = (regValue >> 5) & 0x1f;
            break;
#ifdef INCLUDE_ETH_PORT_2
        case ETH2:
            phyAddr = (regValue >> 10) & 0x1f;
            break;
#endif /* INCLUDE_ETH_PORT_2 */
        default:
            return false;
    }
    EAGLE_MAC_WRITE(ETH_SMI_REG, (phyAddr << 16) | (PHYReg << 21) |
                 ((value) & 0xffff));
    return true;
}

/*******************************************************************************       
* gtEtherSetPhyAddress - Changes PHY address for the given port
*
* DESCRIPTION:
*       Change the PHY device address for a given port (change in PHY address 
*       reg).
* INPUT:
*       port.                         
*       newAddress - max 31 (5 bit field)
*
* OUTPUT:
*       None.
*
* RETURN:
*       None.
*
*******************************************************************************/
void gtEtherSetPhyAddress(ETH_PORT port, unsigned int newAddress)
{
    unsigned int phyAddReg = EAGLE_MAC_READ_IMM(ETH_PHY_ADDR_REG);
    switch(port)
    {
        case ETH0:
            EAGLE_MAC_WRITE(ETH_PHY_ADDR_REG,
                         (phyAddReg & 0xffffffe0) | newAddress);
            break;
        case ETH1:
            EAGLE_MAC_WRITE(ETH_PHY_ADDR_REG, 
                         (phyAddReg & 0xfffffc1f) | (newAddress << 5));
            break;
#ifdef INCLUDE_ETH_PORT_2
        case ETH2:
            EAGLE_MAC_WRITE(ETH_PHY_ADDR_REG, 
                         (phyAddReg & 0xffff83ff) | (newAddress << 10));
#endif /* INCLUDE_ETH_PORT_2 */
    }
    
}

/*******************************************************************************
* gtEtherGetPhyAddress - return phy device address for a given port
*
* DESCRIPTION:
*       Return phy device address for a given port, according to PHY address 
*       register.
*
* INPUT:
*       port.
*
* OUTPUT:
*       None.
*
* RETURN:
*       Given port's phy device address.
*
*******************************************************************************/
unsigned int gtEtherGetPhyAddress(ETH_PORT port)
{
    unsigned int regValue = EAGLE_MAC_READ_IMM(ETH_PHY_ADDR_REG);
    return ((regValue >> (5*port)) & 0x1f);
}

/*******************************************************************************
* gtEtherDefaultInit - initiates ETH ports with default parameters.
*
* DESCRIPTION:
*       Initiates port to work in promiscuous mode, RMII mode, MIB counters
*       work in clear, max frame length=2KB and sdma burst size is 64B.
*
* INPUT:
*       eth port
*
* OUTPUT:
*       None.
*
* RETURN:
*       None.
*******************************************************************************/
void gtEtherDefaultInit(ETH_PORT port)
{
/*
     EAGLE_MAC_WRITE(ETH_PORT_CONFIG_REG(port), ETH_PROMISCUOUS_MODE 
                                                             | ETH_PORT_ENABLE);
*/
    /* BIT 1 sets No broadcast */
    EAGLE_MAC_WRITE(ETH_PORT_CONFIG_REG(port), ETH_PORT_ENABLE | BIT1);
    EAGLE_MAC_WRITE(ETH_PORT_CONFIG_EXTEND_REG(port), ETH_RMII_ENABLE 
                                                    | ETH_MAX_FRAME_LENGTH_2KB);
    EAGLE_MAC_WRITE(ETH_SDMA_CONFIG_REG(port), EAGLE_MAC_READ_IMM(ETH_SDMA_CONFIG_REG(port)) 
                                                          | ETH_BURST_SIZE_64B);
}

#define EAGLE_MAC_READ(x,y) *y = *(volatile unsigned int *) (0x80008000 + x)
#define EAGLE_MAC_WRITE(x,y) *(volatile unsigned int *) (0x80008000 + x) = y;

#define W81_WRITE_BYTE(x,y) * (unsigned char *) x = y;
#define W81_WRITE_HWORD(x,y) * (unsigned short *) x = y;
#define W81_WRITE_WORD(x,y) * (unsigned int *) x = y;
typedef unsigned int   uint32;
typedef unsigned int   SMI_REG;
typedef unsigned short uint16;
typedef unsigned char  uint8;

#define ETHER_SMI_REG 0x10
#define SMI_BUSY (1 << 28)
#define SMI_OP_CODE_BIT_READ                    1
#define SMI_OP_CODE_BIT_WRITE                   0
#define READ_VALID                              (1<<27)

GT_BOOL readMiiReg (GT_QD_DEV* dev, uint32 portNumber , uint32 MIIReg,
                        uint32* value);
GT_BOOL writeMiiReg (GT_QD_DEV* dev, uint32 portNumber , uint32 MIIReg,
                        uint32  value);

GT_STATUS gprtGetPortCtr
(
    IN  GT_QD_DEV       *dev,
    IN  GT_LPORT        port,
    OUT GT_PORT_STAT    *ctr
);
GT_STATUS hwGetGlobalRegField
(
    IN GT_QD_DEV *dev,
    IN  GT_U8    regAddr,
    IN  GT_U8    fieldOffset,
    IN  GT_U8    fieldLength,
    OUT GT_U16   *data
);

GT_PORT_STAT  stats[10];
GT_STATUS retVal;


GT_QD_DEV       etherDev;
GT_STATUS hwReadPortReg
(
    IN GT_QD_DEV *dev,
    IN  GT_U8    portNum,
    IN  GT_U8    regAddr,
    OUT GT_U16   *data
    );

void
getstats()
{
    int i;
   /* 6052 should reset with VLAN map set up with all ports accessible by */
   /* all other ports.  Set up after testing with Wan port mapped only to */  
   /* cpu port and not accessible by any other port.                      */
   for(i=0;i < etherDev.numOfPorts;i++) {
	   //retVal = gstpGetPortState(&etherDev, i, &stats[i]);
       retVal = gprtGetPortCtr(&etherDev, i, &stats[i]);
   }
}
/*
 *	WAN Port (Port 0) and CPU Port (Port 5) are in VLAN 2 and
 *	all ports (including CPU Port) except WAN Port are in VLAN 1.
 *	1) Set PVID for each port.
 *	2) Set Port Based VLAN Map for each port.
*/
static GT_STATUS SohoGatewayVlan(GT_QD_DEV *dev,GT_LPORT numOfPorts, GT_LPORT cpuPort)
{
	GT_STATUS status;
	GT_LPORT index,port,portToSet;
	GT_LPORT portList[MAX_SWITCH_PORTS];

	/* 
	 *  set PVID for each port.
	 *	the first port(port 0, WAN) has default VID 2 and all others has 1.
	 */

	if((status = gvlnSetPortVid(dev,0,2)) != GT_OK)
	{
		DBG_INFO(("gprtSetPortVid returned fail.\n"));
		return status;
	}

	for (port=1; port<numOfPorts; port++)
	{
		if((status = gvlnSetPortVid(dev,port,1)) != GT_OK)
		{
			DBG_INFO(("gprtSetPortVid returned fail.\n"));
			return status;
		}
	}

	/* 
	 *  set Port VLAN Mapping.
	 *	port 0 (WAN) and cpu port are in a vlan 2.
	 *	And all the rest ports (LAN) and cpu port are in a vlan 1.
	 */

	/* port 0 : set cpuPort only */
	portList[0] = cpuPort;
	if((status = gvlnSetPortVlanPorts(dev,0,portList,1)) != GT_OK)
	{
		DBG_INFO(("gvlnSetPortVlanPorts returned fail.\n"));
		return status;
	}

	/* set all ports except port 0 and itself */
	for (portToSet=1; portToSet<numOfPorts; portToSet++)
	{
		/* port 0 and cpuPort will be taken cared seperately. */
		if (portToSet == cpuPort)
		{
			continue;
		}

		index = 0;
		for (port=1; port<numOfPorts; port++)
		{
			if (port == portToSet)
			{
				continue;
			}
			portList[index++] = port;
		}

		if((status = gvlnSetPortVlanPorts(dev,portToSet,portList,index)) != GT_OK)
		{
			DBG_INFO(("gvlnSetPortVlanPorts returned fail.\n"));
			return status;
		}
	}

	/* cpuPort : set all port except cpuPort */
	index = 0;
	for (port=0; port<numOfPorts; port++)
	{
		if (port == cpuPort)
		{
			continue;
		}
		portList[index++] = port;
	}

	if((status = gvlnSetPortVlanPorts(dev,cpuPort,portList,index)) != GT_OK)
	{
		DBG_INFO(("gvlnSetPortVlanPorts returned fail.\n"));
		return status;
	}

	return GT_OK;
}

static void
etherswitch_init()
{
    int           i;
    uint16        deviceId;
    GT_STATUS     retVal; 
    uint16        ready;
    GT_BOOL	  res[20];

    /* Functions return value.      */
    /* Initialize Marvell 88E6052/60 driver. */

   /* Power up using GPIO port bit 3.  Drive high-low-high for reset. */

   /* Set bit 3 to output mode on GPIO. Leave other GPIO unchanged. */
   W81_WRITE_HWORD(0x8000d000, 0xff7f);
   /* Program bit 3 to output mode. */
   W81_WRITE_HWORD(0x8000d008, 0xfff7);
   /* Set bit 3 output high then pause. */
   W81_WRITE_HWORD(0x8000d00c, 0xffff);
   /* Set bit 3 output low then pause. */
   W81_WRITE_HWORD(0x8000d00c, 0xff7f);
   /* Set bit 3 output high.  6052 should now be reset. */
   W81_WRITE_HWORD(0x8000d00c, 0xffff);

   /*
    *  Register all the required functions to QuarterDeck Driver.
   */

   etherDev.devNum       = 1;
   etherDev.devEnabled   = 1;
   etherDev.baseRegAddr  = 0x10;
   etherDev.numOfPorts   = 0x7;
   etherDev.cpuPortNum   = 0x5;
   etherDev.maxPhyNum    = 0x5;
   etherDev.stpMode      = 0;
   etherDev.devName      = 0;
   etherDev.atuRegsSem   = 0;
   etherDev.vtuRegsSem   = 0;
   etherDev.statsRegsSem = 0;
   etherDev.fgtReadMii   = readMiiReg;
   etherDev.fgtWriteMii  = writeMiiReg;
   etherDev.semCreate    = NULL;
   etherDev.semDelete    = NULL;
   etherDev.semTake      = NULL;
   etherDev.semGive      = NULL;
   etherDev.appData      = NULL;

   /* Now initialize 6052 chip for default setting - For now configure chip */
   /* to be a simple bridge with layer 2 switching between ports, all ports */
   /* can communicate with all other ports in this configuration (intended  */
   /* for testing purposes. */


   /* Get the Device Id and revision from the switch. */ 
   hwReadPortReg(&etherDev,1,QD_REG_SWITCH_ID,&deviceId);
   etherDev.revision = (uint8) (deviceId & 0x000F);
   etherDev.deviceId = (0x00FF) & (deviceId >> 4);

   /* Enable all ports. Ports 0-6 */

   for (i=0 ; i < etherDev.numOfPorts ; i++) {
      gprtGetVLANPortTagging(&etherDev, i, &res[i]);
   }

   for (i=0 ; i < etherDev.numOfPorts ; i++)
      gstpSetPortState(&etherDev, i, 0x3);  

   gprtClearAllCtr(&etherDev);

   getstats();
  
   /* use pin config. force control, unmodify ingress, no multicast limit, */
   /* normal trailer mode. */
   for (i=0 ; i < etherDev.numOfPorts ; i++)
   {
      gprtSetForceFc(&etherDev, i, GT_FALSE);
      gprtSetIngressMode(&etherDev, i, GT_UNMODIFY_INGRESS);
      gprtSetMcRateLimit(&etherDev, i, GT_MC_100_PERCENT_RL);
      gprtSetTrailerMode(&etherDev, i, GT_FALSE);
   }
#ifdef VLAN
   SohoGatewayVlan(&etherDev, etherDev.numOfPorts, etherDev.cpuPortNum);
   /* Set Egress trailer mode for cpu port 5. */
   gprtSetTrailerMode(&etherDev, 5, GT_TRUE);
   /* Set Ingress trailer mode for cpu port 5. */
   gprtSetIngressMode(&etherDev, 5, GT_TRAILER_INGRESS);
#endif
    retVal = hwGetGlobalRegField(&etherDev,QD_REG_GLOBAL_STATUS,10,2,&ready);
#if 0
    if((retVal != GT_OK) || (ready != 3))
    {
	exit(1);
    }
#endif
}

/****************************************************************************** 
 * 
 * Name: readMIIReg
 * 
 * Description: 
 *   This routine reads the MII register for the specified port.
 * 
 * Conditions For Use: 
 *   There is a device connected to the MII interface. 
 * 
 * Arguments: 
 *   portNumber - Port number.
 *   MIIReg     - MII Register to read.
 *   value      - pointer passed that MII register content is stored.
 * 
 * Return Value: 
 *   Boolean  True successful read.
 *            False unsuccessful read.
 * 
 * Notes: 
 *   None. 
 * 
 * PDL: 
 *    
 * END PDL 
 * 
 *****************************************************************************/ 

GT_BOOL readMiiReg (GT_QD_DEV* dev, uint32 portNumber, uint32 MIIReg,
                        uint32* value)
{
    SMI_REG smiReg;
    uint32 phyAddr;
    uint32 timeOut = 10; /* timeOut for Error condition. */

    /* first check that it is not busy */
    EAGLE_MAC_READ (ETHER_SMI_REG,(uint32*)&smiReg);
    while (smiReg & SMI_BUSY) 
    {
        os_TaskDelay(2);
        EAGLE_MAC_READ (ETHER_SMI_REG,(uint32*)&smiReg);
        if (timeOut-- <1 )
            return GT_FALSE; 
    }

    /* not busy */

    phyAddr = portNumber;

    smiReg =  (phyAddr << 16) | (SMI_OP_CODE_BIT_READ << 26) | (MIIReg << 21) |
         SMI_OP_CODE_BIT_READ<<26;

    EAGLE_MAC_WRITE (ETHER_SMI_REG,*((uint32*)&smiReg));
    timeOut = 10; /* Reinitialize the time out. */
    EAGLE_MAC_READ (ETHER_SMI_REG,(uint32*)&smiReg);
    while (!(smiReg & READ_VALID)) 
    {
        os_TaskDelay(2);
        EAGLE_MAC_READ (ETHER_SMI_REG,(uint32*)&smiReg);
        if (timeOut-- <1 )
            return GT_FALSE; 
    }

    *value = (uint32)(smiReg & 0xffff);
    
    return GT_TRUE;


}


/****************************************************************************** 
 * 
 * Name: writeMIIReg
 * 
 * Description: 
 *   This routine writes data to the MII register for the specified port.
 * 
 * Conditions For Use: 
 *   There is a device connected to the MII interface. 
 * 
 * Arguments: 
 *   portNumber - Port number.
 *   MIIReg     - MII Register to write data.
 *   value      - data to be written to MII Register.
 * 
 * Return Value: 
 *   Boolean  True successful write.
 *            False unsuccessful write.
 * 
 * Notes: 
 *   None. 
 * 
 * PDL: 
 *    
 * END PDL 
 * 
 *****************************************************************************/

GT_BOOL writeMiiReg (GT_QD_DEV* dev, uint32 portNumber, uint32 MIIReg,
                       uint32 value)
{
    SMI_REG smiReg;
    uint32 phyAddr;
    uint32 timeOut = 10; /* timeOut for Error condition. */

    /* first check that it is not busy */
    EAGLE_MAC_READ (ETHER_SMI_REG,(uint32*)&smiReg);
    while (smiReg & SMI_BUSY) 
    {
        EAGLE_MAC_READ (ETHER_SMI_REG,(uint32*)&smiReg);
        if (timeOut-- < 1 )
            return GT_FALSE; 
    }

    /* not busy */

    phyAddr = portNumber;

    smiReg = 0;
    smiReg = smiReg | (phyAddr << 16) | (SMI_OP_CODE_BIT_WRITE << 26) |
             (MIIReg << 21) | (value & 0xffff);

    EAGLE_MAC_WRITE (ETHER_SMI_REG,*((uint32*)&smiReg));

    return GT_TRUE;
}
/********************************************************************************
* gtMiiSmiIf.c
*
* DESCRIPTION:
*       Includes functions prototypes for initializing and accessing the
*       MII / SMI interface.
*       This is the only file to be included from upper layers.
*
* DEPENDENCIES:
*       None.
*
* FILE REVISION NUMBER:
*       $Revision: 1.1.1.1 $
*
*******************************************************************************/

#include <gtDrvSwRegs.h>
#include <gtHwCntl.h>
#include <gtMiiSmiIf.h>
#include <platformDeps.h>
#include <stdio.h>

/*******************************************************************************
* miiSmiIfInit
*
* DESCRIPTION:
*       This function initializes the MII / SMI interface.
*
* INPUTS:
*       None.
*
* OUTPUTS:
*       highSmiDevAddr - Indicates whether to use the high device register
*                     addresses when accessing switch's registers (of all kinds)
*                     i.e, the devices registers range is 0x10 to 0x1F, or to
*                     use the low device register addresses (range 0x0 to 0xF).
*                       GT_TRUE     - use high addresses (0x10 to 0x1F).
*                       GT_FALSE    - use low addresses (0x0 to 0xF).
*
* RETURNS:
*       GT_OK       - on success
*       GT_FAIL     - on error
*
* COMMENTS:
*       None.
*
*******************************************************************************/
GT_STATUS miiSmiIfInit
(
	IN  GT_QD_DEV    *dev,
	OUT GT_BOOL * highSmiDevAddr
)
{
	GT_STATUS status;
	GT_U16 data, data1;

	if((status = miiSmiIfReadRegister(dev,PORT_REGS_START_ADDR,QD_REG_SWITCH_ID,&data)) != GT_OK)
	{
		return status;
	}

	if((status = miiSmiIfReadRegister(dev,PORT_REGS_START_ADDR+1,QD_REG_SWITCH_ID,&data1)) != GT_OK)
	{
		return status;
	}

	switch(data & 0xFF00)
	{
		case 0x0200:
		case 0x0500:
		case 0x0600:
		case 0x1500:
		case 0xF500:
		case 0xF900:
			if (data == data1)
			{
				*highSmiDevAddr = GT_FALSE;
				return GT_OK;
			}
			break;
		default:
			break;
	}

	if((status = miiSmiIfReadRegister(dev,PORT_REGS_START_ADDR+0x10,QD_REG_SWITCH_ID,&data)) != GT_OK)
	{
		return status;
	}

	if((status = miiSmiIfReadRegister(dev,PORT_REGS_START_ADDR+0x11,QD_REG_SWITCH_ID,&data1)) != GT_OK)
	{
		return status;
	}

	switch(data & 0xFF00)
	{
		case 0x0200:
		case 0x0500:
		case 0x0600:
		case 0x1500:
		case 0xF500:
		case 0xF900:
			if (data == data1)
			{
				*highSmiDevAddr = GT_TRUE;
				return GT_OK;
			}
			break;
		default:
			break;
	}

    return GT_FAIL;
}


/*******************************************************************************
* miiSmiIfReadRegister
*
* DESCRIPTION:
*       This function reads a register throw the SMI / MII interface, to be used
*       by upper layers.
*
* INPUTS:
*       phyAddr     - The PHY address to be read.
*       regAddr     - The register address to read.
*
* OUTPUTS:
*       data        - The register's data.
*
* RETURNS:
*       GT_OK   - on success
*       GT_FAIL - on error
*
* COMMENTS:
*       None.
*
*******************************************************************************/
GT_STATUS miiSmiIfReadRegister
(
    IN  GT_QD_DEV    *dev,
    IN  GT_U8        phyAddr,
    IN  GT_U8        regAddr,
    OUT GT_U16       *data
)
{
    unsigned int tmpData;

    if(dev->fgtReadMii(dev,(GT_U32)phyAddr,(GT_U32)regAddr,&tmpData) != GT_TRUE)
    {
        return GT_FAIL;
    }

    *data = (GT_U16)tmpData;
    return GT_OK;
}


/*******************************************************************************
* miiSmiIfWriteRegister
*
* DESCRIPTION:
*       This function writes to a register throw the SMI / MII interface, to be
*       used by upper layers.
*
* INPUTS:
*       phyAddr     - The PHY address to be read.
*       regAddr     - The register address to read.
*       data        - The data to be written to the register.
*
* OUTPUTS:
*       None.
*
* RETURNS:
*       GT_OK   - on success
*       GT_FAIL - on error
*
* COMMENTS:
*       None.
*
*******************************************************************************/
GT_STATUS miiSmiIfWriteRegister
(
    IN  GT_QD_DEV    *dev,
    IN  GT_U8        phyAddr,
    IN  GT_U8        regAddr,
    IN  GT_U16       data
)
{
    if(dev->fgtWriteMii(dev,(GT_U32)phyAddr,(GT_U32)regAddr,(GT_U32)data) != GT_TRUE)
    	return GT_FAIL;
	else
	return GT_OK;
}



/********************************************************************************
* gtPortCtrl.c
*
* DESCRIPTION:
*       API implementation for switch port control.
*
* DEPENDENCIES:
*
* FILE REVISION NUMBER:
*       $Revision: 1.1.1.1 $
*******************************************************************************/

#include <msApi.h>
#include <gtHwCntl.h>
#include <gtDrvSwRegs.h>

/*******************************************************************************
* gprtSetForceFc
*
* DESCRIPTION:
*       This routine set the force flow control state.
*
* INPUTS:
*       port  - the logical port number.
*       force - GT_TRUE for force flow control  or GT_FALSE otherwise
*
* OUTPUTS:
*       None.
*
* RETURNS:
*       GT_OK   - on success
*       GT_FAIL - on error
*
* COMMENTS:
*
*
* GalTis:
*
*******************************************************************************/
GT_STATUS gprtSetForceFc
(
    IN GT_QD_DEV  *dev,
    IN GT_LPORT   port,
    IN GT_BOOL    force
)
{
    GT_U16          data;           /* Used to poll the SWReset bit */
    GT_STATUS       retVal;         /* Functions return value.      */
    GT_U8           hwPort;         /* the physical port number     */
    GT_PORT_STP_STATE  state;

    DBG_INFO(("gprtSetForceFc Called.\n"));

	/* Port should be disabled before Set Force Flow Control bit */
	retVal = gstpGetPortState(dev,port, &state);
    if(retVal != GT_OK)
	{
	    DBG_INFO(("gstpGetPortState failed.\n"));
		return retVal;
	}

	retVal = gstpSetPortState(dev,port, GT_PORT_DISABLE);
    if(retVal != GT_OK)
	{
	    DBG_INFO(("gstpSetPortState failed.\n"));
		return retVal;
	}

    /* translate BOOL to binary */
    BOOL_2_BIT(force, data);
    /* translate LPORT to hardware port */
    hwPort = GT_LPORT_2_PORT(port);

    /* Set the force flow control bit.  */
    retVal = hwSetPortRegField(dev,hwPort, QD_REG_PORT_CONTROL,15,1,data);
    if(retVal != GT_OK)
        DBG_INFO(("Failed.\n"));
    else
        DBG_INFO(("OK.\n"));

	/* Restore original stp state. */
	if(gstpSetPortState(dev,port, state) != GT_OK)
	{
	    DBG_INFO(("gstpSetPortState failed.\n"));
		return GT_FAIL;
	}

    return retVal;
}



/*******************************************************************************
* gprtGetForceFc
*
* DESCRIPTION:
*       This routine get the force flow control state.
*
* INPUTS:
*       port  - the logical port number.
*
* OUTPUTS:
*       force - GT_TRUE for force flow control  or GT_FALSE otherwise
*
* RETURNS:
*       GT_OK   - on success
*       GT_FAIL - on error
*
* COMMENTS:
*
*
* GalTis:
*
*******************************************************************************/
GT_STATUS gprtGetForceFc
(
    IN  GT_QD_DEV  *dev,
    IN  GT_LPORT   port,
    OUT GT_BOOL    *force
)
{
    GT_U16          data;           /* Used to poll the SWReset bit */
    GT_STATUS       retVal;         /* Functions return value.      */
    GT_U8           hwPort;         /* the physical port number     */

    DBG_INFO(("gprtGetForceFc Called.\n"));
    /* translate LPORT to hardware port */
    hwPort = GT_LPORT_2_PORT(port);
    /* Get the force flow control bit.  */
    retVal = hwGetPortRegField(dev,hwPort, QD_REG_PORT_CONTROL,15,1,&data);
    /* translate binary to BOOL  */
    BIT_2_BOOL(data, *force);
    if(retVal != GT_OK)
        DBG_INFO(("Failed.\n"));
    else
        DBG_INFO(("OK.\n"));

    return retVal;
}

/*******************************************************************************
* gprtGetVLANPortTagging
*
* DESCRIPTION:
*       This routine get the state of the VLAN Port Tag mode
*
* INPUTS:
*       port  - the logical port number.
*
* OUTPUTS:
*       PortTag - GT_TRUE for VLAN Port Tagging on or GT_FALSE otherwise
*
* RETURNS:
*       GT_OK   - on success
*       GT_FAIL - on error
*
* COMMENTS:
*
*
* GalTis:
*
*******************************************************************************/
GT_STATUS gprtGetVLANPortTagging
(
    IN  GT_QD_DEV  *dev,
    IN  GT_LPORT   port,
    OUT GT_BOOL    *PortTag
)
{
    GT_U16          data;           /* Used to poll the SWReset bit */
    GT_STATUS       retVal;         /* Functions return value.      */
    GT_U8           hwPort;         /* the physical port number     */

    DBG_INFO(("gprtGeVLANPortTagging Called.\n"));
    /* translate LPORT to hardware port */
    hwPort = GT_LPORT_2_PORT(port);
    /* Get the VLANPortTagging bit.  */
    retVal = hwGetPortRegField(dev,hwPort, QD_REG_PORT_CONTROL,11,1,&data);
    /* translate binary to BOOL  */
    BIT_2_BOOL(data, *PortTag);
    if(retVal != GT_OK)
        DBG_INFO(("Failed.\n"));
    else
        DBG_INFO(("OK.\n"));

    return retVal;
}


/*******************************************************************************
* gprtSetVLANPortTagging
*
* DESCRIPTION:
*       This routine sets the VLANPortTagging bit
*
* INPUTS:
*       port  - the logical port number.
*       PortTag - GT_TRUE for VLAN Port Tagging on or GT_FALSE otherwise
*
* OUTPUTS:
*       None.
*
* RETURNS:
*       GT_OK   - on success
*       GT_FAIL - on error
*
* COMMENTS:
*
*
* GalTis:
*
*******************************************************************************/
GT_STATUS gprtSetVLANPortTagging
(
    IN GT_QD_DEV  *dev,
    IN GT_LPORT   port,
    IN GT_BOOL    PortTag
)
{
    GT_U16          data;           /* Used to poll the SWReset bit */
    GT_STATUS       retVal;         /* Functions return value.      */
    GT_U8           hwPort;         /* the physical port number     */
    GT_PORT_STP_STATE  state;

    DBG_INFO(("gprtSetVLANPortTagging Called.\n"));

	/* Port should be disabled before Set Force Flow Control bit */
	retVal = gstpGetPortState(dev,port, &state);
    if(retVal != GT_OK)
	{
	    DBG_INFO(("gstpGetPortState failed.\n"));
		return retVal;
	}

	retVal = gstpSetPortState(dev,port, GT_PORT_DISABLE);
    if(retVal != GT_OK)
	{
	    DBG_INFO(("gstpSetPortState failed.\n"));
		return retVal;
	}

    /* translate BOOL to binary */
    BOOL_2_BIT(PortTag, data);
    /* translate LPORT to hardware port */
    hwPort = GT_LPORT_2_PORT(port);

    /* Set the VLAN Port Tag control bit.  */
    retVal = hwSetPortRegField(dev,hwPort, QD_REG_PORT_CONTROL,11,1,data);
    if(retVal != GT_OK)
        DBG_INFO(("Failed.\n"));
    else
        DBG_INFO(("OK.\n"));

	/* Restore original stp state. */
	if(gstpSetPortState(dev,port, state) != GT_OK)
	{
	    DBG_INFO(("gstpSetPortState failed.\n"));
		return GT_FAIL;
	}

    return retVal;
}



/*******************************************************************************
* gprtSetTrailerMode
*
* DESCRIPTION:
*       This routine set the egress trailer mode.
*
* INPUTS:
*       port - the logical port number.
*       mode - GT_TRUE for add trailer or GT_FALSE otherwise
*
* OUTPUTS:
*       None.
*
* RETURNS:
*       GT_OK   - on success
*       GT_FAIL - on error
*
* COMMENTS:
*
*
* GalTis:
*
*******************************************************************************/
GT_STATUS gprtSetTrailerMode
(
    IN GT_QD_DEV  *dev,
    IN GT_LPORT   port,
    IN GT_BOOL    mode
)
{
    GT_U16          data;           /* Used to poll the SWReset bit */
    GT_STATUS       retVal;         /* Functions return value.      */
    GT_U8           hwPort;         /* the physical port number     */

    DBG_INFO(("gprtSetTrailerMode Called.\n"));

    /* check if device supports this feature */
	if (!IS_IN_DEV_GROUP(dev,DEV_TRAILER|DEV_TRAILER_P5|DEV_TRAILER_P4P5))
	{
        DBG_INFO(("GT_NOT_SUPPORTED.\n"));
        return GT_NOT_SUPPORTED;
	}

    /* translate BOOL to binary */
    BOOL_2_BIT(mode, data);
    /* translate LPORT to hardware port */
    hwPort = GT_LPORT_2_PORT(port);

	if(hwPort < 4)
	{
	    /* check if device supports this feature for this port */
		if (IS_IN_DEV_GROUP(dev,DEV_TRAILER_P5|DEV_TRAILER_P4P5))
		{
	        DBG_INFO(("GT_NOT_SUPPORTED.\n"));
    	    return GT_NOT_SUPPORTED;
		}
	}
	else if(hwPort == 4)
	{
	    /* check if device supports this feature for this port*/
		if (IS_IN_DEV_GROUP(dev,DEV_TRAILER_P5))
		{
	        DBG_INFO(("GT_NOT_SUPPORTED.\n"));
    	    return GT_NOT_SUPPORTED;
		}
	}

    /* Set the trailer mode.            */
    retVal = hwSetPortRegField(dev,hwPort, QD_REG_PORT_CONTROL,14,1,data);

    if(retVal != GT_OK)
        DBG_INFO(("Failed.\n"));
    else
        DBG_INFO(("OK.\n"));
    return retVal;
}



/*******************************************************************************
* gprtGetTrailerMode
*
* DESCRIPTION:
*       This routine get the egress trailer mode.
*
* INPUTS:
*       port  - the logical port number.
*
* OUTPUTS:
*       mode - GT_TRUE for add trailer or GT_FALSE otherwise
*
* RETURNS:
*       GT_OK   - on success
*       GT_FAIL - on error
*
* COMMENTS:
*
*
* GalTis:
*
*******************************************************************************/
GT_STATUS gprtGetTrailerMode
(
    IN  GT_QD_DEV  *dev,
    IN  GT_LPORT   port,
    OUT GT_BOOL    *mode
)
{
    GT_U16          data;           /* Used to poll the SWReset bit */
    GT_STATUS       retVal;         /* Functions return value.      */
    GT_U8           hwPort;         /* the physical port number     */

    DBG_INFO(("gprtGetTrailerMode Called.\n"));

    /* check if device supports this feature */
	if (!IS_IN_DEV_GROUP(dev,DEV_TRAILER|DEV_TRAILER_P5|DEV_TRAILER_P4P5))
	{
        DBG_INFO(("GT_NOT_SUPPORTED.\n"));
        return GT_NOT_SUPPORTED;
	}

    /* translate LPORT to hardware port */
    hwPort = GT_LPORT_2_PORT(port);

	if(hwPort < 4)
	{
	    /* check if device supports this feature for this port */
		if (IS_IN_DEV_GROUP(dev,DEV_TRAILER_P5|DEV_TRAILER_P4P5))
		{
	        DBG_INFO(("GT_NOT_SUPPORTED.\n"));
    	    return GT_NOT_SUPPORTED;
		}
	}
	else if(hwPort == 4)
	{
	    /* check if device supports this feature for this port */
		if (IS_IN_DEV_GROUP(dev,DEV_TRAILER_P5))
		{
	        DBG_INFO(("GT_NOT_SUPPORTED.\n"));
    	    return GT_NOT_SUPPORTED;
		}
	}

    /* Get the Trailer mode.            */
    retVal = hwGetPortRegField(dev,hwPort, QD_REG_PORT_CONTROL,14,1,&data);
    /* translate binary to BOOL  */
    BIT_2_BOOL(data, *mode);
    if(retVal != GT_OK)
        DBG_INFO(("Failed.\n"));
    else
        DBG_INFO(("OK.\n"));

    return retVal;
}




/*******************************************************************************
* gprtSetIngressMode
*
* DESCRIPTION:
*       This routine set the ingress mode.
*
* INPUTS:
*       port - the logical port number.
*       mode - the ingress mode.
*
* OUTPUTS:
*       None.
*
* RETURNS:
*       GT_OK   - on success
*       GT_FAIL - on error
*
* COMMENTS:
*
*
* GalTis:
*
*******************************************************************************/
GT_STATUS gprtSetIngressMode
(
    IN  GT_QD_DEV      *dev,
    IN GT_LPORT        port,
    IN GT_INGRESS_MODE mode
)
{
    GT_STATUS       retVal;         /* Functions return value.      */
    GT_U8           hwPort;         /* the physical port number     */

    DBG_INFO(("gprtSetIngressMode Called.\n"));
    /* translate LPORT to hardware port */
    hwPort = GT_LPORT_2_PORT(port);

#if 0
	/* 
	 * if IGMP/MLD Snooping is supported, 
	 * GT_TRAILER_INGRESS and GT_CPUPORT_INGRESS modes can be assigned only to
	 * CPU port.
	 */
    if(IS_IN_DEV_GROUP(dev,DEV_IGMP_SNOOPING))
	{
		if ((mode == GT_TRAILER_INGRESS) || (mode == GT_CPUPORT_INGRESS))
		{
			if(port != dev->cpuPortNum)
			{
			    DBG_INFO(("Given ingress mode is supported by CPU port only\n"));
				return GT_NOT_SUPPORTED;
			}
		}
	}
#endif

    /* Set the the Ingress Mode.        */
    retVal = hwSetPortRegField(dev,hwPort, QD_REG_PORT_CONTROL,8,2,(GT_U16)mode);
    if(retVal != GT_OK)
        DBG_INFO(("Failed.\n"));
    else
        DBG_INFO(("OK.\n"));

    return retVal;
}



/*******************************************************************************
* gprtGetIngressMode
*
* DESCRIPTION:
*       This routine get the ingress mode.
*
* INPUTS:
*       port  - the logical port number.
*
* OUTPUTS:
*       mode - the ingress mode.
*
* RETURNS:
*       GT_OK   - on success
*       GT_FAIL - on error
*
* COMMENTS:
*
*
* GalTis:
*
*******************************************************************************/
GT_STATUS gprtGetIngressMode
(
    IN  GT_QD_DEV      *dev,
    IN  GT_LPORT        port,
    OUT GT_INGRESS_MODE *mode
)
{
    GT_STATUS       retVal;         /* Functions return value.      */
    GT_U8           hwPort;         /* the physical port number     */
    GT_U16          data;           /* to keep the read valve       */

    DBG_INFO(("gprtGetIngressMode Called.\n"));
    /* translate LPORT to hardware port */
    hwPort = GT_LPORT_2_PORT(port);
    /* Get the Ingress Mode.            */
    retVal = hwGetPortRegField(dev,hwPort, QD_REG_PORT_CONTROL, 8, 2,&data);
    *mode = data;
    if(retVal != GT_OK)
        DBG_INFO(("Failed.\n"));
    else
        DBG_INFO(("OK.\n"));

    return retVal;
}



/*******************************************************************************
* gprtSetMcRateLimit
*
* DESCRIPTION:
*       This routine set the port multicast rate limit.
*
* INPUTS:
*       port - the logical port number.
*       rate - GT_TRUE to Enable, GT_FALSE for otherwise.
*
* OUTPUTS:
*       None.
*
* RETURNS:
*       GT_OK   - on success
*       GT_FAIL - on error
*
* COMMENTS:
*
*
* GalTis:
*
*******************************************************************************/
GT_STATUS gprtSetMcRateLimit
(
    IN  GT_QD_DEV   *dev,
    IN GT_LPORT     port,
    IN GT_MC_RATE   rate
)
{
    GT_STATUS       retVal;         /* Functions return value.      */
    GT_U8           hwPort;         /* the physical port number     */

    DBG_INFO(("gprtSetMcRateLimit Called.\n"));

    /* translate LPORT to hardware port */
    hwPort = GT_LPORT_2_PORT(port);

    /* this feature only exits in 6051, 6052, and 6012. It is replace with
     * Rate Cotrol Register in the future products, starting from clippership
     */
    if((retVal = IS_VALID_API_CALL(dev,hwPort, DEV_MC_RATE_PERCENT)) != GT_OK)
        return retVal;

    /* Set the multicast rate limit.    */
    retVal = hwSetPortRegField(dev,hwPort, QD_REG_PORT_CONTROL,2,2,(GT_U16)rate);
    if(retVal != GT_OK)
        DBG_INFO(("Failed.\n"));
    else
        DBG_INFO(("OK.\n"));

    return retVal;
}



/*******************************************************************************
* gprtGetMcRateLimit
*
* DESCRIPTION:
*       This routine Get the port multicast rate limit.
*
* INPUTS:
*       port - the logical port number.
*
* OUTPUTS:
*       rate - GT_TRUE to Enable, GT_FALSE for otherwise.
*
* RETURNS:
*       GT_OK   - on success
*       GT_FAIL - on error
*
* COMMENTS:
*
*
* GalTis:
*
*******************************************************************************/
GT_STATUS gprtGetMcRateLimit
(
    IN  GT_QD_DEV   *dev,
    IN  GT_LPORT    port,
    OUT GT_MC_RATE  *rate
)
{
    GT_STATUS       retVal;         /* Functions return value.      */
    GT_U8           hwPort;         /* the physical port number     */
    GT_U16          data;           /* to keep the read data        */

    DBG_INFO(("gprtGetMcRateLimit Called.\n"));

    /* translate LPORT to hardware port */
    hwPort = GT_LPORT_2_PORT(port);

    /* this feature only exits in 6051, 6052, and 6012. It is replace with
     * Rate Cotrol Register in the future products, starting from clippership
     */
    if((retVal = IS_VALID_API_CALL(dev,hwPort, DEV_MC_RATE_PERCENT)) != GT_OK)
        return retVal;

    /* Get the multicast rate limit.    */
    retVal = hwGetPortRegField(dev,hwPort, QD_REG_PORT_CONTROL, 2, 2,&data);
    *rate = data;
    if(retVal != GT_OK)
        DBG_INFO(("Failed.\n"));
    else
        DBG_INFO(("OK.\n"));
    return retVal;
}


/* the following two APIs are added to support fullsail and clippership */

/*******************************************************************************
* gprtSetIGMPSnoop
*
* DESCRIPTION:
*       This routine set the IGMP Snoop. When set to one and this port receives
*       IGMP frame, the frame is switched to the CPU port, overriding all other 
*     	switching decisions, with exception for CPU's Trailer.
*
* INPUTS:
*       port - the logical port number.
*       mode - GT_TRUE for IGMP Snoop or GT_FALSE otherwise
*
* OUTPUTS:
*       None.
*
* RETURNS:
*       GT_OK   - on success
*       GT_FAIL - on error
*
* COMMENTS: 
*
* GalTis:
*
*******************************************************************************/
GT_STATUS gprtSetIGMPSnoop
(
    IN  GT_QD_DEV   *dev,
    IN GT_LPORT     port,
    IN GT_BOOL      mode
)
{
    GT_U16          data;           /* Used to poll the SWReset bit */
    GT_STATUS       retVal;         /* Functions return value.      */
    GT_U8           hwPort;         /* the physical port number     */

    DBG_INFO(("gprtSetIGMPSnoop Called.\n"));

    /* translate LPORT to hardware port */
    hwPort = GT_LPORT_2_PORT(port);

    /* check if device supports this feature */
    if((retVal = IS_VALID_API_CALL(dev,hwPort, DEV_IGMP_SNOOPING)) != GT_OK)
      return retVal;

    /* translate BOOL to binary */
    BOOL_2_BIT(mode, data);

    /* Set the trailer mode.            */
    retVal = hwSetPortRegField(dev,hwPort, QD_REG_PORT_CONTROL,10,1, data);

    if(retVal != GT_OK)
        DBG_INFO(("Failed.\n"));
    else
        DBG_INFO(("OK.\n"));
    return retVal;
}



/*******************************************************************************
* gprtGetIGMPSnoop
*
* DESCRIPTION:
*       This routine get the IGMP Snoop mode.
*
* INPUTS:
*       port  - the logical port number.
*
* OUTPUTS:
*       mode - GT_TRUE: IGMP Snoop enabled
*	       GT_FALSE otherwise
*
* RETURNS:
*       GT_OK   - on success
*       GT_FAIL - on error
*
* COMMENTS:
*
* GalTis:
*
*******************************************************************************/
GT_STATUS gprtGetIGMPSnoop
(
    IN  GT_QD_DEV   *dev,
    IN  GT_LPORT    port,
    OUT GT_BOOL     *mode
)
{
    GT_STATUS       retVal;         /* Functions return value.      */
    GT_U8           hwPort;         /* the physical port number     */
    GT_U16          data;           /* to keep the read valve       */

    DBG_INFO(("gprtGetIGMPSnoop Called.\n"));

    /* translate LPORT to hardware port */
    hwPort = GT_LPORT_2_PORT(port);

    /* check if device supports this feature */
    if((retVal = IS_VALID_API_CALL(dev,hwPort, DEV_IGMP_SNOOPING)) != GT_OK)
      return retVal;

    /* Get the Ingress Mode.            */
    retVal = hwGetPortRegField(dev,hwPort, QD_REG_PORT_CONTROL, 10, 1, &data);

    /* translate binary to BOOL  */
    BIT_2_BOOL(data, *mode);
    if(retVal != GT_OK)
        DBG_INFO(("Failed.\n"));
    else
        DBG_INFO(("OK.\n"));

    return retVal;
}

/* the following two APIs are added to support clippership */

/*******************************************************************************
* gprtSetHeaderMode
*
* DESCRIPTION:
*       This routine set ingress and egress header mode of a switch port. 
*
* INPUTS:
*       port - the logical port number.
*       mode - GT_TRUE for header mode  or GT_FALSE otherwise
*
* OUTPUTS:
*       None.
*
* RETURNS:
*       GT_OK   - on success
*       GT_FAIL - on error
*
* COMMENTS: 
*
* GalTis:
*
*******************************************************************************/
GT_STATUS gprtSetHeaderMode
(
    IN  GT_QD_DEV   *dev,
    IN GT_LPORT     port,
    IN GT_BOOL      mode
)
{
    GT_U16          data;           /* Used to poll the SWReset bit */
    GT_STATUS       retVal;         /* Functions return value.      */
    GT_U8           hwPort;         /* the physical port number     */

    DBG_INFO(("gprtSetHeaderMode Called.\n"));

    /* only devices beyond quarterdeck (6052) has this feature */
    /* Fullsail (DEV_QD_88E6502) is an exception, and does not support this feature */
    if(IS_VALID_API_CALL(dev,port, DEV_HEADER|DEV_HEADER_P5|DEV_HEADER_P4P5) != GT_OK)
	{
        DBG_INFO(("GT_NOT_SUPPORTED.\n"));
        return GT_NOT_SUPPORTED;
	}

    /* translate BOOL to binary */
    BOOL_2_BIT(mode, data);

    /* translate LPORT to hardware port */
    hwPort = GT_LPORT_2_PORT(port);

	if(hwPort < 4)
	{
		if (IS_IN_DEV_GROUP(dev,DEV_HEADER_P5|DEV_HEADER_P4P5))
		{
	        DBG_INFO(("GT_NOT_SUPPORTED.\n"));
    	    return GT_NOT_SUPPORTED;
		}
	}
	else if(hwPort == 4)
	{
		if (IS_IN_DEV_GROUP(dev,DEV_HEADER_P5))
		{
	        DBG_INFO(("GT_NOT_SUPPORTED.\n"));
    	    return GT_NOT_SUPPORTED;
		}
	}

    /* Set the header mode.            */
    retVal = hwSetPortRegField(dev,hwPort, QD_REG_PORT_CONTROL,11,1, data);

    if(retVal != GT_OK)
        DBG_INFO(("Failed.\n"));
    else
        DBG_INFO(("OK.\n"));
    return retVal;
}



/*******************************************************************************
* gprtGetHeaderMode
*
* DESCRIPTION:
*       This routine gets ingress and egress header mode of a switch port. 
*
* INPUTS:
*       port  - the logical port number.
*
* OUTPUTS:
*       mode - GT_TRUE: header mode enabled
*	       GT_FALSE otherwise
*
* RETURNS:
*       GT_OK   - on success
*       GT_FAIL - on error
*
* COMMENTS:
*
* GalTis:
*
*******************************************************************************/
GT_STATUS gprtGetHeaderMode
(
    IN  GT_QD_DEV   *dev,
    IN  GT_LPORT    port,
    OUT GT_BOOL     *mode
)
{
    GT_STATUS       retVal;         /* Functions return value.      */
    GT_U8           hwPort;         /* the physical port number     */
    GT_U16          data;           /* to keep the read valve       */

    DBG_INFO(("gprtGetHeaderMode Called.\n"));

    /* only devices beyond quarterdeck (6052) has this feature */
    /* Fullsail (DEV_QD_88E602) is an exception, and does not support this feature */
    if(IS_VALID_API_CALL(dev,port, DEV_HEADER|DEV_HEADER_P5|DEV_HEADER_P4P5) != GT_OK)
	{
        DBG_INFO(("GT_NOT_SUPPORTED.\n"));
        return GT_NOT_SUPPORTED;
	}

    /* translate LPORT to hardware port */
    hwPort = GT_LPORT_2_PORT(port);

	if(hwPort < 4)
	{
		if (IS_IN_DEV_GROUP(dev,DEV_HEADER_P5|DEV_HEADER_P4P5))
		{
	        DBG_INFO(("GT_NOT_SUPPORTED.\n"));
    	    return GT_NOT_SUPPORTED;
		}
	}
	else if(hwPort == 4)
	{
		if (IS_IN_DEV_GROUP(dev,DEV_HEADER_P5))
		{
	        DBG_INFO(("GT_NOT_SUPPORTED.\n"));
    	    return GT_NOT_SUPPORTED;
		}
	}

    /* Get the Header Mode.            */
    retVal = hwGetPortRegField(dev,hwPort, QD_REG_PORT_CONTROL, 11, 1, &data);

    /* translate binary to BOOL  */
    BIT_2_BOOL(data, *mode);
    if(retVal != GT_OK)
        DBG_INFO(("Failed.\n"));
    else
        DBG_INFO(("OK.\n"));

    return retVal;
}

//#include <Copyright.h>

/********************************************************************************
* gtPortStat.c
*
* DESCRIPTION:
*       API implementation for switch port rx/tx counters.
*
* DEPENDENCIES:
*
* FILE REVISION NUMBER:
*******************************************************************************/

#include <msApi.h>
#include <gtHwCntl.h>
#include <gtDrvSwRegs.h>


/*******************************************************************************
* gprtSetCtrMode
*
* DESCRIPTION:
*       This routine sets the port rx/tx counters mode of operation.
*
* INPUTS:
*       mode  - the counter mode.
*
* OUTPUTS:
*       None.
*
* RETURNS:
*       GT_OK   - on success
*       GT_FAIL - on error
*
* COMMENTS:
*
*
* GalTis:
*
*******************************************************************************/
GT_STATUS gprtSetCtrMode
(
    IN GT_QD_DEV    *dev,
    IN GT_CTR_MODE  mode
)
{
    GT_STATUS       retVal;         /* Functions return value.      */

    DBG_INFO(("gprtSetCtrMode Called.\n"));
    retVal = hwSetGlobalRegField(dev,QD_REG_GLOBAL_CONTROL,8,1,(GT_U16)mode);
    if(retVal != GT_OK)
    {
        DBG_INFO(("gprtSetCtrMode Failed .\n"));
        return GT_FAIL;
    }

    DBG_INFO(("gprtSetCtrMode OK .\n"));
    return retVal;
}



/*******************************************************************************
* gprtClearAllCtr
*
* DESCRIPTION:
*       This routine clears all port rx/tx counters.
*
* INPUTS:
*       None.
*
* OUTPUTS:
*       None.
*
* RETURNS:
*       GT_OK   - on success
*       GT_FAIL - on error
*
* COMMENTS:
*
*
* GalTis:
*
*******************************************************************************/
GT_STATUS gprtClearAllCtr
(
    IN GT_QD_DEV    *dev
)
{
    IN GT_STATUS     retVal;         /* Functions return value.      */
    IN GT_U16        mode;           /* hold counters current mode   */

    DBG_INFO(("gprtClearAllCtr Called.\n"));
    /* get counter current mode  */
    if(hwGetGlobalRegField(dev,QD_REG_GLOBAL_CONTROL,8,1,&mode) != GT_OK)
    {
        DBG_INFO(("Failed (Get field).\n"));
        return GT_FAIL;
    }
    /* write opposite value to reset counter */
    if(hwSetGlobalRegField(dev,QD_REG_GLOBAL_CONTROL,8,1,(GT_U16)(1 - mode)) != GT_OK)
    {
        DBG_INFO(("Failed (Get field).\n"));
        return GT_FAIL;
    }
    /* restore counters mode */
    retVal = hwSetGlobalRegField(dev,QD_REG_GLOBAL_CONTROL,8,1,mode);

    DBG_INFO(("OK.\n"));
    return retVal;
}



/*******************************************************************************
* gprtGetPortCtr
*
* DESCRIPTION:
*       This routine gets the port rx/tx counters.
*
* INPUTS:
*       port  - the logical port number.
*
* OUTPUTS:
*       ctr - the counters value.
*
* RETURNS:
*       GT_OK   - on success
*       GT_FAIL - on error
*
* COMMENTS:
*
*
* GalTis:
*
*******************************************************************************/
GT_STATUS gprtGetPortCtr
(
    IN  GT_QD_DEV       *dev,
    IN  GT_LPORT        port,
    OUT GT_PORT_STAT    *ctr
)
{
    GT_U16          count;          /* counters current value       */
    GT_U8           hwPort;         /* physical port number         */

    DBG_INFO(("gprtGetPortCtr Called.\n"));

    if(ctr  == NULL)
    {
        DBG_INFO(("Failed.\n"));
        return GT_BAD_PARAM;
    }

    if(ctr  == NULL)
    {
        DBG_INFO(("Failed.\n"));
        return GT_BAD_PARAM;
    }
    /* translate logical port to physical port */
    hwPort = GT_LPORT_2_PORT(port);

    /* get rx counter value  */
    if(hwReadPortReg(dev,hwPort, QD_REG_RX_COUNTER, &count) != GT_OK)
    {
        DBG_INFO(("Failed (Read Rx).\n"));
        return GT_FAIL;
    }
    ctr->rxCtr = count;
    /* get tx counter value  */
    if(hwReadPortReg(dev,hwPort, QD_REG_TX_COUNTER, &count) != GT_OK)
    {
        DBG_INFO(("Failed (Read Tx).\n"));
        return GT_FAIL;
    }
    ctr->txCtr = count;

    DBG_INFO(("OK.\n"));
    return GT_OK;
}

#ifdef DEBUG_FEATURE /* this is a debug feature*/
/*******************************************************************************
* gprtGetPortQueueCtr
*
* DESCRIPTION:
*       This routine gets the port queue counters.
*
* INPUTS:
*       port  - the logical port number.
*
* OUTPUTS:
*       ctr - the counters value.
*
* RETURNS:
*       GT_OK   - on success
*       GT_FAIL - on error
*
* COMMENTS: 
*
*
* GalTis:
*
*******************************************************************************/
GT_STATUS gprtGetPortQueueCtr
(
    IN  GT_QD_DEV       *dev,
    IN  GT_LPORT        port,
    OUT GT_PORT_Q_STAT  *ctr
)
{
    GT_U16          count;          /* counters current value       */
    GT_U8           hwPort;         /* physical port number         */

    DBG_INFO(("gprtGetPortQueueCtr Called.\n"));

    if(ctr  == NULL)
    {
        DBG_INFO(("Failed.\n"));
        return GT_BAD_PARAM;
    }

    /* translate logical port to physical port */
    hwPort = GT_LPORT_2_PORT(port);

    /* get queue counter value  */
    if(hwReadPortReg(dev,hwPort, QD_REG_Q_COUNTER, &count) != GT_OK)
    {
        DBG_INFO(("Failed (Read Rx).\n"));
        return GT_FAIL;
    }

    /* the fist 5 bits(4:0) are OutQ_Size */
    ctr->OutQ_Size = count & 0x1F;

    /* the Rsv_Size are bits 15:8 */
    ctr->Rsv_Size  = count >> 8;

    DBG_INFO(("OK.\n"));
    return GT_OK;
}
#endif 
/*******************************************************************************
*                   Copyright 2002, GALILEO TECHNOLOGY, LTD.                   *
* THIS CODE CONTAINS CONFIDENTIAL INFORMATION OF MARVELL.                      *
* NO RIGHTS ARE GRANTED HEREIN UNDER ANY PATENT, MASK WORK RIGHT OR COPYRIGHT  *
* OF MARVELL OR ANY THIRD PARTY. MARVELL RESERVES THE RIGHT AT ITS SOLE        *
* DISCRETION TO REQUEST THAT THIS CODE BE IMMEDIATELY RETURNED TO MARVELL.     *
* THIS CODE IS PROVIDED "AS IS". MARVELL MAKES NO WARRANTIES, EXPRESSED,       *
* IMPLIED OR OTHERWISE, REGARDING ITS ACCURACY, COMPLETENESS OR PERFORMANCE.   *
*                                                                              *
* MARVELL COMPRISES MARVELL TECHNOLOGY GROUP LTD. (MTGL) AND ITS SUBSIDIARIES, *
* MARVELL INTERNATIONAL LTD. (MIL), MARVELL TECHNOLOGY, INC. (MTI), MARVELL    *
* SEMICONDUCTOR, INC. (MSI), MARVELL ASIA PTE LTD. (MAPL), MARVELL JAPAN K.K.  *
* (MJKK), GALILEO TECHNOLOGY LTD. (GTL) AND GALILEO TECHNOLOGY, INC. (GTI).    *
********************************************************************************
* gtDesc.c  
*
* DESCRIPTION:                                                                 
*       MPSC and Ethernet descriptors related functions.
*
* DEPENDENCIES:
*
*******************************************************************************/

/* includes */
#include "gtDesc.h"
        
/*******************************************************************************
* gtDescInitRxChain - Initialize a chain of descriptors for RX.
*
* DESCRIPTION:
*           Initialize a chain of descriptors for RX.
*
* INPUT:
*           numOfDesc - number of descriptors in chain                            
*           firstRxDescAddr - address of first desc                            
*           firstRxBufferAddr - address of first buffer                                   
*           rxBufferSize - buffer size (in bytes)  
*           cmdStsWord  - A word to be written in all descs' command word. Use
*                         defines in gtDesc.h to set bits. 
*           command - Create a cyclic chain or not - use defines in gtDesc.h                      
*
* OUTPUT:
*           None.
*
* RETURN:
*           DESC_INIT_STATUS word that determines if the initialization
*           succeeded. In case of failure it determines the exact failure 
*           reason. 
*
*******************************************************************************/
DESC_INIT_STATUS gtDescInitRxChain(unsigned int numOfDesc, 
                                   unsigned int firstRxDescAddr,
                                   unsigned int firstRxBufferAddr,
                                   unsigned int rxBufferSize,
                                   unsigned int cmdStsWord,
				   DESC_COMMAND command)
{
    unsigned int    i;
    unsigned int    bufferAddr;
    RX_DESC*        rxPointer;
    bool            cyclic = false;
    /* mask firstRxBufferAddr except 3 lsb */
    i = (firstRxBufferAddr & (0x00000007));     
    if(i != 0x0)
    {
        return BUFFERS_BASE_NOT_ALLINGED;
    }
    i = (firstRxDescAddr & (0x0000000f));     
    if(i != 0x0)
    {
        return DESCS_BASE_NOT_ALLINGED;
    }
    if(rxBufferSize > 0x10000)
    {
        return BUFFER_TOO_BIG;
    }
    
    if(command & CREATE_CYCLIC_CHAIN)
    {
        cyclic = true;
    }

    rxPointer = (RX_DESC*)PHY_TO_VIRTUAL(firstRxDescAddr);
    bufferAddr = PHY_TO_VIRTUAL(firstRxBufferAddr);
    for(i = 0; i < numOfDesc; i++)
    {
        if((bufferAddr & 0x00000007) != 0x0)
        {
          /* round up Address to closest allinged address */
          bufferAddr = bufferAddr + 8 - (bufferAddr & 0x00000007);  
        }
        rxPointer[i].cmd_sts =  cmdStsWord; 
        /* buffer size */
        rxPointer[i].bufsize = rxBufferSize;
        /* initialize counter */
        rxPointer[i].bytecnt = 0;    
        /* buffer pointer */
        rxPointer[i].buf_ptr = VIRTUAL_TO_PHY(bufferAddr);
        /* pointer to next descriptor */
        rxPointer[i].next_desc_ptr = VIRTUAL_TO_PHY(firstRxDescAddr + (i+1) * 
                                                    DESC_SIZE);
        bufferAddr += rxBufferSize;
    }

    if (cyclic)
    {
        /* make the descriptors chain cyclic */
        rxPointer[i-1].next_desc_ptr = VIRTUAL_TO_PHY(firstRxDescAddr);
    }
    else
    {
        rxPointer[i-1].next_desc_ptr = 0;
    }

    return DESC_INIT_SUCCESS;
}


/*******************************************************************************
* gtDescInitTxChain - Initialize a chain of descriptors for TX.
*
* DESCRIPTION:
*          Iinitialize a chain of descriptors for TX.
*
* INPUT:
*           numOfDesc - num of descriptors in chain                            
*           firstTxDescAddr - address of first desc                            
*           firstTxBufferAddr - address of first buffer                                   
*           txBufferSize - buffer size (in bytes)  
*           cmdStsWord  - A word to be written in all descs' command word. Use
*           defines in gtDesc.h to set bits. 
*           command - Create a cyclic chain or not - use defines in gtDesc.h                      
*
* OUTPUT:
*           None.
*
* RETURN:
*           DESC_INIT_STATUS word that determines if the initialization
*           succeeded. In case of failure it determines the exact failure 
*           reason. 
*
*******************************************************************************/
DESC_INIT_STATUS gtDescInitTxChain(unsigned int numOfDesc, 
                                   unsigned int firstTxDescAddr,
                                   unsigned int firstTxBufferAddr,
                                   unsigned int txBufferSize,
                                   unsigned int cmdStsWord,
		         	   DESC_COMMAND command, 
                                   unsigned int numOfBufPerPacket)
{

    unsigned int    i;
    unsigned int    bufferAddr;
    TX_DESC*        txPointer;
    bool            cyclic = false;
    
    /* The following check is WWWWWRRRRRRRRROOOONNNNNNNNNNGGGGGGG - Rabeeh */
    /*    i = (firstTxBufferAddr & (0x00000007));     
	  if(i != 0x0)
	  {
	  return BUFFERS_BASE_NOT_ALLINGED;
	  }*/
    
    i = (firstTxDescAddr & (0x0000000f));     
    if(i != 0x0)
    {
        return DESCS_BASE_NOT_ALLINGED;
    }
    if(txBufferSize > 0x10000)
    {
        return BUFFER_TOO_BIG;
    }

    if(numOfBufPerPacket == 0 || numOfBufPerPacket > numOfDesc)
    {
        return WRONG_NUM_OF_BUFFERS_PER_PACKET;
    }
    
    if(command & CREATE_CYCLIC_CHAIN)
    {                         
        cyclic = true;
    }

    txPointer = (TX_DESC*)PHY_TO_VIRTUAL(firstTxDescAddr);
    bufferAddr = PHY_TO_VIRTUAL(firstTxBufferAddr);
    for(i = 0; i < numOfDesc; i++)
    {
      /* The following check is WRONG - Rabeeh */
      //        if((bufferAddr & 0x00000007) != 0x0)
      //        {
      //            /* round up Address to closest allinged address */
      //            bufferAddr = bufferAddr + 8 - (bufferAddr & 0x00000007);  
      //        }
        txPointer[i].cmd_sts =  cmdStsWord;
        /* buffer size */
        txPointer[i].bytecnt = txBufferSize;
        /* shadow size - relevant only in mpsc desc */
        txPointer[i].shadow = txBufferSize;
        /* buffer pointer */
        txPointer[i].buf_ptr = VIRTUAL_TO_PHY(bufferAddr);
        /* pointer to next descriptor */
        txPointer[i].next_desc_ptr = VIRTUAL_TO_PHY(firstTxDescAddr + 
                                                    (i+1)*DESC_SIZE);
        bufferAddr += txBufferSize;
    }
    if (cyclic)
    {
        /* make the descriptors chain cyclic */
        txPointer[i-1].next_desc_ptr = VIRTUAL_TO_PHY(firstTxDescAddr);
    }
    else
    {
        txPointer[i-1].next_desc_ptr = 0;
    }

    /* set First and last flags */
    txPointer = (TX_DESC*)PHY_TO_VIRTUAL(firstTxDescAddr);
    for(i = 0 ; i < numOfDesc ; i+=numOfBufPerPacket)
    {
        txPointer[i].cmd_sts = txPointer[i].cmd_sts | DESC_FIRST;
        if(i + numOfBufPerPacket - 1 > numOfDesc - 1)
        {
            txPointer[numOfDesc - 1].cmd_sts = 
                txPointer[numOfDesc - 1].cmd_sts | DESC_LAST;
            break;
        }
        txPointer[i + numOfBufPerPacket - 1].cmd_sts = 
            txPointer[i + numOfBufPerPacket - 1].cmd_sts | DESC_LAST;
    }
    return DESC_INIT_SUCCESS;
}
/*******************************************************************************
* gtDescGetTxOwnership - returns desc ownership
*
* DESCRIPTION:
*           Checks ownership bit in desc status word to determine its ownership.      
*
* INPUT:
*      descAddr - address of the tx desc to be checked.
*
* OUTPUT:
*      None.
*
* RETURN:
*     DESC_OWNER_IS_GT - if owned by gt. 
*     DESC_OWNER_IS_CPU - if owned by cpu. 
*
*******************************************************************************/
DESC_OWNER gtDescGetTxOwnership(unsigned int descAddr)
{
    TX_DESC*     desc = (TX_DESC*)PHY_TO_VIRTUAL(descAddr);
    unsigned int cmd_sts;

    cmd_sts = desc->cmd_sts;
    if(cmd_sts & DESC_OWNED_BY_GT)
    {
        return DESC_OWNER_IS_GT;
    }
    return DESC_OWNER_IS_CPU;
}

/*******************************************************************************
* gtDescGetRxOwnership - returns desc ownership
*
* DESCRIPTION:
*           Checks ownership bit in desc status word to determine its ownership.      
*
* INPUT:
*      descAddr - address of the rx desc to be checked.
*
* OUTPUT:
*      None.
*
* RETURN:
*     DESC_OWNER_IS_GT - if owned by gt. 
*     DESC_OWNER_IS_CPU - if owned by cpu. 
*
*******************************************************************************/
DESC_OWNER gtDescGetRxOwnership(unsigned int descAddr)
{
    RX_DESC*     desc = (RX_DESC*)PHY_TO_VIRTUAL(descAddr);
    unsigned int cmd_sts;

    cmd_sts = desc->cmd_sts;
    if(cmd_sts & DESC_OWNED_BY_GT)
    {
        return DESC_OWNER_IS_GT;
    }
    return DESC_OWNER_IS_CPU;
}

/******************************************************************************* 
* gtDescSetTxOwnedByGT - move all desc in chain to gt ownership
*
* DESCRIPTION:
*       Set ownership bit in all tx desc in chain.
*
* INPUT:
*       firstTxDescAddr - address of first descriptor in chain to be moved to gt 
*                         ownership.
*       numOfDesc - number of descriptors to be moved to gt ownership
*
* OUTPUT:
*       None.
*
* RETURN:
*       None.
*
*******************************************************************************/
void gtDescSetTxOwnedByGT(unsigned int firstTxDescAddr, unsigned int numOfDesc)
{
    int      i;
    TX_DESC* txPointer = (TX_DESC*)PHY_TO_VIRTUAL(firstTxDescAddr);
    for(i = 0; i < numOfDesc; i++)
    {
        txPointer->cmd_sts = txPointer->cmd_sts | DESC_OWNED_BY_GT;
        txPointer = (TX_DESC*)PHY_TO_VIRTUAL(txPointer->next_desc_ptr); 
    }
}


/******************************************************************************* 
* gtDescSetRxOwnedByGT - move all desc in chain to gt ownership
*
* DESCRIPTION:
*       Set ownership bit in all rx desc in chain.
*
* INPUT:
*       firstRxDescAddr - address of first descriptor in chain to be moved to gt 
*                         ownership.
*       numOfDesc - number of descriptors to be moved to gt ownership.
*
* OUTPUT:
*       None.
*
* RETURN:
*       None.
*
*******************************************************************************/
void gtDescSetRxOwnedByGT(unsigned int firstRxDescAddr,unsigned int numOfDesc)
{
    int      i;
    RX_DESC* rxPointer = (RX_DESC*)PHY_TO_VIRTUAL(firstRxDescAddr);
    for(i = 0; i < numOfDesc; i++)
    {
        rxPointer->cmd_sts = rxPointer->cmd_sts | DESC_OWNED_BY_GT;
        rxPointer = (RX_DESC*)PHY_TO_VIRTUAL(rxPointer->next_desc_ptr); 
    }
}


/*******************************************************************************
* gtDescIsOverRunSet - checks if overRun event has happened
*
* DESCRIPTION:
*       Checks in a chain of rx descriptors if OverRun bit is set in any of the
*       chains' descriptors status word        
*
* INPUT:
*       firstRxDescAddr - first desc to be checked.
*       numOfDesc - number of descs to be checked.
* OUTPUT:
*       None.
*
* RETURN:
*       true - if underRun bit is set in any of the descs.
*       false - otherwise.
*******************************************************************************/
bool gtDescIsOverRunSet(unsigned int firstRxDescAddr,
                        unsigned int numOfDesc)
{
    int      i;
    RX_DESC* rxPointer = (RX_DESC*)PHY_TO_VIRTUAL(firstRxDescAddr);
    for(i = 0; i < numOfDesc; i++)
    {
        if(rxPointer->cmd_sts & DESC_DATA_OVERRUN) return true;
        rxPointer = (RX_DESC*)PHY_TO_VIRTUAL(rxPointer->next_desc_ptr); 
    }
    return false;
}



/*******************************************************************************
* gtDescIsUnderRunSet - checks if underRun event has happened
*
* DESCRIPTION:
*       Checks in a chain of tx descriptors if underRun bit is set in any of the
*       chains' descriptors status word        
*
* INPUT:
*       firstTxDescAddr - first desc to be checked.
*       numOfDesc - number of descs to be checked.
*
* OUTPUT:
*       None.
*
* RETURN:
*       true - if underRun bit is set in any of the descs.
*       false - otherwise.
*******************************************************************************/
bool gtDescIsUnderRunSet(unsigned int firstTxDescAddr,
                         unsigned int numOfDesc)
{
    int      i;
    TX_DESC* txPointer = (TX_DESC*)PHY_TO_VIRTUAL(firstTxDescAddr);
    for(i = 0; i < numOfDesc; i++)
    {
        if(txPointer->cmd_sts & DESC_DATA_UNDERRUN) return true;
        txPointer = (TX_DESC*)PHY_TO_VIRTUAL(txPointer->next_desc_ptr); 
    }
    return false;
}

/*******************************************************************************
* gtDescInitTxChainForBisync - initialize a chain of descriptors for TX.
*
* DESCRIPTION:
*           Initialize a chain of descriptors for TX (only for bisync).
*
* INPUT:
*           bisyncMode - BISYNC_NORMAL,
*						 BISYNC_TRANSPARENT,
*						 BISYNC_AUTO_TRANSPARENT
*			numOfDesc - num od descriptors in chain.                            
*           firstTxDescAddr - address pf first desc.                            
*           firstTxBufferAddr - address of first buffer                                   
*           txBufferSize - buffer size (in bytes)  
*           cmdStsWord  - a word to be written in all descs' command word. use
*           defines in gtDesc.h to set bits. 
*           command - create a cyclic chain or not - use defines in gtDesc.h                      
*
* OUTPUT:
*           None.
*
* RETURN:
*           DESC_INIT_STATUS word that determines if the initialization
*           succeeded. In case of failure it determines the exact failure 
*           reason. 
*
*******************************************************************************/
DESC_INIT_STATUS gtDescInitTxChainForBisync(unsigned int bisyncMode,
											unsigned int numOfDesc, 
                                            unsigned int firstTxDescAddr,
                                            unsigned int firstTxBufferAddr,
                                            unsigned int txBufferSize,
                                            unsigned int cmdStsWord,
								            DESC_COMMAND command)
{

    unsigned int    i;
    unsigned int    bufferAddr;
    TX_DESC*        txPointer;
    bool            cyclic = false;
    
    i = (firstTxBufferAddr & (0x00000007));     
    if(i != 0x0)
    {
        return BUFFERS_BASE_NOT_ALLINGED;
    }
    i = (firstTxDescAddr & (0x0000000f));     
    if(i != 0x0)
    {
        return DESCS_BASE_NOT_ALLINGED;
    }
    if(txBufferSize > 0x10000)
    {
        return BUFFER_TOO_BIG;
    }

    if(command & CREATE_CYCLIC_CHAIN)
    {                         
        cyclic = true;
    }

    txPointer = (TX_DESC*)(firstTxDescAddr);
    bufferAddr = firstTxBufferAddr;
	
	/* Set the descriptors for BISYNC protocol. each original descriptor is
	   replace by three descriptors first for SOT and second for DATA 
	   and third for EOT */

    for(i = 0; i < 3 * numOfDesc; i=i+3)
    {
        if((bufferAddr & 0x00000007) != 0x0)
        {
            /* round up Address to closest allinged address */
            bufferAddr = bufferAddr + 8 - (bufferAddr & 0x00000007);  
        }
		/* Set first bisync descriptor */
		if(bisyncMode == BISYNC_NORMAL)
        {
			txPointer[i].cmd_sts =  cmdStsWord | DESC_FIRST | DESC_RESET_BCC;

        }

		if(bisyncMode == BISYNC_TRANSPARENT)
			txPointer[i].cmd_sts =  cmdStsWord | DESC_FIRST |
                                    DESC_TRANSMIT_DLE_BEFORE_BUFFER;

		if(bisyncMode == BISYNC_AUTO_TRANSPARENT)
			txPointer[i].cmd_sts =  cmdStsWord | DESC_FIRST | 
									DESC_TRANSMIT_DLE_BEFORE_BUFFER;
        /* buffer size */
        txPointer[i].bytecnt = 1;
        /* shadow size - relevant only in mpsc desc */
        txPointer[i].shadow = 1;
        /* buffer pointer */
        txPointer[i].buf_ptr = VIRTUAL_TO_PHY(bufferAddr);
        /* pointer to next descriptor */
        txPointer[i].next_desc_ptr = VIRTUAL_TO_PHY(firstTxDescAddr + (i+1) *
                                                    DESC_SIZE);
        bufferAddr += 8;

		/* Set second bisync descriptor */
		if(bisyncMode == BISYNC_NORMAL)
			txPointer[i+1].cmd_sts =  cmdStsWord | DESC_BCE_BCC_ENABLE;

		if(bisyncMode == BISYNC_TRANSPARENT)
			txPointer[i+1].cmd_sts =  cmdStsWord | DESC_BCE_BCC_ENABLE;

		if(bisyncMode == BISYNC_AUTO_TRANSPARENT)
			txPointer[i+1].cmd_sts =  cmdStsWord | DESC_BCE_BCC_ENABLE;

        /* buffer size */
        txPointer[i+1].bytecnt = txBufferSize;
        /* shadow size - relevant only in mpsc desc */
        txPointer[i+1].shadow = txBufferSize;
        /* buffer pointer */
        txPointer[i+1].buf_ptr = VIRTUAL_TO_PHY(bufferAddr);
        /* pointer to next descriptor */
        txPointer[i+1].next_desc_ptr = VIRTUAL_TO_PHY(firstTxDescAddr + 
                                                    (i+2)*DESC_SIZE);
        bufferAddr += txBufferSize;

		/* Set third bisync descriptor */
		if(bisyncMode == BISYNC_NORMAL)
			txPointer[i+2].cmd_sts =  cmdStsWord | DESC_BCE_BCC_ENABLE |
								      DESC_GENERATE_ERROR_CODE_TX | DESC_LAST;

		if(bisyncMode == BISYNC_TRANSPARENT)
			txPointer[i+2].cmd_sts =  cmdStsWord | DESC_BCE_BCC_ENABLE |
									  DESC_GENERATE_ERROR_CODE_TX | DESC_LAST |
									  DESC_TRANSMIT_DLE_BEFORE_BUFFER;

		if(bisyncMode == BISYNC_AUTO_TRANSPARENT)
			txPointer[i+2].cmd_sts =  cmdStsWord | DESC_BCE_BCC_ENABLE |
									  DESC_GENERATE_ERROR_CODE_TX | DESC_LAST |
									  DESC_TRANSMIT_DLE_BEFORE_BUFFER;
        /* buffer size */
        txPointer[i+2].bytecnt = 1;
        /* shadow size - relevant only in mpsc desc */
        txPointer[i+2].shadow = 1;
        /* buffer pointer */
        txPointer[i+2].buf_ptr = VIRTUAL_TO_PHY(bufferAddr);
        /* pointer to next descriptor */
        txPointer[i+2].next_desc_ptr = VIRTUAL_TO_PHY(firstTxDescAddr + (i+3) *
                                                      DESC_SIZE);
        bufferAddr += 8;
    }

    if (cyclic)
    {
        /* make the descriptors chain cyclic */
        txPointer[i-1].next_desc_ptr = VIRTUAL_TO_PHY(firstTxDescAddr);
    }
    else
    {
        txPointer[i-1].next_desc_ptr = 0;
    }

    return DESC_INIT_SUCCESS;
}



/*******************************************************************************
* gtDescInitTxChainForBisyncHeader - initialize a chain of descriptors for TX.
*									 with headers.
* DESCRIPTION:
*           Initialize a chain of descriptors for TX at bisync only.
*
* INPUT:
*           bisyncMode - BISYNC_NORMAL,
*						 BISYNC_TRANSPARENT,
*						 BISYNC_AUTO_TRANSPARENT
*			numOfDesc - num od descriptors in chain                            
*           firstTxDescAddr - address pf first desc                            
*           firstTxBufferAddr - address of first buffer                                   
*           txBufferSize - buffer size (in bytes)  
*           cmdStsWord  - a word to be written in all descs' command word. use
*           defines in gtDesc.h to set bits. 
*           command - create a cyclic chain or not - use defines in gtDesc.h                      
*
* OUTPUT:
*           None.
*
* RETURN:
*           DESC_INIT_STATUS word that determines if the initialization
*           succeeded. In case of failure it determines the exact failure 
*           reason. 
*s
*******************************************************************************/
DESC_INIT_STATUS gtDescInitTxChainForBisyncHeader(unsigned int bisyncMode,
											unsigned int numOfDesc, 
                                            unsigned int firstTxDescAddr,
                                            unsigned int firstTxBufferAddr,
                                            unsigned int txBufferSize,
                                            unsigned int cmdStsWord,
								            DESC_COMMAND command)
{

    unsigned int    i;
    unsigned int    bufferAddr;
    TX_DESC*        txPointer;
    bool            cyclic = false;
    
    i = (firstTxBufferAddr & (0x00000007));     
    if(i != 0x0)
    {
        return BUFFERS_BASE_NOT_ALLINGED;
    }
    i = (firstTxDescAddr & (0x0000000f));     
    if(i != 0x0)
    {
        return DESCS_BASE_NOT_ALLINGED;
    }
    if(txBufferSize > 0x10000)
    {
        return BUFFER_TOO_BIG;
    }

    if(command & CREATE_CYCLIC_CHAIN)
    {                         
        cyclic = true;
    }

    txPointer = (TX_DESC*)(firstTxDescAddr);
    bufferAddr = firstTxBufferAddr;
	
	/* Set the descriptors for BISYNC protocol. each original descriptor is
	   replace by three descriptors first for SOT and second for DATA 
	   and third for EOT */

    for(i = 0; i < 5 * numOfDesc; i=i+5)
    {
        if((bufferAddr & 0x00000007) != 0x0)
        {
            /* round up Address to closest allinged address */
            bufferAddr = bufferAddr + 8 - (bufferAddr & 0x00000007);  
        }


		/* Set first bisync descriptor */
		if(bisyncMode == BISYNC_NORMAL)
			txPointer[i].cmd_sts =  cmdStsWord | DESC_FIRST;

		if(bisyncMode == BISYNC_TRANSPARENT)
			txPointer[i].cmd_sts =  cmdStsWord | DESC_FIRST |
                                    DESC_TRANSMIT_DLE_BEFORE_BUFFER;

		if(bisyncMode == BISYNC_AUTO_TRANSPARENT)
			txPointer[i].cmd_sts =  cmdStsWord | DESC_FIRST | 
									DESC_TRANSMIT_DLE_BEFORE_BUFFER;
        /* buffer size */
        txPointer[i].bytecnt = 1;
        /* shadow size - relevant only in mpsc desc */
        txPointer[i].shadow = 1;
        /* buffer pointer */
        txPointer[i].buf_ptr = VIRTUAL_TO_PHY(bufferAddr);
        /* pointer to next descriptor */
        txPointer[i].next_desc_ptr = VIRTUAL_TO_PHY(firstTxDescAddr + (i+1) *
                                                    DESC_SIZE);
        bufferAddr += 8;


		/* Set second bisync descriptor header data */
		if(bisyncMode == BISYNC_NORMAL)
			txPointer[i+1].cmd_sts =  cmdStsWord | DESC_BCE_BCC_ENABLE;

		if(bisyncMode == BISYNC_TRANSPARENT)
			txPointer[i+1].cmd_sts =  cmdStsWord | DESC_BCE_BCC_ENABLE |
									  DESC_BYSINC_IN_TRANSPARENT_MODE;

		if(bisyncMode == BISYNC_AUTO_TRANSPARENT)
			txPointer[i+1].cmd_sts =  cmdStsWord | DESC_BCE_BCC_ENABLE;
        /* buffer size */
        txPointer[i+1].bytecnt = 8;
        /* shadow size - relevant only in mpsc desc */
        txPointer[i+1].shadow = 8;
        /* buffer pointer */
        txPointer[i+1].buf_ptr = VIRTUAL_TO_PHY(bufferAddr);
        /* pointer to next descriptor */
        txPointer[i+1].next_desc_ptr = VIRTUAL_TO_PHY(firstTxDescAddr + (i+2) *
                                                      DESC_SIZE);
        bufferAddr += 0x10;

		/* set third bisync descriptor STX */
		if(bisyncMode == BISYNC_NORMAL)
			txPointer[i+2].cmd_sts =  cmdStsWord | DESC_BCE_BCC_ENABLE;

		if(bisyncMode == BISYNC_TRANSPARENT)
			txPointer[i+2].cmd_sts =  cmdStsWord | DESC_BCE_BCC_ENABLE |
  									  DESC_TRANSMIT_DLE_BEFORE_BUFFER |
  									  DESC_BYSINC_IN_TRANSPARENT_MODE;

		if(bisyncMode == BISYNC_AUTO_TRANSPARENT)
			txPointer[i+2].cmd_sts =  cmdStsWord | DESC_BCE_BCC_ENABLE | 
									  DESC_TRANSMIT_DLE_BEFORE_BUFFER;
        /* buffer size */
        txPointer[i+2].bytecnt = 1;
        /* shadow size - relevant only in mpsc desc */
        txPointer[i+2].shadow = 1;
        /* buffer pointer */
        txPointer[i+2].buf_ptr = VIRTUAL_TO_PHY(bufferAddr);
        /* pointer to next descriptor */
        txPointer[i+2].next_desc_ptr = VIRTUAL_TO_PHY(firstTxDescAddr + 
                                                    (i+3)*DESC_SIZE);
        bufferAddr += 8;

		/* set fourth bisync descriptor text data */
		if(bisyncMode == BISYNC_NORMAL)
			txPointer[i+3].cmd_sts =  cmdStsWord | DESC_BCE_BCC_ENABLE;

		if(bisyncMode == BISYNC_TRANSPARENT)
			txPointer[i+3].cmd_sts =  cmdStsWord | DESC_BCE_BCC_ENABLE |
									  DESC_BYSINC_IN_TRANSPARENT_MODE;

		if(bisyncMode == BISYNC_AUTO_TRANSPARENT)
			txPointer[i+3].cmd_sts =  cmdStsWord | DESC_BCE_BCC_ENABLE;

        /* buffer size */
        txPointer[i+3].bytecnt = txBufferSize;
        /* shadow size - relevant only in mpsc desc */
        txPointer[i+3].shadow = txBufferSize;
        /* buffer pointer */
        txPointer[i+3].buf_ptr = VIRTUAL_TO_PHY(bufferAddr);
        /* pointer to next descriptor */
        txPointer[i+3].next_desc_ptr = VIRTUAL_TO_PHY(firstTxDescAddr + (i+4) *
                                                      DESC_SIZE);
        bufferAddr += (txBufferSize + 8);

		/* set fifth bisync descriptor */
		if(bisyncMode == BISYNC_NORMAL)
			txPointer[i+4].cmd_sts =  cmdStsWord | DESC_BCE_BCC_ENABLE |
								      DESC_GENERATE_ERROR_CODE_TX | DESC_LAST;

		if(bisyncMode == BISYNC_TRANSPARENT)
			txPointer[i+4].cmd_sts =  cmdStsWord | DESC_BCE_BCC_ENABLE |
									  DESC_GENERATE_ERROR_CODE_TX | DESC_LAST |
									  DESC_TRANSMIT_DLE_BEFORE_BUFFER;

		if(bisyncMode == BISYNC_AUTO_TRANSPARENT)
			txPointer[i+4].cmd_sts =  cmdStsWord | DESC_BCE_BCC_ENABLE |
									  DESC_GENERATE_ERROR_CODE_TX | DESC_LAST |
									  DESC_TRANSMIT_DLE_BEFORE_BUFFER;
        /* buffer size */
        txPointer[i+4].bytecnt = 1;
        /* shadow size - relevant only in mpsc desc */
        txPointer[i+4].shadow = 1;
        /* buffer pointer */
        txPointer[i+4].buf_ptr = VIRTUAL_TO_PHY(bufferAddr);
        /* pointer to next descriptor */
        txPointer[i+4].next_desc_ptr = VIRTUAL_TO_PHY(firstTxDescAddr + (i+5)
                                                      * DESC_SIZE);
        bufferAddr += 8;
    }

    if (cyclic)
    {
        /* make the descriptors chain cyclic */
        txPointer[i-1].next_desc_ptr = VIRTUAL_TO_PHY(firstTxDescAddr);
    }
    else
    {
        txPointer[i-1].next_desc_ptr = 0;
    }

    return DESC_INIT_SUCCESS;
}

/********************************************************************************
* gtHwCntl.c
*
* DESCRIPTION:
*       Functions declarations for Hw accessing quarterDeck phy, internal and
*       global registers.
*
* DEPENDENCIES:
*       None.
*
* FILE REVISION NUMBER:
*       $Revision: 1.1.1.1 $
*
*******************************************************************************/

#include <gtHwCntl.h>
#include <gtMiiSmiIf.h>

/****************************************************************************/
/* Phy registers related functions.                                         */
/****************************************************************************/

/*******************************************************************************
* hwReadPhyReg
*
* DESCRIPTION:
*       This function reads a switch's port phy register.
*
* INPUTS:
*       portNum - Port number to read the register for.
*       regAddr - The register's address.
*
* OUTPUTS:
*       data    - The read register's data.
*
* RETURNS:
*       GT_OK on success, or
*       GT_FAIL otherwise.
*
* COMMENTS:
*       None.
*
*******************************************************************************/
GT_STATUS hwReadPhyReg
(
    IN GT_QD_DEV *dev,
    IN  GT_U8    portNum,
    IN  GT_U8    regAddr,
    OUT GT_U16   *data
)
{
    GT_U8       phyAddr;
    GT_STATUS   retVal;

    phyAddr = CALC_SMI_DEV_ADDR(dev->baseRegAddr,
                                portNum + PHY_REGS_START_ADDR);

    retVal = miiSmiIfReadRegister(dev,phyAddr,regAddr,data);

    DBG_INFO(("Read from phy(%d) register: phyAddr 0x%x, regAddr 0x%x, ",
              portNum,phyAddr,regAddr));

    return retVal;
}


/*******************************************************************************
* hwWritePhyReg
*
* DESCRIPTION:
*       This function writes to a switch's port phy register.
*
* INPUTS:
*       portNum - Port number to write the register for.
*       regAddr - The register's address.
*       data    - The data to be written.
*
* OUTPUTS:
*       None.
*
* RETURNS:
*       GT_OK on success, or
*       GT_FAIL otherwise.
*
* COMMENTS:
*       None.
*
*******************************************************************************/
GT_STATUS hwWritePhyReg
(
    IN GT_QD_DEV *dev,
    IN  GT_U8    portNum,
    IN  GT_U8    regAddr,
    IN  GT_U16   data
)
{
    GT_U8   phyAddr;

    phyAddr = CALC_SMI_DEV_ADDR(dev->baseRegAddr,
                                portNum + PHY_REGS_START_ADDR);

    DBG_INFO(("Write to phy(%d) register: phyAddr 0x%x, regAddr 0x%x, ",
              portNum,phyAddr,regAddr));
    DBG_INFO(("data 0x%x.\n",data));
    return miiSmiIfWriteRegister(dev,phyAddr,regAddr,data);
}


/*******************************************************************************
* hwGetPhyRegField
*
* DESCRIPTION:
*       This function reads a specified field from a switch's port phy register.
*
* INPUTS:
*       portNum     - Port number to read the register for.
*       regAddr     - The register's address.
*       fieldOffset - The field start bit index. (0 - 15)
*       fieldLength - Number of bits to read.
*
* OUTPUTS:
*       data        - The read register field.
*
* RETURNS:
*       GT_OK on success, or
*       GT_FAIL otherwise.
*
* COMMENTS:
*       1.  The sum of fieldOffset & fieldLength parameters must be smaller-
*           equal to 16.
*
*******************************************************************************/
GT_STATUS hwGetPhyRegField
(
    IN GT_QD_DEV *dev,
    IN  GT_U8    portNum,
    IN  GT_U8    regAddr,
    IN  GT_U8    fieldOffset,
    IN  GT_U8    fieldLength,
    OUT GT_U16   *data
)
{
    GT_U16 mask;            /* Bits mask to be read */
    GT_U16 tmpData;

    if(hwReadPhyReg(dev,portNum,regAddr,&tmpData) != GT_OK)
        return GT_FAIL;

    CALC_MASK(fieldOffset,fieldLength,mask);

    tmpData = (tmpData & mask) >> fieldOffset;
    *data = tmpData;

    DBG_INFO(("Read from phy(%d) register: regAddr 0x%x, ",
              portNum,regAddr));
    DBG_INFO(("fOff %d, fLen %d, data 0x%x.\n",fieldOffset,fieldLength,*data));

    return GT_OK;
}


/*******************************************************************************
* hwSetPhyRegField
*
* DESCRIPTION:
*       This function writes to specified field in a switch's port phy register.
*
* INPUTS:
*       portNum     - Port number to write the register for.
*       regAddr     - The register's address.
*       fieldOffset - The field start bit index. (0 - 15)
*       fieldLength - Number of bits to write.
*       data        - Data to be written.
*
* OUTPUTS:
*       None.
*
* RETURNS:
*       GT_OK on success, or
*       GT_FAIL otherwise.
*
* COMMENTS:
*       1.  The sum of fieldOffset & fieldLength parameters must be smaller-
*           equal to 16.
*
*******************************************************************************/
GT_STATUS hwSetPhyRegField
(
    IN GT_QD_DEV *dev,
    IN  GT_U8    portNum,
    IN  GT_U8    regAddr,
    IN  GT_U8    fieldOffset,
    IN  GT_U8    fieldLength,
    IN  GT_U16   data
)
{
    GT_U16 mask;
    GT_U16 tmpData;

    if(hwReadPhyReg(dev,portNum,regAddr,&tmpData) != GT_OK)
        return GT_FAIL;

    CALC_MASK(fieldOffset,fieldLength,mask);

    /* Set the desired bits to 0.                       */
    tmpData &= ~mask;
    /* Set the given data into the above reset bits.    */
    tmpData |= ((data << fieldOffset) & mask);

    DBG_INFO(("Write to phy(%d) register: regAddr 0x%x, ",
              portNum,regAddr));
    DBG_INFO(("fieldOff %d, fieldLen %d, data 0x%x.\n",fieldOffset,
              fieldLength,data));
    return hwWritePhyReg(dev,portNum,regAddr,tmpData);
}


/****************************************************************************/
/* Per port registers related functions.                                    */
/****************************************************************************/

/*******************************************************************************
* hwReadPortReg
*
* DESCRIPTION:
*       This function reads a switch's port register.
*
* INPUTS:
*       portNum - Port number to read the register for.
*       regAddr - The register's address.
*
* OUTPUTS:
*       data    - The read register's data.
*
* RETURNS:
*       GT_OK on success, or
*       GT_FAIL otherwise.
*
* COMMENTS:
*       None.
*
*******************************************************************************/
GT_STATUS hwReadPortReg
(
    IN GT_QD_DEV *dev,
    IN  GT_U8    portNum,
    IN  GT_U8    regAddr,
    OUT GT_U16   *data
)
{
    GT_U8       phyAddr;
    GT_STATUS   retVal;

    phyAddr = CALC_SMI_DEV_ADDR(dev->baseRegAddr,
                                portNum + PORT_REGS_START_ADDR);

    retVal =  miiSmiIfReadRegister(dev,phyAddr,regAddr,data);
    DBG_INFO(("Read from port(%d) register: phyAddr 0x%x, regAddr 0x%x, ",
              portNum,phyAddr,regAddr));
    DBG_INFO(("data 0x%x.\n",*data));
    return retVal;
}


/*******************************************************************************
* hwWritePortReg
*
* DESCRIPTION:
*       This function writes to a switch's port register.
*
* INPUTS:
*       portNum - Port number to write the register for.
*       regAddr - The register's address.
*       data    - The data to be written.
*
* OUTPUTS:
*       None.
*
* RETURNS:
*       GT_OK on success, or
*       GT_FAIL otherwise.
*
* COMMENTS:
*       None.
*
*******************************************************************************/
GT_STATUS hwWritePortReg
(
    IN GT_QD_DEV *dev,
    IN  GT_U8    portNum,
    IN  GT_U8    regAddr,
    IN  GT_U16   data
)
{
    GT_U8   phyAddr;

    phyAddr = CALC_SMI_DEV_ADDR(dev->baseRegAddr,
                                portNum + PORT_REGS_START_ADDR);

    DBG_INFO(("Write to port(%d) register: phyAddr 0x%x, regAddr 0x%x, ",
              portNum,phyAddr,regAddr));
    DBG_INFO(("data 0x%x.\n",data));

    return miiSmiIfWriteRegister(dev,phyAddr,regAddr,data);
}


/*******************************************************************************
* hwGetPortRegField
*
* DESCRIPTION:
*       This function reads a specified field from a switch's port register.
*
* INPUTS:
*       portNum     - Port number to read the register for.
*       regAddr     - The register's address.
*       fieldOffset - The field start bit index. (0 - 15)
*       fieldLength - Number of bits to read.
*
* OUTPUTS:
*       data        - The read register field.
*
* RETURNS:
*       GT_OK on success, or
*       GT_FAIL otherwise.
*
* COMMENTS:
*       1.  The sum of fieldOffset & fieldLength parameters must be smaller-
*           equal to 16.
*
*******************************************************************************/
GT_STATUS hwGetPortRegField
(
    IN GT_QD_DEV *dev,
    IN  GT_U8    portNum,
    IN  GT_U8    regAddr,
    IN  GT_U8    fieldOffset,
    IN  GT_U8    fieldLength,
    OUT GT_U16   *data
)
{
    GT_U16 mask;            /* Bits mask to be read */
    GT_U16 tmpData;

    if(hwReadPortReg(dev,portNum,regAddr,&tmpData) != GT_OK)
        return GT_FAIL;

    CALC_MASK(fieldOffset,fieldLength,mask);

    tmpData = (tmpData & mask) >> fieldOffset;
    *data = tmpData;
    DBG_INFO(("Read from port(%d) register: regAddr 0x%x, ",
              portNum,regAddr));
    DBG_INFO(("fOff %d, fLen %d, data 0x%x.\n",fieldOffset,fieldLength,*data));

    return GT_OK;
}


/*******************************************************************************
* hwSetPortRegField
*
* DESCRIPTION:
*       This function writes to specified field in a switch's port register.
*
* INPUTS:
*       portNum     - Port number to write the register for.
*       regAddr     - The register's address.
*       fieldOffset - The field start bit index. (0 - 15)
*       fieldLength - Number of bits to write.
*       data        - Data to be written.
*
* OUTPUTS:
*       None.
*
* RETURNS:
*       GT_OK on success, or
*       GT_FAIL otherwise.
*
* COMMENTS:
*       1.  The sum of fieldOffset & fieldLength parameters must be smaller-
*           equal to 16.
*
*******************************************************************************/
GT_STATUS hwSetPortRegField
(
    IN GT_QD_DEV *dev,
    IN  GT_U8    portNum,
    IN  GT_U8    regAddr,
    IN  GT_U8    fieldOffset,
    IN  GT_U8    fieldLength,
    IN  GT_U16   data
)
{
    GT_U16 mask;
    GT_U16 tmpData;

    if(hwReadPortReg(dev,portNum,regAddr,&tmpData) != GT_OK)
        return GT_FAIL;

    CALC_MASK(fieldOffset,fieldLength,mask);

    /* Set the desired bits to 0.                       */
    tmpData &= ~mask;
    /* Set the given data into the above reset bits.    */
    tmpData |= ((data << fieldOffset) & mask);
    DBG_INFO(("Write to port(%d) register: regAddr 0x%x, ",
              portNum,regAddr));
    DBG_INFO(("fieldOff %d, fieldLen %d, data 0x%x.\n",fieldOffset,
              fieldLength,data));

    return hwWritePortReg(dev,portNum,regAddr,tmpData);
}


/****************************************************************************/
/* Global registers related functions.                                      */
/****************************************************************************/

/*******************************************************************************
* hwReadGlobalReg
*
* DESCRIPTION:
*       This function reads a switch's global register.
*
* INPUTS:
*       regAddr - The register's address.
*
* OUTPUTS:
*       data    - The read register's data.
*
* RETURNS:
*       GT_OK on success, or
*       GT_FAIL otherwise.
*
* COMMENTS:
*       None.
*
*******************************************************************************/
GT_STATUS hwReadGlobalReg
(
    IN GT_QD_DEV *dev,
    IN  GT_U8    regAddr,
    OUT GT_U16   *data
)
{
    GT_U8       phyAddr;
    GT_STATUS   retVal;

    phyAddr = CALC_SMI_DEV_ADDR(dev->baseRegAddr,
                                GLOBAL_REGS_START_ADDR);

    retVal = miiSmiIfReadRegister(dev,phyAddr,regAddr,data);
    DBG_INFO(("read from global register: phyAddr 0x%x, regAddr 0x%x, ",
              phyAddr,regAddr));
    DBG_INFO(("data 0x%x.\n",*data));
    return retVal;
}


/*******************************************************************************
* hwWriteGlobalReg
*
* DESCRIPTION:
*       This function writes to a switch's global register.
*
* INPUTS:
*       regAddr - The register's address.
*       data    - The data to be written.
*
* OUTPUTS:
*       None.
*
* RETURNS:
*       GT_OK on success, or
*       GT_FAIL otherwise.
*
* COMMENTS:
*       None.
*
*******************************************************************************/
GT_STATUS hwWriteGlobalReg
(
    IN GT_QD_DEV *dev,
    IN  GT_U8    regAddr,
    IN  GT_U16   data
)
{
    GT_U8   phyAddr;

    phyAddr = CALC_SMI_DEV_ADDR(dev->baseRegAddr,
                                GLOBAL_REGS_START_ADDR);

    DBG_INFO(("Write to global register: phyAddr 0x%x, regAddr 0x%x, ",
              phyAddr,regAddr));
    DBG_INFO(("data 0x%x.\n",data));

    return miiSmiIfWriteRegister(dev,phyAddr,regAddr,data);
}


/*******************************************************************************
* hwGetGlobalRegField
*
* DESCRIPTION:
*       This function reads a specified field from a switch's global register.
*
* INPUTS:
*       regAddr     - The register's address.
*       fieldOffset - The field start bit index. (0 - 15)
*       fieldLength - Number of bits to read.
*
* OUTPUTS:
*       data        - The read register field.
*
* RETURNS:
*       GT_OK on success, or
*       GT_FAIL otherwise.
*
* COMMENTS:
*       1.  The sum of fieldOffset & fieldLength parameters must be smaller-
*           equal to 16.
*
*******************************************************************************/
GT_STATUS hwGetGlobalRegField
(
    IN GT_QD_DEV *dev,
    IN  GT_U8    regAddr,
    IN  GT_U8    fieldOffset,
    IN  GT_U8    fieldLength,
    OUT GT_U16   *data
)
{
    GT_U16 mask;            /* Bits mask to be read */
    GT_U16 tmpData;

    if(hwReadGlobalReg(dev,regAddr,&tmpData) != GT_OK)
        return GT_FAIL;

    CALC_MASK(fieldOffset,fieldLength,mask);
    tmpData = (tmpData & mask) >> fieldOffset;
    *data = tmpData;
    DBG_INFO(("Read from global register: regAddr 0x%x, ",
              regAddr));
    DBG_INFO(("fOff %d, fLen %d, data 0x%x.\n",fieldOffset,fieldLength,*data));

    return GT_OK;
}


/*******************************************************************************
* hwSetGlobalRegField
*
* DESCRIPTION:
*       This function writes to specified field in a switch's global register.
*
* INPUTS:
*       regAddr     - The register's address.
*       fieldOffset - The field start bit index. (0 - 15)
*       fieldLength - Number of bits to write.
*       data        - Data to be written.
*
* OUTPUTS:
*       None.
*
* RETURNS:
*       GT_OK on success, or
*       GT_FAIL otherwise.
*
* COMMENTS:
*       1.  The sum of fieldOffset & fieldLength parameters must be smaller-
*           equal to 16.
*
*******************************************************************************/
GT_STATUS hwSetGlobalRegField
(
    IN GT_QD_DEV *dev,
    IN  GT_U8    regAddr,
    IN  GT_U8    fieldOffset,
    IN  GT_U8    fieldLength,
    IN  GT_U16   data
)
{
    GT_U16 mask;
    GT_U16 tmpData;

    if(hwReadGlobalReg(dev,regAddr,&tmpData) != GT_OK)
        return GT_FAIL;

    CALC_MASK(fieldOffset,fieldLength,mask);

    /* Set the desired bits to 0.                       */
    tmpData &= ~mask;
    /* Set the given data into the above reset bits.    */
    tmpData |= ((data << fieldOffset) & mask);

    DBG_INFO(("Write to global register: regAddr 0x%x, ",
              regAddr));
    DBG_INFO(("fieldOff %d, fieldLen %d, data 0x%x.\n",fieldOffset,
              fieldLength,data));

    return hwWriteGlobalReg(dev,regAddr,tmpData);
}

/*******************************************************************************
* hwReadQDReg
*
* DESCRIPTION:
*       This function reads a switch register.
*
* INPUTS:
*       phyAddr - Phy Address to read the register for.( 0 ~ 0x1F )
*       regAddr - The register's address.
*
* OUTPUTS:
*       data    - The read register's data.
*
* RETURNS:
*       GT_OK on success, or
*       GT_FAIL otherwise.
*
* COMMENTS:
*       None.
*
*******************************************************************************/
GT_STATUS hwReadMiiReg
(
    IN  GT_QD_DEV *dev,
    IN  GT_U8     phyAddr,
    IN  GT_U8     regAddr,
    OUT GT_U16    *data
)
{
    GT_STATUS   retVal;

    retVal = miiSmiIfReadRegister(dev,phyAddr,regAddr,data);

    DBG_INFO(("Read from phy(0x%x) register: regAddr 0x%x, data 0x%x.\n",
              phyAddr,regAddr,*data));

    return retVal;
}


/*******************************************************************************
* hwWriteMiiReg
*
* DESCRIPTION:
*       This function writes a switch register.
*
* INPUTS:
*       phyAddr - Phy Address to read the register for.( 0 ~ 0x1F )
*       regAddr - The register's address.
*
* OUTPUTS:
*       data    - The read register's data.
*
* RETURNS:
*       GT_OK on success, or
*       GT_FAIL otherwise.
*
* COMMENTS:
*       None.
*
*******************************************************************************/
GT_STATUS hwWriteMiiReg
(
    IN GT_QD_DEV *dev,
    IN  GT_U8    phyAddr,
    IN  GT_U8    regAddr,
    IN  GT_U16   data
)
{
    GT_STATUS   retVal;

    retVal = miiSmiIfWriteRegister(dev,phyAddr,regAddr,data);

    DBG_INFO(("Write to phy(0x%x) register: regAddr 0x%x, data 0x%x.\n",
              phyAddr,regAddr,data));

    return retVal;
}


/********************************************************************************
* gtBrgStp.c
*
* DESCRIPTION:
*       API definitions to handle port spanning tree state.
*
* DEPENDENCIES:
*
* FILE REVISION NUMBER:
*       $Revision: 1.1.1.1 $
*******************************************************************************/

#include <msApi.h>
#include <gtHwCntl.h>
#include <gtDrvSwRegs.h>

GT_STATUS gfdbAddMacEntry(GT_QD_DEV    *dev, GT_ATU_ENTRY *macEntry)
{
    return GT_OK; 
}
GT_STATUS gfdbDelMacEntry(GT_QD_DEV    *dev, GT_ETHERADDR  *macAddress)
{
    return GT_OK;
}


/*******************************************************************************
* gstpSetMode
*
* DESCRIPTION:
*       This routine Enable the Spanning tree.
*
* INPUTS:
*       en - GT_TRUE for enable, GT_FALSE for disable.
*
* OUTPUTS:
*       None.
*
* RETURNS:
*       GT_OK   - on success
*       GT_FAIL - on error
*
* COMMENTS:
*       when enabled, this function sets all port to blocking state, and inserts
*       the BPDU MAC into the ATU to be captured to CPU, on disable all port are
*       being modified to be in forwarding state.
*
* GalTis:
*
*******************************************************************************/
GT_STATUS gstpSetMode
(
    IN GT_QD_DEV *dev,
    IN GT_BOOL  en
)
{
    GT_STATUS       retVal;         /* Functions return value.      */
    GT_PORT_STP_STATE   state;      /* STP state to be set.         */
    GT_ATU_ENTRY        atuEntry;   /* The ATU entry data to be set */
    GT_U8           i;

    DBG_INFO(("gstpSetMode Called.\n"));
    if(dev->deviceId == GT_88E6051)
    {
        DBG_INFO(("Failed.\n"));
        return GT_FAIL;
    }

    if((en == GT_TRUE) && (dev->stpMode == 1))
    {
        DBG_INFO(("OK.\n"));
        return GT_OK;
    }

    /* Set the STP state in the relevant register.  */
    if(en == GT_TRUE)
        state = GT_PORT_BLOCKING;
    else
        state = GT_PORT_FORWARDING;

    for(i = 0; i < MAX_SWITCH_PORTS; i++)
    {
        retVal = gstpSetPortState(dev,i,state);
        if(retVal != GT_OK)
        {
            DBG_INFO(("Failed.\n"));
            return retVal;
        }
    }

    /* Set the Atu entry parameters.    */
    atuEntry.macAddr.arEther[0] = 0x01;
    atuEntry.macAddr.arEther[1] = 0x80;
    atuEntry.macAddr.arEther[2] = 0xC2;
    atuEntry.macAddr.arEther[3] = 0x00;
    atuEntry.macAddr.arEther[4] = 0x00;
    atuEntry.macAddr.arEther[5] = 0x00;
    atuEntry.portVec = ( 1 << GT_PORT_2_LPORT(dev->cpuPortNum));
    atuEntry.prio    = 3;
	atuEntry.DBNum = 0;
    atuEntry.entryState.mcEntryState = GT_MC_PRIO_MGM_STATIC;

    if(en == GT_TRUE)
    {
        retVal = gfdbAddMacEntry(dev,&atuEntry);
    }
    else if((en == GT_FALSE) && (dev->stpMode != 0))
        retVal = gfdbDelMacEntry(dev,&(atuEntry.macAddr));
    else
        retVal = GT_OK;

    if(en == GT_TRUE)
        dev->stpMode = 1;
    else
        dev->stpMode = 2;
    if(retVal == GT_OK)
        DBG_INFO(("OK.\n"));
    else
        DBG_INFO(("Failed.\n"));
    return retVal;
}



/*******************************************************************************
* gstpSetPortState
*
* DESCRIPTION:
*       This routine set the port state.
*
* INPUTS:
*       port  - the logical port number.
*       state - the port state to set.
*
* OUTPUTS:
*       None.
*
* RETURNS:
*       GT_OK   - on success
*       GT_FAIL - on error
*
* COMMENTS:
*
*
* GalTis:
*
*******************************************************************************/
GT_STATUS gstpSetPortState
(
    IN GT_QD_DEV *dev,
    IN GT_LPORT           port,
    IN GT_PORT_STP_STATE  state
)
{
    GT_U8           phyPort;        /* Physical port                */
    GT_U16          data;           /* Data to write to register.   */
    GT_STATUS       retVal;         /* Functions return value.      */

    DBG_INFO(("gstpSetPortState Called.\n"));

    phyPort = GT_LPORT_2_PORT(port);
    data    = state;

    /* Set the port state bits.             */
    retVal= hwSetPortRegField(dev,phyPort, QD_REG_PORT_CONTROL,0,2,data);
    if(retVal != GT_OK)
    {
        DBG_INFO(("Failed.\n"));
        return retVal;
    }
    DBG_INFO(("OK.\n"));
    return GT_OK;
}



/*******************************************************************************
* gstpGetPortState
*
* DESCRIPTION:
*       This routine returns the port state.
*
* INPUTS:
*       port  - the logical port number.
*
* OUTPUTS:
*       state - the current port state.
*
* RETURNS:
*       GT_OK   - on success
*       GT_FAIL - on error
*
* COMMENTS:
*       None.
*
* GalTis:
*
*******************************************************************************/
GT_STATUS gstpGetPortState
(
    IN GT_QD_DEV *dev,
    IN  GT_LPORT           port,
    OUT GT_PORT_STP_STATE  *state
)
{
    GT_U8           phyPort;        /* Physical port                */
    GT_U16          data;           /* Data read from register.     */
    GT_STATUS       retVal;         /* Functions return value.      */

    DBG_INFO(("gstpGetPortState Called.\n"));

    phyPort = GT_LPORT_2_PORT(port);

    /* Get the port state bits.             */
    retVal = hwGetPortRegField(dev,phyPort, QD_REG_PORT_CONTROL,0,2,&data);
    if(retVal != GT_OK)
    {
        DBG_INFO(("Failed.\n"));
        return retVal;
    }

    *state = data & 0x3;
    DBG_INFO(("OK.\n"));
    return GT_OK;
}
unsigned char *GetTxBuf()
{
    return (unsigned char *)eth0_tx_desc->buf_ptr;
}
void
FinishTx(unsigned len)
{
    int portNum = 0;
    char *p = (char *)eth0_tx_desc->buf_ptr;

    gtDescInitTxChain(NT, (unsigned int)eth0_tx_desc,
                      (unsigned int) eth0_tx_desc->buf_ptr, len, 
		      DESC_OWNED_BY_GT | DESC_GENERATE_ERROR_CODE_TX | DESC_ADD_PADDING , 
		      NO_CYCLIC_CHAIN, 1); 

    gtEtherStartTransmit(portNum, (unsigned int) eth0_tx_desc, ETH_TX_PRIO0);

//    getstats();

}
/**************************************************************************
eth_poll: Wait for a frame, by polling the current waiting rx desc (desc no. 
          CurrRxDesc). When a frame arrives it initializes again the rx
          descriptor, increments CurrRxDesc and sets Enable Rx bit again.
***************************************************************************/
extern void LEDtest();
int ethcount=0;
extern int loopled;

int eth_poll(char *buffer)
{
    int portNum = 0;
    long wait = 0;
    int len;

    //unsigned char wu[200]="wuming packet 12355267647";
    //unsigned int cnt;

    /* return true if there's an ethernet packet ready to read */
    /* nic->packet should contain data on return */
    /* nic->packetlen should contain length of data */  

    disable_data_cache();
    /* wait for a frame */
    
    //cnt=0;
    while (eth0_rx_desc[CurrRxDesc].cmd_sts & DESC_OWNED_BY_GT)
    {
    	
    	 //cnt++;
         //if(cnt>=100)
         //{
         //	cnt=0;
         //	report_error(wu, 100);
         //}
        
    	
    	ethcount++;
    	//if((ethcount==100000 && loopled == 0))
    	if((ethcount==30 && loopled == 0))
    	{
    	LEDtest();
    	ethcount=0;
    	}
	getstats();
    }
    enable_data_cache();
    invalidate_data_cache();

    len = eth0_rx_desc[CurrRxDesc].bytecnt;

    memcpy(buffer, (char *) eth0_rx_buffer[CurrRxDesc], len);


    /* sets the receiving desc to initial state */
    eth0_rx_desc[CurrRxDesc].bufsize = 1536;
    eth0_rx_desc[CurrRxDesc].cmd_sts = DESC_OWNED_BY_GT;

    /* increment rx descs counter */
    CurrRxDesc ++;
    if (CurrRxDesc == NR) CurrRxDesc = 0;
    
    /* ENABLE Rx - in case it was aborted */
    EAGLE_MAC_WRITE (ETH_SDMA_COMMAND_REG(0) + (portNum << 10), ETH_ENABLE_RX); 
    return len;
}
void 
eth_transmit(char *buffer, int len)
{
    int portNum = 0;
    if(len < 60) {
	len = 60;
    }
    memcpy(eth0_tx_buffer, buffer, len);

    gtDescInitTxChain(1, (unsigned int)eth0_tx_desc,
                      (unsigned int) eth0_tx_buffer, len, DESC_OWNED_BY_GT | 
                      DESC_GENERATE_ERROR_CODE_TX | DESC_ADD_PADDING 
                      , NO_CYCLIC_CHAIN, 1); 

    gtEtherStartTransmit(portNum, (unsigned int) eth0_tx_desc, ETH_TX_PRIO0);
}
/*******************************************************************************
* gvlnSetPortVlanPorts
*
* DESCRIPTION:
*       This routine sets the port VLAN group port membership list.
*
* INPUTS:
*       port        - logical port number to set.
*       memPorts    - array of logical ports.
*       memPortsLen - number of members in memPorts array
*
* OUTPUTS:
*       None.
*
* RETURNS:
*       GT_OK               - on success
*       GT_FAIL             - on error
*       GT_BAD_PARAM        - on bad parameters
*
* COMMENTS:
*
* GalTis:
*
*******************************************************************************/
GT_STATUS gvlnSetPortVlanPorts
(
    IN GT_QD_DEV *dev,
    IN GT_LPORT  port,
    IN GT_LPORT  memPorts[],
    IN GT_U8     memPortsLen
)
{
    GT_STATUS       retVal;         /* Functions return value.      */
    GT_U16          data;           /* Data to be set into the      */
                                    /* register.                    */
    GT_U8           phyPort;        /* Physical port.               */
    GT_U8           i;

    DBG_INFO(("gvlnSetPortVlanPorts Called.\n"));
    if(memPorts == NULL)
    {
        DBG_INFO(("Failed.\n"));
        return GT_BAD_PARAM;
    }

    phyPort = GT_LPORT_2_PORT(port);
    data = 0;

	if(memPortsLen > dev->numOfPorts)
    {
        DBG_INFO(("Failed (PortsLen Too Big).\n"));
        return GT_BAD_PARAM;
    }

    for(i = 0; i < memPortsLen; i++)
        data |= (1 << GT_LPORT_2_PORT(memPorts[i]));

    /* memPortsLen = 3 for fullsail, =7 for others */
    retVal = hwSetPortRegField(dev,phyPort,QD_REG_PORT_VLAN_MAP,0,dev->numOfPorts,data);
    if(retVal != GT_OK)
    {
        DBG_INFO(("Failed.\n"));
        return retVal;
    }

    DBG_INFO(("OK.\n"));
    return GT_OK;
}
/*******************************************************************************
* gvlnSetPortVid
*
* DESCRIPTION:
*       This routine Set the port default vlan id.
*
* INPUTS:
*       port - logical port number to set.
*       vid  - the port vlan id.
*
* OUTPUTS:
*       None.
*
* RETURNS:
*       GT_OK               - on success
*       GT_FAIL             - on error
*       GT_BAD_PARAM        - on bad parameters
*
* COMMENTS:
*
* GalTis:
*
*******************************************************************************/
GT_STATUS gvlnSetPortVid
(
    IN GT_QD_DEV    *dev,
    IN GT_LPORT     port,
    IN GT_U16       vid
)
{
    GT_STATUS       retVal;         /* Functions return value.      */
    GT_U8           phyPort;        /* Physical port.               */

    DBG_INFO(("gvlnSetPortVid Called.\n"));
    phyPort = GT_LPORT_2_PORT(port);

    retVal = hwSetPortRegField(dev,phyPort,QD_REG_PVID,0,12, vid);
    if(retVal != GT_OK)
    {
        DBG_INFO(("Failed.\n"));
        return retVal;
    }
    DBG_INFO(("OK.\n"));
    return GT_OK;
}

