#include "iob.h"

#define MAX_BUF_NO         80
char DriverBuf[MAX_BUF_NO][1600];
int Driverflag[MAX_BUF_NO];


void * getCBFromQ(CBQ *psCBQ,unsigned int zeroSize)
{
void * psCB;
//ULONG mask;
//   mask=intLock();
   if (psCBQ->dwQCount != 0) {
   /*  if there a CB available in this queue */
      psCB = psCBQ->psQHead;
      /*   get a CB to use, use the CB queue head        */
      psCBQ->psQHead = (void *)((CB *)psCBQ->psQHead)->psNextCB;
      /*   make new CB queue head              */
      ((CB *)psCB)->psNextCB = NULL;
      if (--psCBQ->dwQCount==0) psCBQ->psQTail=NULL;
      if (zeroSize) memset((BYTE *)psCB,0x00,zeroSize);
   }  else {
      psCB =  NULL;
   }
//   intUnlock(mask);
   return (psCB);
}


void putCBToQ(CBQ *psCBQ,void * psCB,unsigned char dbOrder)
{
//   ULONG mask;
   if (psCB==NULL) return;
//   mask=intLock();
   if (psCBQ->dwQCount==0) {
    /* if the psCB will be the only CB on queue make it the queue head */
      psCBQ->psQHead = psCB;
      psCBQ->psQTail = psCB;
      ((CB *)psCB)->psNextCB = NULL;
   } else {
    /* 1 or more CB is in queue                                */
      if (dbOrder==TAIL) {
         ((CB *)psCB)->psNextCB = NULL;
         ((CB *)psCBQ->psQTail)->psNextCB = psCB;
         psCBQ->psQTail = psCB;
      } else if (dbOrder==HEAD || dbOrder == ADDRORDER && psCB < psCBQ->psQHead) {
         /* if the CB address is smaller than queue head, make CB */
         /* the new queue head, and make the chain */
         ((CB *)psCB)->psNextCB = psCBQ->psQHead;
         psCBQ->psQHead = psCB;
      } else {
         /* if CB address is bigger than free queue head         */
         /* find a CB in chain such that it's address is smaller */
         /* than THE CB. Put THE CB in chain so that the queue is*/
         /* is a sort-by-address sorted-queue                    */
         CB *aCB;
         aCB = (CB *)psCBQ->psQHead;
         while ((psCB > aCB->psNextCB)
                && aCB->psNextCB != NULL ) {
            aCB = (CB *)aCB->psNextCB;
         } /* endwhile */
         ((CB *)psCB)->psNextCB = aCB->psNextCB;
         aCB->psNextCB = psCB;
         if (aCB==psCBQ->psQTail) psCBQ->psQTail = psCB;
      } /* endif */
   } /* endif */
   psCBQ->dwQCount++;
//   intUnlock(mask);
   return;
}

IOB * DriverGetIOB ( unsigned int dwSize )
{
   int i;
   IOB * psIOB = NULL;
//   ULONG mask;
//   mask=intLock();
    if (dwSize < 1600) {
       for (i=0;i<MAX_BUF_NO ;i ++ ) {
          if (Driverflag[i] == 0) {
             Driverflag[i] = 1;
             psIOB = (IOB *)&DriverBuf[i];
             break;;
          } /* endif */
       } /* endfor */
    } /* endif */
//   intUnlock(mask);
    return psIOB;
}


int FreeIOB ( IOB * psIOB )
{
   int i;
//   ULONG mask;
//   mask=intLock();
   for (i=0;i<MAX_BUF_NO ;i++ ) {
      if (psIOB == (IOB *)&DriverBuf[i]) {
         Driverflag[i] = 0;
         break;
      } /* endif */
   } /* endfor */
//   intUnlock(mask);
   return 0;
}



