#                Copyright 2004, Marvell International Ltd.
# This code contains confidential information of Marvell Semiconductor, Inc.
# No rights are granted herein under any patent, mask work right or copyright
# of Marvell or any third party.
# Marvell reserves the right at its sole discretion to request that this code
# be immediately returned to Marvell. This code is provided "as is".
# Marvell makes no warranties, express, implied or otherwise, regarding its
# accuracy, completeness or performance.

# The tools chain
CC   = $(GCC_DIR)/arm-elf-gcc -mcpu=arm9tdmi
LD   = $(GCC_DIR)/arm-elf-gcc
AR   = $(GCC_DIR)/arm-elf-ar

###### GLOBAL VARIABLES
# Local makefiles may override these.
# Tools chain options

ifdef W8510H
LINK_MAP=target-W8510H.ld
else 
ifdef W8512
LINK_MAP=target-W8512.ld
else
LINK_MAP=target-wgx102.ld
endif
endif

ifndef NO_ECOS_STACK
INC_DIR   = $(PKG_INSTALL_DIR)/include -I$(WLANDRV_DIR)/incl
else
INC_DIR   = $(PKG_INSTALL_DIR_NO_STACK)/include -I$(WLANDRV_DIR)/incl
endif
CFLAGS     = -fshort-enums -DAP_SW -D__ECOS -DECOS -DAP22 -DFREE_IN_TXTASK\
             -DWPA -DAP_WPA2 -DQOS_FEATURE -DQOS_WSM_FEATURE

EXTRACFLAGS   = -Wall -I$(INC_DIR) -I$(INCLUDE_AP_DIR) \
                -I$(INCLUDE_ETHERSWITCH) \
                -I$(INCLUDE_ETHERSWITCH_H_PLATFORM)  \
                -I$(INCLUDE_ETHERSWITCH_H_DRIVER)    \
                -I$(INCLUDE_ETHERSWITCH_H_MSAPI)     \
                -ffunction-sections  -fdata-sections

#ifndef NO_ECOS_STACK
#LDFLAGS   = -nostartfiles -L$(PKG_INSTALL_DIR)/lib -Wl,--gc-sections\
#    -Xlinker -Map -Xlinker $(basename $@).map
#else
#LDFLAGS   = -nostartfiles -L$(PKG_INSTALL_DIR_NO_STACK)/lib -Wl,--gc-sections\
#    -Xlinker -Map -Xlinker $(basename $@).map
#endif
ARFLAGS   = rv

###### VARIABLES
# Any of these can be overriden on the command-line or in your environment

ifdef DEBUGMODE
COPTFLAGS = -g -DAP5X
else
COPTFLAGS = -O3 -DAP5X
endif
ifdef BUILD_TOOLS
COPTFLAGS = -DAP5X
endif

ifdef BUILD_WLANDRV
COPTFLAGS =-DAP5X
endif

ifdef AP51
COPTFLAGS += -DPROD_NAME=1
endif
ifdef AP52
COPTFLAGS += -DPROD_NAME=0
endif
ifdef UNIVERSAL_RPTR
COPTFLAGS += -DAP_URPTR -DUR_WPA -DWPA_STA -DWPA2 -DW8515 -DDHCP_MODIFICATION -DETHPORT_AS_URCLIENTPORT	-DAP_URPTR_LED -DPPPoE_SUPPORT -DAP_SITE_SURVEY -DAP_URPTR_NEW_RATE -DAP_URAUTOCFG
endif
ifeq ($(PROD_NAME), AP31P)
COPTFLAGS += -DAP_SITE_SURVEY -DWPA_INFO
endif

######
# These have been default for all AP/Xin1 products
COPTFLAGS   += -DUDP_API -DNEWCALDATA
COPTFLAGS   += -DTASKDHCP -DDOMAIN_SUPPORTED -DSTA_INFO_DB -DAUTOCHANNEL -DIEEE80211H -DBOOSTER_MODE
COPTFLAGS   += -DRESET_BUTTON_EVENT -DENABLE_GPIO_INT #-DLED_SUPPORT
ifndef VOIP
COPTFLAGS   += -DLED_SUPPORT
endif

#COPTFLAGS   += -DENABLE_ETH_DEBUG

ifdef STA_QOS
COPTFLAGS += -DSTA_QOS
endif

ifdef SDRAM_4MB
COPTFLAGS += -DSDRAM_4MB
endif 

ifdef FALCON
COPTFLAGS += -DFALCON
endif

ifdef PEREGRINE
COPTFLAGS += -DPEREGRINE
endif

ifdef GUEST_ACCESS
COPTFLAGS += -DGUEST_ACCESS
endif

ifdef AP31E_P
COPTFLAGS   += -DAP31E_P -DAPCFGUR
endif

ifdef AP51E
COPTFLAGS   += -DAP51E
endif 

ifdef AUTOLINK
COPTFLAGS += -DAUTOLINK
endif

ifeq ($(UTILBUTTON), AUTOLINK)
COPTFLAGS += -DUTIL_AUTOLINK
else ifeq ($(UTILBUTTON), AUTOCONFIG)
COPTFLAGS += -DUTIL_AUTOCFG
endif

ifdef DCS
COPTFLAGS += -DDCS
endif

ifdef EEPROM
COPTFLAGS   += -DEEPROM
endif

ifdef VERSION_STRING
COPTFLAGS += -DVERSION=\"$(VERSION_STRING)\"
endif

ifdef NO_ECOS_STACK
COPTFLAGS   += -DNO_ECOS_TCP_IP_STACK
else
COPTFLAGS   += -DECOS_TCP_IP_STACK
endif

ifdef DHCP_MAGIC_OPTION
COPTFLAGS   += -DDHCP_MAGIC_OPTION=\"$(DHCP_MAGIC_OPTION)\"
endif

ifdef GATEWAY
COPTFLAGS += -DGATEWAY
endif

ifdef DHCPS
COPTFLAGS += -DDHCPS
endif

ifdef NAT
COPTFLAGS += -DNAT
endif

ifdef CONDOR2
COPTFLAGS += -DB0_CHIP -DCONDOR2
ifdef W8510H
COPTFLAGS += -DCONDOR2_64SQ
endif
endif


ifdef VOIP
COPTFLAGS += -DVOIP
endif

ifdef VOIP_GUI
COPTFLAGS += -DVOIP_GUI
endif

ifdef AUDIO_GUI
COPTFLAGS += -DAUDIO_GUI
endif

ifdef SLIC_GUI
COPTFLAGS += -DSLIC_GUI
endif

ifdef VOIP_ATA
COPTFLAGS += -DVOIP_ATA
endif

ifdef ATA_BOARD
COPTFLAGS += -DATA_BOARD
endif

ifdef V_BOARD
COPTFLAGS += -V_BOARD
endif

ifdef UAPSD
COPTFLAGS += -DUSE_TBTT_FOR_TIM  -DONENULL -DUAPSD
endif

ifdef MLME_CALLBACK
COPTFLAGS += -DMLME_CALLBACK
endif

ifdef ENABLE_UART
COPTFLAGS += -DENABLE_UART
endif

CFLAGS += $(COPTFLAGS)
