#include "wltypes.h"
#include "oem.h"
#include "IEEE_types.h"
#include "mib.h"
#include "api.h"
#include	"wsIntrn.h"
#ifdef UEMF
	#include	"uemf.h"
#else
	#include	"../basic/basicInternal.h"
#endif
#ifdef ENABLE_ETH_DEBUG
#include "eth_debug.h"
#endif

#include  "Mrvap.h"

typedef struct{
    UCHAR  enable;
    UCHAR  caWPAHex[32];
    }WPAHex;

void dummy_CmdProc(void) {
}

WL_STATUS ApCmdGetProc(UINT16 CmdCode, char *pResult)
{
	APICMDBUF *pBuf;
	WL_STATUS  nStatus;


	nStatus = STATUS_SUCCESS;

	switch (CmdCode)
	{

                //start MRVL
                #if defined(GATEWAY) || defined(DHCPS)
                case APCMD_GET_ETH_DHCPS_CONFIG:

                    (APICMDBUF_GET_ETH_DHCPS_CONFIG*)pBuf = malloc(sizeof (APICMDBUF_GET_ETH_DHCPS_CONFIG));

                    ((APICMDBUF_GET_ETH_DHCPS_CONFIG*)pBuf)->cmdCode = CmdCode;
                    ((APICMDBUF_GET_ETH_DHCPS_CONFIG*)pBuf)->seqNum = 1;
                    ((APICMDBUF_GET_ETH_DHCPS_CONFIG*)pBuf)->cmdBodyLen = sizeof(APICMDBUF_GET_ETH_DHCPS_CONFIG)-BUF_HDR_LEN;

                    apctl(pBuf);

                    if (pBuf->cmdStatus==APCTL_OK)
                    {
                            memcpy(pResult, (UCHAR*)&(((APICMDBUF_GET_ETH_DHCPS_CONFIG *)pBuf)->isEnable), 1360);
                    }
                    else
                    {
                            nStatus = STATUS_FAIL;
                    }
                    free ((APICMDBUF_GET_ETH_DHCPS_CONFIG*)pBuf);
                    break;
                #endif

                #if defined(GATEWAY)
                case APCMD_GET_ETH_LAN_IP_CONFIG:
                        (APICMDBUF_GET_ETH_LAN_IP_CONFIG*)pBuf = malloc(sizeof (APICMDBUF_GET_ETH_LAN_IP_CONFIG));

                        ((APICMDBUF_GET_ETH_LAN_IP_CONFIG*)pBuf)->cmdCode = CmdCode;
                        ((APICMDBUF_GET_ETH_LAN_IP_CONFIG*)pBuf)->seqNum = 1;
                        ((APICMDBUF_GET_ETH_LAN_IP_CONFIG*)pBuf)->cmdBodyLen = sizeof(APICMDBUF_GET_ETH_LAN_IP_CONFIG)-BUF_HDR_LEN;

                        //calling my function to add
                        apctl(pBuf);

                        if (pBuf->cmdStatus==APCTL_OK)
                        {
                            memcpy(pResult, (UCHAR*)&(((APICMDBUF_GET_ETH_LAN_IP_CONFIG *)pBuf)->ipAddress), 8);
                        }
                        else
                        {
                            nStatus = STATUS_FAIL;
                        }
                        free ((APICMDBUF_GET_ETH_LAN_IP_CONFIG*)pBuf);
                        break;

                case APCMD_GET_ETH_WAN_IP_CONFIG:
                        (APICMDBUF_GET_ETH_WAN_IP_CONFIG*)pBuf = malloc(sizeof (APICMDBUF_GET_ETH_WAN_IP_CONFIG));

                        ((APICMDBUF_GET_ETH_WAN_IP_CONFIG*)pBuf)->cmdCode = CmdCode;
                        ((APICMDBUF_GET_ETH_WAN_IP_CONFIG*)pBuf)->seqNum = 1;
                        ((APICMDBUF_GET_ETH_WAN_IP_CONFIG*)pBuf)->cmdBodyLen = sizeof(APICMDBUF_GET_ETH_WAN_IP_CONFIG)-BUF_HDR_LEN;

                        //calling my function to add
                        apctl(pBuf);

                        if (pBuf->cmdStatus==APCTL_OK)
                        {
                            memcpy(pResult, (UCHAR*)&(((APICMDBUF_GET_ETH_WAN_IP_CONFIG *)pBuf)->dhcpEnabled), 24);
                        }
                        else
                        {
                            nStatus = STATUS_FAIL;
                        }
                        free ((APICMDBUF_GET_ETH_WAN_IP_CONFIG*)pBuf);
                        break;
                 #endif

                //end MRVL

		case APCMD_GET_SSID:
		case APCMD_GET_SSID2:
		case APCMD_GET_FIRMWARE_VERSION:
			pBuf = malloc(sizeof (APICMDBUF)+60);
			pBuf->cmdCode = CmdCode;
			pBuf->seqNum = 1;
			pBuf->cmdBody = (char*)pBuf+sizeof(APICMDBUF);
			pBuf->cmdBodyLen = 60;
			
			apctl(pBuf);

			if (pBuf->cmdStatus == APCTL_OK)
			{
				strcpy((char*)pResult, pBuf->cmdBody); 
			}
			else
			{
				nStatus = STATUS_FAIL;
			}
			//free(pBuf->cmdBody);
			free(pBuf);
			break;
		case APCMD_GET_OPEN_SSID_EN_STATE:
				(APICMDBUF_GET_OPEN_SSID_EN_STATE*)pBuf = malloc(sizeof (APICMDBUF_GET_OPEN_SSID_EN_STATE));
				((APICMDBUF_GET_OPEN_SSID_EN_STATE*)pBuf)->cmdCode = CmdCode;
				((APICMDBUF_GET_OPEN_SSID_EN_STATE*)pBuf)->seqNum = 1;
				((APICMDBUF_GET_OPEN_SSID_EN_STATE*)pBuf)->cmdBodyLen = sizeof(APICMDBUF_GET_OPEN_SSID_EN_STATE)-BUF_HDR_LEN;

				apctl(pBuf);

				if (pBuf->cmdStatus == APCTL_OK)
				{
					*pResult = ((APICMDBUF_GET_OPEN_SSID_EN_STATE*)pBuf)->openSSIDEnabled;
				}
				else
				{
					nStatus = STATUS_FAIL;
				}
				free((APICMDBUF_GET_OPEN_SSID_EN_STATE*)pBuf);
				break;
		case APCMD_GET_RF_CHANNEL:
			(APICMDBUF_GET_RF_CHANNEL*)pBuf = malloc(sizeof (APICMDBUF_GET_RF_CHANNEL));

				((APICMDBUF_GET_RF_CHANNEL*)pBuf)->cmdCode = CmdCode;
				((APICMDBUF_GET_RF_CHANNEL*)pBuf)->seqNum = 1;
				((APICMDBUF_GET_RF_CHANNEL*)pBuf)->cmdBodyLen = sizeof(APICMDBUF_GET_RF_CHANNEL)-BUF_HDR_LEN;

				apctl(pBuf);

				if (pBuf->cmdStatus==APCTL_OK)
				{
					*((USHORT*)pResult) =  ((APICMDBUF_GET_RF_CHANNEL*)pBuf)->curChanNum;
#ifdef AUTOCHANNEL
					if(((APICMDBUF_GET_RF_CHANNEL*)pBuf)->isAutoChan)
						*((USHORT*)pResult) |= 0x8000;
#endif
				}
				else
				{
					nStatus = STATUS_FAIL;
				}
				free ((APICMDBUF_GET_RF_CHANNEL*)pBuf);
				break;	
		case APCMD_GET_RF_CHANNEL2:
			(APICMDBUF_GET_RF_CHANNEL*)pBuf = malloc(sizeof (APICMDBUF_GET_RF_CHANNEL));

				((APICMDBUF_GET_RF_CHANNEL*)pBuf)->cmdCode = CmdCode;
				((APICMDBUF_GET_RF_CHANNEL*)pBuf)->seqNum = 1;
				((APICMDBUF_GET_RF_CHANNEL*)pBuf)->cmdBodyLen = sizeof(APICMDBUF_GET_RF_CHANNEL)-BUF_HDR_LEN;

				apctl(pBuf);

				if (pBuf->cmdStatus==APCTL_OK)
				{
					*((USHORT*)pResult) =  ((APICMDBUF_GET_RF_CHANNEL*)pBuf)->curChanNum;
#ifdef AUTOCHANNEL
					if(((APICMDBUF_GET_RF_CHANNEL*)pBuf)->isAutoChan)
						*((USHORT*)pResult) |= 0x8000;
#endif
				}
				else
				{
					nStatus = STATUS_FAIL;
				}
				free ((APICMDBUF_GET_RF_CHANNEL*)pBuf);
				break;	

		case APCMD_GET_TX_POWER_LEVEL:
				(APICMDBUF_GET_TX_POWER_LEVEL*)pBuf = malloc(sizeof (APICMDBUF_GET_TX_POWER_LEVEL));

				((APICMDBUF_GET_TX_POWER_LEVEL*)pBuf)->cmdCode = CmdCode;
				((APICMDBUF_GET_TX_POWER_LEVEL*)pBuf)->seqNum = 1;
				((APICMDBUF_GET_TX_POWER_LEVEL*)pBuf)->cmdBodyLen = sizeof(APICMDBUF_GET_TX_POWER_LEVEL)-BUF_HDR_LEN;

				apctl(pBuf);

				if (pBuf->cmdStatus==APCTL_OK)
				{
					memcpy(pResult, &(((APICMDBUF_GET_TX_POWER_LEVEL*)pBuf)->txPowerLevel), 9);  
				}
				else
				{
					nStatus = STATUS_FAIL;
				}
				free ((APICMDBUF_GET_TX_POWER_LEVEL*)pBuf);
				break;
		case APCMD_GET_BEACON_PERIOD:
				(APICMDBUF_GET_BEACON_PERIOD*)pBuf = malloc(sizeof (APICMDBUF_GET_BEACON_PERIOD));

				((APICMDBUF_GET_BEACON_PERIOD*)pBuf)->cmdCode = CmdCode;
				((APICMDBUF_GET_BEACON_PERIOD*)pBuf)->seqNum = 1;
				((APICMDBUF_GET_BEACON_PERIOD*)pBuf)->cmdBodyLen = sizeof(APICMDBUF_GET_BEACON_PERIOD)-BUF_HDR_LEN;

				apctl(pBuf);

				if (pBuf->cmdStatus==APCTL_OK)
				{
					*((ULONG*)pResult) =  ((APICMDBUF_GET_BEACON_PERIOD*)pBuf)->beaconPeriod;
				}
				else
				{
					nStatus = STATUS_FAIL;
				}
				free ((APICMDBUF_GET_BEACON_PERIOD*)pBuf);
				break;
		case APCMD_GET_DTIM_PERIOD:
				(APICMDBUF_GET_DTIM_PERIOD*)pBuf = malloc(sizeof (APICMDBUF_GET_DTIM_PERIOD));

				((APICMDBUF_GET_DTIM_PERIOD*)pBuf)->cmdCode = CmdCode;
				((APICMDBUF_GET_DTIM_PERIOD*)pBuf)->seqNum = 1;
				((APICMDBUF_GET_DTIM_PERIOD*)pBuf)->cmdBodyLen = sizeof(APICMDBUF_GET_DTIM_PERIOD)-BUF_HDR_LEN;

				apctl(pBuf);

				if (pBuf->cmdStatus==APCTL_OK)
				{
					*((ULONG*)pResult) =  ((APICMDBUF_GET_DTIM_PERIOD*)pBuf)->dtimPeriod;
				}
				else
				{
					nStatus = STATUS_FAIL;
				}
				free ((APICMDBUF_GET_DTIM_PERIOD*)pBuf);
				break;
		case APCMD_GET_FRAG_THRESHOLD:
				(APICMDBUF_GET_FRAG_THRESHOLD*)pBuf = malloc(sizeof (APICMDBUF_GET_FRAG_THRESHOLD));

				((APICMDBUF_GET_FRAG_THRESHOLD*)pBuf)->cmdCode = CmdCode;
				((APICMDBUF_GET_FRAG_THRESHOLD*)pBuf)->seqNum = 1;
				((APICMDBUF_GET_FRAG_THRESHOLD*)pBuf)->cmdBodyLen = sizeof(APICMDBUF_GET_FRAG_THRESHOLD)-BUF_HDR_LEN;

				apctl(pBuf);

				if (pBuf->cmdStatus==APCTL_OK)
				{
					*((USHORT*)pResult) =  ((APICMDBUF_GET_FRAG_THRESHOLD*)pBuf)->fragThreshold;
				}
				else
				{
					nStatus = STATUS_FAIL;
				}
				free ((APICMDBUF_GET_FRAG_THRESHOLD*)pBuf);
				break;
		case APCMD_GET_RTS_THRESHOLD:
				(APICMDBUF_GET_RTS_THRESHOLD*)pBuf = malloc(sizeof (APICMDBUF_GET_RTS_THRESHOLD));

				((APICMDBUF_GET_RTS_THRESHOLD*)pBuf)->cmdCode = CmdCode;
				((APICMDBUF_GET_RTS_THRESHOLD*)pBuf)->seqNum = 1;
				((APICMDBUF_GET_RTS_THRESHOLD*)pBuf)->cmdBodyLen = sizeof(APICMDBUF_GET_RTS_THRESHOLD)-BUF_HDR_LEN;

				apctl(pBuf);

				if (pBuf->cmdStatus==APCTL_OK)
				{
					*((USHORT*)pResult) =  ((APICMDBUF_GET_RTS_THRESHOLD*)pBuf)->rtsThreshold;
				}
				else
				{
					nStatus = STATUS_FAIL;
				}
				free ((APICMDBUF_GET_RTS_THRESHOLD*)pBuf);
				break;
		case APCMD_GET_DATA_RETRY_LIMIT:
				(APICMDBUF_GET_DATA_RETRY_LIMIT*)pBuf = malloc(sizeof (APICMDBUF_GET_DATA_RETRY_LIMIT));

				((APICMDBUF_GET_DATA_RETRY_LIMIT*)pBuf)->cmdCode = CmdCode;
				((APICMDBUF_GET_DATA_RETRY_LIMIT*)pBuf)->seqNum = 1;
				((APICMDBUF_GET_DATA_RETRY_LIMIT*)pBuf)->cmdBodyLen = sizeof(APICMDBUF_GET_DATA_RETRY_LIMIT)-BUF_HDR_LEN;

				apctl(pBuf);

				if (pBuf->cmdStatus==APCTL_OK)
				{
					*((USHORT*)pResult) =  ((APICMDBUF_GET_DATA_RETRY_LIMIT*)pBuf)->dataRetryLimit;
				}
				else
				{
					nStatus = STATUS_FAIL;
				}
				free ((APICMDBUF_GET_DATA_RETRY_LIMIT*)pBuf);
				break;
		case APCMD_GET_RTS_RETRY_LIMIT:
				(APICMDBUF_GET_RTS_RETRY_LIMIT*)pBuf = malloc(sizeof (APICMDBUF_GET_RTS_RETRY_LIMIT));

				((APICMDBUF_GET_RTS_RETRY_LIMIT*)pBuf)->cmdCode = CmdCode;
				((APICMDBUF_GET_RTS_RETRY_LIMIT*)pBuf)->seqNum = 1;
				((APICMDBUF_GET_RTS_RETRY_LIMIT*)pBuf)->cmdBodyLen = sizeof(APICMDBUF_GET_RTS_RETRY_LIMIT)-BUF_HDR_LEN;

				apctl(pBuf);

				if (pBuf->cmdStatus==APCTL_OK)
				{
					*((USHORT*)pResult) =  ((APICMDBUF_GET_RTS_RETRY_LIMIT*)pBuf)->rtsRetryLimit;
				}
				else
				{
					nStatus = STATUS_FAIL;
				}
				free ((APICMDBUF_GET_RTS_RETRY_LIMIT*)pBuf);
				break;
		case APCMD_GET_RF_PREAMBLE_OPTION:
				(APICMBUF_GET_RF_PREAMBLE_OPTION*)pBuf = malloc(sizeof (APICMBUF_GET_RF_PREAMBLE_OPTION));

				((APICMBUF_GET_RF_PREAMBLE_OPTION*)pBuf)->cmdCode = CmdCode;
				((APICMBUF_GET_RF_PREAMBLE_OPTION*)pBuf)->seqNum = 1;
				((APICMBUF_GET_RF_PREAMBLE_OPTION*)pBuf)->cmdBodyLen = sizeof(APICMBUF_GET_RF_PREAMBLE_OPTION)-BUF_HDR_LEN;

				apctl(pBuf);

				if (pBuf->cmdStatus==APCTL_OK)
				{
					*((char*)pResult) =  ((APICMBUF_GET_RF_PREAMBLE_OPTION*)pBuf)->rfPreambleOption;
				}
				else
				{
					nStatus = STATUS_FAIL;
				}
				free ((APICMDBUF_GET_BEACON_PERIOD*)pBuf);
				break;
		case APCMD_GET_ANTENNA_MODE:
				(APICMDBUF_GET_ANTENNA_MODE*)pBuf = malloc(sizeof (APICMDBUF_GET_ANTENNA_MODE));

				((APICMDBUF_GET_ANTENNA_MODE*)pBuf)->cmdCode = CmdCode;
				((APICMDBUF_GET_ANTENNA_MODE*)pBuf)->seqNum = 1;
				((APICMDBUF_GET_ANTENNA_MODE*)pBuf)->cmdBodyLen = sizeof(APICMDBUF_GET_ANTENNA_MODE)-BUF_HDR_LEN;

				apctl(pBuf);

				if (pBuf->cmdStatus==APCTL_OK)
				{
					*((USHORT*)pResult) =  ((APICMDBUF_GET_ANTENNA_MODE*)pBuf)->rxAntennaMode |
								(((APICMDBUF_GET_ANTENNA_MODE*)pBuf)->txAntennaMode << 4) | 
								(((APICMDBUF_GET_ANTENNA_MODE*)pBuf)->whichAnt<< 8);
				}
				else
				{
					nStatus = STATUS_FAIL;
				}
				free ((APICMDBUF_GET_ANTENNA_MODE*)pBuf);
				break;
		case APCMD_GET_TX_DATA_RATE:
        case APCMD_GET_TX_DATA_RATE_G:
		case APCMD_GET_TX_DATA_RATE_A:
				(APICMDBUF_GET_TX_DATA_RATE*)pBuf = malloc(sizeof (APICMDBUF_GET_TX_DATA_RATE));
				((APICMDBUF_GET_TX_DATA_RATE*)pBuf)->cmdCode = CmdCode;
				((APICMDBUF_GET_TX_DATA_RATE*)pBuf)->seqNum= 1;
				((APICMDBUF_GET_TX_DATA_RATE*)pBuf)->cmdBodyLen = sizeof(APICMDBUF_GET_TX_DATA_RATE)-BUF_HDR_LEN;
				
				apctl(pBuf);

				if (pBuf->cmdStatus==APCTL_OK)
				{
					*pResult =  ((APICMDBUF_GET_TX_DATA_RATE*)pBuf)->txDataRate;
				}
				else
				{
					nStatus = STATUS_FAIL;
				}
				free ((APICMDBUF_GET_TX_DATA_RATE*)pBuf);
				break;
	/*	case APCMD_GET_SUP_DATA_RATES: */
		case APCMD_GET_BASIC_DATA_RATES:
				(APICMDBUF_GET_BASIC_DATA_RATES*)pBuf = malloc(sizeof (APICMDBUF_GET_BASIC_DATA_RATES));

				((APICMDBUF_GET_BASIC_DATA_RATES*)pBuf)->cmdCode = CmdCode;
				((APICMDBUF_GET_BASIC_DATA_RATES*)pBuf)->seqNum = 1;
				((APICMDBUF_GET_BASIC_DATA_RATES*)pBuf)->cmdBodyLen = sizeof(APICMDBUF_GET_BASIC_DATA_RATES)-BUF_HDR_LEN;

				apctl(pBuf);

				if (pBuf->cmdStatus==APCTL_OK)
				{
					memcpy(pResult, ((APICMDBUF_GET_BASIC_DATA_RATES*)pBuf)->basicDataRates, 8);  
				}
				else
				{
					nStatus = STATUS_FAIL;
				}
				free ((APICMDBUF_GET_BASIC_DATA_RATES*)pBuf);
				break;
		case APCMD_GET_BASIC_DATA_RATES_G:
			(APICMDBUF_GET_BASIC_DATA_RATES*)pBuf = malloc(sizeof (APICMDBUF_GET_BASIC_DATA_RATES_G));

			((APICMDBUF_GET_BASIC_DATA_RATES_G*)pBuf)->cmdCode = CmdCode;
			((APICMDBUF_GET_BASIC_DATA_RATES_G*)pBuf)->seqNum = 1;
			((APICMDBUF_GET_BASIC_DATA_RATES_G*)pBuf)->cmdBodyLen = sizeof(APICMDBUF_GET_BASIC_DATA_RATES_G)-BUF_HDR_LEN;

			apctl(pBuf);

			if (pBuf->cmdStatus==APCTL_OK)
			{
				memcpy(pResult, ((APICMDBUF_GET_BASIC_DATA_RATES*)pBuf)->basicDataRates, 16);  
			}
			else
			{
				nStatus = STATUS_FAIL;
			}
			free ((APICMDBUF_GET_BASIC_DATA_RATES*)pBuf);
			break;
	case APCMD_GET_AUTH_MODE:
		case APCMD_GET_AUTH_MODE_G:
				(APICMDBUF_GET_AUTH_MODE*)pBuf = malloc(sizeof (APICMDBUF_GET_AUTH_MODE));

				((APICMDBUF_GET_AUTH_MODE*)pBuf)->cmdCode = CmdCode;
				((APICMDBUF_GET_AUTH_MODE*)pBuf)->seqNum = 1;
				((APICMDBUF_GET_AUTH_MODE*)pBuf)->cmdBodyLen = sizeof(APICMDBUF_GET_AUTH_MODE)-BUF_HDR_LEN;

				apctl(pBuf);

				if (pBuf->cmdStatus==APCTL_OK)
				{
					*pResult = ((APICMDBUF_GET_AUTH_MODE*)pBuf)->authMode;
				}
				else
				{
					nStatus = STATUS_FAIL;
				}
				free ((APICMDBUF_GET_AUTH_MODE*)pBuf);
				break;
		case APCMD_GET_PRIVACY_OPTION:
		case APCMD_GET_PRIVACY_OPTION_G:
				(APICMDBUF_GET_PRIVACY_OPTION*)pBuf = malloc(sizeof (APICMDBUF_GET_PRIVACY_OPTION));

				((APICMDBUF_GET_PRIVACY_OPTION*)pBuf)->cmdCode = CmdCode;
				((APICMDBUF_GET_PRIVACY_OPTION*)pBuf)->seqNum = 1;
				((APICMDBUF_GET_PRIVACY_OPTION*)pBuf)->cmdBodyLen = sizeof(APICMDBUF_GET_PRIVACY_OPTION)-BUF_HDR_LEN;

				apctl(pBuf);

				if (pBuf->cmdStatus==APCTL_OK)
				{
					*pResult = ((APICMDBUF_GET_PRIVACY_OPTION*)pBuf)->dataEncrypt;
				}
				else
				{
					nStatus = STATUS_FAIL;
				}
				free ((APICMDBUF_GET_PRIVACY_OPTION*)pBuf);
				break;
		case APCMD_GET_DEFAULT_WEP_KEYS:
		case APCMD_GET_DEFAULT_WEP_KEYS_G:
				(APICMDBUF_GET_DEFAULT_WEP_KEYS*)pBuf = malloc(sizeof (APICMDBUF_GET_DEFAULT_WEP_KEYS));

				((APICMDBUF_GET_DEFAULT_WEP_KEYS*)pBuf)->cmdCode = CmdCode;
				((APICMDBUF_GET_DEFAULT_WEP_KEYS*)pBuf)->seqNum = 1;
				((APICMDBUF_GET_DEFAULT_WEP_KEYS*)pBuf)->cmdBodyLen = sizeof(APICMDBUF_GET_DEFAULT_WEP_KEYS)-BUF_HDR_LEN;

				apctl(pBuf);

				if (pBuf->cmdStatus==APCTL_OK)
				{
					memcpy(pResult, &(((APICMDBUF_GET_DEFAULT_WEP_KEYS*)pBuf)->keyindex), sizeof (WEP_KEY));  
				}
				else
				{
					nStatus = STATUS_FAIL;
				}
				free ((APICMDBUF_GET_DEFAULT_WEP_KEYS*)pBuf);
				break;
		case APCMD_GET_STA_LIST:
				pBuf = malloc(sizeof (APICMDBUF)+ (*((USHORT*)pResult)));
				pBuf->cmdCode = CmdCode;
				pBuf->seqNum = 1;
				pBuf->cmdBodyLen = *((USHORT*)pResult);
				pBuf->cmdBody = (char*)pBuf+sizeof(APICMDBUF);;		
				apctl(pBuf);
				if (pBuf->cmdStatus==APCTL_OK)
				{
					memcpy(pResult, pBuf->cmdBody, pBuf->cmdBodyLen);
				}
				else if (pBuf->cmdStatus==APCTL_BUF_TOO_SMALL)
				{
					*((USHORT*)pResult) = pBuf->cmdBodyLen;
					nStatus = STATUS_BUFFER_TOO_SMALL;
				}else
				{
					*((USHORT*)pResult) = 0;
					nStatus = STATUS_FAIL;
				}
				free (pBuf);
				break;
		case APCMD_GET_WLAN_FILTER_LIST:
				pBuf = malloc(sizeof (APICMDBUF)+(*((USHORT*)pResult)));
				pBuf->cmdCode = CmdCode;
				pBuf->seqNum = 1;
				pBuf->cmdBodyLen = *((USHORT*)pResult);
				pBuf->cmdBody = (char*)pBuf+sizeof(APICMDBUF);		
				apctl(pBuf);
				if (pBuf->cmdStatus==APCTL_OK)
				{
					memcpy(pResult, pBuf->cmdBody, pBuf->cmdBodyLen);
				}
				else if (pBuf->cmdStatus==APCTL_BUF_TOO_SMALL)
				{
					*((USHORT*)pResult) = pBuf->cmdBodyLen;
					nStatus = STATUS_BUFFER_TOO_SMALL;
				}else
				{
					nStatus = STATUS_FAIL;
				}
				//free (pBuf->cmdBody);
				free (pBuf);
				break;
       case APCMD_GET_WLAN_FILTER_MODE:
            ((APICMDBUF_FILTER_MODE *)pBuf) = malloc(sizeof (APICMDBUF_FILTER_MODE));
            ((APICMDBUF_FILTER_MODE *)pBuf)->cmdCode = CmdCode;
            ((APICMDBUF_FILTER_MODE *)pBuf)->seqNum = 1;
            ((APICMDBUF_FILTER_MODE *)pBuf)->cmdBodyLen = 1;
			  	apctl(pBuf);
            if (((APICMDBUF_FILTER_MODE *)pBuf)->cmdStatus==APCTL_OK)
				{
                *pResult = ((APICMDBUF_FILTER_MODE *)pBuf)->mode;
            }else
				{
					nStatus = STATUS_FAIL;
				}
            free (((APICMDBUF_FILTER_MODE *)pBuf));
				break;
		case APCMD_GET_ETH_IP_CONFIG:
				(APICMDBUF_GET_ETH_IP_CONFIG*)pBuf = malloc(sizeof (APICMDBUF_GET_ETH_IP_CONFIG));

				((APICMDBUF_GET_ETH_IP_CONFIG*)pBuf)->cmdCode = CmdCode;
				((APICMDBUF_GET_ETH_IP_CONFIG*)pBuf)->seqNum = 1;
				((APICMDBUF_GET_ETH_IP_CONFIG*)pBuf)->cmdBodyLen = sizeof(APICMDBUF_GET_ETH_IP_CONFIG)-BUF_HDR_LEN;

				apctl(pBuf);

				if (pBuf->cmdStatus==APCTL_OK)
				{
					memcpy(pResult, (UCHAR*)&(((APICMDBUF_GET_ETH_IP_CONFIG *)pBuf)->dhcpEnabled), 16);  
				}
				else
				{
					nStatus = STATUS_FAIL;
				}
				free ((APICMDBUF_GET_ETH_IP_CONFIG*)pBuf);
				break;
		case APCMD_GET_PRIVACY_TBL_RSN_ENABLED:
				(APICMDBUF_GET_PRIVACY_TBL_RSN_ENABLED*)pBuf = malloc(sizeof (APICMDBUF_GET_PRIVACY_TBL_RSN_ENABLED));
				((APICMDBUF_GET_PRIVACY_TBL_RSN_ENABLED*)pBuf)->cmdCode = CmdCode;
				((APICMDBUF_GET_PRIVACY_TBL_RSN_ENABLED*)pBuf)->seqNum = 1;
				((APICMDBUF_GET_PRIVACY_TBL_RSN_ENABLED*)pBuf)->cmdBodyLen = sizeof(APICMDBUF_GET_PRIVACY_TBL_RSN_ENABLED)-BUF_HDR_LEN;
			  	apctl(pBuf);
				if (pBuf->cmdStatus==APCTL_OK)
				{
					*((UCHAR*)pResult) = ((APICMDBUF_GET_PRIVACY_TBL_RSN_ENABLED*)pBuf)->Enabled;
				}
				else
				{
					*((USHORT*)pResult) = 0;
					nStatus = STATUS_FAIL;
				}
				free (pBuf);
				break;
#ifdef AP_WPA2
        case APCMD_GET_WPA2_ENABLED:
                (APICMDBUF_GET_WPA2_ENABLED*)pBuf = malloc(sizeof (APICMDBUF_GET_WPA2_ENABLED));
                ((APICMDBUF_GET_WPA2_ENABLED*)pBuf)->cmdCode = CmdCode;
                ((APICMDBUF_GET_WPA2_ENABLED*)pBuf)->seqNum = 1;
                ((APICMDBUF_GET_WPA2_ENABLED*)pBuf)->cmdBodyLen = sizeof(APICMDBUF_GET_WPA2_ENABLED)-BUF_HDR_LEN;
                apctl(pBuf);
                if (pBuf->cmdStatus==APCTL_OK)
                {
                    *((UCHAR*)pResult) = ((APICMDBUF_GET_WPA2_ENABLED*)pBuf)->Enabled;
                }
                else
                {
                    *((USHORT*)pResult) = 0;
                    nStatus = STATUS_FAIL;
                }
                free (pBuf);
                break;
        case APCMD_GET_WPA2ONLY_ENABLED:
                (APICMDBUF_GET_WPA2ONLY_ENABLED*)pBuf = malloc(sizeof (APICMDBUF_GET_WPA2ONLY_ENABLED));
                ((APICMDBUF_GET_WPA2ONLY_ENABLED*)pBuf)->cmdCode = CmdCode;
                ((APICMDBUF_GET_WPA2ONLY_ENABLED*)pBuf)->seqNum = 1;
                ((APICMDBUF_GET_WPA2ONLY_ENABLED*)pBuf)->cmdBodyLen = sizeof(APICMDBUF_GET_WPA2ONLY_ENABLED)-BUF_HDR_LEN;
                apctl(pBuf);
                if (pBuf->cmdStatus==APCTL_OK)
                {
                    *((UCHAR*)pResult) = ((APICMDBUF_GET_WPA2ONLY_ENABLED*)pBuf)->Enabled;
                }
                else
                {
                    *((USHORT*)pResult) = 0;
                    nStatus = STATUS_FAIL;
                }
                free (pBuf);
                break;
    case APCMD_GET_RSN_CFG_WPA2_UNICAST_CIPHER2:
            (APICMDBUF_GET_RSN_CFG_WPA2_UNICAST_CIPHER2*)pBuf = malloc(sizeof (APICMDBUF_GET_RSN_CFG_WPA2_UNICAST_CIPHER2));
            ((APICMDBUF_GET_RSN_CFG_WPA2_UNICAST_CIPHER2*)pBuf)->cmdCode = CmdCode;
            ((APICMDBUF_GET_RSN_CFG_WPA2_UNICAST_CIPHER2*)pBuf)->seqNum = 1;
            ((APICMDBUF_GET_RSN_CFG_WPA2_UNICAST_CIPHER2*)pBuf)->cmdBodyLen = sizeof(APICMDBUF_GET_RSN_CFG_WPA2_UNICAST_CIPHER2)-BUF_HDR_LEN;
            apctl(pBuf);
            if (pBuf->cmdStatus==APCTL_OK)
            {
                *((UCHAR*)pResult  ) = ((APICMDBUF_GET_RSN_CFG_WPA2_UNICAST_CIPHER2*)pBuf)->UnicastCipher[0];
                *((UCHAR*)pResult+1) = ((APICMDBUF_GET_RSN_CFG_WPA2_UNICAST_CIPHER2*)pBuf)->UnicastCipher[1];
                *((UCHAR*)pResult+2) = ((APICMDBUF_GET_RSN_CFG_WPA2_UNICAST_CIPHER2*)pBuf)->UnicastCipher[2];
                *((UCHAR*)pResult+3) = ((APICMDBUF_GET_RSN_CFG_WPA2_UNICAST_CIPHER2*)pBuf)->UnicastCipher[3];
            }
            else
            {
                *((USHORT*)pResult) = 0;
                nStatus = STATUS_FAIL;
            }
            free (pBuf);
            break;
#endif
    case APCMD_GET_RSN_CFG_UNICAST_CIPHER:
            (APICMDBUF_GET_RSN_CFG_UNICAST_CIPHER*)pBuf = malloc(sizeof (APICMDBUF_GET_RSN_CFG_UNICAST_CIPHER));
            ((APICMDBUF_GET_RSN_CFG_UNICAST_CIPHER*)pBuf)->cmdCode = CmdCode;
            ((APICMDBUF_GET_RSN_CFG_UNICAST_CIPHER*)pBuf)->seqNum = 1;
            ((APICMDBUF_GET_RSN_CFG_UNICAST_CIPHER*)pBuf)->cmdBodyLen = sizeof(APICMDBUF_GET_RSN_CFG_UNICAST_CIPHER)-BUF_HDR_LEN;
            apctl(pBuf);
            if (pBuf->cmdStatus==APCTL_OK)
            {
                *((UCHAR*)pResult  ) = ((APICMDBUF_GET_RSN_CFG_UNICAST_CIPHER*)pBuf)->UnicastCipher[0];
                *((UCHAR*)pResult+1) = ((APICMDBUF_GET_RSN_CFG_UNICAST_CIPHER*)pBuf)->UnicastCipher[1];
                *((UCHAR*)pResult+2) = ((APICMDBUF_GET_RSN_CFG_UNICAST_CIPHER*)pBuf)->UnicastCipher[2];
                *((UCHAR*)pResult+3) = ((APICMDBUF_GET_RSN_CFG_UNICAST_CIPHER*)pBuf)->UnicastCipher[3];
            }
            else
            {
                *((USHORT*)pResult) = 0;
                nStatus = STATUS_FAIL;
            }
            free (pBuf);
            break;
		case APCMD_GET_RSN_CFG_AUTH_SUITE:
				(APICMDBUF_GET_RSN_CFG_AUTH_SUITE*)pBuf = malloc(sizeof (APICMDBUF_GET_RSN_CFG_AUTH_SUITE));
				((APICMDBUF_GET_RSN_CFG_AUTH_SUITE*)pBuf)->cmdCode = CmdCode;
				((APICMDBUF_GET_RSN_CFG_AUTH_SUITE*)pBuf)->seqNum = 1;
				((APICMDBUF_GET_RSN_CFG_AUTH_SUITE*)pBuf)->cmdBodyLen = sizeof(APICMDBUF_GET_RSN_CFG_AUTH_SUITE)-BUF_HDR_LEN;
				apctl(pBuf);
				if (pBuf->cmdStatus==APCTL_OK)
				{
					*((UCHAR*)pResult  ) = ((APICMDBUF_GET_RSN_CFG_AUTH_SUITE*)pBuf)->AuthSuites[0];
					*((UCHAR*)pResult+1) = ((APICMDBUF_GET_RSN_CFG_AUTH_SUITE*)pBuf)->AuthSuites[1];
					*((UCHAR*)pResult+2) = ((APICMDBUF_GET_RSN_CFG_AUTH_SUITE*)pBuf)->AuthSuites[2];
					*((UCHAR*)pResult+3) = ((APICMDBUF_GET_RSN_CFG_AUTH_SUITE*)pBuf)->AuthSuites[3];
				}
				else
				{
					*((USHORT*)pResult) = 0;
					nStatus = STATUS_FAIL;
				}
				free (pBuf);
				break;
		case APCMD_GET_RSN_STATS:
				(APICMDBUF_GET_RSN_STATS*)pBuf = malloc(sizeof (APICMDBUF_GET_RSN_STATS));
				((APICMDBUF_GET_RSN_STATS*)pBuf)->cmdCode = CmdCode;
				((APICMDBUF_GET_RSN_STATS*)pBuf)->seqNum = 1;
				((APICMDBUF_GET_RSN_STATS*)pBuf)->cmdBodyLen = sizeof(APICMDBUF_GET_RSN_STATS)-BUF_HDR_LEN;
			  	apctl(pBuf);
				if (pBuf->cmdStatus==APCTL_OK)
				{
					memcpy(pResult, pBuf, sizeof(APICMDBUF_GET_RSN_STATS));
				}
				else
				{
					memset(pResult, 0, sizeof(APICMDBUF_GET_RSN_STATS));
					nStatus = STATUS_FAIL;
				}
				free (pBuf);
				break;
        case APCMD_GET_RSN_CFG_TBL:
                (APICMDBUF_GET_RSN_CFG_TBL*)pBuf = malloc(sizeof (APICMDBUF_GET_RSN_CFG_TBL));
                ((APICMDBUF_GET_RSN_CFG_TBL*)pBuf)->cmdCode = CmdCode;
                ((APICMDBUF_GET_RSN_CFG_TBL*)pBuf)->seqNum = 1;
                ((APICMDBUF_GET_RSN_CFG_TBL*)pBuf)->cmdBodyLen = sizeof(APICMDBUF_GET_RSN_CFG_TBL)-BUF_HDR_LEN;
			  	apctl(pBuf);
				if (pBuf->cmdStatus==APCTL_OK)
				{
                    memcpy(pResult, pBuf, sizeof(APICMDBUF_GET_RSN_CFG_TBL));
				}
				else
				{
                    memset(pResult, 0, sizeof(APICMDBUF_GET_RSN_CFG_TBL));
					nStatus = STATUS_FAIL;
				}
				free (pBuf);
				break;
		case APCMD_GET_AP_MODE:
				(APICMDBUF_GET_AP_MODE*)pBuf = malloc(sizeof (APICMDBUF_GET_AP_MODE));
				((APICMDBUF_GET_AP_MODE*)pBuf)->cmdCode = CmdCode;
				((APICMDBUF_GET_AP_MODE*)pBuf)->seqNum = 1;
				((APICMDBUF_GET_AP_MODE*)pBuf)->cmdBodyLen = sizeof(APICMDBUF_GET_AP_MODE)-BUF_HDR_LEN;

				apctl(pBuf);

				if (pBuf->cmdStatus==APCTL_OK)
				{
					*((USHORT*)pResult) =  ((APICMDBUF_GET_AP_MODE*)pBuf)->apMode;
				}
				else
				{
					nStatus = STATUS_FAIL;
				}
				free ((APICMDBUF_GET_AP_MODE*)pBuf);
				break;	
#ifdef BURST_MODE
        case APCMD_GET_BURST_MODE:
				(APICMDBUF_GET_BURST_MODE*)pBuf = malloc(sizeof (APICMDBUF_GET_BURST_MODE));
				((APICMDBUF_GET_BURST_MODE*)pBuf)->cmdCode = CmdCode;
				((APICMDBUF_GET_BURST_MODE*)pBuf)->seqNum = 1;
				((APICMDBUF_GET_BURST_MODE*)pBuf)->cmdBodyLen = sizeof(APICMDBUF_GET_BURST_MODE)-BUF_HDR_LEN;

				apctl(pBuf);

				if (pBuf->cmdStatus==APCTL_OK)
				{
					((BURST_INFO *)pResult)->BurstMode =  ((APICMDBUF_GET_BURST_MODE*)pBuf)->burstMode;
					((BURST_INFO *)pResult)->BurstRate =  ((APICMDBUF_GET_BURST_MODE*)pBuf)->burstRate;
				}
				else
				{
					nStatus = STATUS_FAIL;
				}
				free ((APICMDBUF_GET_BURST_MODE*)pBuf);
				break;									
#endif		
		case APCMD_GET_FORCE_PROTECTION_MODE:
				(APICMDBUF_GET_FORCE_PROTECTION_MODE*)pBuf = malloc(sizeof (APICMDBUF_GET_FORCE_PROTECTION_MODE));
				((APICMDBUF_GET_FORCE_PROTECTION_MODE*)pBuf)->cmdCode = CmdCode;
				((APICMDBUF_GET_FORCE_PROTECTION_MODE*)pBuf)->seqNum = 1;
				((APICMDBUF_GET_FORCE_PROTECTION_MODE*)pBuf)->cmdBodyLen = sizeof(APICMDBUF_GET_FORCE_PROTECTION_MODE)-BUF_HDR_LEN;

				apctl(pBuf);

				if (pBuf->cmdStatus==APCTL_OK)
				{
					*((USHORT*)pResult) =  ((APICMDBUF_GET_FORCE_PROTECTION_MODE*)pBuf)->forceProtectMode;
				}
				else
				{
					nStatus = STATUS_FAIL;
				}
				free ((APICMDBUF_GET_FORCE_PROTECTION_MODE*)pBuf);
				break;		

#if defined(WIPOD)
		case APCMD_GET_WIPOD_MODE:
			pBuf = malloc(sizeof(APICMDBUF_GET_WIPOD_MODE));
			pBuf->cmdCode = CmdCode;
			pBuf->seqNum = 1;
			pBuf->cmdBodyLen = sizeof(APICMDBUF_GET_WIPOD_MODE) - 4*sizeof(unsigned short);
            				
			apctl(pBuf);

			if (pBuf->cmdStatus == APCTL_OK) 
			{
				*((UCHAR*)pResult) = ((APICMDBUF_GET_WIPOD_MODE *)pBuf)->mode;

                /* Temp. If it's not AP/WB we need to copy more data.
                if( ((APICMDBUF_GET_WIPOD_MODE *)pBuf)->mode != 0x01 
                    && ((APICMDBUF_GET_WIPOD_MODE *)pBuf)->mode != 0x82 ) 
                {
                    memcpy(pResult, pBuf->cmdBody, pBuf->cmdBodyLen);
                }*/
			}
			else
			{
				nStatus = STATUS_FAIL;
			}
			free (pBuf);
			break;
#endif /* WIPOD */

#ifdef WDS_FEATURE
		case APCMD_GET_WDS_MODE:
			pBuf = malloc(sizeof (APICMDBUF)+2);
			pBuf->cmdCode = CmdCode;
			pBuf->seqNum = 1;
			pBuf->cmdBody = (char *)pBuf+sizeof(APICMDBUF);
			pBuf->cmdBodyLen = 2;			

			apctl(pBuf);

			if (pBuf->cmdStatus==APCTL_OK)
			{
				*((UCHAR*)pResult) =  pBuf->cmdBody[0];
			}
			else
			{
				nStatus = STATUS_FAIL;
			}
			//free (pBuf->cmdBody);
			free (pBuf);
			break;
		case APCMD_GET_WDS_LIST:
				pBuf = malloc(sizeof (APICMDBUF)+6*MAX_WDS_AP_LIST+2);
				pBuf->cmdCode = CmdCode;
				pBuf->seqNum = 1;
				pBuf->cmdBodyLen = 6*MAX_WDS_AP_LIST+2;
				pBuf->cmdBody = (char*)pBuf+sizeof(APICMDBUF);		
				apctl(pBuf);
				if (pBuf->cmdStatus==APCTL_OK)
				{
					memcpy(pResult, pBuf->cmdBody, pBuf->cmdBodyLen);
				}
				else
				{
					nStatus = STATUS_FAIL;
				}
				//free (pBuf->cmdBody);
				free (pBuf);
				break;
		case APCMD_GET_DISABLE_ASSOC:
			pBuf = malloc(sizeof (APICMDBUF)+2);
			pBuf->cmdCode = CmdCode;
			pBuf->seqNum = 1;
			pBuf->cmdBody = (char *)pBuf+sizeof(APICMDBUF);
			pBuf->cmdBodyLen = 2;			

			apctl(pBuf);

			if (pBuf->cmdStatus==APCTL_OK)
			{
				*((UCHAR*)pResult) =  pBuf->cmdBody[0];
			}
			else
			{
				nStatus = STATUS_FAIL;
			}
			//free (pBuf->cmdBody);
			free (pBuf);
			break;
		case APCMD_GET_WDS_OPTION:
			pBuf = malloc(sizeof (APICMDBUF)+2);
			pBuf->cmdCode = CmdCode;
			pBuf->seqNum = 1;
			pBuf->cmdBody = (char *)pBuf+sizeof(APICMDBUF);
			pBuf->cmdBodyLen = 2;			

			apctl(pBuf);

			if (pBuf->cmdStatus==APCTL_OK)
			{
				*((UCHAR*)pResult) =  pBuf->cmdBody[0];
			}
			else
			{
				nStatus = STATUS_FAIL;
			}
			//free (pBuf->cmdBody);
			free (pBuf);
			break;
#endif 
#ifdef AP_SITE_SURVEY
        case APCMD_GET_SURVEY_INFO:
				(APICMDBUF_GET_SURVEY_INFO*)pBuf = malloc(sizeof (APICMDBUF_GET_SURVEY_INFO));
				((APICMDBUF_GET_SURVEY_INFO*)pBuf)->cmdCode = CmdCode;
				((APICMDBUF_GET_SURVEY_INFO*)pBuf)->seqNum = 1;
				((APICMDBUF_GET_SURVEY_INFO*)pBuf)->cmdBodyLen = sizeof(APICMDBUF_GET_SURVEY_INFO)-BUF_HDR_LEN;
			  	apctl(pBuf);
				if (pBuf->cmdStatus==APCTL_OK)
				{
					memcpy(pResult, pBuf, sizeof (APICMDBUF_GET_SURVEY_INFO));
				}
				else
				{
					nStatus = STATUS_FAIL;
				}
				free (pBuf);
				break;
#endif /* AP_SITE_SURVEY */
#ifdef SELF_CTS
    case APCMD_GET_SELF_CTS:
            (APICMDBUF_GET_SELF_CTS*)pBuf = malloc(sizeof (APICMDBUF_GET_SELF_CTS));
            ((APICMDBUF_GET_SELF_CTS*)pBuf)->cmdCode = CmdCode;
            ((APICMDBUF_GET_SELF_CTS*)pBuf)->seqNum = 1;
            ((APICMDBUF_GET_SELF_CTS*)pBuf)->cmdBodyLen = sizeof(APICMDBUF_GET_SELF_CTS)-BUF_HDR_LEN;

            apctl(pBuf);

            if (pBuf->cmdStatus==APCTL_OK)
            {
                *((UCHAR*)pResult) =  ((APICMDBUF_GET_SELF_CTS*)pBuf)->SelfCts;
            }
            else
            {
                nStatus = STATUS_FAIL;
            }
            free ((APICMDBUF_GET_SELF_CTS*)pBuf);
            break;		
#endif
#ifdef TURBO_SETUP
    case APCMD_GET_AUTO_LINK_MODE:
            (APICMDBUF_GET_AUTO_LINK_MODE*)pBuf = malloc(sizeof (APICMDBUF_GET_AUTO_LINK_MODE));
            ((APICMDBUF_GET_AUTO_LINK_MODE*)pBuf)->cmdCode = CmdCode;
            ((APICMDBUF_GET_AUTO_LINK_MODE*)pBuf)->seqNum = 1;
            ((APICMDBUF_GET_AUTO_LINK_MODE*)pBuf)->cmdBodyLen = sizeof(APICMDBUF_GET_AUTO_LINK_MODE)-BUF_HDR_LEN;

            apctl(pBuf);

            if (pBuf->cmdStatus == APCTL_OK)
            {
                *pResult = ((APICMDBUF_GET_AUTO_LINK_MODE*)pBuf)->AutoLink;
            }
            else
            {
                nStatus = STATUS_FAIL;
            }
            free((APICMDBUF_GET_AUTO_LINK_MODE*)pBuf);
            break;
#endif
#ifdef BOOSTER_MODE
    case APCMD_GET_BOOSTER_MODE:
            (APICMDBUF_GET_BOOSTER_MODE*)pBuf = malloc(sizeof (APICMDBUF_GET_BOOSTER_MODE));
            ((APICMDBUF_GET_BOOSTER_MODE*)pBuf)->cmdCode = CmdCode;
            ((APICMDBUF_GET_BOOSTER_MODE*)pBuf)->seqNum = 1;
            ((APICMDBUF_GET_BOOSTER_MODE*)pBuf)->cmdBodyLen = sizeof(APICMDBUF_GET_BOOSTER_MODE)-BUF_HDR_LEN;

            apctl(pBuf);

            if (pBuf->cmdStatus == APCTL_OK)
            {
                *pResult = ((APICMDBUF_GET_BOOSTER_MODE*)pBuf)->BoosterMode;
            }
            else
            {
                nStatus = STATUS_FAIL;
            }
            free((APICMDBUF_GET_BOOSTER_MODE*)pBuf);
            break;
#endif
#ifdef IEEE80211H
    case APCMD_GET_SPECTRUM_MGMT:
            (APICMDBUF_GET_SPECTRUM_MGMT*)pBuf = malloc(sizeof (APICMDBUF_GET_SPECTRUM_MGMT));
            ((APICMDBUF_GET_SPECTRUM_MGMT*)pBuf)->cmdCode = CmdCode;
            ((APICMDBUF_GET_SPECTRUM_MGMT*)pBuf)->seqNum = 1;
            ((APICMDBUF_GET_SPECTRUM_MGMT*)pBuf)->cmdBodyLen = sizeof(APICMDBUF_GET_SPECTRUM_MGMT)-BUF_HDR_LEN;

            apctl(pBuf);

            if (pBuf->cmdStatus == APCTL_OK)
            {
                *pResult = ((APICMDBUF_GET_SPECTRUM_MGMT*)pBuf)->isEnable;
            }
            else
            {
                nStatus = STATUS_FAIL;
            }
            free((APICMDBUF_GET_SPECTRUM_MGMT*)pBuf);
            break;
    case APCMD_GET_MITIGATION:
            (APICMDBUF_GET_MITIGATION*)pBuf = malloc(sizeof (APICMDBUF_GET_MITIGATION));
			((APICMDBUF_GET_MITIGATION*)pBuf)->cmdCode = CmdCode;
			((APICMDBUF_GET_MITIGATION*)pBuf)->seqNum = 1;
			((APICMDBUF_GET_MITIGATION*)pBuf)->cmdBodyLen = sizeof(APICMDBUF_GET_MITIGATION)-BUF_HDR_LEN;

			apctl(pBuf);
			if (pBuf->cmdStatus==APCTL_OK)
			{
#ifdef ENABLE_ETH_DEBUG 
			    eprintf("ApCmdGetProc = %d \n", ((APICMDBUF_GET_MITIGATION*)pBuf)->mitigationValue); 
#endif
				*((UINT32*)pResult) =  ((APICMDBUF_GET_MITIGATION*)pBuf)->mitigationValue;
			}
			else
			{
				nStatus = STATUS_FAIL;
			}
			free ((APICMDBUF_GET_MITIGATION*)pBuf);
            break;
     case APCMD_GET_REGULATORY_DOMAIN:
            (APICMDBUF_GET_REGULATORY_DOMAIN*)pBuf = malloc(sizeof (APICMDBUF_GET_REGULATORY_DOMAIN));
			((APICMDBUF_GET_REGULATORY_DOMAIN*)pBuf)->cmdCode = CmdCode;
			((APICMDBUF_GET_REGULATORY_DOMAIN*)pBuf)->seqNum = 1;
			((APICMDBUF_GET_REGULATORY_DOMAIN*)pBuf)->cmdBodyLen = sizeof(APICMDBUF_GET_REGULATORY_DOMAIN)-BUF_HDR_LEN;

			apctl(pBuf);
			if (pBuf->cmdStatus==APCTL_OK)
			{
#ifdef ENABLE_ETH_DEBUG 
			    eprintf("ApCmdGetProc = %d \n", ((APICMDBUF_GET_REGULATORY_DOMAIN*)pBuf)->domain); 
#endif
				*((UINT32*)pResult) =  ((APICMDBUF_GET_REGULATORY_DOMAIN*)pBuf)->domain;
			}
			else
			{
				nStatus = STATUS_FAIL;
			}
			free ((APICMDBUF_GET_REGULATORY_DOMAIN*)pBuf);
            break;       
#endif
#ifdef DCS
    case APCMD_GET_DCS_MODE:
            (APICMDBUF_GET_DCS_MODE*)pBuf = malloc(sizeof (APICMDBUF_GET_DCS_MODE));
            ((APICMDBUF_GET_DCS_MODE*)pBuf)->cmdCode = CmdCode;
            ((APICMDBUF_GET_DCS_MODE*)pBuf)->seqNum = 1;
            ((APICMDBUF_GET_DCS_MODE*)pBuf)->cmdBodyLen = sizeof(APICMDBUF_GET_DCS_MODE)-BUF_HDR_LEN;
            apctl(pBuf);

            if (pBuf->cmdStatus == APCTL_OK)
            {
                *pResult = ((APICMDBUF_GET_DCS_MODE*)pBuf)->DCSMode;
            }
            else
            {
                nStatus = STATUS_FAIL;
            }
            free((APICMDBUF_GET_DCS_MODE*)pBuf);
            break;
        case APCMD_GET_BGSCAN_DATA:
				(APICMDBUF_GET_BGSCAN_DATA*)pBuf = malloc(sizeof (APICMDBUF_GET_BGSCAN_DATA));
				((APICMDBUF_GET_BGSCAN_DATA*)pBuf)->cmdCode = CmdCode;
				((APICMDBUF_GET_BGSCAN_DATA*)pBuf)->seqNum = 1;
				((APICMDBUF_GET_BGSCAN_DATA*)pBuf)->cmdBodyLen = sizeof(APICMDBUF_GET_BGSCAN_DATA)-BUF_HDR_LEN;
			  	apctl(pBuf);
				if (pBuf->cmdStatus==APCTL_OK)
				{
					memcpy(pResult, pBuf, sizeof(APICMDBUF_GET_BGSCAN_DATA));
				}
				else
				{
					nStatus = STATUS_FAIL;
				}
				free (pBuf);
				break;
        case APCMD_GET_CHWEIGHT_DATA:
				(APICMDBUF_GET_CHWGT_DATA*)pBuf = malloc(sizeof (APICMDBUF_GET_CHWGT_DATA));
				((APICMDBUF_GET_CHWGT_DATA*)pBuf)->cmdCode = CmdCode;
				((APICMDBUF_GET_CHWGT_DATA*)pBuf)->seqNum = 1;
				((APICMDBUF_GET_CHWGT_DATA*)pBuf)->cmdBodyLen = sizeof(APICMDBUF_GET_CHWGT_DATA)-BUF_HDR_LEN;
			  	apctl(pBuf);
				if (pBuf->cmdStatus==APCTL_OK)
				{
					memcpy(pResult, pBuf, sizeof(APICMDBUF_GET_CHWGT_DATA));
				}
				else
				{
					nStatus = STATUS_FAIL;
				}
				free (pBuf);
				break;
#endif /* DCS */

		case APCMD_GET_STA_AVERSSI:
				(APICMDBUF_GET_STA_AVERSSI*)pBuf = malloc(sizeof (APICMDBUF_GET_STA_AVERSSI));
    			if(pBuf == NULL)
				{
					return STATUS_FAIL;
				}
				((APICMDBUF_GET_STA_AVERSSI*)pBuf)->cmdCode = CmdCode;
				((APICMDBUF_GET_STA_AVERSSI*)pBuf)->seqNum = 1;
				((APICMDBUF_GET_STA_AVERSSI*)pBuf)->cmdBodyLen = sizeof(APICMDBUF_GET_STA_AVERSSI)-BUF_HDR_LEN;
				memcpy((char *)&(((APICMDBUF_GET_STA_AVERSSI*)pBuf)->aveRssiInfo), pResult, sizeof (API_STA_AVERSSI));
				
				apctl(pBuf);

				if (pBuf->cmdStatus==APCTL_OK)
				{
					memcpy(pResult, (char *)&(((APICMDBUF_GET_STA_AVERSSI*)pBuf)->aveRssiInfo), sizeof (API_STA_AVERSSI));
				}
				else
				{
					nStatus = STATUS_FAIL;
				}
				free ((APICMDBUF_GET_STA_AVERSSI*)pBuf);
				break;
		
		case APCMD_GET_AGING_STATE:
				(APICMDBUF_GET_AGING_STATE*)pBuf = malloc(sizeof (APICMDBUF_GET_AGING_STATE));
				if(pBuf == NULL)
				{
					return STATUS_FAIL;
				}
				((APICMDBUF_GET_AGING_STATE*)pBuf)->cmdCode = CmdCode;
				((APICMDBUF_GET_AGING_STATE*)pBuf)->seqNum = 1;
				((APICMDBUF_GET_AGING_STATE*)pBuf)->cmdBodyLen = sizeof(APICMDBUF_GET_AGING_STATE)-BUF_HDR_LEN;

				apctl(pBuf);

				if (pBuf->cmdStatus == APCTL_OK)
				{
					*((SINT32*)pResult) =  ((APICMDBUF_GET_AGING_STATE*)pBuf)->agingTime;
				}
				else
				{
					nStatus = STATUS_FAIL;
				}
				free((APICMDBUF_GET_AGING_STATE*)pBuf);
				break;

        default: nStatus = STATUS_FAIL; 
				 break;
	}

	return nStatus;

}

extern void Reset(void);

WL_STATUS ApCmdSetProc(UINT16 CmdCode, char *pData)
{
	APICMDBUF *pBuf;
	WL_STATUS  nStatus;
	int i;
	
	switch (CmdCode)
	{
		APICMDBUF *pBuf; 
	
                //start MRVL
                #if defined(GATEWAY) || defined(DHCPS)
                case APCMD_SET_ETH_DHCPS_CONFIG:

                              (APICMDBUF_SET_ETH_DHCPS_CONFIG*)pBuf = malloc(sizeof (APICMDBUF_SET_ETH_DHCPS_CONFIG));
                              ((APICMDBUF_SET_ETH_DHCPS_CONFIG*)pBuf)->cmdCode = CmdCode;
                              ((APICMDBUF_SET_ETH_DHCPS_CONFIG*)pBuf)->seqNum = 1;
                              ((APICMDBUF_SET_ETH_DHCPS_CONFIG*)pBuf)->cmdBodyLen = sizeof(APICMDBUF_SET_ETH_DHCPS_CONFIG)-BUF_HDR_LEN;
                              memcpy((UCHAR*)&(((APICMDBUF_SET_ETH_DHCPS_CONFIG *)pBuf)->isEnable), pData, 100);
                              apctl(pBuf);
                              free ((APICMDBUF_SET_ETH_DHCPS_CONFIG*)pBuf);
                              break;
         
                case APCMD_SET_ETH_LAN_IP_CONFIG:
                                (APICMDBUF_SET_ETH_LAN_IP_CONFIG*)pBuf = malloc(sizeof (APICMDBUF_SET_ETH_LAN_IP_CONFIG));
                                ((APICMDBUF_SET_ETH_LAN_IP_CONFIG*)pBuf)->cmdCode = CmdCode;
                                ((APICMDBUF_SET_ETH_LAN_IP_CONFIG*)pBuf)->seqNum = 1;
                                ((APICMDBUF_SET_ETH_LAN_IP_CONFIG*)pBuf)->cmdBodyLen = sizeof(APICMDBUF_SET_ETH_LAN_IP_CONFIG)-BUF_HDR_LEN;
                                memcpy((UCHAR*)&(((APICMDBUF_SET_ETH_LAN_IP_CONFIG *)pBuf)->ipAddress), pData, 8);
                                apctl(pBuf);
                                free ((APICMDBUF_SET_ETH_LAN_IP_CONFIG*)pBuf);
                                break;

				#if defined(GATEWAY)
                case APCMD_SET_ETH_WAN_IP_CONFIG:
                                (APICMDBUF_SET_ETH_WAN_IP_CONFIG*)pBuf = malloc(sizeof (APICMDBUF_SET_ETH_WAN_IP_CONFIG));
                                ((APICMDBUF_SET_ETH_WAN_IP_CONFIG*)pBuf)->cmdCode = CmdCode;
                                ((APICMDBUF_SET_ETH_WAN_IP_CONFIG*)pBuf)->seqNum = 1;
                                ((APICMDBUF_SET_ETH_WAN_IP_CONFIG*)pBuf)->cmdBodyLen = sizeof(APICMDBUF_SET_ETH_WAN_IP_CONFIG)-BUF_HDR_LEN;
                                memcpy((UCHAR*)&(((APICMDBUF_SET_ETH_WAN_IP_CONFIG *)pBuf)->dhcpEnabled), pData, 24);
                                apctl(pBuf);
                                free ((APICMDBUF_SET_ETH_WAN_IP_CONFIG*)pBuf);
                                break;
                 #endif
                 #endif

                //end MRVL

		case APCMD_BSS_START:
			
				pBuf = malloc(sizeof(APICMDBUF));
				pBuf->cmdCode = CmdCode;
				pBuf->seqNum = 1;
				pBuf->cmdBodyLen = 0;
				apctl(pBuf);
				free(pBuf); 

        /* Reset AP if required */
#if 0
        if (*pData) {
          Reset();
        }
#endif
				break;
		case APCMD_SET_SSID:
		case APCMD_SET_SSID2:
				pBuf = malloc(sizeof (APICMDBUF)+32);
				pBuf->cmdCode = CmdCode;
				pBuf->seqNum = 1;
				pBuf->cmdBody = (char*)pBuf+sizeof(APICMDBUF);
				pBuf->cmdBodyLen = 32;
				/*strcpy(pBuf->cmdBody, (char*)pData); */
				memcpy(pBuf->cmdBody, pData, 32);
				apctl(pBuf);
				//free (pBuf->cmdBody);
				free (pBuf);
				break;
		case APCMD_SET_OPEN_SSID_EN_STATE:
				(APICMDBUF_SET_OPEN_SSID_EN_STATE*)pBuf = malloc(sizeof (APICMDBUF_SET_OPEN_SSID_EN_STATE));
				((APICMDBUF_SET_OPEN_SSID_EN_STATE*)pBuf)->cmdCode = CmdCode;
				((APICMDBUF_SET_OPEN_SSID_EN_STATE*)pBuf)->seqNum = 1;
				((APICMDBUF_SET_OPEN_SSID_EN_STATE*)pBuf)->cmdBodyLen = sizeof(APICMDBUF_SET_OPEN_SSID_EN_STATE)-BUF_HDR_LEN;
				((APICMDBUF_SET_OPEN_SSID_EN_STATE*)pBuf)->openSSIDEnabled = *pData;
				apctl(pBuf);
				free((APICMDBUF_SET_OPEN_SSID_EN_STATE*)pBuf); 
				break;
		case APCMD_SET_RF_CHANNEL:
				(APICMDBUF_SET_RF_CHANNEL*)pBuf = malloc(sizeof (APICMDBUF_SET_RF_CHANNEL));
				((APICMDBUF_SET_RF_CHANNEL*)pBuf)->cmdCode = CmdCode;
				((APICMDBUF_SET_RF_CHANNEL*)pBuf)->seqNum = 1;
				((APICMDBUF_SET_RF_CHANNEL*)pBuf)->cmdBodyLen = sizeof(APICMDBUF_SET_RF_CHANNEL)-BUF_HDR_LEN;
				((APICMDBUF_SET_RF_CHANNEL*)pBuf)->curChanNum = *((USHORT*)pData);
				apctl(pBuf);
 				free ((APICMDBUF_SET_RF_CHANNEL*)pBuf); 
				break;				
		case APCMD_SET_RF_CHANNEL2:
				(APICMDBUF_SET_RF_CHANNEL*)pBuf = malloc(sizeof (APICMDBUF_SET_RF_CHANNEL));
				((APICMDBUF_SET_RF_CHANNEL*)pBuf)->cmdCode = CmdCode;
				((APICMDBUF_SET_RF_CHANNEL*)pBuf)->seqNum = 1;
				((APICMDBUF_SET_RF_CHANNEL*)pBuf)->cmdBodyLen = sizeof(APICMDBUF_SET_RF_CHANNEL)-BUF_HDR_LEN;
				((APICMDBUF_SET_RF_CHANNEL*)pBuf)->curChanNum = *((USHORT*)pData);
				apctl(pBuf);
 				free ((APICMDBUF_SET_RF_CHANNEL*)pBuf); 
				break;				

		case APCMD_SET_TX_POWER_LEVEL:
				(APICMDBUF_SET_TX_POWER_LEVEL*)pBuf = malloc(sizeof (APICMDBUF_SET_TX_POWER_LEVEL));
				((APICMDBUF_SET_TX_POWER_LEVEL*)pBuf)->cmdCode = CmdCode;
				((APICMDBUF_SET_TX_POWER_LEVEL*)pBuf)->seqNum = 1;
				((APICMDBUF_SET_TX_POWER_LEVEL*)pBuf)->cmdBodyLen = sizeof(APICMDBUF_SET_TX_POWER_LEVEL)-BUF_HDR_LEN;
				((APICMDBUF_SET_TX_POWER_LEVEL*)pBuf)->txPowerLevel = *((UCHAR*)pData);
				apctl(pBuf);
 				free ((APICMDBUF_SET_TX_POWER_LEVEL*)pBuf); 
				break;				
		case APCMD_SET_BEACON_PERIOD:
				(APICMDBUF_SET_BEACON_PERIOD*)pBuf = malloc(sizeof (APICMDBUF_SET_BEACON_PERIOD));

				((APICMDBUF_SET_BEACON_PERIOD*)pBuf)->cmdCode = CmdCode;
				((APICMDBUF_SET_BEACON_PERIOD*)pBuf)->seqNum = 1;
				((APICMDBUF_SET_BEACON_PERIOD*)pBuf)->cmdBodyLen = sizeof(APICMDBUF_SET_BEACON_PERIOD)-BUF_HDR_LEN;
				((APICMDBUF_SET_BEACON_PERIOD*)pBuf)->beaconPeriod = *((ULONG*)pData);
				
				apctl(pBuf);
				free ((APICMDBUF_SET_BEACON_PERIOD*)pBuf); 
				break;	
		case APCMD_SET_DTIM_PERIOD:
				(APICMDBUF_SET_DTIM_PERIOD*)pBuf = malloc(sizeof (APICMDBUF_SET_DTIM_PERIOD));

				((APICMDBUF_SET_DTIM_PERIOD*)pBuf)->cmdCode = CmdCode;
				((APICMDBUF_SET_DTIM_PERIOD*)pBuf)->seqNum = 1;
				((APICMDBUF_SET_DTIM_PERIOD*)pBuf)->cmdBodyLen = sizeof(APICMDBUF_SET_DTIM_PERIOD)-BUF_HDR_LEN;
				((APICMDBUF_SET_DTIM_PERIOD*)pBuf)->dtimPeriod = *((ULONG*)pData);
				
				apctl(pBuf);
				free ((APICMDBUF_SET_DTIM_PERIOD*)pBuf); 
				break;	
		case APCMD_SET_FRAG_THRESHOLD:
				(APICMDBUF_SET_FRAG_THRESHOLD*)pBuf = malloc(sizeof (APICMDBUF_SET_FRAG_THRESHOLD));

				((APICMDBUF_SET_FRAG_THRESHOLD*)pBuf)->cmdCode = CmdCode;
				((APICMDBUF_SET_FRAG_THRESHOLD*)pBuf)->seqNum = 1;
				((APICMDBUF_SET_FRAG_THRESHOLD*)pBuf)->cmdBodyLen = sizeof(APICMDBUF_SET_FRAG_THRESHOLD)-BUF_HDR_LEN;
				((APICMDBUF_SET_FRAG_THRESHOLD*)pBuf)->fragThreshold = *((USHORT*)pData);
				
				apctl(pBuf);
				free ((APICMDBUF_SET_FRAG_THRESHOLD*)pBuf); 
				break;	
		case APCMD_SET_RTS_THRESHOLD:
				(APICMDBUF_SET_RTS_THRESHOLD*)pBuf = malloc(sizeof (APICMDBUF_SET_RTS_THRESHOLD));

				((APICMDBUF_SET_RTS_THRESHOLD*)pBuf)->cmdCode = CmdCode;
				((APICMDBUF_SET_RTS_THRESHOLD*)pBuf)->seqNum = 1;
				((APICMDBUF_SET_RTS_THRESHOLD*)pBuf)->cmdBodyLen = sizeof(APICMDBUF_SET_RTS_THRESHOLD)-BUF_HDR_LEN;
				((APICMDBUF_SET_RTS_THRESHOLD*)pBuf)->rtsThreshold = *((USHORT*)pData);
				
				apctl(pBuf);
				free ((APICMDBUF_SET_RTS_THRESHOLD*)pBuf); 
				break;	
		case APCMD_SET_DATA_RETRY_LIMIT:
				(APICMDBUF_SET_DATA_RETRY_LIMIT*)pBuf = malloc(sizeof (APICMDBUF_SET_DATA_RETRY_LIMIT));

				((APICMDBUF_SET_DATA_RETRY_LIMIT*)pBuf)->cmdCode = CmdCode;
				((APICMDBUF_SET_DATA_RETRY_LIMIT*)pBuf)->seqNum = 1;
				((APICMDBUF_SET_DATA_RETRY_LIMIT*)pBuf)->cmdBodyLen = sizeof(APICMDBUF_SET_DATA_RETRY_LIMIT)-BUF_HDR_LEN;
				((APICMDBUF_SET_DATA_RETRY_LIMIT*)pBuf)->dataRetryLimit = *((USHORT*)pData);
				
				apctl(pBuf);
				free ((APICMDBUF_SET_DATA_RETRY_LIMIT*)pBuf); 
				break;	
		case APCMD_SET_RTS_RETRY_LIMIT:
				(APICMDBUF_SET_RTS_RETRY_LIMIT*)pBuf = malloc(sizeof (APICMDBUF_SET_RTS_RETRY_LIMIT));

				((APICMDBUF_SET_RTS_RETRY_LIMIT*)pBuf)->cmdCode = CmdCode;
				((APICMDBUF_SET_RTS_RETRY_LIMIT*)pBuf)->seqNum = 1;
				((APICMDBUF_SET_RTS_RETRY_LIMIT*)pBuf)->cmdBodyLen = sizeof(APICMDBUF_SET_RTS_RETRY_LIMIT)-BUF_HDR_LEN;
				((APICMDBUF_SET_RTS_RETRY_LIMIT*)pBuf)->rtsRetryLimit = *((USHORT*)pData);
				
				apctl(pBuf);
				free ((APICMDBUF_SET_RTS_RETRY_LIMIT*)pBuf); 
				break;	
		case APCMD_SET_RF_PREAMBLE_OPTION:
				(APICMBUF_SET_RF_PREAMBLE_OPTION*)pBuf = malloc(sizeof (APICMBUF_SET_RF_PREAMBLE_OPTION));

				((APICMBUF_SET_RF_PREAMBLE_OPTION*)pBuf)->cmdCode = CmdCode;
				((APICMBUF_SET_RF_PREAMBLE_OPTION*)pBuf)->seqNum = 1;
				((APICMBUF_SET_RF_PREAMBLE_OPTION*)pBuf)->cmdBodyLen = sizeof(APICMBUF_SET_RF_PREAMBLE_OPTION)-BUF_HDR_LEN;
				((APICMBUF_SET_RF_PREAMBLE_OPTION*)pBuf)->rfPreambleOption = *pData;
				apctl(pBuf);
				free ((APICMDBUF_GET_BEACON_PERIOD*)pBuf); 
				break;
		case APCMD_SET_ANTENNA_MODE:
			
				(APICMDBUF_SET_ANTENNA_MODE*)pBuf = malloc(sizeof (APICMDBUF_SET_ANTENNA_MODE));

				((APICMDBUF_SET_ANTENNA_MODE*)pBuf)->cmdCode = CmdCode;
				((APICMDBUF_SET_ANTENNA_MODE*)pBuf)->seqNum = 1;
				((APICMDBUF_SET_ANTENNA_MODE*)pBuf)->cmdBodyLen = sizeof(APICMDBUF_SET_ANTENNA_MODE)-BUF_HDR_LEN;
				((APICMDBUF_SET_ANTENNA_MODE*)pBuf)->antennaMode = *pData;
				((APICMDBUF_SET_ANTENNA_MODE*)pBuf)->whichAnt = *(pData+1);
				apctl(pBuf);
				free ((APICMDBUF_GET_ANTENNA_MODE*)pBuf);
				break;
		case APCMD_SET_TX_DATA_RATE:
		case APCMD_SET_TX_DATA_RATE_G:
		case APCMD_SET_TX_DATA_RATE_A:
				(APICMDBUF_SET_TX_DATA_RATE*)pBuf = malloc(sizeof (APICMDBUF_SET_TX_DATA_RATE));
				((APICMDBUF_SET_TX_DATA_RATE*)pBuf)->cmdCode = CmdCode;
				((APICMDBUF_SET_TX_DATA_RATE*)pBuf)->seqNum= 1;
				((APICMDBUF_SET_TX_DATA_RATE*)pBuf)->cmdBodyLen = sizeof(APICMDBUF_SET_TX_DATA_RATE)-BUF_HDR_LEN;
				((APICMDBUF_SET_TX_DATA_RATE*)pBuf)->txDataRate = *pData;
				apctl(pBuf);
				free ((APICMDBUF_SET_TX_DATA_RATE*)pBuf);
				break;
	/*	case APCMD_SET_SUP_DATA_RATES: */
		case APCMD_SET_BASIC_DATA_RATES:	
				(APICMDBUF_SET_BASIC_DATA_RATES*)pBuf = malloc(sizeof (APICMDBUF_SET_BASIC_DATA_RATES));

				((APICMDBUF_SET_BASIC_DATA_RATES*)pBuf)->cmdCode = CmdCode;
				((APICMDBUF_SET_BASIC_DATA_RATES*)pBuf)->seqNum = 1;
				((APICMDBUF_SET_BASIC_DATA_RATES*)pBuf)->cmdBodyLen = sizeof(APICMDBUF_SET_BASIC_DATA_RATES)-BUF_HDR_LEN;
				memcpy(((APICMDBUF_SET_BASIC_DATA_RATES*)pBuf)->basicDataRates, pData, 14);  
				apctl(pBuf);
				free ((APICMDBUF_SET_BASIC_DATA_RATES*)pBuf); 
				break; 
		case APCMD_SET_BASIC_DATA_RATES_G:
				(APICMDBUF_SET_BASIC_DATA_RATES_G*)pBuf = malloc(sizeof (APICMDBUF_SET_BASIC_DATA_RATES_G));

				((APICMDBUF_SET_BASIC_DATA_RATES_G*)pBuf)->cmdCode = CmdCode;
				((APICMDBUF_SET_BASIC_DATA_RATES_G*)pBuf)->seqNum = 1;
				((APICMDBUF_SET_BASIC_DATA_RATES_G*)pBuf)->cmdBodyLen = sizeof(APICMDBUF_SET_BASIC_DATA_RATES_G)-BUF_HDR_LEN;
				memcpy(((APICMDBUF_SET_BASIC_DATA_RATES_G*)pBuf)->basicDataRates, pData, 16);  
				apctl(pBuf);
				free ((APICMDBUF_SET_BASIC_DATA_RATES_G*)pBuf); 
				break; 
		case APCMD_SET_AUTH_MODE:
		case APCMD_SET_AUTH_MODE_G:
				(APICMDBUF_SET_AUTH_MODE*)pBuf = malloc(sizeof (APICMDBUF_SET_AUTH_MODE));

				((APICMDBUF_SET_AUTH_MODE*)pBuf)->cmdCode = CmdCode;
				((APICMDBUF_SET_AUTH_MODE*)pBuf)->seqNum = 1;
				((APICMDBUF_SET_AUTH_MODE*)pBuf)->cmdBodyLen = sizeof(APICMDBUF_SET_AUTH_MODE)-BUF_HDR_LEN;
				((APICMDBUF_SET_AUTH_MODE*)pBuf)->authMode = *pData;
				apctl(pBuf);
				free ((APICMDBUF_GET_AUTH_MODE*)pBuf);
				
				break;
		case APCMD_SET_PRIVACY_OPTION:
		case APCMD_SET_PRIVACY_OPTION_G:
				(APICMDBUF_SET_PRIVACY_OPTION*)pBuf = malloc(sizeof (APICMDBUF_SET_PRIVACY_OPTION));

				((APICMDBUF_SET_PRIVACY_OPTION*)pBuf)->cmdCode = CmdCode;
				((APICMDBUF_SET_PRIVACY_OPTION*)pBuf)->seqNum = 1;
				((APICMDBUF_SET_PRIVACY_OPTION*)pBuf)->cmdBodyLen = sizeof(APICMDBUF_SET_PRIVACY_OPTION)-BUF_HDR_LEN;
				((APICMDBUF_SET_PRIVACY_OPTION*)pBuf)->dataEncrypt = *pData;
				apctl(pBuf);
				free ((APICMDBUF_SET_PRIVACY_OPTION*)pBuf); 
				break;
        case APCMD_SET_PSK_PASSPHRASE:
			
				(APICMDBUF_SET_PSK_PASSPHRASE*)pBuf = malloc(sizeof (APICMDBUF_SET_PSK_PASSPHRASE));

				((APICMDBUF_SET_PSK_PASSPHRASE*)pBuf)->cmdCode = CmdCode;
				((APICMDBUF_SET_PSK_PASSPHRASE*)pBuf)->seqNum = 1;
				((APICMDBUF_SET_PSK_PASSPHRASE*)pBuf)->cmdBodyLen = sizeof(APICMDBUF_SET_PSK_PASSPHRASE)-BUF_HDR_LEN;
				strcpy(((APICMDBUF_SET_PSK_PASSPHRASE*)pBuf)->passphrase, pData);
				apctl(pBuf);
				free ((APICMDBUF_SET_PSK_PASSPHRASE*)pBuf); 
				break;
        case APCMD_SET_GRP_REKEY_TIME:
			
				(APICMDBUF_SET_GRP_REKEY_TIME*)pBuf = malloc(sizeof (APICMDBUF_SET_GRP_REKEY_TIME));

				((APICMDBUF_SET_GRP_REKEY_TIME*)pBuf)->cmdCode = CmdCode;
				((APICMDBUF_SET_GRP_REKEY_TIME*)pBuf)->seqNum = 1;
				((APICMDBUF_SET_GRP_REKEY_TIME*)pBuf)->cmdBodyLen = sizeof(APICMDBUF_SET_GRP_REKEY_TIME)-BUF_HDR_LEN;
				((APICMDBUF_SET_GRP_REKEY_TIME*)pBuf)->rekey_time = *pData;
				apctl(pBuf);
				free ((APICMDBUF_SET_GRP_REKEY_TIME*)pBuf); 
				break;
        case APCMD_SET_WPA_PSK_VALUE:
            {
                (APICMDBUF_SET_WPA_PSK_VALUE*)pBuf = malloc(sizeof (APICMDBUF_SET_WPA_PSK_VALUE));
    
                ((APICMDBUF_SET_WPA_PSK_VALUE*)pBuf)->cmdCode = CmdCode;
                ((APICMDBUF_SET_WPA_PSK_VALUE*)pBuf)->seqNum = 1;
                ((APICMDBUF_SET_WPA_PSK_VALUE*)pBuf)->cmdBodyLen = sizeof(APICMDBUF_SET_WPA_PSK_VALUE)-BUF_HDR_LEN;
                ((APICMDBUF_SET_WPA_PSK_VALUE*)pBuf)->PSKValueEnabled = ((WPAHex*)pData)->enable;
                memcpy(((APICMDBUF_SET_WPA_PSK_VALUE*)pBuf)->PSKValue, ((WPAHex*)pData)->caWPAHex, 32);
                apctl(pBuf);
                free ((APICMDBUF_SET_WPA_PSK_VALUE*)pBuf); 
            }
                break;
        case APCMD_SET_WPA2_PSK_VALUE:
            {
                (APICMDBUF_SET_WPA2_PSK_VALUE*)pBuf = malloc(sizeof (APICMDBUF_SET_WPA2_PSK_VALUE));
    
                ((APICMDBUF_SET_WPA2_PSK_VALUE*)pBuf)->cmdCode = CmdCode;
                ((APICMDBUF_SET_WPA2_PSK_VALUE*)pBuf)->seqNum = 1;
                ((APICMDBUF_SET_WPA2_PSK_VALUE*)pBuf)->cmdBodyLen = sizeof(APICMDBUF_SET_WPA2_PSK_VALUE)-BUF_HDR_LEN;
                ((APICMDBUF_SET_WPA2_PSK_VALUE*)pBuf)->PSKValueEnabled = ((WPAHex*)pData)->enable;
                memcpy(((APICMDBUF_SET_WPA2_PSK_VALUE*)pBuf)->PSKValue, ((WPAHex*)pData)->caWPAHex, 32);
                apctl(pBuf);
                free ((APICMDBUF_SET_WPA2_PSK_VALUE*)pBuf); 
            }
                break;
		case APCMD_SET_DEFAULT_WEP_KEYS:
		case APCMD_SET_DEFAULT_WEP_KEYS_G:
			
				(APICMDBUF_SET_DEFAULT_WEP_KEYS*)pBuf = malloc(sizeof (APICMDBUF_SET_DEFAULT_WEP_KEYS));

				((APICMDBUF_SET_DEFAULT_WEP_KEYS*)pBuf)->cmdCode = CmdCode;
				((APICMDBUF_SET_DEFAULT_WEP_KEYS*)pBuf)->seqNum = 1;
				((APICMDBUF_SET_DEFAULT_WEP_KEYS*)pBuf)->cmdBodyLen = sizeof(APICMDBUF_SET_DEFAULT_WEP_KEYS)-BUF_HDR_LEN;;
		 		((APICMDBUF_SET_DEFAULT_WEP_KEYS*)pBuf)->keyindex = ((WEP_KEY*)pData)->TxKeyIndex;  
				((APICMDBUF_SET_DEFAULT_WEP_KEYS*)pBuf)->keyType0 = ((WEP_KEY*)pData)->keyType0; 
				memcpy(((APICMDBUF_SET_DEFAULT_WEP_KEYS*)pBuf)->keyValue0, ((WEP_KEY*)pData)->keyValue0, 13);
				((APICMDBUF_SET_DEFAULT_WEP_KEYS*)pBuf)->keyType1 = ((WEP_KEY*)pData)->keyType1; 
				memcpy(((APICMDBUF_SET_DEFAULT_WEP_KEYS*)pBuf)->keyValue1, ((WEP_KEY*)pData)->keyValue1, 13);
				((APICMDBUF_SET_DEFAULT_WEP_KEYS*)pBuf)->keyType2 = ((WEP_KEY*)pData)->keyType2; 
				memcpy(((APICMDBUF_SET_DEFAULT_WEP_KEYS*)pBuf)->keyValue2, ((WEP_KEY*)pData)->keyValue2, 13);
				((APICMDBUF_SET_DEFAULT_WEP_KEYS*)pBuf)->keyType3 = ((WEP_KEY*)pData)->keyType3; 
				memcpy(((APICMDBUF_SET_DEFAULT_WEP_KEYS*)pBuf)->keyValue3, ((WEP_KEY*)pData)->keyValue3, 13);
				apctl(pBuf);
				free((APICMDBUF_SET_DEFAULT_WEP_KEYS*)pBuf);
				break;
		case APCMD_SET_WLAN_FILTER_LIST:
				pBuf = malloc(sizeof (APICMDBUF) + pData[1] * 6 + 2);
				pBuf->cmdCode = CmdCode;
				pBuf->seqNum = 1;
				pBuf->cmdBodyLen = pData[1] * 6 + 2;
				pBuf->cmdBody = (char*)pBuf+sizeof(APICMDBUF); 
				memcpy(pBuf->cmdBody, pData, pBuf->cmdBodyLen);
				apctl(pBuf);
				/*free (pBuf->cmdBody); */
				free (pBuf);
				break;
    case APCMD_SET_WLAN_FILTER_MODE:
            (APICMDBUF_FILTER_MODE*)pBuf = malloc(sizeof (APICMDBUF_FILTER_MODE));
            pBuf->cmdCode = CmdCode;
            pBuf->seqNum = 1;
            pBuf->cmdBodyLen = 1;
            ((APICMDBUF_FILTER_MODE *)pBuf)->mode = *pData;
            apctl(pBuf);
            free (pBuf);
            break;
		case APCMD_SET_ETH_IP_CONFIG:
				(APICMDBUF_SET_ETH_IP_CONFIG*)pBuf = malloc(sizeof (APICMDBUF_SET_ETH_IP_CONFIG));
				((APICMDBUF_SET_ETH_IP_CONFIG*)pBuf)->cmdCode = CmdCode;
				((APICMDBUF_SET_ETH_IP_CONFIG*)pBuf)->seqNum = 1;
				((APICMDBUF_SET_ETH_IP_CONFIG*)pBuf)->cmdBodyLen = sizeof(APICMDBUF_SET_ETH_IP_CONFIG)-BUF_HDR_LEN;
				memcpy((UCHAR*)&(((APICMDBUF_SET_ETH_IP_CONFIG *)pBuf)->dhcpEnabled), pData, 16); 		
				apctl(pBuf);				
				free ((APICMDBUF_SET_ETH_IP_CONFIG*)pBuf);
				break;	
		case APCMD_SET_AP_MODE:
			
				(APICMDBUF_SET_AP_MODE*)pBuf = malloc(sizeof (APICMDBUF_SET_AP_MODE));

				((APICMDBUF_SET_AP_MODE*)pBuf)->cmdCode = CmdCode;
				((APICMDBUF_SET_AP_MODE*)pBuf)->seqNum = 1;
				((APICMDBUF_SET_AP_MODE*)pBuf)->cmdBodyLen = sizeof(APICMDBUF_SET_AP_MODE)-BUF_HDR_LEN;
				((APICMDBUF_SET_AP_MODE*)pBuf)->apMode = *pData; 
				apctl(pBuf);
				free ((APICMDBUF_SET_AP_MODE*)pBuf);
				break;		
#ifdef BURST_MODE
		case APCMD_SET_BURST_MODE:
			
				(APICMDBUF_SET_BURST_MODE*)pBuf = malloc(sizeof (APICMDBUF_SET_BURST_MODE));

				((APICMDBUF_SET_BURST_MODE*)pBuf)->cmdCode = CmdCode;
				((APICMDBUF_SET_BURST_MODE*)pBuf)->seqNum = 1;
				((APICMDBUF_SET_BURST_MODE*)pBuf)->cmdBodyLen = sizeof(APICMDBUF_SET_BURST_MODE)-BUF_HDR_LEN;
				((APICMDBUF_SET_BURST_MODE*)pBuf)->burstMode = ((BURST_INFO *)pData)->BurstMode; 
				((APICMDBUF_SET_BURST_MODE*)pBuf)->burstRate= ((BURST_INFO *)pData)->BurstRate;
				apctl(pBuf);
				free ((APICMDBUF_SET_BURST_MODE*)pBuf);
				break;								
#endif		
		case APCMD_SET_FORCE_PROTECTION_MODE:
			
				(APICMDBUF_SET_FORCE_PROTECTION_MODE*)pBuf = malloc(sizeof (APICMDBUF_SET_FORCE_PROTECTION_MODE));

				((APICMDBUF_SET_FORCE_PROTECTION_MODE*)pBuf)->cmdCode = CmdCode;
				((APICMDBUF_SET_FORCE_PROTECTION_MODE*)pBuf)->seqNum = 1;
				((APICMDBUF_SET_FORCE_PROTECTION_MODE*)pBuf)->cmdBodyLen = sizeof(APICMDBUF_SET_FORCE_PROTECTION_MODE)-BUF_HDR_LEN;
				((APICMDBUF_SET_FORCE_PROTECTION_MODE*)pBuf)->forceProtectMode = *pData;
				apctl(pBuf);
				free ((APICMDBUF_SET_FORCE_PROTECTION_MODE*)pBuf);
				
				break;		

#if defined(WIPOD)
		case APCMD_SET_WIPOD_MODE:
			pBuf = malloc(sizeof(APICMDBUF_SET_WIPOD_MODE));
			pBuf->cmdCode = CmdCode;
			pBuf->seqNum = 1;
			pBuf->cmdBodyLen = sizeof(APICMDBUF_SET_WIPOD_MODE) - 4*sizeof(unsigned short);
			((APICMDBUF_SET_WIPOD_MODE *)pBuf)->mode = *pData;

            /* Temp. If it's not AP/WB we need to copy more data. 
            if( ((APICMDBUF_SET_WIPOD_MODE *)pBuf)->mode != 0x01 
                && ((APICMDBUF_SET_WIPOD_MODE *)pBuf)->mode != 0x82 ) 
            {
                memcpy(pBuf->cmdBody, pData, pBuf->cmdBodyLen);
            }*/

			apctl(pBuf);
			free (pBuf);
			break;	
#endif /* WIPOD */
		
#ifdef WDS_FEATURE
		case APCMD_SET_WDS_MODE:
			pBuf = malloc(sizeof(APICMDBUF)+2);
			pBuf->cmdCode = CmdCode;
			pBuf->seqNum = 1;
			pBuf->cmdBodyLen = 2;
			pBuf->cmdBody = (char*)pBuf+sizeof(APICMDBUF);
			pBuf->cmdBody[0] = pData[0];
			apctl(pBuf);
			//free (pBuf->cmdBody);
			free (pBuf);
			break;	
		case APCMD_SET_WDS_LIST:
			pBuf = malloc(sizeof (APICMDBUF)+6*MAX_WDS_AP_LIST+2);
			pBuf->cmdCode = CmdCode;
			pBuf->seqNum = 1;
			pBuf->cmdBodyLen = 6*MAX_WDS_AP_LIST+2;
			pBuf->cmdBody = (char*)pBuf+sizeof(APICMDBUF);		
			memcpy(pBuf->cmdBody, pData, pBuf->cmdBodyLen);
			apctl(pBuf);
			//free (pBuf->cmdBody);
			free (pBuf);
			break;
		case APCMD_SET_DISABLE_ASSOC:
			pBuf = malloc(sizeof(APICMDBUF)+2);
			pBuf->cmdCode = CmdCode;
			pBuf->seqNum = 1;
			pBuf->cmdBodyLen = 2;
			pBuf->cmdBody = (char*)pBuf+sizeof(APICMDBUF);
			pBuf->cmdBody[0] = pData[0];
			apctl(pBuf);
			//free (pBuf->cmdBody);
			free (pBuf);
			break;	
		case APCMD_SET_WDS_OPTION:
			pBuf = malloc(sizeof(APICMDBUF)+2);
			pBuf->cmdCode = CmdCode;
			pBuf->seqNum = 1;
			pBuf->cmdBodyLen = 2;
			pBuf->cmdBody = (char*)pBuf+sizeof(APICMDBUF);
			pBuf->cmdBody[0] = pData[0];
			apctl(pBuf);
			//free (pBuf->cmdBody);
			free (pBuf);
			break;	
#endif 
#ifdef AP_SITE_SURVEY
        case APCMD_SET_SURVEY_SCAN:
				(APICMDBUF*)pBuf = malloc(sizeof (APICMDBUF));
				((APICMDBUF*)pBuf)->cmdCode = CmdCode;
				((APICMDBUF*)pBuf)->seqNum = 1;
				((APICMDBUF*)pBuf)->cmdBodyLen = sizeof(APICMDBUF)-BUF_HDR_LEN;
				apctl(pBuf);
				free ((APICMDBUF*)pBuf);
				break;
#endif /* AP_SITE_SURVEY */
#ifdef SELF_CTS
    case APCMD_SET_SELF_CTS:

            (APICMDBUF_SET_SELF_CTS*)pBuf = malloc(sizeof (APICMDBUF_SET_SELF_CTS));

            ((APICMDBUF_SET_SELF_CTS*)pBuf)->cmdCode = CmdCode;
            ((APICMDBUF_SET_SELF_CTS*)pBuf)->seqNum = 1;
            ((APICMDBUF_SET_SELF_CTS*)pBuf)->cmdBodyLen = sizeof(APICMDBUF_SET_SELF_CTS)-BUF_HDR_LEN;
            ((APICMDBUF_SET_SELF_CTS*)pBuf)->SelfCts = *pData;
            apctl(pBuf);
            free ((APICMDBUF_SET_SELF_CTS*)pBuf);

            break;
#endif
#ifdef TURBO_SETUP
    case APCMD_SET_AUTO_LINK_MODE:
            (APICMDBUF_SET_AUTO_LINK_MODE*)pBuf = malloc(sizeof (APICMDBUF_SET_AUTO_LINK_MODE));
            ((APICMDBUF_SET_AUTO_LINK_MODE*)pBuf)->cmdCode = CmdCode;
            ((APICMDBUF_SET_AUTO_LINK_MODE*)pBuf)->seqNum = 1;
            ((APICMDBUF_SET_AUTO_LINK_MODE*)pBuf)->cmdBodyLen = sizeof(APICMDBUF_SET_AUTO_LINK_MODE)-BUF_HDR_LEN;
            ((APICMDBUF_SET_AUTO_LINK_MODE*)pBuf)->AutoLink = *pData;
            apctl(pBuf);
            free((APICMDBUF_SET_AUTO_LINK_MODE*)pBuf); 
            break;
#endif
#ifdef BOOSTER_MODE
    case APCMD_SET_BOOSTER_MODE:
            (APICMDBUF_SET_BOOSTER_MODE*)pBuf = malloc(sizeof (APICMDBUF_SET_BOOSTER_MODE));
            ((APICMDBUF_SET_BOOSTER_MODE*)pBuf)->cmdCode = CmdCode;
            ((APICMDBUF_SET_BOOSTER_MODE*)pBuf)->seqNum = 1;
            ((APICMDBUF_SET_BOOSTER_MODE*)pBuf)->cmdBodyLen = sizeof(APICMDBUF_SET_BOOSTER_MODE)-BUF_HDR_LEN;
            ((APICMDBUF_SET_BOOSTER_MODE*)pBuf)->BoosterMode = *pData;
            apctl(pBuf);
            free((APICMDBUF_SET_BOOSTER_MODE*)pBuf); 
            break;
#endif
#ifdef QOS_FEATURE
    		case APCMD_SET_EDCA_PARAM:
				(APICMDBUF_SET_EDCA_PARAM *)pBuf = malloc(sizeof (APICMDBUF_SET_EDCA_PARAM));

				((APICMDBUF_SET_EDCA_PARAM*)pBuf)->cmdCode = CmdCode;
				((APICMDBUF_SET_EDCA_PARAM*)pBuf)->seqNum = 1;
				((APICMDBUF_SET_EDCA_PARAM*)pBuf)->cmdBodyLen = sizeof(APICMDBUF_SET_EDCA_PARAM)-BUF_HDR_LEN;
				((APICMDBUF_SET_EDCA_PARAM*)pBuf)->QAPEDCATable.QAPEDCATblIndx= ((mib_QAPEDCATable_t *)pData)->QAPEDCATblIndx;
                ((APICMDBUF_SET_EDCA_PARAM*)pBuf)->QAPEDCATable.QAPEDCATblCWmin= ((mib_QAPEDCATable_t *)pData)->QAPEDCATblCWmin;
                ((APICMDBUF_SET_EDCA_PARAM*)pBuf)->QAPEDCATable.QAPEDCATblCWmax= ((mib_QAPEDCATable_t *)pData)->QAPEDCATblCWmax;
                ((APICMDBUF_SET_EDCA_PARAM*)pBuf)->QAPEDCATable.QAPEDCATblAIFSN= ((mib_QAPEDCATable_t *)pData)->QAPEDCATblAIFSN;
                ((APICMDBUF_SET_EDCA_PARAM*)pBuf)->QAPEDCATable.QAPEDCATblTXOPLimitBAP = ((mib_QAPEDCATable_t *)pData)->QAPEDCATblTXOPLimitBAP;

                ((APICMDBUF_SET_EDCA_PARAM*)pBuf)->QAPEDCATable.QAPEDCATblTXOPLimit= ((mib_QAPEDCATable_t *)pData)->QAPEDCATblTXOPLimit;
                ((APICMDBUF_SET_EDCA_PARAM*)pBuf)->QAPEDCATable.QAPEDCATblMandatory= ((mib_QAPEDCATable_t *)pData)->QAPEDCATblMandatory;

				apctl(pBuf);
				free ((APICMDBUF_SET_EDCA_PARAM*)pBuf); 
				break;
#endif
#ifdef IEEE80211H
            case APCMD_SET_SPECTRUM_MGMT:
                (APICMDBUF_SET_SPECTRUM_MGMT*)pBuf = malloc(sizeof (APICMDBUF_SET_SPECTRUM_MGMT));
                ((APICMDBUF_SET_SPECTRUM_MGMT*)pBuf)->cmdCode = CmdCode;
                ((APICMDBUF_SET_SPECTRUM_MGMT*)pBuf)->seqNum = 1;
                ((APICMDBUF_SET_SPECTRUM_MGMT*)pBuf)->cmdBodyLen = sizeof(APICMDBUF_SET_SPECTRUM_MGMT)-BUF_HDR_LEN;
                ((APICMDBUF_SET_SPECTRUM_MGMT*)pBuf)->isEnable = *pData;
#ifdef ENABLE_ETH_DEBUG 
                eprintf("ApCmdSetProc: APCMD_SET_SPECTRUM_MGMT = %d \n", ((APICMDBUF_SET_SPECTRUM_MGMT*)pBuf)->isEnable); 
#endif
                apctl(pBuf);
                free((APICMDBUF_SET_SPECTRUM_MGMT*)pBuf);
                break;
            case APCMD_SET_MITIGATION:
                (APICMDBUF_SET_MITIGATION*)pBuf = malloc(sizeof (APICMDBUF_SET_MITIGATION));
                ((APICMDBUF_SET_MITIGATION*)pBuf)->cmdCode = CmdCode;
                ((APICMDBUF_SET_MITIGATION*)pBuf)->seqNum = 1;
                ((APICMDBUF_SET_MITIGATION*)pBuf)->cmdBodyLen = sizeof(APICMDBUF_SET_MITIGATION)-BUF_HDR_LEN;
                ((APICMDBUF_SET_MITIGATION*)pBuf)->mitigationValue = *(ULONG*)pData;
#ifdef ENABLE_ETH_DEBUG 
                eprintf("ApCmdSetProc: APCMD_SET_MITIGATION = %d \n", ((APICMDBUF_SET_MITIGATION*)pBuf)->mitigationValue); 
#endif
                apctl(pBuf);
                free((APICMDBUF_SET_MITIGATION*)pBuf);
                break;
            case APCMD_SEND_SWITCH_CHANNEL_ANNOUNCEMENT:
                (APICMDBUF_SEND_SWITCH_CHANNEL_ANNOUNCEMENT*)pBuf = malloc(sizeof (APICMDBUF_SEND_SWITCH_CHANNEL_ANNOUNCEMENT));
                ((APICMDBUF_SEND_SWITCH_CHANNEL_ANNOUNCEMENT*)pBuf)->cmdCode = CmdCode;
                ((APICMDBUF_SEND_SWITCH_CHANNEL_ANNOUNCEMENT*)pBuf)->seqNum = 1;
                ((APICMDBUF_SEND_SWITCH_CHANNEL_ANNOUNCEMENT*)pBuf)->cmdBodyLen = sizeof(APICMDBUF_SET_MITIGATION)-BUF_HDR_LEN;
                ((APICMDBUF_SEND_SWITCH_CHANNEL_ANNOUNCEMENT*)pBuf)->channel = *pData;
#ifdef ENABLE_ETH_DEBUG 
                eprintf("ApCmdSetProc: APCMD_SEND_SWITCH_CHANNEL_ANNOUNCEMENT = %d \n", ((APICMDBUF_SEND_SWITCH_CHANNEL_ANNOUNCEMENT*)pBuf)->channel); 
#endif
                apctl(pBuf);
                free((APICMDBUF_SEND_SWITCH_CHANNEL_ANNOUNCEMENT*)pBuf);
                break;
            case APCMD_SET_REGULATORY_DOMAIN:
                (APICMDBUF_SET_SPECTRUM_MGMT*)pBuf = malloc(sizeof (APICMDBUF_SET_REGULATORY_DOMAIN));
                ((APICMDBUF_SET_REGULATORY_DOMAIN*)pBuf)->cmdCode = CmdCode;
                ((APICMDBUF_SET_REGULATORY_DOMAIN*)pBuf)->seqNum = 1;
                ((APICMDBUF_SET_REGULATORY_DOMAIN*)pBuf)->cmdBodyLen = sizeof(APICMDBUF_SET_REGULATORY_DOMAIN)-BUF_HDR_LEN;
                ((APICMDBUF_SET_REGULATORY_DOMAIN*)pBuf)->domain = *pData;
#ifdef ENABLE_ETH_DEBUG 
                eprintf("ApCmdSetProc: APCMD_SET_REGULATORY_DOMAIN = %d \n", ((APICMDBUF_SET_REGULATORY_DOMAIN*)pBuf)->domain); 
#endif
                apctl(pBuf);
                free((APICMDBUF_SET_REGULATORY_DOMAIN*)pBuf);
                break;                
#endif
#ifdef DCS
    case APCMD_SET_DCS_MODE:
            (APICMDBUF_SET_DCS_MODE*)pBuf = malloc(sizeof (APICMDBUF_SET_DCS_MODE));
            ((APICMDBUF_SET_DCS_MODE*)pBuf)->cmdCode = CmdCode;
            ((APICMDBUF_SET_DCS_MODE*)pBuf)->seqNum = 1;
            ((APICMDBUF_SET_DCS_MODE*)pBuf)->cmdBodyLen = sizeof(APICMDBUF_SET_DCS_MODE)-BUF_HDR_LEN;
            ((APICMDBUF_SET_DCS_MODE*)pBuf)->DCSMode = *pData;
            apctl(pBuf);
            free((APICMDBUF_SET_DCS_MODE*)pBuf); 
            break;
    case APCMD_SET_DCS_CHANNEL:
            (APICMDBUF_SET_DCS_CHANNEL*)pBuf = malloc(sizeof (APICMDBUF_SET_DCS_CHANNEL));
            ((APICMDBUF_SET_DCS_CHANNEL*)pBuf)->cmdCode = CmdCode;
            ((APICMDBUF_SET_DCS_CHANNEL*)pBuf)->seqNum = 1;
            ((APICMDBUF_SET_DCS_CHANNEL*)pBuf)->cmdBodyLen = sizeof(APICMDBUF_SET_DCS_CHANNEL)-BUF_HDR_LEN;
            ((APICMDBUF_SET_DCS_CHANNEL*)pBuf)->channel = *pData;
            apctl(pBuf);
            free((APICMDBUF_SET_DCS_CHANNEL*)pBuf); 
            break;
#endif
		case APCMD_SET_DISABLE_AGING:
				(APICMDBUF_SET_STA_AGING_TIME*)pBuf = malloc(sizeof (APICMDBUF_SET_STA_AGING_TIME));
    			if(pBuf == NULL)
				{
					return STATUS_FAIL;
				}
				((APICMDBUF_SET_STA_AGING_TIME*)pBuf)->cmdCode = APCMD_SET_STA_AGING_TIME_IN_MINUTES;
				((APICMDBUF_SET_STA_AGING_TIME*)pBuf)->seqNum = 1;
				((APICMDBUF_SET_STA_AGING_TIME*)pBuf)->cmdBodyLen = sizeof(APICMDBUF_SET_STA_AGING_TIME)-BUF_HDR_LEN;
				((APICMDBUF_SET_STA_AGING_TIME*)pBuf)->timeInMinutes = ((*pData == 1)?0:mib_AgingTime); 

				apctl(pBuf);
				free ((APICMDBUF_SET_STA_AGING_TIME*)pBuf);
				break;

		case APCMD_SET_STA_FIXEDRATE:
				(APICMDBUF_SET_STA_FIXEDRATE*)pBuf = malloc(sizeof (APICMDBUF_SET_STA_FIXEDRATE));
    			if(pBuf == NULL)
				{
					return STATUS_FAIL;
				}
				((APICMDBUF_SET_STA_FIXEDRATE*)pBuf)->cmdCode = CmdCode;
				((APICMDBUF_SET_STA_FIXEDRATE*)pBuf)->seqNum = 1;
				((APICMDBUF_SET_STA_FIXEDRATE*)pBuf)->cmdBodyLen = sizeof(APICMDBUF_SET_STA_FIXEDRATE)-BUF_HDR_LEN;
				memcpy((char *)&(((APICMDBUF_SET_STA_FIXEDRATE*)pBuf)->fixedRateInfo), pData, sizeof (API_STA_FIXEDRATE));
				
				apctl(pBuf);
				if (pBuf->cmdStatus!=APCTL_OK)
					nStatus = STATUS_FAIL;

				free ((APICMDBUF_SET_STA_FIXEDRATE*)pBuf);
				break;

		case APCMD_SET_STA_AGING_TIME_IN_MINUTES:  
				(APICMDBUF_SET_STA_AGING_TIME*)pBuf = malloc(sizeof (APICMDBUF_SET_STA_AGING_TIME));
    			if(pBuf == NULL)
				{
					return STATUS_FAIL;
				}
				((APICMDBUF_SET_STA_AGING_TIME*)pBuf)->cmdCode = APCMD_SET_STA_AGING_TIME_IN_MINUTES;
				((APICMDBUF_SET_STA_AGING_TIME*)pBuf)->seqNum = 1;
				((APICMDBUF_SET_STA_AGING_TIME*)pBuf)->cmdBodyLen = sizeof(APICMDBUF_SET_STA_AGING_TIME)-BUF_HDR_LEN;
				((APICMDBUF_SET_STA_AGING_TIME*)pBuf)->timeInMinutes = *((SINT32 *)pData);  

				apctl(pBuf);
				free ((APICMDBUF_SET_STA_AGING_TIME*)pBuf);
				break;

		default: nStatus = STATUS_FAIL; 
				 break;
	}

	return nStatus;

}

/*************************************************************************
* Function:     webApiCmd
*
* Description:  wrapper function for apctl()
*
* Input:
*
* Output:       Success: return 0
*
**************************************************************************/
int webApiCmd(UINT16 opCode, APICMDBUF *apiCmd, UINT32 lenDataBuf)
{
    apiCmd->cmdCode = opCode;
    apiCmd->seqNum = 1;
    apiCmd->cmdBodyLen = lenDataBuf;

    apctl(apiCmd);

    if(apiCmd->cmdStatus != APCTL_OK)
    {
        return -1;
    }
    return 0;
}
