#include "wltypes.h"
#include "oem.h"
#include "IEEE_types.h"
#include	"wsIntrn.h"
#ifdef UEMF
	#include	"uemf.h"
#else
	#include	"../basic/basicInternal.h"
#endif

#include  "RfTest.h"
#include  "Mrvap.h"
#include "mib.h"
#include  "api.h" 
#include  "webs.h"
#include  "buildModes.h"

#if 1//bt_test
#define websErrorMsg(x) "hello"
#endif //bt_test_end


/************************************ Locals **********************************/
typedef struct {				/* Struct for CGI tasks which have completed */
	webs_t	wp;					/* pointer to session websRec */
	char_t	*stdIn;				/* file desc. for task's temp input fd */
	char_t	*stdOut;			/* file desc. for task's temp output fd */
	char_t	*cgiPath;			/* path to executable process file */
	char_t	**argp;				/* pointer to buf containing argv tokens */
	char_t	**envp;				/* pointer to array of environment strings */
	int		handle;				/* process handle of the task */
	long	fplacemark;			/* seek location for CGI output file */
} cgiRec;

/************************************* Code ***********************************/

/*
 *	Process a form request. Returns 1 always to indicate it handled the URL
 */
 extern 
int websRfTestHandler(webs_t wp, char_t *urlPrefix, char_t *webDir, int arg, 
		char_t *url, char_t *path, char_t* query)
{
	if (websValidateUrl(wp, path)<0)
	{
		websError(wp, RETCODE_INT_ERR, T("Invalid URL %s"), url);
		return 1;
	}
#if defined(MAIN_PAGE_EVALTOOL)
 	else if (!strcmp(path, "/evaltool.htm") || !strcmp(path, "/index.htm"))
#else
    else if (!strcmp(path, "/evaltool.htm"))
#endif
	{
 		RfTest(wp, query, RF_PAGE);
	}
	else if (!strcmp(path, "/submitchanges.htm"))
	{
		RfTest(wp, query, SUBMIT_CHANGE);		
	}
	else if (!strcmp(path, "/startconttx.htm"))
	{
		RfTest(wp, query, START_TX_CONT);
	}
	else if (!strcmp(path, "/stopconttx.htm"))
	{
		RfTest(wp, query, STOP_TX_CONT);
	}
	else if (!strcmp(path, "/startcwtx.htm"))
	{
		RfTest(wp, query, START_CW_TX);
	}
	else if (!strcmp(path, "/stopcwtx.htm"))
	{
		RfTest(wp, query, STOP_CW_TX);
	}
	else if (!strcmp(path, "/startcarsup.htm"))
	{
		RfTest(wp, query, START_CAR_SUP);
	}
	else if (!strcmp(path, "/stopcarsup.htm"))
	{
		RfTest(wp, query, STOP_CAR_SUP);
	}
	else if (!strcmp(path, "/startrxsen.htm"))
	{
		RfTest(wp, query, START_RX_SEN);
	}
	else if (!strcmp(path, "/stoprxsen.htm"))
	{
		RfTest(wp, query, STOP_RX_SEN);
	}
	else if (strstr(path, ".gif"))
	{
		websDefaultHandler(wp, urlPrefix, webDir, arg, url, path, query);
	}
	else  
	{
		websError(wp, RETCODE_BAD_REQ, T("Bad Request"));
		//websDefaultHandler(wp, urlPrefix, webDir, arg, url, path, query);
	}

 /*	else
	{
		websError(wp, 400, T("Request is not supported."));
	}
 */

	return 1;
} 
 

int RfTest(webs_t wp, char_t* query, UCHAR testMode)
{
	char_t *date;
	char   szData[20];
	ULONG  lData;
	USHORT i, nData;
	

	if (testMode == SUBMIT_CHANGE)
	{
		ChangeSetting(query);
		cyg_thread_delay(500);
	}
/* else if (testMode == START_CAR_SUP)
	{
		// Change Tx Data Rate to 22 Mbps
		SetTxDataRate(RATE_22MBPS);
		//ApCmdSetProc(APCMD_BSS_START, 0); // reset AP to have antenna changes take effect
	}
*/ 
	//WriteHTMLHeader();
	websWrite(wp, T("HTTP/1.1 %d %s\r\n"), 200, websErrorMsg(200));
	websWrite(wp, T("Server: %s\r\n"), WEBS_NAME);
	
	if ((date = websGetDateString(NULL)) != NULL) {
			websWrite(wp, T("Date: %s\r\n"), date);
			bfree(B_L, date);
		}

	websWrite(wp, T("Pragma: no-cache\r\nCache-Control: no-cache\r\n"));
	websWrite(wp, T("Content-Type: text/html\r\n"));
	websWrite(wp, T("\r\n"));
	// end of WriteHtmlHeader

	websWrite(wp, T("<html><head><title>%s</title></head>\r\n"), "RF Test");  
	websWrite(wp, T("<body bgcolor=\"#E8E8E8\" text=\"#000000\"> <font face=\"Times New Roman\">\r\n"));

	websWrite(wp, T("<table border=0 cellspacing=0 width=350><tr><td width=\"5%%\"></td>\r\n"));
	websWrite(wp, T("<td width=\"65%%\"><i><b><font size=6 color=\"#800000\">AP RF Test"));  
	websWrite(wp, T("</font></b></i></td>\r\n<td width=\"30%%\"><img border=\"0\" src=\"Image/logo.gif\" width=\"102\"  height=\"57\"></td>\r\n"));  
	websWrite(wp, T("</tr><tr><td width=\"100%%\" colspan=3><font size=1>_________________________________________________________________________________________</font></td></tr></table>\r\n"));
	 
	websWrite(wp, T("<br><form method=\"Post\" action=\"submitchanges.htm\"><table border=0 width=500><tr>\r\n"));

	// Get Channel
	nData = GetChannel();
	websWrite(wp, T("<tr><td width=\"5%%\"></td><td width=\"30%%\">RF Channel</td>"));
    websWrite(wp, T("<td width=\"65%%\"><select size=1 name=\"Channel\">"));
	for (i=1; i<=14;i++)
	{
		websWrite(wp, T("<option%s>Channel %d</option>"), (nData==i)?" selected":"", i);
	}
    websWrite(wp, T("</select></td>"));
    websWrite(wp, T("</tr>"));

	nData = GetChannel2();
	websWrite(wp, T("<tr><td width=\"5%%\"></td><td width=\"30%%\">RF Channel2</td>"));
       websWrite(wp, T("<td width=\"65%%\"><select size=1 name=\"Channel\">"));
	for (i=1; i<=14;i++)
	{
		websWrite(wp, T("<option%s>Channel %d</option>"), (nData==i)?" selected":"", i);
	}
       websWrite(wp, T("</select></td>"));
       websWrite(wp, T("</tr>"));

	
	// Get Tx Antenna
	if (ApCmdGetProc(APCMD_GET_ANTENNA_MODE, (char*)&nData)==STATUS_FAIL)
	{
		nData = DATA_ERROR;
	}
	websWrite(wp, T("<tr><td width=\"5%%\"></td><td width=\"30%%\">Tx Antenna</td>"));
    websWrite(wp, T("<td width=\"65%%\"><select size=\"1\" name=\"TxAntenna\">"));	
//	websWrite(wp, T("<option%s>Antenna 1</option>"), ((nData&0xF0)>>4)==AP_ANT_A?" selected":"");
//	websWrite(wp, T("<option%s>Antenna 2</option>"), ((nData&0xF0)>>4)==AP_ANT_B?" selected":"");
	websWrite(wp, T("<option%s>By Rx</option>"), ((nData&0xF0)>>4)==AP_ANT_DIVERSITY?" selected":"");
	
	

	// Get Rx Antenna
	websWrite(wp, T("<tr><td width=\"5%%\"></td><td width=\"30%%\">Rx Antenna</td>"));
    websWrite(wp, T("<td width=\"65%%\"><select size=\"1\" name=\"RxAntenna\">"));	
	websWrite(wp, T("<option%s>Antenna 1</option>"), ((nData&0x0F)==AP_ANT_A)?" selected":"");
	websWrite(wp, T("<option%s>Antenna 2</option>"), ((nData&0x0F)==AP_ANT_B)?" selected":"");
	websWrite(wp, T("<option%s>Diversity</option>"), ((nData&0x0F)==AP_ANT_DIVERSITY)?" selected":"");


	// Get Beacon Interval
	nData = GetBeaconInterval();
	websWrite(wp, T("<tr><td width=\"5%%\"></td>"));
	websWrite(wp, T("<td width=\"30%%\">Beacon Interval</td>"));
  	websWrite(wp, T("<td width=\"65%%\"><p align=\"left\"><input type=\"text\" name=\"Beacon\" value=\"%d\" size=\"20\">(milliseconds)</td></tr>\r\n"), nData);
  
	// Get Tx Data Rate (Fix)
	websWrite(wp, T("<tr><td width=\"5%%\"></td>"));
	websWrite(wp, T("<td width=\"30%%\">Tx Data Rate</td>"));
    websWrite(wp, T("<td width=\"65%%\"><select size=1 name=\"TxDataRate\">"));
	
	websWrite(wp, T("<option>Auto Select</option>"));

	nData = GetTxDataRate();  

	for (i=0; i<NUM_DATA_RATE;i++)	
	{
		strcpy(szData, (nData==webDataRate[i])?"selected":"");
		websWrite(wp, T("<option %s>%d%s Mbps</option>"), szData, webDataRate[i]/10, webDataRate[i]%2==0?"":".5");
	}
 
	websWrite(wp, T("</select></td></tr><tr><td width=\"100%%\" colspan=3><font size=1>_________________________________________________________________________________________</font></td></tr></table>\r\n"));

	websWrite(wp, T("<br><table border=0 cellspacing=0 width=500>\r\n"));
	

	// Get Output Power
	nData = GetOutputPower();
	websWrite(wp, T("<tr><td width=\"8%%\"></td>"));
	websWrite(wp, T("<td width=\"20%%\">Output Power</td>"));
    websWrite(wp, T("<td width=\"20%%\"><select size=\"1\" name=\"OutPower%d\">"), nData);
	for (i=MIN_PWR_LVL; i<=MAX_PWR_LVL;i++)
	{
		websWrite(wp, T("<option%s>%d dBm</option>"), (nData==i)?" selected":"", i);
	}
    websWrite(wp, T("</select></td>"));

	// Get Tx VGA Ext Ctrl		
	nData = webReadRfReg(0x23);
  	websWrite(wp, T("<td width=\"52%%\" colspan=2><p align=\"left\"><input type=\"checkbox\" name=\"ExtCtrlTxVga\" %s>External Ctrl Tx VGA</td></tr>\r\n"), 
		(nData&0x20)?"checked":"");


	// Get PA_GA 
	ToBinary((webReadRfReg(0x21) & 0x70)>>4, szData, 3);
	websWrite(wp, T("<tr><td width=\"8%%\"></td>"));
	websWrite(wp, T("<td width=\"20%%\">PA_GA </td>"));
  	websWrite(wp, T("<td width=\"20%%\"><p align=\"left\"><input type=\"text\" name=\"PaGa\" value=\"%s\" size=\"5\"></td>\r\n"), szData);

	// Get Tx VGA 
	nData = ((nData&0x20)==0)?(webReadRfReg(0x24)&0x0F):(nData&0x0F);
	
	websWrite(wp, T("<td width=\"32%%\">Tx VGA</td>"));
 	websWrite(wp, T("<td width=\"20%%\"><select size=\"1\" name=\"TxVgaCtrl\">"));
	for (i=0; i<=15;i++)
	{
		websWrite(wp, T("<option%s>%d dB</option>"), (nData==i)?" selected":"",i-TX_VGA_OFFSET);
	}
	websWrite(wp, T("</select></td></tr>"));

	// Get PA_GB
	ToBinary(webReadRfReg(0x21) & 0x0F, szData, 4);
	websWrite(wp, T("<tr><td width=\"8%%\"></td>"));
	websWrite(wp, T("<td width=\"20%%\">PA_GB </td>"));
  	websWrite(wp, T("<td width=\"20%%\"><p align=\"left\"><input type=\"text\" name=\"PaGb\" value=\"%s\" size=\"5\"></td>\r\n"), szData);

   // Get PADRV 
	nData = (((webReadRfReg(0x26)&0x70)>>4) * 2) + PADRV_OFFSET;
	websWrite(wp, T("<td width=\"32%%\">Tx Pre-Driver Gain Ctrl</td>"));
  	websWrite(wp, T("<td width=\"20%%\"><select size=\"1\" name=\"PaDrv\">"));
	for (i=8; i<=20;i+=2)
	{
		websWrite(wp, T("<option%s>%d dB</option>"),(nData==i)?" selected":"", i);
	}
	websWrite(wp, T("</select></td><tr>"));

	// Get PA_I 
	ToBinary(webReadRfReg(0x22) & 0x07, szData, 3);
	websWrite(wp, T("<tr><td width=\"8%%\"></td>"));
	websWrite(wp, T("<td width=\"20%%\">PA_I </td>"));
  	websWrite(wp, T("<td width=\"20%%\"><p align=\"left\"><input type=\"text\" name=\"PaI\" value=\"%s\" size=\"5\"></td>\r\n"), szData);

	websWrite(wp, T("<td width=\"52%%\" colspan=2></td></tr>\r\n"));


 	websWrite(wp, T("<tr><td width=\"100%%\" colspan=5><font size=1>_________________________________________________________________________________________</font></td></tr>\r\n"));
	
 	websWrite(wp, T("<tr><td width=\"100%%\" colspan=5>&nbsp;</td><tr><td width=\"8%%\"></td><td width=\"20%%\">Change Setting</td>"));
    websWrite(wp, T("<td width=\"72%%\" colspan=3><input type=\"submit\" value=\"Submit\" name=\"Submit\"></td></tr></table></form>"));
 
	// Continuous Tx Test & Rx Sensitivity Test
	websWrite(wp, T("<table border=1 width=500 bgcolor=\"#808080\" bordercolor=\"#C0C0C0\" cellspacing=\"0\">\r\n"));  
	websWrite(wp, T("<tr><td width=\"50%%\" align=\"center\"><a href=\"startconttx.htm\"><font color=\"#F0F0F0\">Start Continuous Tx Test</font></a></td>\r\n"));  
	websWrite(wp, T("<td width=\"50%%\" align=\"center\"><a href=\"stopconttx.htm\"><font color=\"#F0F0F0\">Stop Continuous Tx Test</font></a></td>\r\n"));  
	websWrite(wp, T("</tr><tr><td width=\"50%%\" align=\"center\"><a href=\"startcwtx.htm\"><font color=\"#F0F0F0\">Start Un-modulated Carrier Tx Test</font></a></td>\r\n"));  
	websWrite(wp, T("<td width=\"50%%\" align=\"center\"><a href=\"stopcwtx.htm\"><font color=\"#F0F0F0\">Stop Un-modulated Carrier Tx Test</font></a></td>\r\n"));  
	websWrite(wp, T("</tr><tr><td width=\"50%%\" align=\"center\"><a href=\"startcarsup.htm\"><font color=\"#F0F0F0\">Start Carrier Suppression Test</font></a></td>\r\n"));  
	websWrite(wp, T("<td width=\"50%%\" align=\"center\"><a href=\"stopcarsup.htm\"><font color=\"#F0F0F0\">Stop Carrier Suppression Test</font></a></td>\r\n"));  
	websWrite(wp, T("</tr><tr><td width=\"50%%\" align=\"center\"><a href=\"startrxsen.htm\"><font color=\"#F0F0F0\">Start Rx Sensitivity Test</font></a></td>\r\n"));  
	websWrite(wp, T("<td width=\"50%%\" align=\"center\"><a href=\"stoprxsen.htm\"><font color=\"#F0F0F0\">Stop Rx Sensitivity Test</font></a></td>\r\n"));  
	websWrite(wp, T("</tr></table>\r\n"));  
/*
	websWrite(wp, T("&nbsp;&nbsp;<a href=\"startconttx.htm\">Start Continuous Tx Test</a>"));  
	websWrite(wp, T("&nbsp;&nbsp;<a href=\"stopconttx.htm\">Stop Continuous Tx Test</a>"));  
	websWrite(wp, T("<br>&nbsp;&nbsp;<a href=\"startrxsen.htm\">Start Rx Sensitivity Test</a>\r\n"));  
	websWrite(wp, T("&nbsp;&nbsp;<a href=\"stoprxsen.htm\">Stop Rx Sensitivity Test</a>\r\n"));  
*/
	// Beacon Interval (goes with Duty Cycle Test)

	switch (testMode)
	{
		case START_TX_CONT: 
			StartContTxTest(); 
			websWrite(wp, T("<br>&nbsp;&nbsp;Continuous Tx Test in progress..."));			
			break;
		case STOP_TX_CONT: 
			StopContTxTest(); 
			websWrite(wp, T("<br>&nbsp;&nbsp;Continuous Tx Test Ends."));			
			break;
		case START_RX_SEN:  
			StartRxSensitivityTest(); 
			websWrite(wp, T("<br>&nbsp;&nbsp;Rx Sensitivity Test in progress..."));			
			break;
		case STOP_RX_SEN:   
			lData = StopRxSensitivityTest(); 
			websWrite(wp, T("<br>&nbsp;&nbsp;Rx Multicast Packets Received:   %d"), lData);			
			break;
		case START_CW_TX:  
			StartCwTxTest(); 
			websWrite(wp, T("<br>&nbsp;&nbsp;Un-modulated Carrier Tx Test in progress..."));			
			break;
		case STOP_CW_TX:   
			StopCwTxTest(); 
			websWrite(wp, T("<br>&nbsp;&nbsp;Un-modulated Carrier Tx Test Ends."));			
			break;	
		case START_CAR_SUP:  
			StartCarSupTest(); 
			websWrite(wp, T("<br>&nbsp;&nbsp;Carrier Suppression Test in progress..."));			
			break;
		case STOP_CAR_SUP:   
			StopCarSupTest(); 
			websWrite(wp, T("<br>&nbsp;&nbsp;Carrier Suppression Test Ends."));			
			break;		
		default: break;
	}


	websWrite(wp, T("<br><br><br><img border=\"0\" src=\"Image/GoAhead_Logo.gif\"></font></body></html>\r\n"));
	websDone(wp, 200);

	return 1;
}

void ChangeSetting(char_t* query)
{
 	char	*tmp;
	char	*pTemp, *pCur; 
	USHORT  nData, nTmp;
	int		bNegFlag, nInt;
  char chData;

	if (query == NULL || strlen(query)==0)
	{
		return;
	}
	
 	tmp = malloc(250);
	memset(tmp, 0, 250);

	// Tx Antenna
 /*	pCur = strstr(query, "TxAntenna");
	
	if (pCur != NULL)
	{
		strcpy(tmp, pCur);
		
		// Set Tx Antenna : TxAntennaX=Antenna+1 or Antenna+2 or By Rx
		// TxAntennaX, X indicates the previous selection
		if ((pTemp = strchr(tmp, '&'))!=NULL)
		{
			*pTemp = '\0';
		}
	
		if ( (pTemp = strchr(tmp, '='))!=NULL)
		{
			strcpy(tmp, pTemp+1);

			if (((pTemp = strstr(tmp, "Antenna+1"))!=NULL))
			{
				SetTxAntenna(AP_ANT_A);
			}
			else if (((pTemp = strstr(tmp, "Antenna+2"))!=NULL))
			{ 
				SetTxAntenna(AP_ANT_B);
			}
			else // if (((pTemp = strchr(tmp, 'R'))!=NULL))
			{
				SetTxAntenna(AP_ANT_DIVERSITY);
			}
		}			 
	}
 */

 	// Channel
	pCur = strstr(query, "Channel");
	
	if (pCur != NULL)
	{
		strcpy(tmp, pCur);
		
		// Set Channel : Channel=Channel+X
		if ((pTemp = strchr(tmp, '&'))!=NULL)
		{
			*pTemp = '\0';
		}
	
		if ( (pTemp = strchr(tmp, '+'))!=NULL)
		{
			nData = 0;

			while (*(++pTemp)!='\0')	
			{
				nData = nData*10 + *pTemp - '0';
			}

			SetChannel(nData);
		}
	}
	
	 	// Channel
	pCur = strstr(query, "Channel2");
	
	if (pCur != NULL)
	{
		strcpy(tmp, pCur);
		
		// Set Channel : Channel=Channel+X
		if ((pTemp = strchr(tmp, '&'))!=NULL)
		{
			*pTemp = '\0';
		}
	
		if ( (pTemp = strchr(tmp, '+'))!=NULL)
		{
			nData = 0;

			while (*(++pTemp)!='\0')	
			{
				nData = nData*10 + *pTemp - '0';
			}

			SetChannel2(nData);
		}
	}

	
	// Beacon Interval
	pCur = strstr(query, "Beacon");
	
	if (pCur != NULL)
	{
		strcpy(tmp, pCur);
		
		// Set Beacon Interval : Beacon=XX
		if ((pTemp = strchr(tmp, '&'))!=NULL)
		{
			*pTemp = '\0';
		}
	
		if ( (pTemp = strchr(tmp, '='))!=NULL)
		{
			nData = 0;
			
			while (*(++pTemp)!='\0')	
			{
				nData = nData*10 + *pTemp - '0';
			}

			SetBeaconInterval(nData);
		}
	}
	
  chData = 0;
	ApCmdSetProc(APCMD_BSS_START,  &chData); // reset AP to have antenna changes take effect
 

    cyg_thread_delay(500);
	SetTxAntenna(AP_ANT_DIVERSITY);

	// Rx Antenna
	pCur = strstr(query, "RxAntenna");
	
	if (pCur != NULL)
	{
		strcpy(tmp, pCur);
		
		// Set Rx Antenna : RxAntennaX=Antenna+1 or Antenna+2 or Diversity
		// RxAntennaX, X indicates the previous selection
		if ((pTemp = strchr(tmp, '&'))!=NULL)
		{
			*pTemp = '\0';
		}
	
		if ((pTemp = strstr(tmp, "Antenna+1"))!=NULL)// && (nData != AP_ANT_A))
		{
			SetRxAntenna(AP_ANT_A);
            SetTxAntenna(AP_ANT_A);
		}
		else if ((pTemp = strstr(tmp, "Antenna+2"))!=NULL)// && (nData != AP_ANT_B))
		{ 
			SetRxAntenna(AP_ANT_B);
            SetTxAntenna(AP_ANT_B);
		}
		else //if (((pTemp = strchr(tmp, 'D'))!=NULL)) // && (nData != AP_ANT_DIVERSITY))
		{
			SetRxAntenna(AP_ANT_DIVERSITY);
		}		
				 
	}
 
	// Output Power
	pCur = strstr(query, "OutPower");
	
	if (pCur != NULL)
	{
		strcpy(tmp, pCur);
		
		// Set Output Power : OutPowerYY=XX+dbm, YY is the previous power level
		if ((pTemp = strchr(tmp, '&'))!=NULL)
		{
			*pTemp = '\0';
		}
	
		if ( (pTemp = strchr(tmp, '='))!=NULL)
		{
			// get old setting
			pCur = pTemp-1;
			
			if (*pCur>='0' && *pCur<='9')
			{
				nTmp = *pCur - '0';
				pCur--;

				while (*pCur>='0' && *pCur<='9')
				{
					nTmp = nTmp + (*pCur - '0')*10;
					pCur--;
				}			
			}
			else
			{
				nTmp =0;
			}

			// find new setting
			nData = 0;
			
			while (*(++pTemp)!='+')	
			{
				nData = nData*10 + *pTemp - '0';
			}

			SetOutputPower(nData);	// change power settings
			
			if (nTmp == nData)	// set PA-GA, PA-GB, PA-I and PA-DRV
			{
				SetPaGaGbIDrv(query);
			}
		}
	}


	// Set TxVga
	pCur = strstr(query, "ExtCtrlTxVga");

	if (pCur != NULL)
	{
		pCur = strstr(query, "TxVgaCtrl");
		
		if (pCur!=NULL)
		{
			bNegFlag = 0;
			
			memset(tmp, 0, 250);

			strcpy(tmp, pCur);
		
			if ((pTemp = strchr(tmp, '&'))!=NULL)
			{
				*pTemp = '\0';
			}

			if ( (pTemp = strchr(tmp, '='))!=NULL)
			{
				nInt = 0;

				if (*(pTemp+1)=='-')
				{
					bNegFlag=1;
					pTemp++;
				}

				while (*(++pTemp)!='+')	
				{
					nInt = nInt*10 + *pTemp - '0';
				}

				if (bNegFlag)
				{
					nInt = 0-nInt;
				}

				webWriteRfReg(0x23, ((webReadRfReg(0x23)&0xF0)|(nInt+TX_VGA_OFFSET)) | 0x20);
			}
		}
	}
	else
	{
		webWriteRfReg(0x23, (webReadRfReg(0x23) & 0xDF)); // disable external control
	}

	// Set Tx Data Rate:  TxDataRate=XX+Mbps
	pCur = strstr(query, "TxDataRate");
	
	if (pCur != NULL)
	{
		strcpy(tmp, pCur);
		
		// TxDataRate=XX+Mbps
	 	if ((pTemp = strchr(tmp, '&'))!=NULL)
		{
			*pTemp = '\0';
		}
	 
		if ( (pTemp = strchr(tmp, '='))!=NULL)
		{
			switch (*(pTemp+1))
			{
				case '1': nData = (*(pTemp+2)=='1')?RATE_11MBPS:RATE_1MBPS;
						  break;
				case '2': //nData = RATE_2MBPS; 
						  nData = (*(pTemp+2)=='2')?RATE_22MBPS:RATE_2MBPS;
						  break;
				case '5': nData = RATE_5_5MBPS; break;
				default : nData = AUTO_SELECT; break;
			}

			SetTxDataRate(nData);
		}
	}

  	free(tmp);

}


void SetPaGaGbIDrv(char_t* query)
{
	char	*tmp;
	char	*pTemp, *pCur; 
	USHORT  nData;
	
	// Set PaDrv : PaDrv=X+dB
	pCur = strstr(query, "PaDrv");

	if (pCur != NULL)
	{
		strcpy(tmp, pCur);
		
		if ((pTemp = strchr(tmp, '&'))!=NULL)
		{
			*pTemp = '\0';
		}
		
		if ( (pTemp = strchr(tmp, '='))!=NULL)
		{
			nData = 0;

			while (*(++pTemp)!='+')	
			{
				nData = nData*10 + *pTemp - '0';
			}

			webWriteRfReg(0x26, (webReadRfReg(0x26)&0x8F) | (((nData-PADRV_OFFSET)/2)<<4));			
		}
	}
	
	// Set PA-GA
	pCur = strstr(query, "PaGa");

	if (pCur != NULL)
	{
		strcpy(tmp, pCur);
		
		if ((pTemp = strchr(tmp, '&'))!=NULL)
		{
			*pTemp = '\0';
		}
		
		if ( (pTemp = strchr(tmp, '='))!=NULL)
		{
			nData = 0;

			pTemp++;

			while (*pTemp=='0' || *pTemp == '1')	
			{
				nData = nData*2 + *pTemp - '0';
				pTemp++;
			}	
				
			webWriteRfReg(0x21, (webReadRfReg(0x21) & 0x8F)|((nData & 0x07)<<4));	
			
		}
	}

		// Set PA-GB
	pCur = strstr(query, "PaGb");

	if (pCur != NULL)
	{
		strcpy(tmp, pCur);
		
		if ((pTemp = strchr(tmp, '&'))!=NULL)
		{
			*pTemp = '\0';
		}
		
		if ( (pTemp = strchr(tmp, '='))!=NULL)
		{
			nData = 0;

			pTemp++;

			while (*pTemp=='0' || *pTemp == '1')	
			{
				nData = nData*2 + *pTemp - '0';
				pTemp++;
			}	

			webWriteRfReg(0x21, (webReadRfReg(0x21)&0xF0)|(nData & 0x0F));	
			 
		}
	}

		// Set PA-I
	pCur = strstr(query, "PaI");

	if (pCur != NULL)
	{
		strcpy(tmp, pCur);
		
		if ((pTemp = strchr(tmp, '&'))!=NULL)
		{
			*pTemp = '\0';
		}
		
		if ( (pTemp = strchr(tmp, '='))!=NULL)
		{
			nData = 0;

			pTemp++;

			while (*pTemp=='0' || *pTemp == '1')	
			{
				nData = nData*2 + *pTemp - '0';
				pTemp++;
			}	

			webWriteRfReg(0x22, (webReadRfReg(0x22)&0xF8) | (nData & 0x07));	
			
		}
	}

	free(tmp);
}


int GetChannel()
{
/*	UCHAR chChan = webReadRfReg(0x1A) &0x7F; // MSB always read back 0, bug in chip??
		
	if (webReadRfReg(0x19)==0xBE && (webReadRfReg(0x1B)&0x0F)==0x04) //  chan 2.4,6,...
	{
	 //	if (chChan & 0x80)
	//	{
	//		chChan &= ~0x60;
	//	}
	 //
		switch (chChan)
		{
			case 0x61: chChan = 10; break;
			case 0x6B: chChan = 12; break;
			default : chChan = (chChan-(int)0x54)/5 + 1; break;
		}

		//chChan = (chChan-(int)0x54)/5 + 1;
	}
	else	// chan 1, 3, 5, 7,... and chan 14
	{
		switch (chChan)
		{
			case 0x75: chChan = 14; break; // chan 14
			//case 0x9C: chChan = 7; break; // chan 7
			case 0x1C: chChan = 7; break; // chan 7
			default : chChan = (UCHAR)((double)(chChan-(int)0x51)/5*2) + 1;
					 break;
		}
	}

	return (int)chChan;
*/
	USHORT nData;
	
	if (ApCmdGetProc(APCMD_GET_RF_CHANNEL, &nData)==STATUS_FAIL)
	{
		nData = DATA_ERROR;
	}

	return nData;

}

void SetChannel(int nChan)
{
/*	UCHAR chValue;

	if (nChan%2!=0 || nChan == 14)			// Channels 1, 3, 5, ..., 13, 14
	{
		if (nChan==7) //channel 7
		{
			webWriteRfReg(0x1A, 0x9C);
			webWriteRfReg(0x1B, (webReadRfReg(0x1B) & 0xF0)|0x03);
			webWriteRfReg(0x19, 0x0D);			
		}
		else
		{
			if (nChan == 14) // chan 14
			{
				chValue = 0x75;	
			}
			else
			{
				chValue = (UCHAR)(0x51+((nChan-1)/2)*5);
			}

			webWriteRfReg(0x1A, chValue);
			webWriteRfReg(0x1B, (webReadRfReg(0x1B) & 0xF0)| 0x09);
			webWriteRfReg(0x19, 0x1F);
		}
	}
	else	//Channels 2, 4, 6,8,10, 12  
	{
		chValue = (UCHAR)((int)0x54 + (nChan-1) * 5);

		if (nChan >= 10)
		{
			chValue += 0x60;
		}

		webWriteRfReg(0x1A, chValue);
		webWriteRfReg(0x1B, (webReadRfReg(0x1B) & 0xF0)|0x04);
		webWriteRfReg(0x19, 0xBE);
	}


*/	ApCmdSetProc(APCMD_SET_RF_CHANNEL, &nChan); //SetChannel(i);

}
int GetChannel2()
{
	USHORT nData;
	
	if (ApCmdGetProc(APCMD_GET_RF_CHANNEL2, &nData)==STATUS_FAIL)
	{
		nData = DATA_ERROR;
	}

	return nData;

}

void SetChannel2(int nChan)
{

	ApCmdSetProc(APCMD_SET_RF_CHANNEL2, &nChan); //SetChannel(i);

}


int GetOutputPower()
{
	USHORT nRead = (USHORT)(webReadRfReg(0x20) & 0x1F);

	return (PWR_TBL_SIZE - 1 - nRead+PWL_LVL_OFFSET);
}

/*
 * Remove the SetOutputPower to bring up web server.  The SetOutputPower() is
 * conflict with the SEtOutputPower() in src/w81init.c
 */
#if 0
void SetOutputPower(int nPower)
{
	USHORT nGaGbI;
	char chVal;
	
	nPower -= PWL_LVL_OFFSET;

	webWriteRfReg(0x20, webReadRfReg(0x20) & 0xBF); // make sure external PA is disabled
	webWriteRfReg(0x20, (webReadRfReg(0x20) & 0xC0) | (PWR_TBL_SIZE - 1 - nPower)); 
	
	nGaGbI = OPT_SPEC_MASK_TABLE[nPower]; //OPT_EFFI_TABLE[nPower];
	
	// Set PaGa, PaGb
	chVal = nGaGbI >> 8;	
	webWriteRfReg(0x21, (webReadRfReg(0x21)&0x80) | chVal);

	// Set PaI
	chVal = (nGaGbI >> 4) & 0x07;	
	webWriteRfReg(0x22, (webReadRfReg(0x22) & 0xF8) | chVal);

 	// Set PaDrv
	chVal = (nGaGbI & 0x07) << 4;	
	webWriteRfReg(0x26, (webReadRfReg(0x26) & 0x8F) | chVal);
}
#endif
 
int GetTxDataRate()
{
 	ULONG DataRate;
	int i;

	DataRate = ReadMacReg(0x8000A070);

	for (i=1; i<8; i++)
	{
		if (DataRate!=ReadMacReg(0x8000A070 + i*4))
		{
			return AUTO_SELECT;
		}
	}

	return DataRate;
/*
	UCHAR nDataRate = 0;
	
	ApCmdGetProc(APCMD_GET_TX_DATA_RATE, &nDataRate);
	
	return nDataRate;
*/
}

void SetTxDataRate(int nRate)
{
	if (nRate == AUTO_SELECT) // Auto Select
	{
		WriteMacReg(0x8000A070, RATE_1MBPS);
		WriteMacReg(0x8000A074, RATE_2MBPS);
		WriteMacReg(0x8000A078, RATE_5_5MBPS);
		WriteMacReg(0x8000A07C, RATE_11MBPS);
		WriteMacReg(0x8000A080, RATE_1MBPS);
		WriteMacReg(0x8000A084, RATE_2MBPS);
		WriteMacReg(0x8000A088, RATE_5_5MBPS);
		WriteMacReg(0x8000A08C, RATE_11MBPS);
	}
	else if (nRate == RATE_1MBPS || nRate == RATE_2MBPS || 
			 nRate == RATE_5_5MBPS || nRate == RATE_11MBPS || nRate == RATE_22MBPS)
	{
		WriteMacReg(0x8000A070, nRate);
		WriteMacReg(0x8000A074, nRate);
		WriteMacReg(0x8000A078, nRate);
		WriteMacReg(0x8000A07C, nRate);
		WriteMacReg(0x8000A080, nRate);
		WriteMacReg(0x8000A084, nRate);
		WriteMacReg(0x8000A088, nRate);
		WriteMacReg(0x8000A08C, nRate);
	}
/*
	UCHAR chDataRate;

	chDataRate = (UCHAR)nRate;
	ApCmdSetProc(APCMD_SET_TX_DATA_RATE, &chDataRate);
*/
}
 


int GetBeaconInterval()
{
//	return ReadMacReg(0x8000A1D8);
	ULONG lData;

	if (ApCmdGetProc(APCMD_GET_BEACON_PERIOD, &lData)==STATUS_FAIL)
	{
		lData = 0;
	}

	return lData;
}

void SetBeaconInterval(int nBeacon)
{
/*	WriteMacReg(0x8000A1D8, nBeacon);
	WriteMacReg(0x8000A1c0, 0x0);
	WriteMacReg(0x8000A1c4, 0x0);
	WriteMacReg(0x8000A1c8, nBeacon);
	WriteMacReg(0x8000A1cc, 0x0);
	WriteMacReg(0xA1f4, 0x13);
*/

	ApCmdSetProc(APCMD_SET_BEACON_PERIOD, &nBeacon);  

}



void SetTxAntenna(int nAnt)
{
/*	int nVal;

	nVal = nAnt << 6;

	webWriteBbReg(0x38, (webReadBbReg(0x38) & 0x3F) | nVal);
*/
	USHORT nData;

	nData = AP_TX_ANTENNA;

	switch (nAnt)
	{
		case AP_ANT_A: nData = (nData<<8) | AP_ANT_A; break;
		case AP_ANT_B: nData = (nData<<8) | AP_ANT_B; break;
		case AP_ANT_DIVERSITY: nData = (nData<<8) | AP_ANT_DIVERSITY; break;
		default: return;
	}

	ApCmdSetProc(APCMD_SET_ANTENNA_MODE, (char*)&nData);  
}



void SetRxAntenna(int nAnt)
{
/*	int nVal;

	nVal = nAnt << 6;

	webWriteBbReg(0x37, (webReadBbReg(0x37) & 0x3F) | nVal);
*/
	USHORT nData;

	nData = AP_RX_ANTENNA;

	switch (nAnt)
	{
		case AP_ANT_A: nData = (nData<<8) | AP_ANT_A; break;
		case AP_ANT_B: nData = (nData<<8) | AP_ANT_B; break;
		case AP_ANT_DIVERSITY: nData = (nData<<8) | AP_ANT_DIVERSITY; break;
		default: return;
	}

	ApCmdSetProc(APCMD_SET_ANTENNA_MODE, (char*)&nData); 
}

#ifdef TEST_PAGE
void cyg_thread_delay(int delay)
{
	Sleep(delay);
}
#endif

void StartContTxTest()
{
	WriteMacReg(0x8000A808, 0x01); // program backoff bypass
	WriteMacReg(0x8000A150, 0x01); // make sure MAC is in AP mode

	WriteMacReg(0x8000A810, 0xFFFFFFFF);
	cyg_thread_delay(100);
//	Sleep(10);
	WriteMacReg(0x8000A814, 0x400);
	cyg_thread_delay(100);
//	Sleep(10);
	WriteMacReg(0x8000A818, (ReadMacReg(0x8000A070)&0xFF));  // Tx Data Rate
	cyg_thread_delay(100);
//	Sleep(10);
	WriteMacReg(0x8000A81C, 0x03);

}

void StopContTxTest()
{
	WriteMacReg(0x8000A81C, 0); 
}

void StartRxSensitivityTest()
{
	// Stop Tmr Runner	
	WriteMacReg(0x8000A1F8, 0);
	WriteMacReg(0x8000A204, 9); // enable receiver
	ReadMacReg(0x8000A218); // clear counter
}

ULONG StopRxSensitivityTest()
{
	// Reset Tmr Runner	
	WriteMacReg(0x8000A1F8, 0x01);
	WriteMacReg(0x8000A204, 0); // set to default
	return ReadMacReg(0x8000A218);
}


void StartCwTxTest()
{
	UCHAR chRead;

	StartContTxTest();
	
	chRead = webReadBbReg(0x20) & 0xF0;
	webWriteBbReg(0x20, chRead|0x04);  // set single tone 

}

void StopCwTxTest()
{
	StopContTxTest();
	
	webWriteBbReg(0x20, webReadBbReg(0x20) & 0xF0);  // set back to default
}

void StartCarSupTest()
{
	UCHAR chRead;

	// set to 22 Mbps at baseband register  
	SetTxDataRate(RATE_22MBPS);
	webWriteBbReg(0x1F, webReadBbReg(0x1F) | 0x20);
	webWriteBbReg(0x1C, 0xDC);
	
	StartContTxTest();

	// Set Baseband register 0x20 to 0x08
	chRead = webReadBbReg(0x20) & 0xF0;
	webWriteBbReg(0x20, (chRead | 0x08));

}

void StopCarSupTest()
{
	StopContTxTest();
	
//	SetTxDataRate(AUTO_SELECT);
	webWriteBbReg(0x20, webReadBbReg(0x20) & 0xF0);  // set back to default
//	webWriteBbReg(0x1C, 0x6E);	// set back to 11Mbps

}


void ToBinary(int nVal, char*szPtr, int nMin)
{
	char chTmp;
	int  i, nCnt;

 	nCnt = 0;

	while (nVal>1)
	{
		*(szPtr+nCnt)=(nVal%2==0)?'0':'1';
		nVal=nVal/2;
		nCnt++;
	}

	*(szPtr+nCnt)=(nVal==0)?'0':'1';
	nCnt++;

	while (nCnt<nMin)
	{
		*(szPtr+nCnt)='0';
		nCnt++;
	}
		
	for (i=0; i<nCnt/2; i++)
	{
		chTmp = *(szPtr+i);
		*(szPtr+i) = *(szPtr+nMin-i-1);
		*(szPtr+nMin-i-1) = chTmp;
	}

	*(szPtr+nMin) = '\0';
 

}

unsigned char webReadRfReg(unsigned char index)
{
	W81_InitW8000Access();	
	return ReadRfReg(index);
}

void webWriteRfReg(unsigned char index, unsigned char value)
{
	W81_InitW8000Access();
	WriteRfReg(index, value);
}

unsigned char webReadBbReg(unsigned char index)
{
	W81_BBPInitAccess();
	return ReadBbReg(index);
}

void webWriteBbReg(unsigned char index, unsigned char value)
{
	W81_BBPInitAccess();
	WriteBbReg(index, value);
}
