/******************** (c) Marvell Semiconductor, Inc., 2003 *******************

*

* Purpose:

*    This file contains the function prototypes and definitions for the

*    bridge task.

*

* Public Procedures:

*

* Notes:

*    None.

*

*****************************************************************************/

#ifdef WDS_FEATURE

#ifndef __DS_20030502_H__

#define __DS_20030502_H__



#define DS_ROUTER_CHANGE_MIN_TIME       3       //min time for route change

#define MAX_DS_NODES                    100



typedef struct __DSFDescr{

	apio_handle_t porthandle;

	UINT8	*SrcAddr;

	UINT8	*DstAddr;

	UINT16 padding;	//for align,no use

}t_DSFDescr;



//structure used in hash

typedef struct _sDSCargo

{

	apio_handle_t porthandle;

	UINT32 stamp;

	UINT16 firstadd;

} sDSCargo;

#define	HASHcargoName	sDSCargo

#ifndef _DS_H_

typedef struct

{

    UINT32 Key;

    UINT32 totalLen;
#ifdef GATEWAY
    unsigned int interface;/*0 - LAN ;1 - WAN*/
#endif

    UINT8 data[1600];

}

dsQ_LlcData_t;

#endif

typedef struct _t_WDS_Port_CB{

        apio_handle_t wdsxHandle;

        #define WDS_PORT_IN_USE         1

        #define WDS_PORT_NOT_USE        0

        UINT32  status; 

        UINT8 repeaterID[6];

}t_WDS_Port_CB;



extern t_WDS_Port_CB WDS_Port_CB[MAX_WDS_PORT+1];

apio_handle_t llcHandle;



/*exported apies in ds block*/

int DSInit(void);

static void addDSNode(sHASH *p);

static void delDSNode(sHASH *p);

int DSForwardPacket(apio_handle_t port_handler,apio_bufdescr_t *pBufDescr);

//UINT32 * apio_GetWlanTxBuf(void);

//UINT32 * apio_GetEtherTxBuf(void);

inline void CheckDmaDone(void);



#endif

#endif // WDS_FEATURE