#include <cyg/kernel/kapi.h>
#include <cyg/io/io.h>                  /* I/O functions */
#include <cyg/hal/hal_arch.h>           /* CYGNUM_HAL_STACK_SIZE_TYPICAL */ 
#include <stdlib.h>
#include "wltypes.h"
#include "oem.h"
#include "IEEE_types.h" 
#include "mib.h" 
#include "api.h"
#include "ds.h"
#include "keyMgmtCommon.h"
#include "keyMgmt.h"
#include "sysinfo.h"
#include "wpa.h"
#include "os_if.h"
#include "dshash.h"
#include "bridge.h"
#ifndef NO_ECOS_TCP_IP_STACK
#include "eth_drv.h"
#endif
#include "pool.h"
#include "StaDb.h"
#include "eth_debug.h"
#ifdef GATEWAY
#include "packet.h"
#endif
#ifdef WDS_FEATURE
#ifndef EZ_WDS
#ifndef MAX_WDS_PORT
#define MAX_WDS_PORT   6
#endif
#endif

#ifdef AUTOLINK
#include "autoLink.h"
#endif

#ifdef ENABLE_UART
#define CLI_CMD_MAX_SIZE 63
UINT8 cliCmdBuf[CLI_CMD_MAX_SIZE + 1];
#endif

#define dsalign(op,al)  ((op+(al-1)) & ~(al-1))
static sHASHio DSTbl = {addDSNode,delDSNode,0,dsalign(sizeof(sDSCargo),4),100};
U8 DSTblStore[HASHsize((MAX_DS_NODES+1),dsalign(sizeof(sDSCargo),4))];
#ifndef EZ_WDS
t_WDS_Port_CB WDS_Port_CB[MAX_WDS_PORT+1];

extern UINT8 mib_wdsEnable;
extern UINT8 mib_wdsno;
extern UINT8 mib_wdsmac[MAX_WDS_PORT*6];
#endif
#endif // WDS_FEATURE

#ifdef AP_URPTR
extern UINT32 urPort_Write( apio_bufdescr_t *pBufDescr);
extern UINT8  mib_urMode;
extern UINT8  *g_pAssociatedFlag;
extern UINT8  mib_urModeConfig;
extern UINT8  mib_wbMode;
void  urSettingProblemInd(int status)
{
    //status = status code as defined in IEEE_types.h
}
#endif

apio_handle_t LanHandle, WlanHandle, WanHandle;
#define sysinfo_BRIDGESTACK_DATA_Q  0
#define sysinfo_TASK_NAME  "Bridge"
#define sysinfo_TASK_STACK_SIZE    8192//4096*3//8192//4096
#define sysinfo_TASK_PRI         16//8

static cyg_thread Task;
static cyg_handle_t TaskHdl;
static UINT8 Stack[sysinfo_TASK_STACK_SIZE] __attribute__ ((section (".itcmbuf")));

void Bridge(cyg_addrword_t Data);
static cyg_mbox         BridgeStackQueue[1];
static cyg_handle_t     BridgeStackQueueHdl[1] ;

extern void BSS_Start(void);
extern void w8100_eth_RxEvent(int length);
extern struct eth_drv_sc *sc1;
extern struct net_device eth_dev;
extern IEEEtypes_MacAddr_t macStaAddr;
#ifdef ECOS_TCP_IP_STACK
#ifdef GATEWAY
extern struct eth_drv_sc *sc0;
unsigned char * rcvdData;
unsigned int rcvdPort;
extern int SendToProtStack(unsigned char *buf, int count, int port);
#else
extern unsigned char * rcvdData;
extern SendToProtStack(unsigned char *buf, int count);
#endif
#endif
extern extStaDb_Status_e extStaDb_RemoveSta(IEEEtypes_MacAddr_t *Addr_p);

void Bridge(cyg_addrword_t Data);
inline DistTaskMsg_t *CheckStaAssocState2();
void ethTxDoneCb(apio_bufdescr_t *pBufDesc);

#ifdef WPA
inline Status_e CheckStaAssocState(StaAssocStateMsg_t *pMsg);
apio_bufdescr_t *ProcessEAPoL(apio_bufdescr_t *, IEEEtypes_MacAddr_t *); //, STA_ASSOC_TYPE eStaAssocType);
#endif
dsQ_LlcData_t *ReceiveFromProtStack(void);

unsigned char WanMac[] = {0x00, 0xe0, 0x00, 0xbf, 0x81, 0x6a};
unsigned char LanMac [] = {0x00, 0x00, 0x4c, 0xbe, 0xcc, 0xb1};
unsigned char gwLanMac[] = {0x00, 0xc0, 0x02, 0x0b, 0x6a, 0x11};
unsigned char gwWanMac[] = {0x00, 0xc0, 0x02, 0x0b, 0x6a, 0x12};
unsigned char WlanMac[] = {0x00, 0x09, 0x5b, 0x45, 0x3a, 0xbe};

pool_ID_t llcDataPoolId;
unsigned char *rcvdData;
sdpool_CREATE(llcDataPool, "llcDataPool", sizeof(dsQ_LlcData_t), 16);

#ifdef GATEWAY
extern UINT32 ProcessEtherDataGW(int);
extern UINT32 ProcessWirelessDataGW(int);
extern UINT32 ProcessLlcDataGW(int);
UINT32 (*ProcessEtherDataFp)(int pkts)= ProcessEtherDataGW;
UINT32 (*ProcessWirelessDataFp)(int pkts)= ProcessWirelessDataGW;
UINT32 (*ProcessLlcDataFp)(int pkts)= ProcessLlcDataGW;
#else
extern UINT32 ProcessEtherData(int);
extern UINT32 ProcessWirelessData(int);
extern UINT32 ProcessLlcData(int);
extern UINT32 ProcessEtherDataUr(int);
extern UINT32 ProcessWirelessDataUr(int);
extern UINT32 ProcessLlcDataUr(int);
UINT32 (*ProcessEtherDataFp)(int pkts)= ProcessEtherData;
UINT32 (*ProcessWirelessDataFp)(int pkts)= ProcessWirelessData;
#ifndef NO_ECOS_TCP_IP_STACK
UINT32 (*ProcessLlcDataFp)(int pkts)= ProcessLlcData;
#endif
#endif

#ifdef AUTOLINK
extern UINT32 g_ALButtonPressed; //Set when AL button is pressed and reset when event received in Bridge
SINT16 APProcessAutoLinkFrame(UINT8 *pRecvFrame, apio_bufdescr_t *pTxFrame);
#endif

#ifdef WDS_FEATURE
extern sHASH *HASHinit(sHASHio *pHASHio,void *pHASHbuffer,U32 HASHmember);
void OpenWdsPorts(void);
apio_handle_t test_cache[6];
static void dummy (void)
{
}
int DSInit()
{
 HASHinit(&DSTbl,&DSTblStore, (MAX_DS_NODES+1));
    return 0;
}

#ifndef EZ_WDS
void OpenWdsPorts(void)
{
    extern UINT8 AgeOutAP;
    int i,num;
    //unsigned int SubID;
    apio_ErrCode_t error;
    char szWDS[32];

    for(i=0;i<=MAX_WDS_PORT;i++)
    {
       WDS_Port_CB[i].status = WDS_PORT_NOT_USE;
    }

  //open broadcast port
   error = apio_open("wdsffffffffffff",&WDS_Port_CB[0].wdsxHandle,NULL);
   if(error != APIO_ERROR)
 {
       test_cache[0] = WDS_Port_CB[0].wdsxHandle;
      WDS_Port_CB[0].status = WDS_PORT_IN_USE;
        memset(WDS_Port_CB[0].repeaterID,0,6);
  }
   else
    {//should not reach here 
       while(1){};
 }

   if(mib_wdsEnable == 0)
  {
        AgeOutAP = FALSE;

    }
 else if(mib_wdsEnable == 1)
 {
       //static wds
        num = (mib_wdsno <= (MAX_WDS_PORT))? mib_wdsno:(MAX_WDS_PORT);
      for(i=0;i<num;i++)
      {
           sprintf(szWDS, "wds%02x%02x%02x%02x%02x%02x", mib_wdsmac[i*6],
                                              mib_wdsmac[i*6+1],
                                              mib_wdsmac[i*6+2],
                                              mib_wdsmac[i*6+3],
                                              mib_wdsmac[i*6+4],
                                              mib_wdsmac[i*6+5]);
         error = apio_open(szWDS,&WDS_Port_CB[i+1].wdsxHandle,NULL);
         if(error != APIO_ERROR)
         {
               WDS_Port_CB[i+1].status = WDS_PORT_IN_USE;
              memcpy(WDS_Port_CB[i+1].repeaterID,&mib_wdsmac[i*6],6);
         }
       }
        AgeOutAP = FALSE;
  }
   else
    {
       //dynamic wds
   //    apEvtSub(APEVT_UNKNOWN_WDS_ROUTE, (void *)&NewRouterHandler, &SubID);
        AgeOutAP = TRUE;

 }    

}

#if 0
void AddWdsMacs(void)
{
    int i,num;
    if ( mib_wdsEnable == 1 )
    {
        /*static wds*/
        num = (mib_wdsno <= (MAX_WDS_PORT))? mib_wdsno:(MAX_WDS_PORT);
        for ( i=0;i<num;i++ )
        {
            AddAPtoStaList(&mib_wdsmac[i*6]);
            }
        }
    }
#endif

UINT8 getDynamicWdsMac(UINT8 *buf)
{
    int i, j=0;
    for (i = 0; i <MAX_WDS_PORT; i++)
    {
        if(WDS_Port_CB[i+1].status == WDS_PORT_IN_USE)
        {
            memcpy(buf+i*6, WDS_Port_CB[i+1].repeaterID,6);
            j++;
        }
    }
    return j;
}
#endif //EZ_WDS

/***********************************************************************************************
int   DSForwardPacket(apio_handle_t *port_handler,apio_bufdescr_t *pBufDescr)
 Description:    This function update da route table base on information income with 
    Return Value:   See macros defined bellow
                        You should get return information from __DSFDesc->RepeaterID also, all
                        zero value in __DSFDesc->RepeaterI means client connects to BSS interface
***********************************************************************************************/
#ifndef GATEWAY
#define  FORWARD_SUCCESS     0x0
#define FORWARD_ERROR        0x1
int DSForwardPacket(apio_handle_t port_handler, apio_bufdescr_t *pBufDescr)
{
    t_DSFDescr pDSFDescr;
    sHASH *phds;
    sDSCargo *bpds;
    dsQ_LlcData_t *LlcData_p;
    apio_bufdescr_t tmpBufDescr;

    pDSFDescr.SrcAddr = pBufDescr->framePtr + 6;
    pDSFDescr.DstAddr = pBufDescr->framePtr;
    pDSFDescr.porthandle = port_handler;
    phds = HASHautoSearch(&DSTbl, pDSFDescr.SrcAddr);
    if ( ((U32)phds != (U32)HASH_MCAST) && ((U32)phds != (U32)HASH_BCAST) )
    {
        // Add route for unitcast MAC address
        bpds = (sDSCargo *)HASHcargo(phds);
        if ( bpds->porthandle != pDSFDescr.porthandle )
        {
            // Packet come from a different route
            if ( bpds->firstadd == 0 )
            {
                extStaDb_RemoveSta((IEEEtypes_MacAddr_t *)pDSFDescr.SrcAddr);
                bpds->porthandle = pDSFDescr.porthandle;
                goto discard_in_packet;
            }
            else
            {
                // Update the src to the newest route
                bpds->porthandle = pDSFDescr.porthandle;
            }
        }
        bpds->firstadd = 0;
    }

    phds = HASHSearch(&DSTbl, pDSFDescr.DstAddr);
    if ( (U32)phds==(U32)HASH_MCAST || (U32)phds==(U32)HASH_BCAST || (U32)phds==(U32)HASH_NOT_FOUND )
    {
        // Can not find route, broadcast it
        goto broadcast_in_packet;
    }
    else
    {
        bpds = (sDSCargo *)HASHcargo(phds);
        pDSFDescr.porthandle = bpds->porthandle; 
        goto send_in_packet;
    }

    broadcast_in_packet:
#ifdef ECOS_TCP_IP_STACK
    if ( port_handler == llcHandle )
    {
        // Duplicate packet
        if ( (apio_alloc(LanHandle, &tmpBufDescr)) == APCTL_OK )
        {
            tmpBufDescr.frameLen = pBufDescr->frameLen;
            memcpy(tmpBufDescr.framePtr, pBufDescr->framePtr, pBufDescr->frameLen);
        }
        else
        {
            tmpBufDescr.framePtr = NULL;
        }

        // Release LLC buffer
        LlcData_p = (dsQ_LlcData_t *)(pBufDescr->framePtr - 2 * sizeof(unsigned int));
        pool_FreeBuf((UINT8 *)LlcData_p);
        if ( tmpBufDescr.framePtr == NULL )
            return FORWARD_ERROR;
    }
    else
#endif
    {
        tmpBufDescr.framePtr = pBufDescr->framePtr;
        tmpBufDescr.frameLen = pBufDescr->frameLen;
    }
    // Send to wireless side
    if ( port_handler != WlanHandle )
    {
        apio_bufdescr_t duplicate;
#if defined(WIPOD)
        if ( (mib_wipodMode != WIPOD_MODE_REPEATER) || (port_handler != LanHandle) )
#endif
        {
            if ( (apio_alloc(LanHandle, &duplicate)) == APCTL_OK )
            {
                duplicate.frameLen = tmpBufDescr.frameLen;
                duplicate.reserved = 0;
                memcpy(duplicate.framePtr, tmpBufDescr.framePtr, tmpBufDescr.frameLen);
#ifdef AP_URPTR
                if (mib_wbMode == 1)
                {
                    urPort_Write(&duplicate);
                }
                else if (!apio_write(WlanHandle, &duplicate))
                {
                    if ( (mib_urMode == 1) && *g_pAssociatedFlag )
                    {
                        if ( (apio_alloc(LanHandle, &duplicate)) == APCTL_OK )
                        {
                            duplicate.frameLen = tmpBufDescr.frameLen;
                            duplicate.reserved = 0;
                            memcpy(duplicate.framePtr, tmpBufDescr.framePtr, tmpBufDescr.frameLen);
                            apio_urWlanWrite(&duplicate);
                        }
                        else
                        {
                            apio_free(LanHandle, &tmpBufDescr);
                            return FORWARD_ERROR;
                        }
                    }
                }
#else
                apio_write(WlanHandle, &duplicate);
#endif
            }
            else
            {
                apio_free(LanHandle, &tmpBufDescr);
                return FORWARD_ERROR;
            }
        }
    }

    // Send to ethernet side
    if ( port_handler != LanHandle )
    {
        apio_bufdescr_t duplicate;       
#if defined(WIPOD) 
        if ( (mib_wipodMode != WIPOD_MODE_REPEATER) || (port_handler == llcHandle) )
#endif
        {
            if ( (apio_alloc(LanHandle, &duplicate)) == APCTL_OK )
            {
                duplicate.frameLen = tmpBufDescr.frameLen;
                memcpy(duplicate.framePtr, tmpBufDescr.framePtr, tmpBufDescr.frameLen);
                apio_write(LanHandle, &duplicate);
            }
            else
            {
                // Can't allocate buffer for forward, release pre-buffer
                apio_free(LanHandle, &tmpBufDescr);
                return FORWARD_ERROR;
            }
        }
    }
#ifdef ECOS_TCP_IP_STACK
    // Send to LLC if broadcast from LAN port
    if ( port_handler != llcHandle )
    {
        {
#ifdef BLOCK_WLAN_TO_STACK
            if ( port_handler == LanHandle )
#endif
            {
#ifdef ECOS_TCP_IP_STACK
#ifdef GATEWAY
                SendToProtStack(tmpBufDescr.framePtr, tmpBufDescr.frameLen, tmpBufDescr.reserved);
#else
                SendToProtStack(tmpBufDescr.framePtr, tmpBufDescr.frameLen);
#endif            
#endif    
            }
        }
    }
#endif
#if defined(WIPOD) 
    if ( (mib_wipodMode != WIPOD_MODE_REPEATER) || (port_handler != LanHandle) )
#endif
    {

#ifndef EZ_WDS
        if ( mib_wdsBcastMode == BCAST_AS_WDS_BCAST )
        {
            // Send to WDS,write packet to WDS port 0 will broadcast it
            if ( 
#ifdef ECOS_TCP_IP_STACK
     (port_handler == llcHandle)||
#endif
      (port_handler == LanHandle) || (port_handler == WlanHandle) )
            {
                if ( (apio_alloc(LanHandle,&duplicate)) == APCTL_OK )
                {
                    MemDma((UINT32)(duplicate.framePtr),(UINT32)(tmpBufDescr.framePtr),tmpBufDescr.frameLen);
                    CheckDmaDone();
                    duplicate.frameLen = tmpBufDescr.frameLen;
                    duplicate.reserved = 0;
                    apio_write(WDS_Port_CB[0].wdsxHandle,&duplicate);
                }
            }
        }
        else   /* bcast as unicast */
        {
            if ( mib_wdsEnable  && mib_wdsno )
            {
                for ( i=1;i<MAX_WDS_PORT+1;i++ )
                {  //search all wds ports
                    if ( WDS_Port_CB[i].status == WDS_PORT_IN_USE )
                    {//if port opened
                        if ( port_handler != WDS_Port_CB[i].wdsxHandle )
                        {
                            if ( (apio_alloc(LanHandle,&duplicate)) == APCTL_OK )
                            {
                                MemDma((UINT32)(duplicate.framePtr),(UINT32)(tmpBufDescr.framePtr),tmpBufDescr.frameLen);
                                CheckDmaDone();
                                duplicate.frameLen = tmpBufDescr.frameLen;
                                duplicate.reserved = i;

                                apio_write(WDS_Port_CB[i].wdsxHandle,&duplicate);
                            }
                            else
                            {//can't allocate buffer for forward, release pre-buffer

                                apio_free(LanHandle,&tmpBufDescr);
                                return FORWARD_ERROR;
                            }
                        }
                    }
                }
            }
        }
#endif  // EZ_WDS
    }
    apio_free(LanHandle, &tmpBufDescr);
    return FORWARD_SUCCESS;

    send_in_packet:
#ifdef ECOS_TCP_IP_STACK
    if ( port_handler == llcHandle )
    {
        if ( (apio_alloc(LanHandle, &tmpBufDescr)) == APCTL_OK )
        {
            tmpBufDescr.frameLen = pBufDescr->frameLen;
            memcpy(tmpBufDescr.framePtr, pBufDescr->framePtr, pBufDescr->frameLen);
        }
        else
        {
            tmpBufDescr.framePtr = NULL;
        }

        // Release LLC buffer
        LlcData_p = (dsQ_LlcData_t *)(pBufDescr->framePtr - 2 * sizeof(unsigned int));
        pool_FreeBuf((UINT8 *)LlcData_p);
        if ( tmpBufDescr.framePtr == NULL )
            return FORWARD_ERROR;
    }
    else
#endif
    {
        tmpBufDescr.framePtr = pBufDescr->framePtr;
        tmpBufDescr.frameLen = pBufDescr->frameLen;
    }

    if ( pDSFDescr.porthandle == llcHandle )
    {
#ifdef ECOS_TCP_IP_STACK
#ifdef GATEWAY
        SendToProtStack(tmpBufDescr.framePtr, tmpBufDescr.frameLen, tmpBufDescr.reserved);
#else
        SendToProtStack(tmpBufDescr.framePtr, tmpBufDescr.frameLen);
#endif
#endif
      apio_free(LanHandle, &tmpBufDescr);
    }
    else
    {
        if ( pDSFDescr.porthandle != port_handler )
        {
#if defined(WIPOD)
            if ( mib_wipodMode == WIPOD_MODE_REPEATER )
            {
                if ( port_handler == LanHandle )
                {
                    if ( pDSFDescr.porthandle !=llcHandle )
                    {
                        apio_free(LanHandle,&tmpBufDescr);
                        return FORWARD_SUCCESS;
                    }

                }
                else if ( pDSFDescr.porthandle == LanHandle )
                {
                    if ( port_handler != llcHandle )
                    {
                        apio_free(LanHandle,&tmpBufDescr);
                        return FORWARD_SUCCESS;
                    }
                }
            }
#endif
            apio_write(pDSFDescr.porthandle, &tmpBufDescr);
        }
        else
        {
            apio_free(LanHandle, &tmpBufDescr);
        }
    }
 //   apio_free(LanHandle, &tmpBufDescr);
    return FORWARD_SUCCESS;

    discard_in_packet:
#ifdef ECOS_TCP_IP_STACK
    if ( port_handler == llcHandle )
    {
        LlcData_p = (dsQ_LlcData_t *)(pBufDescr->framePtr - 2 * sizeof(unsigned int));
        pool_FreeBuf((UINT8 *)LlcData_p);
    }
    else
#endif
    {
        apio_free(LanHandle, pBufDescr);
    }
    return FORWARD_ERROR;
}
#endif
void addDSNode(sHASH *p)
{
    sDSCargo *bpds;
    bpds = (sDSCargo*)HASHcargo(p);
    bpds->firstadd = 1;
}

void delDSNode(sHASH *p)
{
}

#ifndef EZ_WDS
UINT8 NewRouterHandler(UINT8 *repeaterId)
{
    int i;
    UINT8 szWDS[32];
    apio_ErrCode_t error;

    if(mib_wdsEnable != 2)
 {
       return 0;
   }
   for(i=0;i<=MAX_WDS_PORT;i++)
    {
       if(WDS_Port_CB[i].status != WDS_PORT_IN_USE)
            break;
  }
   if(i != (MAX_WDS_PORT+1))
   {//open a new wds port for this new connect

     sprintf(szWDS, "wds%02x%02x%02x%02x%02x%02x", repeaterId[0],
                                        repeaterId[1],
                                        repeaterId[2],
                                        repeaterId[3],
                                        repeaterId[4],
                                        repeaterId[5]);

     error = apio_open(szWDS,&WDS_Port_CB[i].wdsxHandle,NULL);
       if(error != APIO_ERROR)
     {
           WDS_Port_CB[i].status = WDS_PORT_IN_USE;
            memcpy(WDS_Port_CB[i].repeaterID,repeaterId,6);
         memcpy(&mib_wdsmac[mib_wdsno * 6],repeaterId,6);
            mib_wdsno++;
        }
       return i;
   }
   else
        return 0;
}

void RemoveWdsPort(UINT8 *macAddr)
{
    int i;
    for ( i=1;i<=MAX_WDS_PORT;i++ )
    {
        if(memcmp(macAddr, WDS_Port_CB[i].repeaterID, 6)== 0)
        {
            apio_close(WDS_Port_CB[i].wdsxHandle);
        }
        }
    }

BOOLEAN WdsPortClose(apio_handle_t Handle)
{
    int i;
    for ( i=1;i<=MAX_WDS_PORT;i++ )
    {
        if ( WDS_Port_CB[i].wdsxHandle == Handle )
        {
            WDS_Port_CB[i].status = WDS_PORT_NOT_USE;
            return SUCCESS;
        }
    }
    return FAIL;
}
#endif // EZ_WDS
#endif // WDS_FEATURE

int Bridge_Init(void)
{
#ifdef WDS_FEATURE
    DSInit();
#endif
    if ( systemCfg.prod==AP51 )
    {
        apio_open("eth0", &LanHandle, ethTxDoneCb);
#ifdef GATEWAY
      WanHandle = LanHandle;
#endif
        apio_open("wl0",  &WlanHandle, ethTxDoneCb);
    }
    if ( systemCfg.prod==AP52 )
    {
        apio_open("lan0", &LanHandle, ethTxDoneCb);
        apio_open("wan0", &WanHandle, ethTxDoneCb);
        apio_open("wl0",  &WlanHandle, ethTxDoneCb);
    }
    cyg_thread_create(sysinfo_TASK_PRI,
                      Bridge,
                      0,
                      sysinfo_TASK_NAME,
                      (void *)(Stack),
                      sysinfo_TASK_STACK_SIZE,
                      &TaskHdl,
                      &Task);
    BridgeStackQueueHdl[sysinfo_BRIDGESTACK_DATA_Q] = 0;
    cyg_mbox_create(&BridgeStackQueueHdl[sysinfo_BRIDGESTACK_DATA_Q], 
      &BridgeStackQueue[sysinfo_BRIDGESTACK_DATA_Q]);

    if (BridgeStackQueueHdl[sysinfo_BRIDGESTACK_DATA_Q] == 0)
{
        return (FAIL);
    }
    llcDataPoolId = pool_Create(&llcDataPool); 
    return (SUCCESS);
}

void Bridge_Start(void)
{
    cyg_thread_resume(TaskHdl);
}

inline DistTaskMsg_t *CheckStaAssocState2(void)
{
    DistTaskMsg_t *pDistMsg = NULL;
    pDistMsg = (DistTaskMsg_t *)os_QueueReadNoBlock(sysinfo_WPA_Q);
    return pDistMsg;
}
#ifdef PROFILING
extern inline void Profile_timing(UINT32 status);
#endif
void Bridge(cyg_addrword_t Data)
{
#ifdef LED_SUPPORT
    static UINT32 count = 0;   
#endif
#ifdef PROFILING
  UINT32 cnt;
#endif
#ifdef WDS_FEATURE
#ifndef PRESET_WDS_DYNAMIC_UNICAST
      OpenWdsPorts();             /* opens the ports for the set mode, default 
                                   * wds disabled */
#endif
#endif
    
    BSS_Start();

#ifdef AP_URPTR
    urInit();
    if(mib_urMode)
  {
       ProcessEtherDataFp = ProcessEtherDataUr;
        ProcessWirelessDataFp = ProcessWirelessDataUr;
#ifndef NO_ECOS_TCP_IP_STACK        
      ProcessLlcDataFp = ProcessLlcDataUr;
#endif /* ECOS_TCP_IP_STACK */
  }
#endif

#ifndef AP_URPTR
    if (mib_PrivacyTable_p->RSNEnabled) 
    {
        KeyMgmtInit();
    }
#endif

    while (1)
    {
#ifdef PROFILING
        Profile_timing(cnt?1:0);
        cnt =(*ProcessWirelessDataFp)(NO_OF_PKTS_WLAN);
        cnt +=(*ProcessEtherDataFp)(NO_OF_PKTS_LAN);
        cnt +=(*ProcessLlcDataFp)(NO_OF_PKTS_LAN);
#else
        (*ProcessWirelessDataFp)(NO_OF_PKTS_WLAN);
        (*ProcessEtherDataFp)(NO_OF_PKTS_LAN);
#ifndef NO_ECOS_TCP_IP_STACK
        (*ProcessLlcDataFp)(NO_OF_PKTS_LAN);
#endif /* ECOS_TCP_IP_STACK */
#endif
        // check WPA msg
        {
            DistTaskMsg_t *pDistMsg;
#ifdef AUTOLINK
            if ( mib_PrivacyTable_p->RSNEnabled ||(g_ALButtonPressed == TRUE)) {
#else
            if ( mib_PrivacyTable_p->RSNEnabled ) {
#endif
                if ( (pDistMsg = (DistTaskMsg_t *)os_QueueReadNoBlock(sysinfo_WPA_Q)) != NULL ) 
                {
                    if ( pDistMsg->MsgType == STA_ASSOMSGRECVD ) {
                        StaAssocStateMsg_t *staAssocMsg_p;

                        staAssocMsg_p = &pDistMsg->msg.StaAssocStateMsg;
                        /* call key mgmt function */
                        /*pBufDescrEAPoL = ProcessEAPoL( NULL, &staAssocMsg_p->staMACAddr); */
                        ProcessEAPoL( NULL, &staAssocMsg_p->staMACAddr);
                    }
                    else if ( pDistMsg->MsgType == TIMERMSGRECVD ) {
                        distQ_TimerMsg_t *distTimerMsg_p = &pDistMsg->msg.distQ_TimerMsg;
                        keyMgmt_Timeout(distTimerMsg_p);
                    }
                    else if (pDistMsg->MsgType==KEYMGMTINITMSGRECVD) {
                        KeyMgmtInit();
                    }
#ifdef AUTOLINK
                    else if (pDistMsg->MsgType==AUTOLINKBUTTONPRESSED) {
                        g_ALButtonPressed = FALSE;
                        AutoLinkInit();
                    }
#endif
                    pool_FreeBuf((UINT8 *)pDistMsg);
                }
            }
        }

#ifdef LED_SUPPORT
        if ( count++ > 1000 ) {
            count = 0;
           LEDoff();
        }
#endif
#ifdef ENABLE_UART
    {
        UINT32 len;
        len = CLI_CMD_MAX_SIZE + 1;
        if (uart_read(cliCmdBuf, &len))
        {
            UINT8 c;
            if (len) cliCmdParse(cliCmdBuf);
            c = '>';
            uart_write(&c, 1);
        }
    }
#endif  
    }
}

void ethTxDoneCb(apio_bufdescr_t *pBuf)
{
}

dsQ_LlcData_t *ReceiveFromProtStack(void)
{
      return (cyg_mbox_tryget(BridgeStackQueueHdl[sysinfo_BRIDGESTACK_DATA_Q]));
}

dsQ_LlcData_t *ds_GetLlcDataBuf(void)
{
    return ((dsQ_LlcData_t *)pool_GetBuf(llcDataPoolId));
}

int dsQ_LlcDataWriteNoBlock(dsQ_LlcData_t *LlcData_p)
{
    int status;
    status = cyg_mbox_tryput(BridgeStackQueueHdl[sysinfo_BRIDGESTACK_DATA_Q], LlcData_p);
    if (status)
    {
#ifdef GATEWAY
        if(LlcData_p->interface == 0) /*LAN interface*/
#endif
            eth_drv_tx_done(sc1, LlcData_p->Key, 0);
#ifdef GATEWAY
        else
            eth_drv_tx_done(sc0, LlcData_p->Key, 0);
#endif        
        return (SUCCESS);
    }
    else
    {
        pool_FreeBuf((char *)LlcData_p);
        return (FAIL);
    }
}

int llcBufError = 0;
#ifdef ECOS_TCP_IP_STACK
#ifdef GATEWAY
int SendToProtStack(unsigned char *buf, int count, int port)
#else
int SendToProtStack(unsigned char *buf, int count)
#endif
{
    dsQ_LlcData_t *llcData_p;  
    IEEEtypes_8023_Frame_t *DataEtherFrame_p;
    if ((count <= 0) || (count > 1600) || (buf == NULL))
    {
        llcBufError++;
        return 0;
    }
    
    DataEtherFrame_p = (IEEEtypes_8023_Frame_t *)buf;
#ifdef ENABLE_ETH_DEBUG    
    // Enable receiving debug commands from a LAN port
    {
        UINT16 type;
        type = SHORT_SWAP(DataEtherFrame_p->Hdr.type);
        if (type == DBG_DEFAULT_TYPE)
        {
            etherBugRecv((UINT8 *)DataEtherFrame_p, count);
            return 0;
        }
    }
#endif

#ifdef AUTOLINK
    {
        llc_snap_hdr_t * llcSnap_p;
        UINT16 typelen;
        SINT16 length = -1;
        apio_bufdescr_t TxBuf;
        IEEEtypes_8023_Frame_t * txEtherHdr_p;
        llcSnap_p = (llc_snap_hdr_t *)DataEtherFrame_p->Body;

        typelen = SHORT_SWAP(llcSnap_p->Type);

        if ( llcSnap_p->Dsap == 0xAA && llcSnap_p->Ssap == 0xAA
             && llcSnap_p->Org[0] == 0x00 && llcSnap_p->Org[1] == 0x50 && llcSnap_p->Org[2] == 0x43)
        {
            if(typelen == AL_PROTOCOL_PRODUCT_TYPE_CLIENT || typelen == AL_PROTOCOL_PRODUCT_TYPE_UR )
            {
                if (apio_alloc(WlanHandle, &TxBuf) == APCTL_OK )
                {
                    //eprintf("in send to stack\n");
                    length = APProcessAutoLinkFrame(DataEtherFrame_p->Body + sizeof(llc_snap_hdr_t), &TxBuf);
                }
                else
                    return 0;
            }
#ifdef AP_URPTR
            else if (typelen == AL_PROTOCOL_PRODUCT_TYPE_AP) //AutoLink from sent from AP received at UR or client
            {
                if (apio_alloc(WlanHandle, &TxBuf) == APCTL_OK )
                {
                    length = URProcessAutoLinkFrame(DataEtherFrame_p->Body + sizeof(llc_snap_hdr_t), &TxBuf);
                }
                else
                    return 0;
            }
#endif

            if(length != (-1))
            {
                txEtherHdr_p = (IEEEtypes_8023_Frame_t *)TxBuf.framePtr;
                MACADDR_CPY(&txEtherHdr_p->Hdr.da, &DataEtherFrame_p->Hdr.sa);
                MACADDR_CPY(&txEtherHdr_p->Hdr.sa, &DataEtherFrame_p->Hdr.da);
                txEtherHdr_p->Hdr.type = SHORT_SWAP((length - sizeof(ether_hdr_t)));

                TxBuf.frameLen = length;
                TxBuf.reserved = 0;
                apio_write(WlanHandle, &TxBuf);
                return 0;
            }
        }
    }
#endif //AUTOLINK


    if((DataEtherFrame_p->Hdr.type == 0x0008)                /*ip*/
    && ((DataEtherFrame_p->Body[6] & 0x4) || DataEtherFrame_p->Body[7])  /*fragment*/
    && (DataEtherFrame_p->Body[9] == 0x01))               /*ICMP*/
        return 0;

    //llcData_p = (dsQ_LlcData_t *)pool_GetBuf(llcDataPoolId);
    //if (llcData_p)
    {
        //memcpy((char *)llcData_p->data, (char *)buf, count);
      //llcData_p->totalLen = count;
        //rcvdData = (unsigned char *)llcData_p->data;
        rcvdData = (unsigned char *)buf;
#ifdef GATEWAY
        rcvdPort = port;
#endif
        w8100_eth_RxEvent(count);
       //w8100_eth_RxEvent(llcData_p->totalLen);
        //pool_FreeBuf((char *)llcData_p);
    }
    return 0;
}
#endif

/****************************************************************************** 
 * 
 * Name: ProcessEAPoL 
 * 
 * Description: 
 *   This routine is called to do 802.1x authentication and key managment. 
 * 
 * Conditions For Use: 
 *   Should pass an EAPoL packet to this function.
 * 
 * Arguments: 
 *   apio_bufdescr_t pointer to the incoming packet buffer.
 *   Mac address pointer to the source Mac.  
 * 
 * Return Value: 
 *   apio_bufdescr_t pointer to the outgoing packet buffer.
 * 
 * Notes: 
 *   None. 
 * 
 *****************************************************************************/
apio_bufdescr_t * ProcessEAPoL(apio_bufdescr_t *pBufDescr, IEEEtypes_MacAddr_t *pMacStaAddr)
{
    EAPOL_KeyMsg_t *pEAPoL;    
    Msg msg;

    if ( pBufDescr == NULL )
    {/*Sta association event */
        msg.evt = STA_ASSO_EVT;
    }
    else
    {
        pEAPoL = (EAPOL_KeyMsg_t *)pBufDescr->framePtr;
        if ( pEAPoL->hdr_8021x.pckt_type == 0x03 )
        {/*key data */
            msg.evt = MSGRECVD_EVT;
            msg.body = pEAPoL;
    }
        else
        {/*reject all other EAPoL packet for now.... */
            /*    apio_free(WlanHandle,pBufDescr); */
            return NULL;
    }

    }
    ProcessKeyMgmtData(pBufDescr, pMacStaAddr, &msg);

    if(pBufDescr!=NULL)
    apio_free(LanHandle, pBufDescr);
    return NULL;
}

#if 0
apio_bufdescr_t *ProcessEAPoL(apio_bufdescr_t *pBufDescr, IEEEtypes_MacAddr_t *pMacStaAddr, STA_ASSOC_TYPE eStaAssocType)
{
    EAPOL_KeyMsg_t *pEAPoL;

    if ( eStaAssocType == APEVT_STA_DISASSOCIATED )
    {
        // call API disassociate cmd
        return NULL;
    }

    pEAPoL = (EAPOL_KeyMsg_t *)pBufDescr->framePtr;
    if ((pBufDescr == NULL) || (pEAPoL->hdr_8021x.pckt_type == 0x03))//key data
    {
        ProcessKeyMgmtData(pBufDescr, pMacStaAddr, MSGRECVDEVT);
    }
    else//reject all other EAPoL packet for now....
    {
        // Discard all other EAPOL packets
        apio_free(WlanHandle, pBufDescr);
    }

    return NULL;
}

Status_e CheckStaAssocState(StaAssocStateMsg_t *pMsg)
{
    APICMDBUF *pBuf;
    Status_e  nStatus = SUCCESS;
    UINT32 cmdBodyLen = sizeof(APICMDBUF_GET_STA_ASSOC_STATE) - 4 * sizeof(unsigned short);

    if ((pBuf = (APICMDBUF *)malloc(sizeof(APICMDBUF))) == NULL)
        return FAIL;

    pBuf->cmdCode = APCMD_GET_STA_ASSOC_STATE;
    pBuf->seqNum = 1;
    pBuf->cmdBody = malloc(cmdBodyLen);
    pBuf->cmdBodyLen = cmdBodyLen;

    apctl(pBuf);

    if (pBuf->cmdStatus == APCTL_OK)
    {
        APICMDBUF_GET_STA_ASSOC_STATE *p_apicmdbuf_get_sta_assoc_state;
        p_apicmdbuf_get_sta_assoc_state = (APICMDBUF_GET_STA_ASSOC_STATE *)pBuf;
        memcpy(pMsg->staMACAddr, p_apicmdbuf_get_sta_assoc_state->staMACAddr, 6);
        pMsg->assocType = p_apicmdbuf_get_sta_assoc_state->assocType;
    }
    else
    {
        nStatus = FAIL;
    }
    free(pBuf->cmdBody);
    free(pBuf);

    return(nStatus);
}
#endif

extern void MrvlMICErrorHdl(COUNTER_MEASURE_EVENT event);
void (*MICCounterMeasureInvokedCbFunc)(COUNTER_MEASURE_EVENT event) = MrvlMICErrorHdl;

void GetWanMac(unsigned char *mac) {
 memcpy(mac, WanMac, 6);
}

void GetLanMac(unsigned char *mac) {
    memcpy(mac, LanMac, 6);
}

void GetGwLanMac(unsigned char *mac) {
  memcpy(mac, gwLanMac, 6);
}

void GetGwWanMac(unsigned char *mac) {
    memcpy(mac, gwWanMac, 6);
}

void GetWlanMac(unsigned char *mac) {
 memcpy(mac, WlanMac, 6);
}

void SetWanMac(const unsigned char *mac) {
 memcpy(WanMac, mac, 6); 
}

void SetLanMac(const unsigned char *mac) {
 memcpy(LanMac, mac, 6);
}

void SetGwLanMac(const unsigned char *mac) {
    memcpy(gwLanMac, mac, 6);
}

void SetGwWanMac(const unsigned char *mac) {
  memcpy(gwWanMac, mac, 6);
}

void SetWlanMac(const unsigned char *mac) {
   memcpy(WlanMac, mac, 6);
}

#if defined(GATEWAY) || defined(AP_URPTR) 
#ifdef WDS_FEATURE
#define FORWARD_TO_NONE        0x0
#define  FORWARD_TO_WLAN     0x1
#define FORWARD_TO_LAN       0x2
#define FORWARD_TO_ALL       0x3
int DSForwardPacketWDS(apio_handle_t port_handler, apio_bufdescr_t *pBufDescr)
{
    t_DSFDescr pDSFDescr;
    sHASH *phds;
    sDSCargo *bpds;
//    dsQ_LlcData_t *LlcData_p;
   int retval = FORWARD_TO_ALL;

    pDSFDescr.SrcAddr = pBufDescr->framePtr + 6;
    pDSFDescr.DstAddr = pBufDescr->framePtr;
    pDSFDescr.porthandle = port_handler;

    phds = HASHautoSearch(&DSTbl, pDSFDescr.SrcAddr);
    if ( ((U32)phds != (U32)HASH_MCAST) && ((U32)phds != (U32)HASH_BCAST) )
    {
        // Add route for unitcast MAC address
        bpds = (sDSCargo *)HASHcargo(phds);
        if ( bpds->porthandle != pDSFDescr.porthandle )
        {
            // Packet come from a different route
            if ( bpds->firstadd == 0 )
            {
                extStaDb_RemoveSta((IEEEtypes_MacAddr_t *)pDSFDescr.SrcAddr);
                bpds->porthandle = pDSFDescr.porthandle;
                return retval;
            }
            else
            {
                // Update the src to the newest route
                bpds->porthandle = pDSFDescr.porthandle;
            }
        }
        bpds->firstadd = 0;
    }

    phds = HASHSearch(&DSTbl, pDSFDescr.DstAddr);
    if ( (U32)phds==(U32)HASH_MCAST || (U32)phds==(U32)HASH_BCAST || (U32)phds==(U32)HASH_NOT_FOUND )
    {
        // Can not find route, broadcast it
        goto broadcast_in_packet;
    }
    else
    {
        bpds = (sDSCargo *)HASHcargo(phds);
        pDSFDescr.porthandle = bpds->porthandle; 
        goto send_in_packet;
    }

    broadcast_in_packet:
    // Send to wireless side
    if ( port_handler != WlanHandle )
    {
       retval = FORWARD_TO_WLAN; 
    }

    // Send to ethernet side
    if ( port_handler != LanHandle )
    {
        retval = FORWARD_TO_WLAN; 
    }
    return retval;

    send_in_packet:
    if ( (pDSFDescr.porthandle != port_handler) 
    && (pDSFDescr.porthandle != WlanHandle) 
    && (pDSFDescr.porthandle != LanHandle)
    && (pDSFDescr.porthandle != llcHandle))
    {
        apio_write(pDSFDescr.porthandle, pBufDescr);
      retval = FORWARD_TO_NONE;
    }
    return retval;
}
#endif

#endif

void SendPktToStack(apio_bufdescr_t *pBufDescr)
{
#ifdef ECOS_TCP_IP_STACK
#ifdef GATEWAY
        SendToProtStack(pBufDescr->framePtr, pBufDescr->frameLen, pBufDescr->reserved);
#else
        SendToProtStack(pBufDescr->framePtr, pBufDescr->frameLen);
#endif            
#endif
}
