/******************** (c) Marvell Semiconductor, Inc., 2001 *******************
*
* $Header: \\\\matar\\w81_doc/W81/802.11_MAC-DRIVER_SW/AP/Src/dhcptask.c
* 
* Purpose: 
*    This file contains the implementations of the function prototypes given 
*    in the associated header file for the dhcp Task. 
* 
* Public Procedures: 
*
* 
* Private Procedures: 
*
* 
* Notes: 
*    None. 
* 
*****************************************************************************/

//=============================================================================
//                               INCLUDE FILES
//=============================================================================
#ifndef NO_ECOS_TCP_IP_STACK
#include "wltypes.h"
#include "IEEE_types.h"
#include "sysinfo.h"
#include "os_if.h"
#include "oem.h"
#include <pkgconf/system.h>
#include <pkgconf/net.h>

//#define sysinfo_DHCP_TASK_NAME        "DhcpTask"
#define sysinfo_DHCP_TASK_STACK_SIZE    8192//4096*3//8192//4096
#define sysinfo_DHCP_TASK_PRI         18//8
static cyg_thread Task;
static cyg_handle_t TaskHdl;

static UINT8 Stack[sysinfo_DHCP_TASK_STACK_SIZE] __attribute__ ((section (".itcmbuf")));

extern int dhcp_bind(void);
extern unsigned char stationJoined;
extern UINT8 mib_dhcpenable;
extern UINT8 mib_dhcpstatechange;
extern cyg_sem_t dhcp_needs_attention;
extern cyg_thread_entry_t dhcp_mgt_entry;

//=============================================================================
//                                DEFINITIONS
//=============================================================================



static void DHCPTask( os_Addrword_t Data );

//=============================================================================
//                         CODED PUBLIC PROCEDURES
//=============================================================================

/******************************************************************************
 * 
 * Name: dhcpTask_Init 
 * 
 * Description: 
 *   This routine is called to initialize the the Web Server Task 
 *   and related components. 
 * 
 * Conditions For Use: 
 *   None. 
 * 
 * Arguments: 
 *   None. 
 * 
 * Return Value: 
 *   Status indicating success or failure 
 * 
 * Notes: 
 *   None. 
 * 
 * PDL: 
 * 
 *   
 * END PDL 
 * 
 *****************************************************************************/

#ifdef TASKDHCP
extern Status_e dhcpTask_Init( void )
{
    Status_e status;
    cyg_semaphore_init( &dhcp_needs_attention, 0 );

    cyg_thread_create(sysinfo_DHCP_TASK_PRI,
                      dhcp_mgt_entry,
                      0,
                      sysinfo_DHCP_TASK_NAME,
                      (void *)(Stack),
                      sysinfo_DHCP_TASK_STACK_SIZE,
                      &TaskHdl,
                      &Task);
    return (FAIL);
}


extern void dhcp_Start( void )
{
    cyg_thread_resume(TaskHdl);
}
#endif

//=============================================================================
//                         CODED PRIVATE PROCEDURES
//=============================================================================

/******************************************************************************
 * 
 * Name: WebTask 
 * 
 * Description: 
 * 
 * Conditions For Use: 
 *   The task and related components have been initialized by calling 
 *   web_Init() and then the task has been started by calling 
 *   web_Start(). 
 * 
 * Arguments: 
 *   Arg1 (i  ): Data - Data passed to the task; not actually used - just 
 *                      included to conform to the structure the OS 
 *                      expects when creating a task 
 * 
 * Return Value: 
 *   None. 
 * 
 * Notes: 
 *   None. 
 * 
 * PDL: 
 * END PDL 
 * 
 *****************************************************************************/
#ifdef  TASKDHCP
static void DHCPTask( os_Addrword_t Data )
{
    dhcp_bind(); //Not use right now, already replace by dhcp_mgt_entry
}
#endif
#endif
