/******************** (c) Marvell Semiconductor, Inc., 2005 *******************
*
* Purpose:
*    This file contains an example of the callback function
*    when a wireless STA changes its association state.
*
* Public Procedures:
*    staStateChangedEvent      A callback function 
*
* Private Procedures:
*    None.
*
* Notes:
*    None.
*
*****************************************************************************/

#include "wltypes.h"
#include "IEEE_types.h"
#include "oem.h"
#include "mib.h" 
#include "api.h"


/******************************************************************************
 * 
 * Name:  staStateChangedEvent
 * 
 * Description: 
 *     
 * 
 * Conditions For Use: 
 *    A callback function to notify application that the Association state of an 
 *    STA has been changed.
 * 
 * Arguments: 
 *    sta_addr - hardware address of the STA
 *    evt      - 1 (Associated or Reassociated) or 2 (Disassociated)
 * 
 * Return Value: 
 *    None. 
 * 
 * Notes: 
 *    None. 
 * 
 * PDL: 
 *
 * END PDL 
 * 
 *****************************************************************************/

void staStateChangedEvent(IEEEtypes_MacAddr_t *sta_addr, int evt)
{
    if (evt == 1)
    {
        /* ---- STA is associated with the AP ---- */
    }
    else if (evt == 2)
    {
        /* ---- STA is disassociated from the AP ---- */
    }
}

