#ifndef __INCgt64260rh 
    #define __INCgt64260rh

#define GT64260

/* Supported features */
#define INCLUDE_DMA_4_7
#define INCLUDE_CNTMR_4_7
#define INCLUDE_P2P
#define INCLUDE_PCI_1
#define INCLUDE_PCI_0_ARBITER
#define INCLUDE_PCI_1_ARBITER
#define INCLUDE_SNOOP_SUPPORT
#define INCLUDE_ETH_PORT_2
#define INCLUDE_CPU_MAPPING

/* Unsupported features */

#undef  INCLUDE_MPSC_PORTS_2_7   

/****************************************/
/* Base Address Space				    */
/****************************************/
#define MFU_BASE_ADDR						          		  0x80008000 /* MAC base reg addr*/



/****************************************/
/* Processor Address Space				*/
/****************************************/

/* Sdram's BAR'S */
#define SCS_0_LOW_DECODE_ADDR						          0x008
#define SCS_0_HIGH_DECODE_ADDR						          0x010
#define SCS_1_LOW_DECODE_ADDR						          0x208
#define SCS_1_HIGH_DECODE_ADDR						          0x210
#define SCS_2_LOW_DECODE_ADDR						          0x018
#define SCS_2_HIGH_DECODE_ADDR						          0x020
#define SCS_3_LOW_DECODE_ADDR						          0x218
#define SCS_3_HIGH_DECODE_ADDR						          0x220
/* Devices BAR'S */                                          
#define CS_0_LOW_DECODE_ADDR						          0x028
#define CS_0_HIGH_DECODE_ADDR						          0x030
#define CS_1_LOW_DECODE_ADDR						          0x228
#define CS_1_HIGH_DECODE_ADDR						          0x230
#define CS_2_LOW_DECODE_ADDR						          0x248
#define CS_2_HIGH_DECODE_ADDR						          0x250
#define CS_3_LOW_DECODE_ADDR						          0x038
#define CS_3_HIGH_DECODE_ADDR						          0x040
#define BOOTCS_LOW_DECODE_ADDR						          0x238
#define BOOTCS_HIGH_DECODE_ADDR						          0x240
                                                             
#define PCI_0_I_O_LOW_DECODE_ADDR					          0x048
#define PCI_0_I_O_HIGH_DECODE_ADDR					          0x050
#define PCI_0_MEMORY0_LOW_DECODE_ADDR				          0x058
#define PCI_0_MEMORY0_HIGH_DECODE_ADDR				          0x060
#define PCI_0_MEMORY1_LOW_DECODE_ADDR				          0x080
#define PCI_0_MEMORY1_HIGH_DECODE_ADDR				          0x088
#define PCI_0_MEMORY2_LOW_DECODE_ADDR				          0x258
#define PCI_0_MEMORY2_HIGH_DECODE_ADDR				          0x260
#define PCI_0_MEMORY3_LOW_DECODE_ADDR				          0x280
#define PCI_0_MEMORY3_HIGH_DECODE_ADDR				          0x288
                                                             
#define PCI_1_I_O_LOW_DECODE_ADDR					          0x090
#define PCI_1_I_O_HIGH_DECODE_ADDR					          0x098
#define PCI_1_MEMORY0_LOW_DECODE_ADDR				          0x0a0
#define PCI_1_MEMORY0_HIGH_DECODE_ADDR				          0x0a8
#define PCI_1_MEMORY1_LOW_DECODE_ADDR				          0x0b0
#define PCI_1_MEMORY1_HIGH_DECODE_ADDR				          0x0b8
#define PCI_1_MEMORY2_LOW_DECODE_ADDR				          0x2a0
#define PCI_1_MEMORY2_HIGH_DECODE_ADDR				          0x2a8
#define PCI_1_MEMORY3_LOW_DECODE_ADDR				          0x2b0
#define PCI_1_MEMORY3_HIGH_DECODE_ADDR				          0x2b8
                                                             
                                                             
#define INTERNAL_SPACE_DECODE						          0x068
                                                             
#define CPU_0_LOW_DECODE_ADDR                                 0x290
#define CPU_0_HIGH_DECODE_ADDR                                0x298
#define CPU_1_LOW_DECODE_ADDR                                 0x2c0
#define CPU_1_HIGH_DECODE_ADDR                                0x2c8
                                                             
#define PCI_0_I_O_ADDR_REMAP						          0x0f0
#define PCI_0_MEMORY0_ADDR_REMAP  			   		          0x0f8
#define PCI_0_MEMORY0_HIGH_ADDR_REMAP			   	          0x320
#define PCI_0_MEMORY1_ADDR_REMAP  			   		          0x100
#define PCI_0_MEMORY1_HIGH_ADDR_REMAP			   	          0x328
#define PCI_0_MEMORY2_ADDR_REMAP  			   		          0x2f8
#define PCI_0_MEMORY2_HIGH_ADDR_REMAP			   	          0x330
#define PCI_0_MEMORY3_ADDR_REMAP  			   		          0x300
#define PCI_0_MEMORY3_HIGH_ADDR_REMAP			   	          0x338
                                                             
#define PCI_1_I_O_ADDR_REMAP						          0x108
#define PCI_1_MEMORY0_ADDR_REMAP  				   	          0x110
#define PCI_1_MEMORY0_HIGH_ADDR_REMAP				          0x340
#define PCI_1_MEMORY1_ADDR_REMAP  					          0x118
#define PCI_1_MEMORY1_HIGH_ADDR_REMAP				          0x348
#define PCI_1_MEMORY2_ADDR_REMAP  					          0x310
#define PCI_1_MEMORY2_HIGH_ADDR_REMAP				          0x350
#define PCI_1_MEMORY3_ADDR_REMAP  					          0x318
#define PCI_1_MEMORY3_HIGH_ADDR_REMAP				          0x358
                                                             
                                                             
/****************************************/                   
/*               CPU                    */                   
/****************************************/                   
#define CPU_CONFIG                                            0x000
#define CPU_MODE                                              0x120
#define CPU_MASTER_CONTROL                                    0x160
#define CPU_CROSS_BAR_CONTROL_LOW                             0x150
#define CPU_CROSS_BAR_CONTROL_HIGH                            0x158
#define CPU_CROSS_BAR_TIMEOUT                                 0x168
#define PCI_0_SYNC_BARIER_VIRTUAL_REG				          0x0c0
#define PCI_1_SYNC_BARIER_VIRTUAL_REG				          0x0c8


/****************************************/
/* CPU Access Protect             		*/
/****************************************/

#define CPU_LOW_PROTECT_ADDR_0                                0x180
#define CPU_HIGH_PROTECT_ADDR_0                               0x188
#define CPU_LOW_PROTECT_ADDR_1                                0x190
#define CPU_HIGH_PROTECT_ADDR_1                               0x198
#define CPU_LOW_PROTECT_ADDR_2                                0x1a0
#define CPU_HIGH_PROTECT_ADDR_2                               0x1a8
#define CPU_LOW_PROTECT_ADDR_3                                0x1b0
#define CPU_HIGH_PROTECT_ADDR_3                               0x1b8
#define CPU_LOW_PROTECT_ADDR_4                                0x1c0
#define CPU_HIGH_PROTECT_ADDR_4                               0x1c8
#define CPU_LOW_PROTECT_ADDR_5                                0x1d0
#define CPU_HIGH_PROTECT_ADDR_5                               0x1d8
#define CPU_LOW_PROTECT_ADDR_6                                0x1e0
#define CPU_HIGH_PROTECT_ADDR_6                               0x1e8
#define CPU_LOW_PROTECT_ADDR_7                                0x1f0
#define CPU_HIGH_PROTECT_ADDR_7                               0x1f8
                                                              
                                                                       
/****************************************/                    
/*          Snoop Control          		*/                    
/****************************************/                    
                                                              
#define SNOOP_BASE_ADDR_0                                     0x380
#define SNOOP_TOP_ADDR_0                                      0x388
#define SNOOP_BASE_ADDR_1                                     0x390
#define SNOOP_TOP_ADDR_1                                      0x398
#define SNOOP_BASE_ADDR_2                                     0x3a0
#define SNOOP_TOP_ADDR_2                                      0x3a8
#define SNOOP_BASE_ADDR_3                                     0x3b0
#define SNOOP_TOP_ADDR_3                                      0x3b8
                                                                
/****************************************/                      
/*          CPU Error Report       		*/                      
/****************************************/                      
                                                                
#define CPU_ERROR_ADDR_LOW 							          0x070
#define CPU_ERROR_ADDR_HIGH 							      0x078
#define CPU_ERROR_DATA_LOW                                    0x128
#define CPU_ERROR_DATA_HIGH                                   0x130
#define CPU_ERROR_PARITY                                      0x138
#define CPU_ERROR_CAUSE                                       0x140
#define CPU_ERROR_MASK                                        0x148

/****************************************/
/*          Pslave Debug           		*/
/****************************************/

#define PSLAVE_X_0_ADDR                                       0x360
#define PSLAVE_X_0_COMMAND_ID                                 0x368
#define PSLAVE_X_1_ADDR                                       0x370
#define PSLAVE_X_1_COMMAND_ID                                 0x378
#define PSLAVE_WRITE_DATA_LOW                                 0x3c0
#define PSLAVE_WRITE_DATA_HIGH                                0x3c8
#define PSLAVE_WRITE_BYTE_ENABLE                              0x3e0
#define PSLAVE_READ_DATA_LOW                                  0x3d0
#define PSLAVE_READ_DATA_HIGH                                 0x3d8
#define PSLAVE_READ_ID                                        0x3e8


/****************************************/
/* SDRAM and Device Address Space		*/
/****************************************/
	

/****************************************/
/* SDRAM Configuration					*/
/****************************************/

#define SDRAM_CONFIG	 	    					          0x448
#define SDRAM_OPERATION_MODE							      0x474
#define SDRAM_ADDR_DECODE								      0x47C
#define SDRAM_TIMING_PARAMETERS                               0x4b4
#define SDRAM_UMA_CONTROL                                     0x4a4
#define SDRAM_CROSS_BAR_CONTROL_LOW                           0x4a8
#define SDRAM_CROSS_BAR_CONTROL_HIGH                          0x4ac
#define SDRAM_CROSS_BAR_TIMEOUT                               0x4b0
                                                             
                                                             
/****************************************/                   
/* SDRAM Parameters						*/                   
/****************************************/                   
			                                                 
#define SDRAM_BANK0PARAMETERS							      0x44C
#define SDRAM_BANK1PARAMETERS							      0x450
#define SDRAM_BANK2PARAMETERS							      0x454
#define SDRAM_BANK3PARAMETERS							      0x458


/****************************************/
/* SDRAM Error Report 					*/
/****************************************/
			
#define SDRAM_ERROR_DATA_LOW                                  0x484
#define SDRAM_ERROR_DATA_HIGH                                 0x480
#define SDRAM_AND_DEVICE_ERROR_ADDR                           0x490
#define SDRAM_RECEIVED_ECC                                    0x488
#define SDRAM_CALCULATED_ECC                                  0x48c
#define SDRAM_ECC_CONTROL                                     0x494
#define SDRAM_ECC_ERROR_COUNTER                               0x498


/****************************************/
/* SDunit Debug (for internal use)		*/
/****************************************/

#define SDUNIT_X0_ADDR                                        0x500
#define SDUNIT_X0_COMMAND_AND_ID                              0x504
#define SDUNIT_X0_WRITE_DATA_LOW                              0x508
#define SDUNIT_X0_WRITE_DATA_HIGH                             0x50c
#define SDUNIT_X0_WRITE_BYTE_ENABLE                           0x518
#define SDUNIT_X0_READ_DATA_LOW                               0x510
#define SDUNIT_X0_READ_DATA_HIGH                              0x514
#define SDUNIT_X0_READ_ID                                     0x51c
#define SDUNIT_X1_ADDR                                        0x520
#define SDUNIT_X1_COMMAND_AND_ID                              0x524
#define SDUNIT_X1_WRITE_DATA_LOW                              0x528
#define SDUNIT_X1_WRITE_DATA_HIGH                             0x52c
#define SDUNIT_X1_WRITE_BYTE_ENABLE                           0x538
#define SDUNIT_X1_READ_DATA_LOW                               0x530
#define SDUNIT_X1_READ_DATA_HIGH                              0x534
#define SDUNIT_X1_READ_ID                                     0x53c
#define SDUNIT_X0_SNOOP_ADDR                                  0x540
#define SDUNIT_X0_SNOOP_COMMAND                               0x544
#define SDUNIT_X1_SNOOP_ADDR                                  0x548
#define SDUNIT_X1_SNOOP_COMMAND                               0x54c

	
/****************************************/
/* Device Parameters					*/
/****************************************/

#define DEVICE_BANK0PARAMETERS							      0x45c
#define DEVICE_BANK1PARAMETERS							      0x460
#define DEVICE_BANK2PARAMETERS							      0x464
#define DEVICE_BANK3PARAMETERS							      0x468
#define DEVICE_BOOT_BANK_PARAMETERS						      0x46c
#define DEVICE_CONTROL                                        0x4c0
#define DEVICE_CROSS_BAR_CONTROL_LOW                          0x4c8
#define DEVICE_CROSS_BAR_CONTROL_HIGH                         0x4cc
#define DEVICE_CROSS_BAR_TIMEOUT                              0x4c4


/****************************************/
/* Device Interrupt 					*/
/****************************************/

#define DEVICE_INTERRUPT_CAUSE                                0x4d0
#define DEVICE_INTERRUPT_MASK                                 0x4d4
#define DEVICE_ERROR_ADDR                                     0x4d8

/****************************************/
/* DMA Record							*/
/****************************************/

#define DMA_CHANNEL0_BYTE_COUNT							      0x800
#define DMA_CHANNEL1_BYTE_COUNT	 						      0x804
#define DMA_CHANNEL2_BYTE_COUNT	 						      0x808
#define DMA_CHANNEL3_BYTE_COUNT	 						      0x80C
#define DMA_CHANNEL4_BYTE_COUNT							      0x900
#define DMA_CHANNEL5_BYTE_COUNT	 						      0x904
#define DMA_CHANNEL6_BYTE_COUNT	 						      0x908
#define DMA_CHANNEL7_BYTE_COUNT	 						      0x90C
#define DMA_CHANNEL0_SOURCE_ADDR						      0x810
#define DMA_CHANNEL1_SOURCE_ADDR						      0x814
#define DMA_CHANNEL2_SOURCE_ADDR						      0x818
#define DMA_CHANNEL3_SOURCE_ADDR						      0x81C
#define DMA_CHANNEL4_SOURCE_ADDR						      0x910
#define DMA_CHANNEL5_SOURCE_ADDR						      0x914
#define DMA_CHANNEL6_SOURCE_ADDR						      0x918
#define DMA_CHANNEL7_SOURCE_ADDR						      0x91C
#define DMA_CHANNEL0_DESTINATION_ADDR				          0x820
#define DMA_CHANNEL1_DESTINATION_ADDR				          0x824
#define DMA_CHANNEL2_DESTINATION_ADDR				          0x828
#define DMA_CHANNEL3_DESTINATION_ADDR				          0x82C
#define DMA_CHANNEL4_DESTINATION_ADDR				          0x920
#define DMA_CHANNEL5_DESTINATION_ADDR				          0x924
#define DMA_CHANNEL6_DESTINATION_ADDR				          0x928
#define DMA_CHANNEL7_DESTINATION_ADDR				          0x92C
#define DMA_CHANNEL0_NEXT_RECORD_POINTER					  0x830
#define DMA_CHANNEL1_NEXT_RECORD_POINTER					  0x834
#define DMA_CHANNEL2_NEXT_RECORD_POINTER					  0x838
#define DMA_CHANNEL3_NEXT_RECORD_POINTER					  0x83C
#define DMA_CHANNEL4_NEXT_RECORD_POINTER					  0x930
#define DMA_CHANNEL5_NEXT_RECORD_POINTER					  0x934
#define DMA_CHANNEL6_NEXT_RECORD_POINTER					  0x938
#define DMA_CHANNEL7_NEXT_RECORD_POINTER					  0x93C
#define DMA_CHANNEL0_CURRENT_DESCRIPTOR_POINTER				  0x870
#define DMA_CHANNEL1_CURRENT_DESCRIPTOR_POINTER				  0x874
#define DMA_CHANNEL2_CURRENT_DESCRIPTOR_POINTER				  0x878
#define DMA_CHANNEL3_CURRENT_DESCRIPTOR_POINTER				  0x87C
#define DMA_CHANNEL4_CURRENT_DESCRIPTOR_POINTER				  0x970
#define DMA_CHANNEL5_CURRENT_DESCRIPTOR_POINTER				  0x974
#define DMA_CHANNEL6_CURRENT_DESCRIPTOR_POINTER				  0x978
#define DMA_CHANNEL7_CURRENT_DESCRIPTOR_POINTER				  0x97C
#define DMA_CHANNEL0_SOURCE_HIGH_PCI_ADDR                     0x890
#define DMA_CHANNEL1_SOURCE_HIGH_PCI_ADDR                     0x894
#define DMA_CHANNEL2_SOURCE_HIGH_PCI_ADDR                     0x898
#define DMA_CHANNEL3_SOURCE_HIGH_PCI_ADDR                     0x89c
#define DMA_CHANNEL4_SOURCE_HIGH_PCI_ADDR                     0x990
#define DMA_CHANNEL5_SOURCE_HIGH_PCI_ADDR                     0x994
#define DMA_CHANNEL6_SOURCE_HIGH_PCI_ADDR                     0x998
#define DMA_CHANNEL7_SOURCE_HIGH_PCI_ADDR                     0x99c
#define DMA_CHANNEL0_DESTINATION_HIGH_PCI_ADDR                0x8a0
#define DMA_CHANNEL1_DESTINATION_HIGH_PCI_ADDR                0x8a4
#define DMA_CHANNEL2_DESTINATION_HIGH_PCI_ADDR                0x8a8
#define DMA_CHANNEL3_DESTINATION_HIGH_PCI_ADDR                0x8ac
#define DMA_CHANNEL4_DESTINATION_HIGH_PCI_ADDR                0x9a0
#define DMA_CHANNEL5_DESTINATION_HIGH_PCI_ADDR                0x9a4
#define DMA_CHANNEL6_DESTINATION_HIGH_PCI_ADDR                0x9a8
#define DMA_CHANNEL7_DESTINATION_HIGH_PCI_ADDR                0x9ac
#define DMA_CHANNEL0_NEXT_RECORD_POINTER_HIGH_PCI_ADDR        0x8b0
#define DMA_CHANNEL1_NEXT_RECORD_POINTER_HIGH_PCI_ADDR        0x8b4
#define DMA_CHANNEL2_NEXT_RECORD_POINTER_HIGH_PCI_ADDR        0x8b8
#define DMA_CHANNEL3_NEXT_RECORD_POINTER_HIGH_PCI_ADDR        0x8bc
#define DMA_CHANNEL4_NEXT_RECORD_POINTER_HIGH_PCI_ADDR        0x9b0
#define DMA_CHANNEL5_NEXT_RECORD_POINTER_HIGH_PCI_ADDR        0x9b4
#define DMA_CHANNEL6_NEXT_RECORD_POINTER_HIGH_PCI_ADDR        0x9b8
#define DMA_CHANNEL7_NEXT_RECORD_POINTER_HIGH_PCI_ADDR        0x9bc

/****************************************/
/* DMA Channel Control					*/
/****************************************/

#define DMA_CHANNEL0_CONTROL 								  0x840
#define DMA_CHANNEL0_CONTROL_HIGH							  0x880
#define DMA_CHANNEL1_CONTROL 								  0x844
#define DMA_CHANNEL1_CONTROL_HIGH							  0x884
#define DMA_CHANNEL2_CONTROL 								  0x848
#define DMA_CHANNEL2_CONTROL_HIGH							  0x888
#define DMA_CHANNEL3_CONTROL 								  0x84C
#define DMA_CHANNEL3_CONTROL_HIGH							  0x88C

#define DMA_CHANNEL4_CONTROL 								  0x940
#define DMA_CHANNEL4_CONTROL_HIGH							  0x980
#define DMA_CHANNEL5_CONTROL 								  0x944
#define DMA_CHANNEL5_CONTROL_HIGH							  0x984
#define DMA_CHANNEL6_CONTROL 								  0x948
#define DMA_CHANNEL6_CONTROL_HIGH							  0x988
#define DMA_CHANNEL7_CONTROL 								  0x94C
#define DMA_CHANNEL7_CONTROL_HIGH							  0x98C


/****************************************/
/* DMA Arbiter							*/
/****************************************/

#define DMA_ARBITER_CONTROL_0_3								  0x860
#define DMA_ARBITER_CONTROL_4_7								  0x960


/****************************************/
/* DMA Interrupt						*/
/****************************************/

#define DMA_CHANELS_0_3_INTERRUPT_CAUSE                       0x8c0
#define DMA_CHANELS_0_3_INTERRUPT_MASK                        0x8c4
#define DMA_CHANELS_0_3_ERROR_ADDR                            0x8c8
#define DMA_CHANELS_0_3_ERROR_SELECT                          0x8cc
#define DMA_CHANELS_4_7_INTERRUPT_CAUSE                       0x9c0
#define DMA_CHANELS_4_7_INTERRUPT_MASK                        0x9c4
#define DMA_CHANELS_4_7_ERROR_ADDR                            0x9c8
#define DMA_CHANELS_4_7_ERROR_SELECT                          0x9cc


/****************************************/
/* DMA Debug (for internal use)         */
/****************************************/

#define DMA_X0_ADDR                                           0x8e0
#define DMA_X0_COMMAND_AND_ID                                 0x8e4
#define DMA_X0_WRITE_DATA_LOW                                 0x8e8
#define DMA_X0_WRITE_DATA_HIGH                                0x8ec
#define DMA_X0_WRITE_BYTE_ENABLE                              0x8f8
#define DMA_X0_READ_DATA_LOW                                  0x8f0
#define DMA_X0_READ_DATA_HIGH                                 0x8f4
#define DMA_X0_READ_ID                                        0x8fc
#define DMA_X1_ADDR                                           0x9e0
#define DMA_X1_COMMAND_AND_ID                                 0x9e4
#define DMA_X1_WRITE_DATA_LOW                                 0x9e8
#define DMA_X1_WRITE_DATA_HIGH                                0x9ec
#define DMA_X1_WRITE_BYTE_ENABLE                              0x9f8
#define DMA_X1_READ_DATA_LOW                                  0x9f0
#define DMA_X1_READ_DATA_HIGH                                 0x9f4
#define DMA_X1_READ_ID                                        0x9fc

/****************************************/
/* Timer_Counter 						*/
/****************************************/

#define TIMER_COUNTER0									      0x850
#define TIMER_COUNTER1									      0x854
#define TIMER_COUNTER2									      0x858
#define TIMER_COUNTER3									      0x85C
#define TIMER_COUNTER_0_3_CONTROL						      0x864
#define TIMER_COUNTER_0_3_INTERRUPT_CAUSE				      0x868
#define TIMER_COUNTER_0_3_INTERRUPT_MASK      			      0x86c
#define TIMER_COUNTER4									      0x950
#define TIMER_COUNTER5									      0x954
#define TIMER_COUNTER6									      0x958
#define TIMER_COUNTER7									      0x95C
#define TIMER_COUNTER_4_7_CONTROL						      0x964
#define TIMER_COUNTER_4_7_INTERRUPT_CAUSE				      0x968
#define TIMER_COUNTER_4_7_INTERRUPT_MASK      			      0x96c

/****************************************/
/* PCI Slave Address Decoding           */
/****************************************/
        
#define PCI_0_SCS_0_BANK_SIZE							      0xc08
#define PCI_1_SCS_0_BANK_SIZE							      0xc88
#define PCI_0_SCS_1_BANK_SIZE							      0xd08
#define PCI_1_SCS_1_BANK_SIZE							      0xd88
#define PCI_0_SCS_2_BANK_SIZE							      0xc0c
#define PCI_1_SCS_2_BANK_SIZE							      0xc8c
#define PCI_0_SCS_3_BANK_SIZE							      0xd0c
#define PCI_1_SCS_3_BANK_SIZE							      0xd8c
#define PCI_0_CS_0_BANK_SIZE							      0xc10
#define PCI_1_CS_0_BANK_SIZE							      0xc90
#define PCI_0_CS_1_BANK_SIZE							      0xd10
#define PCI_1_CS_1_BANK_SIZE							      0xd90
#define PCI_0_CS_2_BANK_SIZE							      0xd18
#define PCI_1_CS_2_BANK_SIZE							      0xd98
#define PCI_0_CS_3_BANK_SIZE					        	  0xc14
#define PCI_1_CS_3_BANK_SIZE					        	  0xc94
#define PCI_0_CS_BOOT_BANK_SIZE							      0xd14
#define PCI_1_CS_BOOT_BANK_SIZE							      0xd94
#define PCI_0_P2P_MEM0_BAR_SIZE                               0xd1c
#define PCI_1_P2P_MEM0_BAR_SIZE                               0xd9c
#define PCI_0_P2P_MEM1_BAR_SIZE                               0xd20
#define PCI_1_P2P_MEM1_BAR_SIZE                               0xda0
#define PCI_0_P2P_I_O_BAR_SIZE                                0xd24
#define PCI_1_P2P_I_O_BAR_SIZE                                0xda4
#define PCI_0_CPU_BAR_SIZE                                    0xd28
#define PCI_1_CPU_BAR_SIZE                                    0xda8
#define PCI_0_DAC_SCS_0_BANK_SIZE                             0xe00
#define PCI_1_DAC_SCS_0_BANK_SIZE                             0xe80
#define PCI_0_DAC_SCS_1_BANK_SIZE                             0xe04
#define PCI_1_DAC_SCS_1_BANK_SIZE                             0xe84
#define PCI_0_DAC_SCS_2_BANK_SIZE                             0xe08
#define PCI_1_DAC_SCS_2_BANK_SIZE                             0xe88
#define PCI_0_DAC_SCS_3_BANK_SIZE                             0xe0c
#define PCI_1_DAC_SCS_3_BANK_SIZE                             0xe8c
#define PCI_0_DAC_CS_0_BANK_SIZE                              0xe10
#define PCI_1_DAC_CS_0_BANK_SIZE                              0xe90
#define PCI_0_DAC_CS_1_BANK_SIZE                              0xe14
#define PCI_1_DAC_CS_1_BANK_SIZE                              0xe94
#define PCI_0_DAC_CS_2_BANK_SIZE                              0xe18
#define PCI_1_DAC_CS_2_BANK_SIZE                              0xe98
#define PCI_0_DAC_CS_3_BANK_SIZE                              0xe1c
#define PCI_1_DAC_CS_3_BANK_SIZE                              0xe9c
#define PCI_0_DAC_BOOTCS_BANK_SIZE                            0xe20
#define PCI_1_DAC_BOOTCS_BANK_SIZE                            0xea0
#define PCI_0_DAC_P2P_MEM0_BAR_SIZE                           0xe24
#define PCI_1_DAC_P2P_MEM0_BAR_SIZE                           0xea4
#define PCI_0_DAC_P2P_MEM1_BAR_SIZE                           0xe28
#define PCI_1_DAC_P2P_MEM1_BAR_SIZE                           0xea8
#define PCI_0_DAC_CPU_BAR_SIZE                                0xe2c
#define PCI_1_DAC_CPU_BAR_SIZE                                0xeac
#define PCI_0_EXPANSION_ROM_BAR_SIZE                          0xd2c
#define PCI_1_EXPANSION_ROM_BAR_SIZE                          0xdac
#define PCI_0_BASE_ADDR_REGS_ENABLE 				          0xc3c
#define PCI_1_BASE_ADDR_REGS_ENABLE 				          0xcbc
#define PCI_0_SCS_0_BASE_ADDR_REMAP					          0xc48
#define PCI_1_SCS_0_BASE_ADDR_REMAP					          0xcc8
#define PCI_0_SCS_1_BASE_ADDR_REMAP					          0xd48
#define PCI_1_SCS_1_BASE_ADDR_REMAP					          0xdc8
#define PCI_0_SCS_2_BASE_ADDR_REMAP					          0xc4c
#define PCI_1_SCS_2_BASE_ADDR_REMAP					          0xccc
#define PCI_0_SCS_3_BASE_ADDR_REMAP					          0xd4c
#define PCI_1_SCS_3_BASE_ADDR_REMAP					          0xdcc
#define PCI_0_CS_0_BASE_ADDR_REMAP					          0xc50
#define PCI_1_CS_0_BASE_ADDR_REMAP					          0xcd0
#define PCI_0_CS_1_BASE_ADDR_REMAP					          0xd50
#define PCI_1_CS_1_BASE_ADDR_REMAP					          0xdd0
#define PCI_0_CS_2_BASE_ADDR_REMAP					          0xd58
#define PCI_1_CS_2_BASE_ADDR_REMAP					          0xdd8
#define PCI_0_CS_3_BASE_ADDR_REMAP           			      0xc54
#define PCI_1_CS_3_BASE_ADDR_REMAP           			      0xcd4
#define PCI_0_CS_BOOTCS_BASE_ADDR_REMAP      			      0xd54
#define PCI_1_CS_BOOTCS_BASE_ADDR_REMAP      			      0xdd4
#define PCI_0_P2P_MEM0_BASE_ADDR_REMAP_LOW                    0xd5c
#define PCI_1_P2P_MEM0_BASE_ADDR_REMAP_LOW                    0xddc
#define PCI_0_P2P_MEM0_BASE_ADDR_REMAP_HIGH                   0xd60
#define PCI_1_P2P_MEM0_BASE_ADDR_REMAP_HIGH                   0xde0
#define PCI_0_P2P_MEM1_BASE_ADDR_REMAP_LOW                    0xd64
#define PCI_1_P2P_MEM1_BASE_ADDR_REMAP_LOW                    0xde4
#define PCI_0_P2P_MEM1_BASE_ADDR_REMAP_HIGH                   0xd68
#define PCI_1_P2P_MEM1_BASE_ADDR_REMAP_HIGH                   0xde8
#define PCI_0_P2P_I_O_BASE_ADDR_REMAP                         0xd6c
#define PCI_1_P2P_I_O_BASE_ADDR_REMAP                         0xdec
#define PCI_0_CPU_BASE_ADDR_REMAP                             0xd70
#define PCI_1_CPU_BASE_ADDR_REMAP                             0xdf0
#define PCI_0_DAC_SCS_0_BASE_ADDR_REMAP                       0xf00
#define PCI_1_DAC_SCS_0_BASE_ADDR_REMAP                       0xf80
#define PCI_0_DAC_SCS_1_BASE_ADDR_REMAP                       0xf04
#define PCI_1_DAC_SCS_1_BASE_ADDR_REMAP                       0xf84
#define PCI_0_DAC_SCS_2_BASE_ADDR_REMAP                       0xf08
#define PCI_1_DAC_SCS_2_BASE_ADDR_REMAP                       0xf88
#define PCI_0_DAC_SCS_3_BASE_ADDR_REMAP                       0xf0c
#define PCI_1_DAC_SCS_3_BASE_ADDR_REMAP                       0xf8c
#define PCI_0_DAC_CS_0_BASE_ADDR_REMAP                        0xf10
#define PCI_1_DAC_CS_0_BASE_ADDR_REMAP                        0xf90
#define PCI_0_DAC_CS_1_BASE_ADDR_REMAP                        0xf14
#define PCI_1_DAC_CS_1_BASE_ADDR_REMAP                        0xf94
#define PCI_0_DAC_CS_2_BASE_ADDR_REMAP                        0xf18
#define PCI_1_DAC_CS_2_BASE_ADDR_REMAP                        0xf98
#define PCI_0_DAC_CS_3_BASE_ADDR_REMAP                        0xf1c
#define PCI_1_DAC_CS_3_BASE_ADDR_REMAP                        0xf9c
#define PCI_0_DAC_BOOTCS_BASE_ADDR_REMAP                      0xf20
#define PCI_1_DAC_BOOTCS_BASE_ADDR_REMAP                      0xfa0
#define PCI_0_DAC_P2P_MEM0_BASE_ADDR_REMAP_LOW                0xf24
#define PCI_1_DAC_P2P_MEM0_BASE_ADDR_REMAP_LOW                0xfa4
#define PCI_0_DAC_P2P_MEM0_BASE_ADDR_REMAP_HIGH               0xf28
#define PCI_1_DAC_P2P_MEM0_BASE_ADDR_REMAP_HIGH               0xfa8
#define PCI_0_DAC_P2P_MEM1_BASE_ADDR_REMAP_LOW                0xf2c
#define PCI_1_DAC_P2P_MEM1_BASE_ADDR_REMAP_LOW                0xfac
#define PCI_0_DAC_P2P_MEM1_BASE_ADDR_REMAP_HIGH               0xf30
#define PCI_1_DAC_P2P_MEM1_BASE_ADDR_REMAP_HIGH               0xfb0
#define PCI_0_DAC_CPU_BASE_ADDR_REMAP                         0xf34
#define PCI_1_DAC_CPU_BASE_ADDR_REMAP                         0xfb4
#define PCI_0_EXPANSION_ROM_BASE_ADDR_REMAP                   0xf38
#define PCI_1_EXPANSION_ROM_BASE_ADDR_REMAP                   0xfb8
#define PCI_0_ADDR_DECODE_CONTROL                             0xd3c
#define PCI_1_ADDR_DECODE_CONTROL                             0xdbc

/****************************************/
/* PCI Control                          */
/****************************************/

#define PCI_0_COMMAND									      0xc00
#define PCI_1_COMMAND									      0xc80
#define PCI_0_MODE                                            0xd00
#define PCI_1_MODE                                            0xd80
#define PCI_0_TIMEOUT_RETRY								      0xc04
#define PCI_1_TIMEOUT_RETRY								      0xc84
#define PCI_0_READ_BUFFER_DISCARD_TIMER                       0xd04
#define PCI_1_READ_BUFFER_DISCARD_TIMER                       0xd84
#define PCI_MSI_0_TRIGGER_TIMER                               0xc38
#define PCI_MSI_1_TRIGGER_TIMER                               0xcb8
#define PCI_0_ARBITER_CONTROL                                 0x1d00
#define PCI_1_ARBITER_CONTROL                                 0x1d80
/* changing untill here */
#define PCI_0_CROSS_BAR_CONTROL_LOW                           0x1d08
#define PCI_0_CROSS_BAR_CONTROL_HIGH                          0x1d0c
#define PCI_0_CROSS_BAR_TIMEOUT                               0x1d04
#define PCI_0_READ_RESPONSE_CROSS_BAR_CONTROL_LOW             0x1d18
#define PCI_0_READ_RESPONSE_CROSS_BAR_CONTROL_HIGH            0x1d1c
#define PCI_0_SYNC_BARRIER_VIRTUAL_REG                        0x1d10
#define PCI_0_P2P_CONFIG                                      0x1d14
#define PCI_0_ACCESS_CONTROL_BASE_0_LOW                       0x1e00
#define PCI_0_ACCESS_CONTROL_BASE_0_HIGH                      0x1e04
#define PCI_0_ACCESS_CONTROL_TOP_0                            0x1e08
#define PCI_0_ACCESS_CONTROL_BASE_1_LOW                       0x1e10
#define PCI_0_ACCESS_CONTROL_BASE_1_HIGH                      0x1e14
#define PCI_0_ACCESS_CONTROL_TOP_1                            0x1e18
#define PCI_0_ACCESS_CONTROL_BASE_2_LOW                       0x1e20
#define PCI_0_ACCESS_CONTROL_BASE_2_HIGH                      0x1e24
#define PCI_0_ACCESS_CONTROL_TOP_2                            0x1e28
#define PCI_0_ACCESS_CONTROL_BASE_3_LOW                       0x1e30
#define PCI_0_ACCESS_CONTROL_BASE_3_HIGH                      0x1e34
#define PCI_0_ACCESS_CONTROL_TOP_3                            0x1e38
#define PCI_0_ACCESS_CONTROL_BASE_4_LOW                       0x1e40
#define PCI_0_ACCESS_CONTROL_BASE_4_HIGH                      0x1e44
#define PCI_0_ACCESS_CONTROL_TOP_4                            0x1e48
#define PCI_0_ACCESS_CONTROL_BASE_5_LOW                       0x1e50
#define PCI_0_ACCESS_CONTROL_BASE_5_HIGH                      0x1e54
#define PCI_0_ACCESS_CONTROL_TOP_5                            0x1e58
#define PCI_0_ACCESS_CONTROL_BASE_6_LOW                       0x1e60
#define PCI_0_ACCESS_CONTROL_BASE_6_HIGH                      0x1e64
#define PCI_0_ACCESS_CONTROL_TOP_6                            0x1e68
#define PCI_0_ACCESS_CONTROL_BASE_7_LOW                       0x1e70
#define PCI_0_ACCESS_CONTROL_BASE_7_HIGH                      0x1e74
#define PCI_0_ACCESS_CONTROL_TOP_7                            0x1e78
#define PCI_1_CROSS_BAR_CONTROL_LOW                           0x1d88
#define PCI_1_CROSS_BAR_CONTROL_HIGH                          0x1d8c
#define PCI_1_CROSS_BAR_TIMEOUT                               0x1d84
#define PCI_1_READ_RESPONSE_CROSS_BAR_CONTROL_LOW             0x1d98
#define PCI_1_READ_RESPONSE_CROSS_BAR_CONTROL_HIGH            0x1d9c
#define PCI_1_SYNC_BARRIER_VIRTUAL_REG                        0x1d90
#define PCI_1_P2P_CONFIG                                      0x1d94
#define PCI_1_ACCESS_CONTROL_BASE_0_LOW                       0x1e80
#define PCI_1_ACCESS_CONTROL_BASE_0_HIGH                      0x1e84
#define PCI_1_ACCESS_CONTROL_TOP_0                            0x1e88
#define PCI_1_ACCESS_CONTROL_BASE_1_LOW                       0x1e90
#define PCI_1_ACCESS_CONTROL_BASE_1_HIGH                      0x1e94
#define PCI_1_ACCESS_CONTROL_TOP_1                            0x1e98
#define PCI_1_ACCESS_CONTROL_BASE_2_LOW                       0x1ea0
#define PCI_1_ACCESS_CONTROL_BASE_2_HIGH                      0x1ea4
#define PCI_1_ACCESS_CONTROL_TOP_2                            0x1ea8
#define PCI_1_ACCESS_CONTROL_BASE_3_LOW                       0x1eb0
#define PCI_1_ACCESS_CONTROL_BASE_3_HIGH                      0x1eb4
#define PCI_1_ACCESS_CONTROL_TOP_3                            0x1eb8
#define PCI_1_ACCESS_CONTROL_BASE_4_LOW                       0x1ec0
#define PCI_1_ACCESS_CONTROL_BASE_4_HIGH                      0x1ec4
#define PCI_1_ACCESS_CONTROL_TOP_4                            0x1ec8
#define PCI_1_ACCESS_CONTROL_BASE_5_LOW                       0x1ed0
#define PCI_1_ACCESS_CONTROL_BASE_5_HIGH                      0x1ed4
#define PCI_1_ACCESS_CONTROL_TOP_5                            0x1ed8
#define PCI_1_ACCESS_CONTROL_BASE_6_LOW                       0x1ee0
#define PCI_1_ACCESS_CONTROL_BASE_6_HIGH                      0x1ee4
#define PCI_1_ACCESS_CONTROL_TOP_6                            0x1ee8
#define PCI_1_ACCESS_CONTROL_BASE_7_LOW                       0x1ef0
#define PCI_1_ACCESS_CONTROL_BASE_7_HIGH                      0x1ef4
#define PCI_1_ACCESS_CONTROL_TOP_7                            0x1ef8

/****************************************/
/* PCI Snoop Control                    */
/****************************************/

#define PCI_0_SNOOP_CONTROL_BASE_0_LOW                        0x1f00
#define PCI_0_SNOOP_CONTROL_BASE_0_HIGH                       0x1f04
#define PCI_0_SNOOP_CONTROL_TOP_0                             0x1f08
#define PCI_0_SNOOP_CONTROL_BASE_1_0_LOW                      0x1f10
#define PCI_0_SNOOP_CONTROL_BASE_1_0_HIGH                     0x1f14
#define PCI_0_SNOOP_CONTROL_TOP_1                             0x1f18
#define PCI_0_SNOOP_CONTROL_BASE_2_0_LOW                      0x1f20
#define PCI_0_SNOOP_CONTROL_BASE_2_0_HIGH                     0x1f24
#define PCI_0_SNOOP_CONTROL_TOP_2                             0x1f28
#define PCI_0_SNOOP_CONTROL_BASE_3_0_LOW                      0x1f30
#define PCI_0_SNOOP_CONTROL_BASE_3_0_HIGH                     0x1f34
#define PCI_0_SNOOP_CONTROL_TOP_3                             0x1f38
#define PCI_1_SNOOP_CONTROL_BASE_0_LOW                        0x1f80
#define PCI_1_SNOOP_CONTROL_BASE_0_HIGH                       0x1f84
#define PCI_1_SNOOP_CONTROL_TOP_0                             0x1f88
#define PCI_1_SNOOP_CONTROL_BASE_1_0_LOW                      0x1f90
#define PCI_1_SNOOP_CONTROL_BASE_1_0_HIGH                     0x1f94
#define PCI_1_SNOOP_CONTROL_TOP_1                             0x1f98
#define PCI_1_SNOOP_CONTROL_BASE_2_0_LOW                      0x1fa0
#define PCI_1_SNOOP_CONTROL_BASE_2_0_HIGH                     0x1fa4
#define PCI_1_SNOOP_CONTROL_TOP_2                             0x1fa8
#define PCI_1_SNOOP_CONTROL_BASE_3_0_LOW                      0x1fb0
#define PCI_1_SNOOP_CONTROL_BASE_3_0_HIGH                     0x1fb4
#define PCI_1_SNOOP_CONTROL_TOP_3                             0x1fb8

/****************************************/
/* PCI Configuration Address            */
/****************************************/

#define PCI_0_CONFIG_ADDR 						              0xcf8
#define PCI_0_CONFIG_DATA_VIRTUAL_REG                         0xcfc
#define PCI_1_CONFIG_ADDR 						              0xc78
#define PCI_1_CONFIG_DATA_VIRTUAL_REG                         0xc7c
#define PCI_0_INTERRUPT_ACKNOWLEDGE_VIRTUAL_REG		          0xc34
#define PCI_1_INTERRUPT_ACKNOWLEDGE_VIRTUAL_REG		          0xcb4

/****************************************/
/* PCI Error Report                     */
/****************************************/

#define PCI_0_SERR_MASK										  0xc28
#define PCI_0_ERROR_ADDR_LOW                                  0x1d40
#define PCI_0_ERROR_ADDR_HIGH                                 0x1d44
#define PCI_0_ERROR_DATA_LOW                                  0x1d48
#define PCI_0_ERROR_DATA_HIGH                                 0x1d4c
#define PCI_0_ERROR_COMMAND                                   0x1d50
#define PCI_0_ERROR_CAUSE                                     0x1d58
#define PCI_0_ERROR_MASK                                      0x1d5c
#define PCI_1_SERR_MASK									      0xca8
#define PCI_1_ERROR_ADDR_LOW                                  0x1dc0
#define PCI_1_ERROR_ADDR_HIGH                                 0x1dc4
#define PCI_1_ERROR_DATA_LOW                                  0x1dc8
#define PCI_1_ERROR_DATA_HIGH                                 0x1dcc
#define PCI_1_ERROR_COMMAND                                   0x1dd0
#define PCI_1_ERROR_CAUSE                                     0x1dd8
#define PCI_1_ERROR_MASK                                      0x1ddc


/****************************************/
/* Lslave Debug  (for internal use)     */
/****************************************/

#define L_SLAVE_X0_ADDR                                       0x1d20
#define L_SLAVE_X0_COMMAND_AND_ID                             0x1d24
#define L_SLAVE_X1_ADDR                                       0x1d28
#define L_SLAVE_X1_COMMAND_AND_ID                             0x1d2c
#define L_SLAVE_WRITE_DATA_LOW                                0x1d30
#define L_SLAVE_WRITE_DATA_HIGH                               0x1d34
#define L_SLAVE_WRITE_BYTE_ENABLE                             0x1d60
#define L_SLAVE_READ_DATA_LOW                                 0x1d38
#define L_SLAVE_READ_DATA_HIGH                                0x1d3c
#define L_SLAVE_READ_ID                                       0x1d64

/****************************************/
/* PCI Configuration Function 0         */
/****************************************/

#define PCI_DEVICE_AND_VENDOR_ID 						      0x000
#define PCI_STATUS_AND_COMMAND							      0x004
#define PCI_CLASS_CODE_AND_REVISION_ID				          0x008
#define PCI_BIST_HEADER_TYPE_LATENCY_TIMER_CACHE_LINE 	      0x00C
#define PCI_SCS_0_BASE_ADDR	    						      0x010
#define PCI_SCS_1_BASE_ADDR 							      0x014
#define PCI_SCS_2_BASE_ADDR 							      0x018
#define PCI_SCS_3_BASE_ADDR      					          0x01C
#define PCI_INTERNAL_REGS_MEMORY_MAPPED_BASE_ADDR             0x020
#define PCI_INTERNAL_REGS_I_O_MAPPED_BASE_ADDR	              0x024
#define PCI_SUBSYSTEM_ID_AND_SUBSYSTEM_VENDOR_ID			  0x02C
#define PCI_EXPANSION_ROM_BASE_ADDR_REG				          0x030
#define PCI_CAPABILTY_LIST_POINTER                            0x034
#define PCI_INTERRUPT_PIN_AND_LINE 						      0x03C
#define PCI_POWER_MANAGEMENT_CAPABILITY                       0x040
#define PCI_POWER_MANAGEMENT_STATUS_AND_CONTROL               0x044
#define PCI_VPD_ADDR                                          0x048
#define PCI_VPD_DATA                                          0x04c
#define PCI_MSI_MESSAGE_CONTROL                               0x050
#define PCI_MSI_MESSAGE_ADDR                                  0x054
#define PCI_MSI_MESSAGE_UPPER_ADDR                            0x058
#define PCI_MSI_MESSAGE_DATA                                  0x05c
#define PCI_COMPACT_PCI_HOT_SWAP_CAPABILITY                   0x058

/****************************************/
/* PCI Configuration Function 1         */
/****************************************/

#define PCI_CS_0_BASE_ADDR	    					          0x110
#define PCI_CS_1_BASE_ADDR 							          0x114
#define PCI_CS_2_BASE_ADDR 							          0x118
#define PCI_CS_3_BASE_ADDR     					              0x11c
#define PCI_BOOTCS_BASE_ADDR                     	          0x120
                                                              
/****************************************/                    
/* PCI Configuration Function 2         */                    
/****************************************/                    
                                                              
#define PCI_P2P_MEM0_BASE_ADDR	    				          0x210
#define PCI_P2P_MEM1_BASE_ADDR 						          0x214
#define PCI_P2P_I_O_BASE_ADDR 						          0x218
#define PCI_CPU_BASE_ADDR      						          0x21c
                                                            
/****************************************/                  
/* PCI Configuration Function 4         */                  
/****************************************/                  
                                                            
#define PCI_DAC_SCS_0_BASE_ADDR_LOW 				          0x410
#define PCI_DAC_SCS_0_BASE_ADDR_HIGH				          0x414
#define PCI_DAC_SCS_1_BASE_ADDR_LOW   				          0x418
#define PCI_DAC_SCS_1_BASE_ADDR_HIGH  				          0x41c
#define PCI_DAC_P2P_MEM0_BASE_ADDR_LOW              	      0x420
#define PCI_DAC_P2P_MEM0_BASE_ADDR_HIGH             	      0x424


/****************************************/
/* PCI Configuration Function 5         */
/****************************************/

#define PCI_DAC_SCS_2_BASE_ADDR_LOW 					     0x510
#define PCI_DAC_SCS_2_BASE_ADDR_HIGH					     0x514
#define PCI_DAC_SCS_3_BASE_ADDR_LOW   				         0x518
#define PCI_DAC_SCS_3_BASE_ADDR_HIGH  				         0x51c
#define PCI_DAC_P2P_MEM1_BASE_ADDR_LOW              	     0x520
#define PCI_DAC_P2P_MEM1_BASE_ADDR_HIGH             	     0x524


/****************************************/
/* PCI Configuration Function 6         */
/****************************************/

#define PCI_DAC_CS_0_BASE_ADDR_LOW 					         0x610
#define PCI_DAC_CS_0_BASE_ADDR_HIGH					         0x614
#define PCI_DAC_CS_1_BASE_ADDR_LOW   				         0x618
#define PCI_DAC_CS_1_BASE_ADDR_HIGH  				         0x61c
#define PCI_DAC_CS_2_BASE_ADDR_LOW            	             0x620
#define PCI_DAC_CS_2_BASE_ADDR_HIGH           	             0x624
                                                            
/****************************************/                  
/* PCI Configuration Function 7         */                  
/****************************************/                  
                                                            
#define PCI_DAC_CS_3_BASE_ADDR_LOW 					         0x710
#define PCI_DAC_CS_3_BASE_ADDR_HIGH					         0x714
#define PCI_DAC_BOOTCS_BASE_ADDR_LOW   				         0x718
#define PCI_DAC_BOOTCS_BASE_ADDR_HIGH  				         0x71c
#define PCI_DAC_CPU_BASE_ADDR_LOW            	             0x720
#define PCI_DAC_CPU_BASE_ADDR_HIGH           	             0x724
                                                            
/****************************************/                  
/* Interrupts	  						*/                  
/****************************************/                  
			                                                
#define LOW_INTERRUPT_CAUSE_REG   					         0xc18
#define HIGH_INTERRUPT_CAUSE_REG					         0xc68
#define CPU_INTERRUPT_MASK_REG_LOW					         0xc1c
#define CPU_INTERRUPT_MASK_REG_HIGH				             0xc6c
#define CPU_SELECT_CAUSE_REG						         0xc70
#define PCI_0_INTERRUPT_CAUSE_MASK_REG_LOW			         0xc24
#define PCI_0_INTERRUPT_CAUSE_MASK_REG_HIGH			         0xc64
#define PCI_0_SELECT_CAUSE                                   0xc74
#define PCI_1_INTERRUPT_CAUSE_MASK_REG_LOW			         0xca4
#define PCI_1_INTERRUPT_CAUSE_MASK_REG_HIGH			         0xce4
#define PCI_1_SELECT_CAUSE                                   0xcf4
#define CPU_INT_0_MASK                                       0xe60
#define CPU_INT_1_MASK                                       0xe64
#define CPU_INT_2_MASK                                       0xe68
#define CPU_INT_3_MASK                                       0xe6c

/****************************************/
/* I20 Support registers				*/
/****************************************/

#define I2O_INBOUND_MESSAGE_REG0_PCI_0_SIDE				     0x010
#define I2O_INBOUND_MESSAGE_REG1_PCI_0_SIDE  			     0x014
#define I2O_OUTBOUND_MESSAGE_REG0_PCI_0_SIDE 			     0x018
#define I2O_OUTBOUND_MESSAGE_REG1_PCI_0_SIDE  			     0x01C
#define I2O_INBOUND_DOORBELL_REG_PCI_0_SIDE  			     0x020
#define I2O_INBOUND_INTERRUPT_CAUSE_REG_PCI_0_SIDE  	     0x024
#define I2O_INBOUND_INTERRUPT_MASK_REG_PCI_0_SIDE		     0x028
#define I2O_OUTBOUND_DOORBELL_REG_PCI_0_SIDE 			     0x02C
#define I2O_OUTBOUND_INTERRUPT_CAUSE_REG_PCI_0_SIDE   	     0x030
#define I2O_OUTBOUND_INTERRUPT_MASK_REG_PCI_0_SIDE   	     0x034
#define I2O_INBOUND_QUEUE_PORT_VIRTUAL_REG_PCI_0_SIDE  	     0x040
#define I2O_OUTBOUND_QUEUE_PORT_VIRTUAL_REG_PCI_0_SIDE       0x044
#define I2O_QUEUE_CONTROL_REG_PCI_0_SIDE 				     0x050
#define I2O_QUEUE_BASE_ADDR_REG_PCI_0_SIDE 			         0x054
#define I2O_INBOUND_FREE_HEAD_POINTER_REG_PCI_0_SIDE	     0x060
#define I2O_INBOUND_FREE_TAIL_POINTER_REG_PCI_0_SIDE  	     0x064
#define I2O_INBOUND_POST_HEAD_POINTER_REG_PCI_0_SIDE 	     0x068
#define I2O_INBOUND_POST_TAIL_POINTER_REG_PCI_0_SIDE 	     0x06C
#define I2O_OUTBOUND_FREE_HEAD_POINTER_REG_PCI_0_SIDE	     0x070
#define I2O_OUTBOUND_FREE_TAIL_POINTER_REG_PCI_0_SIDE	     0x074
#define I2O_OUTBOUND_POST_HEAD_POINTER_REG_PCI_0_SIDE	     0x0F8
#define I2O_OUTBOUND_POST_TAIL_POINTER_REG_PCI_0_SIDE	     0x0FC
                                                            
#define I2O_INBOUND_MESSAGE_REG0_PCI_1_SIDE				     0x090
#define I2O_INBOUND_MESSAGE_REG1_PCI_1_SIDE  			     0x094
#define I2O_OUTBOUND_MESSAGE_REG0_PCI_1_SIDE 			     0x098
#define I2O_OUTBOUND_MESSAGE_REG1_PCI_1_SIDE  			     0x09C
#define I2O_INBOUND_DOORBELL_REG_PCI_1_SIDE  			     0x0A0
#define I2O_INBOUND_INTERRUPT_CAUSE_REG_PCI_1_SIDE  	     0x0A4
#define I2O_INBOUND_INTERRUPT_MASK_REG_PCI_1_SIDE		     0x0A8
#define I2O_OUTBOUND_DOORBELL_REG_PCI_1_SIDE 			     0x0AC
#define I2O_OUTBOUND_INTERRUPT_CAUSE_REG_PCI_1_SIDE   	     0x0B0
#define I2O_OUTBOUND_INTERRUPT_MASK_REG_PCI_1_SIDE   	     0x0B4
#define I2O_INBOUND_QUEUE_PORT_VIRTUAL_REG_PCI_1_SIDE  	     0x0C0
#define I2O_OUTBOUND_QUEUE_PORT_VIRTUAL_REG_PCI_1_SIDE       0x0C4
#define I2O_QUEUE_CONTROL_REG_PCI_1_SIDE 				     0x0D0
#define I2O_QUEUE_BASE_ADDR_REG_PCI_1_SIDE 				     0x0D4
#define I2O_INBOUND_FREE_HEAD_POINTER_REG_PCI_1_SIDE	     0x0E0
#define I2O_INBOUND_FREE_TAIL_POINTER_REG_PCI_1_SIDE  	     0x0E4
#define I2O_INBOUND_POST_HEAD_POINTER_REG_PCI_1_SIDE 	     0x0E8
#define I2O_INBOUND_POST_TAIL_POINTER_REG_PCI_1_SIDE 	     0x0EC
#define I2O_OUTBOUND_FREE_HEAD_POINTER_REG_PCI_1_SIDE	     0x0F0
#define I2O_OUTBOUND_FREE_TAIL_POINTER_REG_PCI_1_SIDE	     0x0F4
#define I2O_OUTBOUND_POST_HEAD_POINTER_REG_PCI_1_SIDE	     0x078
#define I2O_OUTBOUND_POST_TAIL_POINTER_REG_PCI_1_SIDE	     0x07C
                                                            
#define I2O_INBOUND_MESSAGE_REG0_CPU0_SIDE				     0x1C10
#define I2O_INBOUND_MESSAGE_REG1_CPU0_SIDE  			     0x1C14
#define I2O_OUTBOUND_MESSAGE_REG0_CPU0_SIDE 			     0x1C18
#define I2O_OUTBOUND_MESSAGE_REG1_CPU0_SIDE  			     0x1C1C
#define I2O_INBOUND_DOORBELL_REG_CPU0_SIDE  			     0x1C20
#define I2O_INBOUND_INTERRUPT_CAUSE_REG_CPU0_SIDE  		     0x1C24
#define I2O_INBOUND_INTERRUPT_MASK_REG_CPU0_SIDE		     0x1C28
#define I2O_OUTBOUND_DOORBELL_REG_CPU0_SIDE 			     0x1C2C
#define I2O_OUTBOUND_INTERRUPT_CAUSE_REG_CPU0_SIDE   	     0x1C30
#define I2O_OUTBOUND_INTERRUPT_MASK_REG_CPU0_SIDE   	     0x1C34
#define I2O_INBOUND_QUEUE_PORT_VIRTUAL_REG_CPU0_SIDE  	     0x1C40
#define I2O_OUTBOUND_QUEUE_PORT_VIRTUAL_REG_CPU0_SIDE        0x1C44
#define I2O_QUEUE_CONTROL_REG_CPU0_SIDE 				     0x1C50
#define I2O_QUEUE_BASE_ADDR_REG_CPU0_SIDE 			         0x1C54
#define I2O_INBOUND_FREE_HEAD_POINTER_REG_CPU0_SIDE	         0x1C60
#define I2O_INBOUND_FREE_TAIL_POINTER_REG_CPU0_SIDE  	     0x1C64
#define I2O_INBOUND_POST_HEAD_POINTER_REG_CPU0_SIDE 	     0x1C68
#define I2O_INBOUND_POST_TAIL_POINTER_REG_CPU0_SIDE 	     0x1C6C
#define I2O_OUTBOUND_FREE_HEAD_POINTER_REG_CPU0_SIDE	     0x1C70
#define I2O_OUTBOUND_FREE_TAIL_POINTER_REG_CPU0_SIDE	     0x1C74
#define I2O_OUTBOUND_POST_HEAD_POINTER_REG_CPU0_SIDE	     0x1CF8
#define I2O_OUTBOUND_POST_TAIL_POINTER_REG_CPU0_SIDE	     0x1CFC
                                                            
#define I2O_INBOUND_MESSAGE_REG0_CPU1_SIDE				     0x1C90
#define I2O_INBOUND_MESSAGE_REG1_CPU1_SIDE  			     0x1C94
#define I2O_OUTBOUND_MESSAGE_REG0_CPU1_SIDE 			     0x1C98
#define I2O_OUTBOUND_MESSAGE_REG1_CPU1_SIDE  			     0x1C9C
#define I2O_INBOUND_DOORBELL_REG_CPU1_SIDE  			     0x1CA0
#define I2O_INBOUND_INTERRUPT_CAUSE_REG_CPU1_SIDE  	         0x1CA4
#define I2O_INBOUND_INTERRUPT_MASK_REG_CPU1_SIDE		     0x1CA8
#define I2O_OUTBOUND_DOORBELL_REG_CPU1_SIDE 			     0x1CAC
#define I2O_OUTBOUND_INTERRUPT_CAUSE_REG_CPU1_SIDE   	     0x1CB0
#define I2O_OUTBOUND_INTERRUPT_MASK_REG_CPU1_SIDE   	     0x1CB4
#define I2O_INBOUND_QUEUE_PORT_VIRTUAL_REG_CPU1_SIDE  	     0x1CC0
#define I2O_OUTBOUND_QUEUE_PORT_VIRTUAL_REG_CPU1_SIDE        0x1CC4
#define I2O_QUEUE_CONTROL_REG_CPU1_SIDE 				     0x1CD0
#define I2O_QUEUE_BASE_ADDR_REG_CPU1_SIDE 			         0x1CD4
#define I2O_INBOUND_FREE_HEAD_POINTER_REG_CPU1_SIDE	         0x1CE0
#define I2O_INBOUND_FREE_TAIL_POINTER_REG_CPU1_SIDE  	     0x1CE4
#define I2O_INBOUND_POST_HEAD_POINTER_REG_CPU1_SIDE 	     0x1CE8
#define I2O_INBOUND_POST_TAIL_POINTER_REG_CPU1_SIDE 	     0x1CEC
#define I2O_OUTBOUND_FREE_HEAD_POINTER_REG_CPU1_SIDE	     0x1CF0
#define I2O_OUTBOUND_FREE_TAIL_POINTER_REG_CPU1_SIDE	     0x1CF4
#define I2O_OUTBOUND_POST_HEAD_POINTER_REG_CPU1_SIDE	     0x1C78
#define I2O_OUTBOUND_POST_TAIL_POINTER_REG_CPU1_SIDE	     0x1C7C

/****************************************/
/* Communication Unit Registers         */
/****************************************/

#define ETH_ADDR_CONTROL_LOW(port)                      (0xf200 + ((port) << 5))
#define ETH_ADDR_CONTROL_HIGH(port)                     (0xf204 + ((port) << 5))
#define ETH_RECEIVE_BUFFER_PCI_HIGH_ADDR(port)          (0xf208 + ((port) << 5))
#define ETH_TRANSMIT_BUFFER_PCI_HIGH_ADDR(port)         (0xf20c + ((port) << 5))
#define ETH_RECEIVE_DESCRIPTOR_PCI_HIGH_ADDR(port)      (0xf210 + ((port) << 5))
#define ETH_TRANSMIT_DESCRIPTOR_PCI_HIGH_ADDR(port)     (0xf214 + ((port) << 5))
#define ETH_HASH_TABLE_PCI_HIGH_ADDR(port)              (0xf218 + ((port) << 5))
#define MPSC_ADDR_CONTROL_LOW(port)                     (0xf280 + ((port) << 6))
#define MPSC_ADDR_CONTROL_HIGH(port)                    (0xf284 + ((port) << 6))
#define MPSC_RECEIVE_BUFFER_PCI_HIGH_ADDR(port)         (0xf288 + ((port) << 6))
#define MPSC_TRANSMIT_BUFFER_PCI_HIGH_ADDR(port)        (0xf28c + ((port) << 6))
#define MPSC_RECEIVE_DESCRIPTOR_PCI_HIGH_ADDR(port)     (0xf290 + ((port) << 6))
#define MPSC_TRANSMIT_DESCRIPTOR_PCI_HIGH_ADDR(port)    (0xf294 + ((port) << 6))
#define SERIAL_INIT_PCI_HIGH_ADDR                            0xf320
#define SERIAL_INIT_LAST_DATA                                0xf324
#define SERIAL_INIT_CONTROL                                  0xf328
#define SERIAL_INIT_STATUSL                                  0xf32c
#define COMM_UNIT_ARBITER_CONTROL                            0xf300
#define CUNIT_CROSS_BAR_TIMEOUT                              0xf304
#define CUNIT_INTERRUPT_CAUSE                                0xf310
#define CUNIT_INTERRUPT_MASK                                 0xf314
#define CUNIT_ERROR_ADDR                                     0xf318
           
/****************************************/
/* Cunit Debug  (for internal use)     */
/****************************************/

#define CUNIT_ADDR                                           0xf340
#define CUNIT_COMMAND_AND_ID                                 0xf344
#define CUNIT_WRITE_DATA_LOW                                 0xf348
#define CUNIT_WRITE_DATA_HIGH                                0xf34c
#define CUNIT_WRITE_BYTE_ENABLE                              0xf358
#define CUNIT_READ_DATA_LOW                                  0xf350
#define CUNIT_READ_DATA_HIGH                                 0xf354
#define CUNIT_READ_ID                                        0xf35c

/****************************************/
/* Fast Ethernet Unit Registers         */
/****************************************/

/* Ethernet */

#define ETH_PHY_ADDR_REG                                     0x000
#define ETH_SMI_REG                                          0x010
#define ETH_PORT_CONFIG_REG(port)                     (0x400 + ((port) << 10))
#define ETH_PORT_CONFIG_EXTEND_REG(port)              (0x408 + ((port) << 10))
#define ETH_PORT_COMMAND_REG(port)                    (0x410 + ((port) << 10))
#define ETH_PORT_STATUS_REG(port)                     (0x418 + ((port) << 10))
#define ETH_SERIAL_PARAMETRS_REG(port)                (0x420 + ((port) << 10))
#define ETH_HASH_TABLE_POINTER_REG(port)              (0x428 + ((port) << 10))
#define ETH_FLOW_CONTROL_SOURCE_ADDR_LOW(port)        (0x430 + ((port) << 10))
#define ETH_FLOW_CONTROL_SOURCE_ADDR_HIGH(port)       (0x438 + ((port) << 10))
#define ETH_SDMA_CONFIG_REG(port)                     (0x440 + ((port) << 10))
#define ETH_SDMA_COMMAND_REG(port)                    (0x448 + ((port) << 10))
#define ETH_INTERRUPT_CAUSE_REG(port)                 (0x450 + ((port) << 10))
#define ETH_INTERRUPT_MASK_REG(port)                  (0x458 + ((port) << 10))
#define ETH_FIRST_RX_DESCRIPTOR_POINTER(port, prio)   (0x480 + ((port) << 10))\
                                                                   + (prio << 2)  
#define ETH_CURRENT_RX_DESCRIPTOR_POINTER(port, prio) (0x4a0 + ((port) << 10))\
                                                                   + (prio << 2)
#define ETH_CURRENT_TX_DESCRIPTOR_POINTER(port, prio) (0x4e0 + ((port) << 10))\
                                                                   + (prio << 2) 
#define ETH_MIB_COUNTER_BASE(port)                    (0x500 + ((port) << 10))


/****************************************/
/* SDMA Registers                       */
/****************************************/
#define SDMA_CONFIG_REG(group, channel)                (0x4000+((channel)<< 13))        
#define SDMA_COMM_REG(group, channel)                  (0x4008+((channel)<< 13))         
#define SDMA_RX_CMD_STATUS(group, channel)             (0x4800+((channel)<< 13))      
#define SDMA_RX_PACKET_AND_BUFFER_SIZES(group,channel) (0x4804+((channel)<< 13))
#define SDMA_RX_BUFFER_POINTER(group, channel)         (0x4808+((channel)<< 13))  
#define SDMA_RX_NEXT_POINTER(group, channel)           (0x480c+((channel)<< 13))    
#define SDMA_CURR_RX_DESC_PTR(group, channel)          (0x4810+((channel)<< 13))   
#define SDMA_TX_CMD_STATUS(group, channel)             (0x4c00+((channel)<< 13))      
#define SDMA_TX_PACKET_SIZE(group, channel)            (0x4c04+((channel)<< 13))     
#define SDMA_TX_BUFFER_POINTER(group, channel)         (0x4c08+((channel)<< 13))  
#define SDMA_TX_NEXT_POINTER(group, channel)           (0x4c0c+((channel)<< 13))    
#define SDMA_CURR_TX_DESC_PTR(group, channel)          (0x4c10+((channel)<< 13))   
#define SDMA_1ST_TX_DESC_PTR(group, channel)           (0x4c14+((channel)<< 13))    
                                                    

/* SDMA Interrupt */

#define SDMA_CAUSE                                           0xb800
#define SDMA_MASK                                            0xb880


/****************************************/
/* Baude Rate Generators Registers      */
/****************************************/

/* BRG's */
#define BRG_CONFIG_REG(brg)                            (0xb200 + ((brg) << 3))
#define BRG_BAUDE_TUNING_REG(brg)                      (0xb204 + ((brg) << 3))


/* BRG Interrupts */

#define BRG_CAUSE_REG                                        0xb834
#define BRG_MASK_REG                                         0xb8b4

/* MISC */

#define MPSC_MAIN_ROUTING_REG                                0xb400
#define MPSC_RECEIVE_CLOCK_ROUTING_REG                       0xb404
#define MPSC_TRANSMIT_CLOCK_ROUTING_REG                      0xb408
#define CUNIT_ARBITER_CONFIG_REG                             0xb40c
#define WATCHDOG_CONFIG_REG                                  0xb410
#define WATCHDOG_VALUE_REG                                   0xb414


/****************************************/
/* Flex TDM Registers                   */
/****************************************/

/* FTDM Port */

#define FTDM_TRANSMIT_READ_POINTER                           0xa800
#define FTDM_RECEIVE_READ_POINTER                            0xa804
#define FTDM_CONFIG_REG                                      0xa808
#define FTDM_AUX_CHANNELA_TX_REG                             0xa80c
#define FTDM_AUX_CHANNELA_RX_REG                             0xa810
#define FTDM_AUX_CHANNELB_TX_REG                             0xa814
#define FTDM_AUX_CHANNELB_RX_REG                             0xa818

/* FTDM Interrupts */

#define FTDM_CAUSE_REG                                       0xb830
#define FTDM_MASK_REG                                        0xb8b0


/****************************************/
/* GPP Interface Registers              */
/****************************************/

#define GPP_IO_CONTROL                                       0xf100
#define GPP_LEVEL_CONTROL                                    0xf110
#define GPP_VALUE                                            0xf104
#define GPP_INTERRUPT_CAUSE                                  0xf108
#define GPP_INTERRUPT_MASK                                   0xf10c
                                                            
#define MPP_CONTROL0                                         0xf000
#define MPP_CONTROL1                                         0xf004
#define MPP_CONTROL2                                         0xf008
#define MPP_CONTROL3                                         0xf00c
#define DEBUG_PORT_MULTIPLEX                                 0xf014
#define SERIAL_PORT_MULTIPLEX                                0xf010

/****************************************/
/* I2C Registers                        */
/****************************************/

#define I2C_SLAVE_ADDR                                       0xc000
#define I2C_EXTENDED_SLAVE_ADDR                              0xc010
#define I2C_DATA                                             0xc004
#define I2C_CONTROL                                          0xc008
#define I2C_STATUS_BAUDE_RATE                                0xc00C
#define I2C_SOFT_RESET                                       0xc01c

/****************************************/ 
/* MPSC Registers                       */ 
/****************************************/ 

/* MPSC's  */
#define MPSC_MAIN_CONFIG_LOW(port)   (0x8000 + ((port) << 12))                 
#define MPSC_MAIN_CONFIG_HIGH(port)  (0x8004 + ((port) << 12))
#define MPSC_PROTOCOL_CONFIG(port)   (0x8008 + ((port) << 12))
#define MPSC_CHANNEL_REG_1(port)     (0x800c + ((port) << 12))               
#define MPSC_CHANNEL_REG_2(port)     (0x8010 + ((port) << 12))               
#define MPSC_CHANNEL_REG_3(port)     (0x8014 + ((port) << 12))               
#define MPSC_CHANNEL_REG_4(port)     (0x8018 + ((port) << 12))               
#define MPSC_CHANNEL_REG_5(port)     (0x801c + ((port) << 12))               
#define MPSC_CHANNEL_REG_6(port)     (0x8020 + ((port) << 12))               
#define MPSC_CHANNEL_REG_7(port)     (0x8024 + ((port) << 12))               
#define MPSC_CHANNEL_REG_8(port)     (0x8028 + ((port) << 12))               
#define MPSC_CHANNEL_REG_9(port)     (0x802c + ((port) << 12))               
#define MPSC_CHANNEL_REG_10(port)    (0x8030 + ((port) << 12))               
/* MPSCs Interupts  */
#define MPSC_CAUSE_REG(port)         (0xb824 + ((port) << 3))
#define MPSC_MASK_REG(port)          (0xb8a4 + ((port) << 3))

#endif /* __INCgt64260rh */
