#include <stdlib.h>
#include <string.h>
#include "types.h"
#include "decls.h"
const u32 ROM_IS_ZERO         = 1;
const u32 ROM_LZH_COMPRESSION = 2;
const u32 ROM_ZIP_COMPRESSION = 3;
const u32 ROM_ENTRY           = 4;

extern union {
    void (*branch) (void);
    s32 hackfest;
} u;

s32 inflate(void);
u8 *addr;
u8  *dst;

//+****************************************************************************
s32
get_byte()
{
    return *addr++;
}
void
write_buf(s32 fd, u8 *buf, u32 cnt)
{
//    printf("from @%08lx to @%08lx\n", (u32)dst, (u32)(dst+cnt));
    memcpy(dst, buf, cnt);
    dst += cnt;
}
void
unpack_and_go(u8 *block)
{
    u32 state;
    int inflate(void);
    void trimITCM(void);
    
    if(!strncmp((char *)block, "MRVL", 4)) { // Bypass AP21 header
	block += 8;
    }
    addr = block;
    for (;;) {
        // Read address
        dst = *(u8 **)addr;
        addr += 4;
        // state 
        state = *(u32 *)addr;
        addr += 4;
        if (state == ROM_ZIP_COMPRESSION) {
            inflate();
            if ((u32)addr & 3) { // Align up
                addr += 4-((u32)addr & 3);
            }
        } else if (state == ROM_ENTRY) {
	    void disable_cache(void);
	    void send_done(void);
#ifdef MAGIC
        send_done();
#endif
            disable_cache();
            u.hackfest = (s32)dst;
            u.branch();
        } else {
            // what to do here...
            for (;;);
        }
    }
}

