#define ciuRegBase	(0x80002000)
#define CIU_PAD_CTRL	(ciuRegBase + 0x44)
#define mduRegBase	(0x80006000)
#define MDU_PAD_CTRL	(mduRegBase + 0x04C)
#define MDU_PI_PAD_CTRL	(mduRegBase + 0x050)

#define REG(x) (*(volatile unsigned long *)(x))

typedef unsigned long u32;

void
setclock()
{
    u32 rdata;
    u32 i;

    rdata = REG(CIU_PAD_CTRL);
    rdata &= 0xffffffc7;
    rdata |= (1 << 3);
    REG(CIU_PAD_CTRL) = rdata;

    // Enable FEU 50M clock
    rdata = REG(MDU_PAD_CTRL);
    REG(MDU_PAD_CTRL) = rdata | 0x1;
    
    // Apply FEU Analog Reset
    rdata = REG(MDU_PI_PAD_CTRL);
    REG(MDU_PI_PAD_CTRL) = rdata | 0x80;

    for(i=0;i < 100;i++);

    REG(MDU_PI_PAD_CTRL) = rdata & 0xff7f;

    for(i=0;i < 10;i++);

    REG(MDU_PI_PAD_CTRL) = rdata | 0x80;

    // Apply FEU reset
    rdata = REG(MDU_PI_PAD_CTRL);
    
    REG(MDU_PI_PAD_CTRL) = rdata | 0x8000;

}
