#ifndef __WINS_H__
#define __WINS_H__

/*
*                Copyright 2003, Marvell Semiconductor, Inc.
* This code contains confidential information of Marvell Semiconductor, Inc.
* No rights are granted herein under any patent, mask work right or copyright
* of Marvell or any third party.
* Marvell reserves the right at its sole discretion to request that this code
* be immediately returned to Marvell. This code is provided "as is".
* Marvell makes no warranties, express, implied or otherwise, regarding its
* accuracy, completeness or performance.
*/

/*!
 * \file    wins.h
 * \brief   Header file for WINS Client Module
 *
 * Author(s):    Binh Tran 
 * Date:         2003-03-25
 *
 * $Revision: #1 $
 * $Date: 2004/09/10 $
 */

#define WINS_PORT               137
#define RD_BUF_MAX_LEN          512
#define WINS_NAME_BUF_MAX_LEN   34

#define NAME_SRV_HDR_LEN        12


typedef struct nameSrvQuery
{
    unsigned char name[WINS_NAME_BUF_MAX_LEN];
    unsigned short type;
    unsigned short nClass;
}nameSrvQuery;

typedef struct nBiosNameSrv
{
    unsigned short transId;
    unsigned short flag;
    unsigned short question;
    unsigned short answer_rrs;
    unsigned short auth_rrs;
    unsigned short add_rrs;
    nameSrvQuery  query;
}nBiosNameSrv;

typedef struct nameSrvAnswer
{
    nameSrvQuery query;
    unsigned short  ttl;    /* byte alignment problem */
    unsigned short lenData;
    unsigned short answFlag;
    unsigned char  data[WINS_NAME_BUF_MAX_LEN];
}nameSrvAnswer;

typedef struct nBiosNameSrvOut
{
    unsigned short transId;
    unsigned short flag;
    unsigned short question;
    unsigned short answer_rrs;
    unsigned short auth_rrs;
    unsigned short add_rrs;
    nameSrvAnswer  answer;

}nBiosNameSrvOut;

extern unsigned char *winsGetDevName(void);
extern unsigned long winsGetEthIp(void);

#endif /* __WINS_H__ */
