#ifndef __DHCPS_DB_H__
#define __DHCPS_DB_H__

/*
*                Copyright 2003, Marvell Semiconductor, Inc.
* This code contains confidential information of Marvell Semiconductor, Inc.
* No rights are granted herein under any patent, mask work right or copyright
* of Marvell or any third party.
* Marvell reserves the right at its sole discretion to request that this code
* be immediately returned to Marvell. This code is provided "as is".
* Marvell makes no warranties, express, implied or otherwise, regarding its
* accuracy, completeness or performance.
*/

/*!
 * \file    dhcps_db.h
 * \brief   Header file for DHCP Server Module - DB
 *
 * Author(s):    Igor Miroshnik
 * Date:         2004-07-21
 *
 * $Revision: #1 $
 * $Date: 2004/11/29 $
 */


typedef enum {

    DHCPS_DB_INIT_OK,
    DHCPS_DB_INIT_REDUNDANT_CALL,
    DHCPS_DB_INIT_BAD_PARAMETER,
    DHCPS_DB_INIT_NO_MEMORY

} DHCPS_DB_INIT_STATUS;

typedef enum {

    DHCPS_DB_INSERT_OK,
    DHCPS_DB_INSERT_DUPLICATE,
    DHCPS_DB_INSERT_OVERFLOW

} DHCPS_DB_INSERT_STATUS;

DHCPS_DB_INIT_STATUS DHCPS_db_init (

    unsigned key_size,
    unsigned entry_size,
    unsigned total
)
;

DHCPS_DB_INSERT_STATUS DHCPS_db_insert (

    void *key,
    void **entry
)
;

void *DHCPS_db_get (

    void *key
)
;

void *DHCPS_db_get_next (

    void *key
)
;

void DHCPS_db_delete (

    void *entry
)
;

void DHCPS_db_cleanup (

    void
)
;

#endif /* __DHCPS_DB_H__ */
