#ifndef __RD_H__
#define __RD_H__

/*
*                Copyright 2003, Marvell Semiconductor, Inc.
* This code contains confidential information of Marvell Semiconductor, Inc.
* No rights are granted herein under any patent, mask work right or copyright
* of Marvell or any third party.
* Marvell reserves the right at its sole discretion to request that this code
* be immediately returned to Marvell. This code is provided "as is".
* Marvell makes no warranties, express, implied or otherwise, regarding its
* accuracy, completeness or performance.
*/

/*!
 *
 * Author(s):    Ariel Gilman
 * Date:         2004-08-03
 *
 * $Revision: #1 $
 * $Date:
 */

#include "marvell/fast_route/fr_main/incl/main_api.h"
/* Debug */

/******************************************************************************
 *
 * Name:   FR_RD_init
 *
 * Description:
 *   This routine is called to initialize RD component of FR.
 *
 * Conditions For Use:
 *   None.
 *
 * Arguments:
 *   None.
 *
 * Return Value:
 *   Status indicating success or failure
 *
 * Notes:
 *   None.
 *
 * PDL:
 *
 *
 * END PDL
 *
 *****************************************************************************/

extern FastRouting_init_ENT  FR_RD_init(void);


/******************************************************************************
 *
 * Name:   FR_Routing_Decision_form_LAN
 *
 * Description:
 *   This routine is calls upon RX of IP packets from LAN.
 *
 * Conditions For Use:
 *   None.
 *
 * Arguments:
 *   Arg1 - buffer.
 *
 * Return Value:
 *   Action for the packet and updated buffer.
 *
 * Notes:
 *   None.
 *
 * PDL:
 *
 *
 * END PDL
 *
 *****************************************************************************/

extern FastRouting_action_ENT  FR_Routing_Decision_form_LAN (
    /* input */
    UINT8                     *buff_PTR
    /* input & output */
    /* output */
);



/******************************************************************************
 *
 * Name:   FR_Routing_Decision_from_WAN_with_NAT
 *
 * Description:
 *   This routine is calls upon RX of IP packets from WAN & NAT is eanbled.
 *
 * Conditions For Use:
 *   None.
 *
 * Arguments:
 *   Arg1 - buffer.
 *
 * Return Value:
 *   Action for the packet and updated buffer.
 *
 * Notes:
 *   None.
 *
 * PDL:
 *
 *
 * END PDL
 *
 *****************************************************************************/

extern FastRouting_action_ENT  FR_Routing_Decision_from_WAN_with_NAT (
    /* input */
    UINT8                     *buff_PTR
    /* input & output */
    /* output */
);



/******************************************************************************
 *
 * Name:   FR_Routing_Decision_from_WAN_with_NAT
 *
 * Description:
 *   This routine is calls upon RX of IP packets from WAN.
 *
 * Conditions For Use:
 *   None.
 *
 * Arguments:
 *   Arg1 - buffer.
 *
 * Return Value:
 *   Action for the packet and updated buffer.
 *
 * Notes:
 *   None.
 *
 * PDL:
 *
 *
 * END PDL
 *
 *****************************************************************************/

extern FastRouting_action_ENT  FR_Routing_Decision_from_WAN_with_NAT (
    /* input */
    UINT8                     *buff_PTR
    /* input & output */
    /* output */
);


#endif /* __RD_H__ */
