#ifndef  __FRARP_H
#define  __FRARP_H
/*
*                Copyright 2003, Marvell Semiconductor, Inc.
* This code contains confidential information of Marvell Semiconductor, Inc.
* No rights are granted herein under any patent, mask work right or copyright
* of Marvell or any third party.
* Marvell reserves the right at its sole discretion to request that this code
* be immediately returned to Marvell. This code is provided "as is".
* Marvell makes no warranties, express, implied or otherwise, regarding its
* accuracy, completeness or performance.
*/

/*!
 * \file    frarp.h
 * \brief   Header file for DHCP Server Module
 *
 * Author(s):    Nimrod Stern
 * Date:         2004-08-03
 *
 * $Revision: #1 $
 * $Date: 2004/11/29 $
 */

/* includes */
#include "marvell/fast_route/fr_main/incl/main_api.h"


/* API functions */
extern void  FR_ARP_create_request_WAN_dgateway(
    /* input */

    UINT8                  *buff_PTR,

    /* input & output */

    UINT32          *buff_len_PTR
    /* output */
);

extern void  FR_ARP_create_request(
/* input */

    IpAddress_TYP         dst_ip_address,
    UINT8                 *buff_PTR,

/* input & output */

    UINT32               *buff_len_PTR
/* output */

);

extern void  FR_ARP_unmark_entry(
/* input */

IpAddress_TYP         ip_address

/* input & output */

/* output */

);


extern MacAddress_TYP*  FR_ARP_mark_entry(
/* input */

IpAddress_TYP         ip_address

/* input & output */

/* output */

);

extern MacAddress_TYP*   FR_ARP_get_Mac (
/* input */

IpAddress_TYP         ip_address

/* input & output */

/* output */

);

extern void FR_ARP_update_from_WAN (
/* input */

UINT8                     *buff_PTR,
UINT32                     buff_len

/* input & output */

/* output */

);


extern void FR_ARP_update_from_LAN (
/* input */

UINT8                     *buff_PTR,
UINT32                     buff_len

/* input & output */

/* output */

);

extern FastRouting_init_ENT  FR_ARP_Init (
/* input */
        void
/* input & output */

/* output */

);
#endif
