/******************** (c) Marvell Semiconductor, Inc., 2001 *******************
*
* Purpose:
*    This file contains the definitions of the fragment module
*
* Public Procedures:
*
* Private Procedures:
*
* Notes:
*    None.
*
*****************************************************************************/
#ifndef  __FRAGMENT_H__
#define __FRAGMENT_H__

//=============================================================================
//                               INCLUDE FILES
//=============================================================================

//=============================================================================
//                                DEFINITIONS
//=============================================================================
#define MAX_FRAGMENT_NUM      16
#define FRAGOUT_FREE          0
#define FRAGOUT_DMA_PENDING   1
#define FRAGOUT_WEP_PENDING   2

//=============================================================================
//                          PUBLIC TYPE DEFINITIONS
//=============================================================================

typedef struct Frag_t
{
    txInfo_t* TxInfo;
    UINT8* wlanPdu; //pointer to frame without 802.3 or 802.11 header
    UINT16 wlanPduLen; //lehgth of frame minus 802.3 or 802.11 header
    UINT8 FragCnt;
UINT8 PsFlag:
    1;   //the des station's ps mode
UINT8 reserved:
    7;
    UINT32 DmaDb_p;
}
PACK_END Frag_t;

typedef struct
{
    rx80211_Frame_t *pFrame;
    UINT16 SeqNo;
    UINT8 *pCurrent;
    UINT32 time_out_time;
    UINT32 time_out_timeMSB;
    UINT8 FragNo;
    
}
DeFragBufInfo_t;

typedef struct 
{
   UINT16 FrameLen[16]; /** max possible frag no **/
   UINT16 SeqNo[16];
   UINT16 Expire_time[16];
   rx80211_Frame_t *frame[16];
}OldDeFragBufInfo_t;

//=============================================================================
//                    PUBLIC PROCEDURES (ANSI Prototypes)
//=============================================================================
void InitFragBuf(void);
UINT32 DoFragment(Frag_t*);
extern void SetDurationId(txInfo_t *txInfo_p);
extern UINT32 timeout_val;
extern DeFragBufInfo_t DeFragBufInfo[3];
extern OldDeFragBufInfo_t OldDeFragBufInfo[3];
extern inline UINT32 GetDeFragBuf(IEEEtypes_MacAddr_t *Addr, UINT16 SeqNo);
extern inline UINT32 GetDeFragFreeBuf(void);
extern inline void ResetDeFragBufInfo(DeFragBufInfo_t *pDeFragBufInfo);

rx80211_Frame_t * DoDeFragCCMP(rx80211_Frame_t *pEncrData, UINT32 pKey, UINT32 Len);



#endif/* __FRAGMENT_H__ */
