#if !defined(_RFREG_H_)
#define _RFREG_H_

/*
 *                Copyright 2003, Marvell Semiconductor, Inc.
 * This code contains confidential information of Marvell Semiconductor, Inc.
 * No rights are granted herein under any patent, mask work right or copyright
 * of Marvell or any third party.
 * Marvell reserves the right at its sole discretion to request that this code
 * be immediately returned to Marvell. This code is provided "as is".
 * Marvell makes no warranties, express, implied or otherwise, regarding its
 * accuracy, completeness or performance.
 */


/*!
 * \file    rfreg.h
 * \brief   This file contains the RF register definitions.
 *
 */
/**  Setting for Rf reg 0x3a, 0x3b, 0x3c **/
UINT8 HarrierRegChannel_SelectG[][]=
{
	{0x5c,0x2f,0xa0},  /** Channel 1 **/
	{0xc3,0x35,0xa1},
	{0x29,0x3c,0xa1},
	{0x8f,0x22,0xa1},
	{0xf6,0x28,0xa1},
	{0x5c,0x2f,0xa1},
	{0xc3,0x35,0xa2},
	{0x29,0x3c,0xa2},
	{0x8f,0x22,0xa2},
	{0xf6,0x28,0xa2},
	{0x5c,0x2f,0xa2},
	{0xc3,0x35,0xa3},
	{0x29,0x3c,0xa3},
	{0x85,0x2b,0xa3}   /**.... Channel 14 **/
};
	
UINT8 HarrierRegChannel_SelectA[][]=
{
	{0xff,0xff,0xff},  /** Not used **/
	{0xff,0xff,0xff},  /** Not used **/
	{0xff,0xff,0xff},  /** Not used **/
	{0xff,0xff,0xff},  /** Not used **/
	{0xff,0xff,0xff},  /** Not used **/
	{0xff,0xff,0xff},  /** Not used **/
	{0xff,0xff,0xff},  /** Not used **/

	{0x9a,0x39,0xa5},  /** Channel 8 for A **/

	{0xff,0xff,0xff},  /** Not used **/
	{0xff,0xff,0xff},  /** Not used **/
	{0xff,0xff,0xff},  /** Not used **/
	{0x66,0x26,0xa5}, /** Channel 12 **/
	{0xff,0xff,0xff},  /** Not used **/
	{0xff,0xff,0xff},  /** Not used **/
	{0xff,0xff,0xff},  /** Not used **/

	{0x33,0x33,0xa5}, // 16 
	
	{0xff,0xff,0xff},  //17
	{0xff,0xff,0xff},  //18 /** Not used **/
	{0xff,0xff,0xff},  //19 /** Not used **/
	{0xff,0xff,0xff},  //20 /** Not used **/
	{0xff,0xff,0xff},  //21 /** Not used **/
	{0xff,0xff,0xff},  //22 /** Not used **/
	{0xff,0xff,0xff},  //23 /** Not used **/
	{0xff,0xff,0xff},  //24 /** Not used **/
	{0xff,0xff,0xff},  //25 /** Not used **/
	{0xff,0xff,0xff},  //26 /** Not used **/
	{0xff,0xff,0xff},  //27 /** Not used **/
	{0xff,0xff,0xff},  //28 /** Not used **/
	{0xff,0xff,0xff},  //29 /** Not used **/
	{0xff,0xff,0xff},  //30 /** Not used **/
	{0xff,0xff,0xff},  //31 /** Not used **/
	{0xff,0xff,0xff},  //32 /** Not used **/
	{0xff,0xff,0xff},  //33 /** Not used **/
	{0xcd,0x2c,0xa7}, // 34
	{0xff,0xff,0xff},  /** Not used **/
	{0x33,0x33,0xa8}, //36
	{0xff,0xff,0xff},  /** Not used **/
	{0x9a,0x39,0xa8}, //38
	{0xff,0xff,0xff},  /** Not used **/
	{0x00,0x20,0xa8}, //4 //40
	{0xff,0xff,0xff},  /** Not used **/
	{0x66,0x26,0xa8}, //42
	{0xff,0xff,0xff},  /** Not used **/
	{0x66,0x26,0xa8}, //44
	{0xff,0xff,0xff},  /** Not used **/
	{0x33,0x33,0xa9}, //46
	{0xff,0xff,0xff},  /** Not used **/
	{0x9a,0x39,0xa9}, //48
	{0xff,0xff,0xff},  /** Not used **/
	{0xff,0xff,0xff},  /** Not used **/
	{0xff,0xff,0xff},  /** Not used **/
	{0x66,0x26,0xa9}, //52
	{0xff,0xff,0xff},  /** Not used **/
	{0xff,0xff,0xff},  /** Not used **/
	{0xff,0xff,0xff},  /** Not used **/
	{0x33,0x33,0xaa}, //56
	{0xff,0xff,0xff},  /** Not used **/
	{0xff,0xff,0xff},  /** Not used **/
	{0xff,0xff,0xff},  /** Not used **/
	{0x00,0x20,0xaa}, //60
	{0xff,0xff,0xff},  /** Not used **/
	{0xff,0xff,0xff},  /** Not used **/
	{0xff,0xff,0xff},  /** Not used **/
	{0xcd,0x2c,0xaa}, //64
	{0xff,0xff,0xff},  //65 /** Not used **/
	{0xff,0xff,0xff},  //66 /** Not used **/
	{0xff,0xff,0xff},  //67 /** Not used **/
	{0xff,0xff,0xff},  //68 /** Not used **/
	{0xff,0xff,0xff},  //69 /** Not used **/
	{0xff,0xff,0xff},  //70 /** Not used **/
	{0xff,0xff,0xff},  //71 /** Not used **/
	{0xff,0xff,0xff},  //72 /** Not used **/
	{0xff,0xff,0xff},  //73 /** Not used **/
	{0xff,0xff,0xff},  //74 /** Not used **/
	{0xff,0xff,0xff},  //75 /** Not used **/
	{0xff,0xff,0xff},  //76 /** Not used **/
	{0xff,0xff,0xff},  //77 /** Not used **/
	{0xff,0xff,0xff},  //78 /** Not used **/

	{0xcd,0x2c,0xaa}, //79

	{0xff,0xff,0xff},  //80 /** Not used **/
	{0xff,0xff,0xff},  //81 /** Not used **/
	{0xff,0xff,0xff},  //82 /** Not used **/
	{0xff,0xff,0xff},  //83 /** Not used **/
	{0xff,0xff,0xff},  //84 /** Not used **/
	{0xff,0xff,0xff},  //85 /** Not used **/
	{0xff,0xff,0xff},  //86 /** Not used **/
	{0xff,0xff,0xff},  //87 /** Not used **/
	{0xff,0xff,0xff},  //88 /** Not used **/
	{0xff,0xff,0xff},  //89 /** Not used **/
	{0xff,0xff,0xff},  //90 /** Not used **/
	{0xff,0xff,0xff},  //91 /** Not used **/
	{0xff,0xff,0xff},  //92 /** Not used **/
	{0xff,0xff,0xff},  //93 /** Not used **/
	{0xff,0xff,0xff},  //94 /** Not used **/
	{0xff,0xff,0xff},  //95 /** Not used **/
	{0xff,0xff,0xff},  //96 /** Not used **/
	{0xff,0xff,0xff},  //97 /** Not used **/
	{0xff,0xff,0xff},  //98 /** Not used **/
	{0xff,0xff,0xff},  //99 /** Not used **/

	{0x00,0x20,0xae}, //100
	{0xff,0xff,0xff},  /** Not used **/
	{0xff,0xff,0xff},  /** Not used **/
	{0xff,0xff,0xff},  /** Not used **/

	{0xcd,0x2c,0xae}, //104
	{0xff,0xff,0xff},  /** Not used **/
	{0xff,0xff,0xff},  /** Not used **/
	{0xff,0xff,0xff},  /** Not used **/

	{0x9a,0x39,0xaf}, //108
	{0xff,0xff,0xff},  /** Not used **/
	{0xff,0xff,0xff},  /** Not used **/
	{0xff,0xff,0xff},  /** Not used **/

	{0x66,0x26,0xaf}, //112
	{0xff,0xff,0xff},  /** Not used **/
	{0xff,0xff,0xff},  /** Not used **/
	{0xff,0xff,0xff},  /** Not used **/

	{0x33,0x33,0xb0}, //116
	{0xff,0xff,0xff},  /** Not used **/
	{0xff,0xff,0xff},  /** Not used **/
	{0xff,0xff,0xff},  /** Not used **/

	{0x00,0x20,0xb0}, //1   
	{0xcd,0x2c,0xb0}, //124
	{0xff,0xff,0xff},  /** Not used **/
	{0xff,0xff,0xff},  /** Not used **/
	{0xff,0xff,0xff},  /** Not used **/

	{0x9a,0x39,0xb1}, //128
	{0xff,0xff,0xff},  /** Not used **/
	{0xff,0xff,0xff},  /** Not used **/
	{0xff,0xff,0xff},  /** Not used **/

	{0x66,0x26,0xb1},//132
	{0xff,0xff,0xff},  /** Not used **/
	{0xff,0xff,0xff},  /** Not used **/
	{0xff,0xff,0xff},  /** Not used **/

	{0x33,0x33,0xb2}, //136
	{0xff,0xff,0xff},  /** Not used **/
	{0xff,0xff,0xff},  /** Not used **/
	{0xff,0xff,0xff},  /** Not used **/

	{0x00,0x20,0xb2}, //140
	{0xff,0xff,0xff},  /** Not used **/
	{0xff,0xff,0xff},  /** Not used **/
	{0xff,0xff,0xff},  /** Not used **/
	{0xff,0xff,0xff},  /** Not used **/
	{0xff,0xff,0xff},  /** Not used **/
	{0xff,0xff,0xff},  /** Not used **/
	{0xff,0xff,0xff},  /** Not used **/
	{0xff,0xff,0xff},  /** Not used **/



	{0xcd,0x3c,0xb3}, //149
	{0xff,0xff,0xff},  /** Not used **/
	{0xff,0xff,0xff},  /** Not used **/
	{0xff,0xff,0xff},  /** Not used **/


	{0xcd,0x04,0xb3}, //153
	{0xff,0xff,0xff},  /** Not used **/
	{0xff,0xff,0xff},  /** Not used **/
	{0xff,0xff,0xff},  /** Not used **/

	{0x33,0x1b,0xb4}, //157
	{0xff,0xff,0xff},  /** Not used **/
	{0xff,0xff,0xff},  /** Not used **/
	{0xff,0xff,0xff},  /** Not used **/

	{0x33,0x1b,0xb4}, //161
	
	{0xff,0xff,0xff},  //162 /** Not used **/
	{0xff,0xff,0xff},  //163 /** Not used **/
	{0xff,0xff,0xff},  //164 /** Not used **/
	{0xff,0xff,0xff},  //165/** Not used **/
	{0xff,0xff,0xff},  //166/** Not used **/
	{0xff,0xff,0xff},  //167 /** Not used **/
	{0xff,0xff,0xff},  //168 /** Not used **/
	{0xff,0xff,0xff},  //169 /** Not used **/
	{0xff,0xff,0xff},  //170 /** Not used **/
	{0xff,0xff,0xff},  //171/** Not used **/
	{0xff,0xff,0xff},  //172 /** Not used **/
	{0xff,0xff,0xff},  //173 /** Not used **/
	{0xff,0xff,0xff},  //174 /** Not used **/
	{0xff,0xff,0xff},  //175/** Not used **/
	{0xff,0xff,0xff},  //176 /** Not used **/
	{0xff,0xff,0xff},  //177 /** Not used **/
	{0xff,0xff,0xff},  //178 /** Not used **/
	{0xff,0xff,0xff},  //179 /** Not used **/
	{0xff,0xff,0xff},  //180 /** Not used **/
	{0xff,0xff,0xff},  //181 /** Not used **/
	{0xff,0xff,0xff},  //182 /** Not used **/
	{0xff,0xff,0xff},  //183 /** Not used **/
	{0xff,0xff,0xff},  //184 /** Not used **/
	{0xff,0xff,0xff},  //185 /** Not used **/
	{0xff,0xff,0xff},  //186 /** Not used **/
	{0xff,0xff,0xff},  //187 /** Not used **/
	{0xff,0xff,0xff},  //188 /** Not used **/
	{0xff,0xff,0xff},  //189 /** Not used **/
	{0xff,0xff,0xff},  //190 /** Not used **/
	{0xff,0xff,0xff},  //191 /** Not used **/
	{0xff,0xff,0xff},  //192 /** Not used **/
	{0xff,0xff,0xff},  //193 /** Not used **/
	{0xff,0xff,0xff},  //194 /** Not used **/
	{0xff,0xff,0xff},  //195/** Not used **/
	{0xff,0xff,0xff},  //196 /** Not used **/
	{0xff,0xff,0xff},  //197 /** Not used **/
	{0xff,0xff,0xff},  //198 /** Not used **/
	{0xff,0xff,0xff},  //199 /** Not used **/
	{0xff,0xff,0xff},  //200 /** Not used **/
	{0xff,0xff,0xff},  //201 /** Not used **/
	{0xff,0xff,0xff},  //202 /** Not used **/
	{0xff,0xff,0xff},  //203 /** Not used **/
	{0xff,0xff,0xff},  //204 /** Not used **/
	{0xff,0xff,0xff},  //205 /** Not used **/
	{0xff,0xff,0xff},  //206 /** Not used **/
	{0xff,0xff,0xff},  //207 /** Not used **/
	{0xff,0xff,0xff},  //208 /** Not used **/
	{0xff,0xff,0xff},  //209 /** Not used **/
	{0xff,0xff,0xff},  //210 /** Not used **/
	{0xff,0xff,0xff},  //211 /** Not used **/
	{0xff,0xff,0xff},  //212 /** Not used **/
	{0xff,0xff,0xff},  //213 /** Not used **/
	{0xff,0xff,0xff},  //214 /** Not used **/
	{0xff,0xff,0xff},  //215 /** Not used **/
	{0xff,0xff,0xff},  //216 /** Not used **/
	{0xff,0xff,0xff},  //217 /** Not used **/
	{0xff,0xff,0xff},  //218/** Not used **/
	{0xff,0xff,0xff},  //219 /** Not used **/
	{0xff,0xff,0xff},  //220 /** Not used **/
	{0xff,0xff,0xff},  //221 /** Not used **/
	{0xff,0xff,0xff},  //222 /** Not used **/
	{0xff,0xff,0xff},  //223 /** Not used **/
	{0xff,0xff,0xff},  //224 /** Not used **/
	{0xff,0xff,0xff},  //225 /** Not used **/
	{0xff,0xff,0xff},  //226 /** Not used **/
	{0xff,0xff,0xff},  //227 /** Not used **/
	{0xff,0xff,0xff},  //228 /** Not used **/
	{0xff,0xff,0xff},  //229 /** Not used **/
	{0xff,0xff,0xff},  //230 /** Not used **/
	{0xff,0xff,0xff},  //231 /** Not used **/
	{0xff,0xff,0xff},  //232 /** Not used **/
	{0xff,0xff,0xff},  //233/** Not used **/
	{0xff,0xff,0xff},  //234 /** Not used **/
	{0xff,0xff,0xff},  //235 /** Not used **/
	{0xff,0xff,0xff},  //236 /** Not used **/
	{0xff,0xff,0xff},  //237 /** Not used **/
	{0xff,0xff,0xff},  //238 /** Not used **/
	{0xff,0xff,0xff},  //239 /** Not used **/


	{0xcd,0x2c,0xa2}, //240
	{0xff,0xff,0xff},  /** Not used **/
	{0xff,0xff,0xff},  /** Not used **/
	{0xff,0xff,0xff},  /** Not used **/


	{0x9a,0x39,0xa3}, //244
	{0xff,0xff,0xff},  /** Not used **/
	{0xff,0xff,0xff},  /** Not used **/
	{0xff,0xff,0xff},  /** Not used **/

	{0x66,0x26,0xa3}, //248
	{0xff,0xff,0xff},  /** Not used **/
	{0xff,0xff,0xff},  /** Not used **/
	{0xff,0xff,0xff},  /** Not used **/

	{0x66,0x26,0xa3} //252
};



	


	

	
}


















}












 




#endif /* _RFREG_H_ */

