#ifndef _BUILD_MODES_H_
#define _BUILD_MODES_H_
#define CONDOR
#define OEMSSID "Marvell-AP5X" /* default SSID */
#define OEM_UR_SSID "Marvell_AP" /* default SSID of AP to connect UR */
#define OEMCHANNEL 36/** default channel **/
#define MAX_STNS  32 /** Maximum allow associated station **/
#define TESTCMD 1

#define AP52 0
#define AP51 1
#if PROD_NAME == AP51
//    #define ENABLE_ETH_DEBUG // Enable interactive commands from user
//    #define RESET_BUTTON_EVENT  1
//    #define TASKDHCP 1
#else
    #define SOHO_GATEWAY
#endif

#define VLAN_MODE 
//#ifndef AP22c
//#define TRIGGEREVENT 1
//#endif

#define ENABLE_ERP_PROTECTION 1
#define ENABLE_RATE_ADAPTATION 1 
/* Enable support for RS232 port */
//#define ENABLE_RATE_ADAPTATION_FOLLOW_STN 1  /* Follows the station rate */
//#define ENABLE_RATE_ADAPTATION_ON_TX_ERR 1 /* Rate adapt, on tx error */
#define ENABLE_RATE_ADAPTATION_BASEBAND 1 /*Uses the OPERA scheme to set the BaseBand Values*/ 
//#define ENABLE_RATE_ADAPTATION_ACKS 1 /*To collect data of acks*/
/*********************************************************
// Aim: To read the Receive Rate of the Ack Packets and determine 
// if the Transmitted packet was sent at the bail out rate.
**********************************************************/ 
//#define ENABLE_RATE_ADAPTATION_ACK_RECV_RATE
#define ENABLE_OSCILLATION_CODE  //To prevent Oscillations from happening.
//#define ENABLE_SYSLOG
#define SAD



#ifdef WPA
#define HW_ENCR
//#define WEP_ITCM 1
#endif
//#define ONTHEFLY_DECRYPT_DISABLED

#define HEADER_MODE 1
#define FIXEDTXPOWER 1
#define ICACHE 1
#define NEW_APIO_ALLOC  1
#define SUPPORT_FIX_TX_DATA_RATE 1
#define MACACCESSTABLE 1
#define LINKTEST 1
#define PASS_IPX
#ifndef CONDOR
//#define FIX_BUFFER_ERROR 1
#define RESET_BUTTON_EVENT 1
#endif
#define FIX_BUFFER_ERROR 1
#define ENABLE_AGING  1
#define BUFFER_WITH_RESERVED_SPACE 1

#if defined(BUFFER_WITH_RESERVED_SPACE)
#define RESERVED_SPACE_LEN   128
#endif

#define USE_BUFFER_OFFSET 1

#ifdef CONDOR

#define ERP 
//#define DEBUG_PRINT 1
#define ETH_STAT 1

#define ENABLE_MFG_CALIBRATION 1
#ifndef FALCON
#ifndef PEREGRINE
#define MFG_DATA_ADDRESS 0xFFFFFD00 /* harrier */
#else
#define MFG_DATA_ADDRESS 0xffffff70 /* peregrine */
#endif /* #ifdef PEREGRINE */
#else /* falcon */
#define MFG_DATA_ADDRESS 0xffffff70 /* falcon */
#endif /* #ifndef falcon*/ 
//#define MUX 1

//#define ENABLE_MILLISEC_TIMER 1
#endif

//#define FREE_BUFFER_OPTION 1
#define DRIVER_BUSY_SIGNATURE 0x5A
#define BRIDGE_FREE_SIGNATURE 0xA5
#define RESERVED_FREE_SIGNATURE 0x8A8A

#define ENABLE_AP_MODES 1 
//#define ENABLE_MILLISEC_TIMER 1


#define POWER_SAVE 1
#define TX_HWWEP 1 
//#define CHECK_FOR_ACK_AGEOUT 1
#define RESETLIMIT 20000
//#define BUGKENNY
//#define OFF_LINE_WEP_DECR
#define RESET 1


/* Use more aggressive cw min/max to get better performance
   in overlapped channel situation */
#define OVERLAP_CHAN_PERF_TUNE

/* Define when building for AP22N, AP22C, AP32GST */
//#define NO_GUI
//#define WEP_IN_INTR_MODE
#define WPA_NO_WAIT
#define ENABLE_WIFI_PROTECTION
#define DISABLE_B_AP_CHECK
#define FORCE_ERP_PROTECTION_SUPPORT
//#define WATCHDOG_ENABLE
//#define QD_BUF_TRACKING
//#define FREEINTXQUEUE
#define NEW_CW_VALUE
//#define  SDRAMBURST 1
//#define B0_CHIP  /** define this if use with B0 chip **/
#ifdef B0_CHIP
#define ONTHEFLY_DECRYPT_DISABLED
#endif
#ifndef FALCON
#ifndef PEREGRINE
#define HARRIER
#endif /* AP_PGRINE */
#endif /* FALCON */
#define AGMode
#define SELF_CTS  1

#define WDS_FEATURE 1
#define EZ_WDS 1    /* wds handling is done in driver, not in bridge */
#define USE_SQRAM 1
#define AEU_176
//#define WAIT_FOR_DUMMY_ENCRYPT 1
//#define PRESET_WDS_DYNAMIC_UNICAST   1
                        /* initial mode dynamic AP learning, bcast pkts sent as unicast */
#ifdef HARRIER
#define COUNTRY_INFO_SUPPORT
#endif //HARRIER
//#define NEW_OSIF_POWERSAVE

#define AGPassThruMode
//#define A_MODE
//#define USE_AONLY_MODE
//#define ECOS

//#define ENABLE_ETH_DEBUG // Enable interactive commands from user
#define CFPOLL_DONEQ_BUG_WORKAROUND 1
//#define TAG1D_REMOVAL_SUPPORT 1
#define WPA_NO_COPY
#ifdef QOS_FEATURE
#define RX_QOSDATA_SUPPORT 
#define QOS_TID_OFFSET_SUPPORT
//#define NOQOSCOPY
//#define QOS_NO_COPY
//#define PRIORITY_OPTION
#define ETHER_RX_QOSDATA_SUPPORT
#define FIX_NO_BEEF_ERROR
//#define WMM_SA_SUPPORT
//#define CNXT_WMMSA_HACK
//#define ZERO_DELAY	
//#define JAPAN_CHANNEL_SPACING_10_SUPPORT
#define ETHER_BUFFER_CHECK
#define BBP_STUCK_RECOVERY
#ifdef UAPSD
#define WMM_PS_SUPPORT
#endif
#endif
#ifdef CONDOR2
#ifdef CONDOR2_64SQ
#define SQRAM_SIZE 0xc0010000
#else
#define SQRAM_SIZE 0xc0020000
#endif
#else
#define SQRAM_SIZE 0xc000c000
#endif
//#define CONDOR2_64SQ
typedef struct _CONFIG
{
   unsigned char prod;
   unsigned char feif;
   #define MII_IF 0
   #define PHY_IF 1
   #define EPHY_IF 2
   unsigned char stack;
   #define ECOS_STACK 0
   unsigned char dhcp;
   #define STATICIP  0
   #define DHCPCLIENT 1
}_CONFIG;

extern _CONFIG systemCfg;

#endif /* _BUILD_MODES_H_ */
