#if !defined(_CIU_H_)
#define _CIU_H_

/*
 *                Copyright 2003, Marvell Semiconductor, Inc.
 * This code contains confidential information of Marvell Semiconductor, Inc.
 * No rights are granted herein under any patent, mask work right or copyright
 * of Marvell or any third party.
 * Marvell reserves the right at its sole discretion to request that this code
 * be immediately returned to Marvell. This code is provided "as is".
 * Marvell makes no warranties, express, implied or otherwise, regarding its
 * accuracy, completeness or performance.
 */

/*!
 * \file    ciu.h
 * \brief   This file contains the CIU Config registers.
 *
 */

/*--------------------------------------------------------------*/
/*  CIU Config registers                           */
/*--------------------------------------------------------------*/
#define WL_CIU_SYS_CONFIG        ((WL_CIU_CFG_BASE)|(0x00))
#define WL_CIU_CLK_EN            ((WL_CIU_CFG_BASE)|(0x0C))
#define WL_CIU_REVNUM            ((WL_CIU_CFG_BASE)|(0x18))
#define WL_CIU_CONTROL           ((WL_CIU_CFG_BASE)|(0x30))

#define HOST_IF_MASK       0x7
#define HOST_PCI           0x00
#define HOST_CARDBUS       0x01
#define HOST_PCCARD        0x02
#define HOST_USB           0x04
#define HOST_MII           0x05

#define CTRL_STOPPCIRETRY  0x20

#endif /* _CIU_H_ */

