#ifndef __ETH_DEBUG_H__
#define __ETH_DEBUG_H__
 
#include "wltypes.h"

#define DBG_DEFAULT_ETH_IO  "lan0"
#define DBG_DEFAULT_TYPE    0x88cc
#define DBG_BUF_MAX_LEN		512
#define ETH_DBG_HDR_LEN     14
#define ETHERBUG_HDR_LEN	6

typedef struct eth_hdr_dbg {
    UINT8  da[6];
    UINT8  sa[6];
    UINT8  type[2];
} PACK_END eth_hdr_dbg;

typedef struct ethbug_info {
	UINT8 resrv[ETHERBUG_HDR_LEN];
} PACK_END ethbug_info;


#ifdef ENABLE_ETH_DEBUG

    extern UINT32 etherBugSend(const char *format, ... );
    extern UINT32 etherBugRecv(UINT8 *pack, UINT32 packLen);

    #define eprintf		etherBugSend
    #define printf      etherBugSend
    #define assert(expr)  (expr)? ((void *)0) : eprintf("%s line %d %s\n",  __FILE__, __LINE__, #expr)

#else

    #define eprintf	
    #define printf  
    #define assert

#endif

#endif /* __ETH_DEBUG_H__ */
