

/* addressTableLow.h - this file has all the declarations of the address table */

#ifndef _ADDRESS_TABLE_
#define _ADDRESS_TABLE_

#include "etherLow.h"


#define ADDRESS_TABLE_ALIGNMENT             0x8
#define MAC_ENTRY_SIZE                      8
#define MAC_ADDRESS_STRING_SIZE             12
#define _8K_TABLE                           0

#define HASH_DEFUALT_MODE                   14
#define HASH_MODE                           13
#define HASH_SIZE                           12
#define PROMISCUOUS_MODE                    0

#define _8K_TABLE                           0
#define VALID					  1
#define SKIP                                1<<1
#define SKIP_BIT                            1
#define HOP_NUMBER                          12
#define EIGHT_K                             0x8000
#define HALF_K                              0x8000/16

#define MAX_NUMBER_OF_ADDRESSES_TO_STORE    1000



#define NIBBLE_SWAPPING_16_BIT(X) (((X&0xf)<<4) | ((X&0xf0)>>4) |\
        ((X&0xf00)<<4) | ((X&0xf000)>>4))

#define NIBBLE_SWAPPING_32_BIT(X) (((X&0xf)<<4) | ((X&0xf0)>>4) |\
        ((X&0xf00)<<4) | ((X&0xf000)>>4) | ((X&0xf0000)<<4) | ((X&0xf00000)>>4)\
         | ((X&0xf000000)<<4) | ((X&0xf0000000)>>4))

#define GT_NIBBLE(X) ((X&0x1)<<3)+((X&0x2)<<1)+((X&0x4)>>1)+((X&0x8)>>3)

#define FLIP_6_BITS(X) (((X&0x1)<<5)+((X&0x2)<<3)+((X&0x4)<<1)+\
        ((X&0x8)>>1)+((X&0x10)>>3)+((X&0x20)>>5))

#define FLIP_9_BITS(X) (((X&0x1)<<8)+((X&0x2)<<6)+((X&0x4)<<4)+\
        ((X&0x8)<<2)+((X&0x10)<<0)+((X&0x20)>>2)+((X&0x40)>>4)+\
        ((X&0x80)>>6)+((X&0x100)>>8))



typedef struct AddressTablestore
{
    unsigned int macL;
unsigned int macH:
    16;
unsigned int rd:
    1;
unsigned int skip:
    1;
unsigned int valid:
    1;
}
ADDRESS_TABLE_STORE;


int hashTableFunction(unsigned int macH, unsigned int macL,
                      int HashSize, int hash_mode);
bool initAddressTable(int port, int hashMode, int hashSize, int hashDefaultMode);
bool addAddressTableEntry(int port, unsigned int macH, unsigned int macL,
                          unsigned int rd, unsigned int skip);
bool enableFiltering(int port);
bool disableFiltering(int port);
bool scanAddressTable(int port);
bool findFirstAddressTableEntry(int port,
                                unsigned int* startEntry, char* resultBuffer);
bool addressTableDefragment(int port, int hashMode,
                            int hashSize, int hashDefaultMode);
bool addressTableClear(int port);



#endif
