#if !defined(_HTIMER_H_)
#define _HTIMER_H_

/*
 *                Copyright 2003, Marvell Semiconductor, Inc.
 * This code contains confidential information of Marvell Semiconductor, Inc.
 * No rights are granted herein under any patent, mask work right or copyright
 * of Marvell or any third party.
 * Marvell reserves the right at its sole discretion to request that this code
 * be immediately returned to Marvell. This code is provided "as is".
 * Marvell makes no warranties, express, implied or otherwise, regarding its
 * accuracy, completeness or performance.
 */


/*!
 * \file    htimer.h
 * \brief   This file contains the hardware timer registers definitions
 *
 */


/*--------------------------------------------------------------*/
/*  Hardware Timer registers                        */
/*--------------------------------------------------------------*/
#define WL_HTIMER_T1_LENGTH   ((WL_TIMER_BASE)|(0x0000))
#define WL_HTIMER_T2_LENGTH   ((WL_TIMER_BASE)|(0x0004))
#define WL_HTIMER_T3_LENGTH   ((WL_TIMER_BASE)|(0x0008))
#define WL_HTIMER_T4_LENGTH   ((WL_TIMER_BASE)|(0x000C))
#define WL_HTIMER_CONTROL     ((WL_TIMER_BASE)|(0x0010))
#define WL_HTIMER_T1_VALUE    ((WL_TIMER_BASE)|(0x0014))
#define WL_HTIMER_T2_VALUE    ((WL_TIMER_BASE)|(0x0018))
#define WL_HTIMER_T3_VALUE    ((WL_TIMER_BASE)|(0x001C))
#define WL_HTIMER_T4_VALUE    ((WL_TIMER_BASE)|(0x0020))
#define WL_HTIMER_ISR         ((WL_TIMER_BASE)|(0x0024))
#define WL_HTIMER_IMR         ((WL_TIMER_BASE)|(0x0028))
#define WL_HTIMER_PRER1K      ((WL_TIMER_BASE)|(0x002C))
#define WL_HTIMER_PRER1M      ((WL_TIMER_BASE)|(0x0030))
#define WL_HTIMER_WATCH_DOG   ((WL_TIMER_BASE | 0x0034))

#define HTIMER_CONTROL_T1_LOAD     (1<<3)
#define HTIMER_CONTROL_T2_LOAD     (1<<7)

#endif /* _HTIMER_H_ */

