#if !defined(_IDMA_H_)
#define _IDMA_H_

/*
 *                Copyright 2003, Marvell Semiconductor, Inc.
 * This code contains confidential information of Marvell Semiconductor, Inc.
 * No rights are granted herein under any patent, mask work right or copyright
 * of Marvell or any third party.
 * Marvell reserves the right at its sole discretion to request that this code
 * be immediately returned to Marvell. This code is provided "as is".
 * Marvell makes no warranties, express, implied or otherwise, regarding its
 * accuracy, completeness or performance.
 */


/*!
 * \file    idma.h
 * \brief   This file contains the DMA registers definitions.
 *
 */


/*--------------------------------------------------------------*/
/*  Independent DMA (_DMA_) registers                           */
/*--------------------------------------------------------------*/
#define WL_IDMA_BYTECNT0        ((WL_IDMA_CFG_BASE)|(0x800))
#define WL_IDMA_BYTECNT1        ((WL_IDMA_CFG_BASE)|(0x804))
#define WL_IDMA_BYTECNT2        ((WL_IDMA_CFG_BASE)|(0x808))
#define WL_IDMA_BYTECNT3        ((WL_IDMA_CFG_BASE)|(0x80C))
#define WL_IDMA_SRCADDR0        ((WL_IDMA_CFG_BASE)|(0x810))
#define WL_IDMA_SRCADDR1        ((WL_IDMA_CFG_BASE)|(0x814))
#define WL_IDMA_SRCADDR2        ((WL_IDMA_CFG_BASE)|(0x818))
#define WL_IDMA_SRCADDR3        ((WL_IDMA_CFG_BASE)|(0x81C))
#define WL_IDMA_DESADDR0        ((WL_IDMA_CFG_BASE)|(0x820))
#define WL_IDMA_DESADDR1        ((WL_IDMA_CFG_BASE)|(0x824))
#define WL_IDMA_DESADDR2        ((WL_IDMA_CFG_BASE)|(0x828))
#define WL_IDMA_DESADDR3        ((WL_IDMA_CFG_BASE)|(0x82C))
#define WL_IDMA_NEXTRECPTR0     ((WL_IDMA_CFG_BASE)|(0x830))
#define WL_IDMA_NEXTRECPTR1     ((WL_IDMA_CFG_BASE)|(0x834))
#define WL_IDMA_NEXTRECPTR2     ((WL_IDMA_CFG_BASE)|(0x838))
#define WL_IDMA_NEXTRECPTR3     ((WL_IDMA_CFG_BASE)|(0x83C))
#define WL_IDMA_CH0_CTRL        ((WL_IDMA_CFG_BASE)|(0x840))
#define WL_IDMA_CH1_CTRL        ((WL_IDMA_CFG_BASE)|(0x844))
#define WL_IDMA_CH2_CTRL        ((WL_IDMA_CFG_BASE)|(0x848))
#define WL_IDMA_CH3_CTRL        ((WL_IDMA_CFG_BASE)|(0x84C))
#define DCC_INC_SRC              0
#define DCC_DEC_SRC              0x00000002
#define DCC_HOLD_SRC             0x00000004
#define DCC_INC_DES              0
#define DCC_DEC_DES              0x00000010
#define DCC_HOLD_DES             0x00000020
#define DCC_DTL_01               0x00000140  /*data transfer limit - 1 byte */
#define DCC_DTL_02               0x00000180  /*data transfer limit - 2 byte */
#define DCC_DTL_04               0x00000000  /*data transfer limit - 4 byte */
#define DCC_DTL_08               0x00000040  /*data transfer limit - 8 byte */
#define DCC_DTL_16               0x000000C0  /*data transfer limit - 16 byte */
#define DCC_DTL_32               0x000001C0  /*data transfer limit - 32 byte */
#define DCC_NO_CHAIN             (1<<9)
#define DCC_CHAIN_INT            (1<<10)  /*chain mode interrupt */
#define DCC_BLOCK_MODE           (1<<11)  /*block mode transfer */
#define DCC_CHANEN               (1<<12)  /*channel enable */
#define DCC_FETNEXREC            (1<<13)  /*force fetch next record */
#define DCC_CHAN_ACT             (1<<14)  /*channel active */
#define DCC_DES_ALIGN            (1<<16)  /*alignment done towards destination */
#define DCC_ABORT                (1<<20)
#define WL_IDMA_IMR0            ((WL_IDMA_CFG_BASE)|(0x880))
#define WL_IDMA_IMR1            ((WL_IDMA_CFG_BASE)|(0x884))
#define WL_IDMA_IMR2            ((WL_IDMA_CFG_BASE)|(0x888))
#define WL_IDMA_IMR3            ((WL_IDMA_CFG_BASE)|(0x88C))
#define WL_IDMA_RSR0            ((WL_IDMA_CFG_BASE)|(0x890))
#define WL_IDMA_RSR1            ((WL_IDMA_CFG_BASE)|(0x894))
#define WL_IDMA_RSR2            ((WL_IDMA_CFG_BASE)|(0x898))
#define WL_IDMA_RSR3            ((WL_IDMA_CFG_BASE)|(0x89C))
#define WL_IDMA_ISR0            ((WL_IDMA_CFG_BASE)|(0x8A0))
#define WL_IDMA_ISR1            ((WL_IDMA_CFG_BASE)|(0x8A4))
#define WL_IDMA_ISR2            ((WL_IDMA_CFG_BASE)|(0x8A8))
#define WL_IDMA_ISR3            ((WL_IDMA_CFG_BASE)|(0x8AC))


#endif /* _IDMA_H_ */

