#ifndef _KEYMGMT_IF_H_
#define _KEYMGMT_IF_H_

#define NONCE_SIZE          32
#define EAPOL_MIC_KEY_SIZE  16

typedef enum
{
    IDLE,
    START4WAYHSK,
    TIMEOUT,
    MSGRECVDEVT,
    KEYMGMTTIMEOUTEVT,
    GRPKEYTIMEOUTEVT
}keyMgmtEvent_e;

typedef  struct
{
    UINT8 protocol_ver;
    UINT8 pckt_type;
    UINT16 pckt_body_len;
}
PACK_END Hdr_8021x_t;

#define KEY_INFO_KEYTYPE    0x0800
#define KEY_INFO_REQUEST    0x0008
#define KEY_INFO_ERROR      0x0004


typedef  struct
{ //don't change this order
UINT16 desc_ver :
    3;
UINT16 key_type :
    1;
UINT16 key_index :
    2;
UINT16 install :
    1;
UINT16 key_ack :
    1;
UINT16 key_MIC :
    1;
UINT16 secure :
    1;
UINT16 error :
    1;
UINT16 request :
    1;
UINT16 rsvd :
    4;

}
PACK_END key_info_t;

typedef struct
{
    ether_hdr_t Ether_Hdr;
    Hdr_8021x_t hdr_8021x;
    UINT8 desc_type;
    union
    {
        key_info_t key_info;
        UINT16 key_info16; //key_info as UINT16
    }PACK_END k;
    UINT16 key_length;
    UINT32 replay_cnt[2];
    UINT8 key_nonce[NONCE_SIZE]; //32 bytes
    UINT8 EAPOL_key_IV[16];
    UINT8 key_RSC[8];
    UINT8 key_ID[8];
    UINT8 key_MIC[EAPOL_MIC_KEY_SIZE];
    UINT16 key_material_len;
    UINT8 key_data[1];
}
PACK_END EAPOL_KeyMsg_t;

extern UINT32 isMsgInQ;

extern void ProcessKeyMgmtData(apio_bufdescr_t *rx_FrmPtr,
                                   IEEEtypes_MacAddr_t *SourceAddr,
                                   keyMgmtEvent_e evt);
void KeyMgmtInit();
#endif
