/******************** (c) Marvell Semiconductor, Inc., 2001 *******************
*
* $Header: //depot/MRVL/main/firmware/AP5x/wlandrv/incl/macpriv.h#5 $
*
* Purpose:
*    This file contains the function prototypes and definitions for the
*
* Public Procedures:
*                           message has been received on one of the message
*                           queues
*
* Notes:
*    None.
*
*****************************************************************************/
#ifndef _MACPRIV_H_
#define _MACPRIV_H_

typedef enum {
    POWER_MODE_CHANGE_NOTIFY = 0,
    PS_POLL_NOTIFY,
    NEW_STN_NOTIFY,
    STNID_RESET,
    AID_NOTIFY,
    AID_RESET
#ifdef WMM_PS_SUPPORT
   ,EOSP_NOTIFY
#endif
} MacInternalMsgType_e;

typedef struct PwrModeChange_t
{
    IEEEtypes_MacAddr_t MacAddr;
    IEEEtypes_PwrMgmtMode_e PwrMgmtMode;
#ifdef WMM_PS_SUPPORT
    UINT8 Trigger;
    UINT8 AccessCAT;
#endif
}
PwrModeChange_t;

typedef struct PsPollNotify_t
{
    UINT16 StnId;
    UINT16 Aid;
}
PsPollNotify_t;

typedef struct NewStnNotify_t
{
    UINT16 StnId;
    IEEEtypes_MacAddr_t MacAddr;
}
NewStnNotify_t;
typedef struct StnIdReset_t
{
    UINT16 StnId;
}
StnIdReset_t;
typedef struct AidNotify_t
{
    UINT16 StnId;
    UINT16 Aid;
    Boolean PollFlag;
#if 0//def WMM_PS_SUPPORT
    UINT8 QosInfo;
#endif
}
AidNotify_t;

#ifdef WMM_PS_SUPPORT
typedef struct EospNotify_t
{
    UINT16 StnId;
    IEEEtypes_MacAddr_t MacAddr;
}
EospNotify_t;
#endif
	
typedef struct AidReset_t
{
    UINT16 StnId;
    UINT16 Aid;
}
AidReset_t;
typedef struct MacInternalMsg_t
{
    MacInternalMsgType_e MsgType;
    union
    {
        PwrModeChange_t PwrModeChange;
        PsPollNotify_t PsPollNotify;
        NewStnNotify_t NewStnNotify;
        StnIdReset_t StnIdReset;
        AidNotify_t AidNotify;
        AidReset_t AidReset;
#ifdef WMM_PS_SUPPORT
	EospNotify_t  EospNotify;
#endif
    } Body;
}
MacInternalMsg_t;

extern pool_ID_t macInternalPoolId;
extern Status_e macpriv_Init( void );
extern Status_e NotifyNewStn(IEEEtypes_MacAddr_t *MacAddr, UINT16 StnId);
extern Status_e NotifyAid(UINT16 StnId, UINT16 Aid, Boolean PollFlag);
extern Status_e ResetAid(UINT16 StnId, UINT16 Aid);
#ifdef WMM_PS_SUPPORT
extern Status_e NotifyPwrModeChange(IEEEtypes_MacAddr_t *MacAddr,
                                        IEEEtypes_PwrMgmtMode_e PwrMode, UINT8,UINT8);

#else
extern Status_e NotifyPwrModeChange(IEEEtypes_MacAddr_t *MacAddr,
                                        IEEEtypes_PwrMgmtMode_e PwrMode);
#endif
extern Status_e NotifyPsPoll(UINT16 StnId, UINT16 Aid);

#endif
