#ifndef SHELL_H
#define SHELL_H

#include "buildModes.h"
#include "oem.h"

#ifndef __uClinux__
extern void debug_printf(const char *fmt, ...);
extern UINT32 dbgBitmap;
#endif

#ifdef ENABLE_UART
#define DUMPMIB 0 /* Console Command dbgprintf Bitmap >oe 1 */
#define dbgprintf(id, args...)	do {          \
    if (dbgBitmap & (1 << id))                \
        debug_printf(args);                  \
} while (0)
#else
#ifndef __uClinux__
#define dbgprintf(id, args...)
#else
/* #define UCLINUX_DEBUG   1 */

#ifdef UCLINUX_DEBUG
#define dbgprintf(id, args...)	printk(args)
#else
#define dbgprintf(id, args...)
#endif
#endif
#endif

enum DBG_OUTPUT_ID {
    DBG_SYS_ERROR = 0,         // For unhandled exceptions
    DBG_HAL_RF,
    DBG_HAL_BBP,
    DBG_HAL_MAC,
    DBG_HAL_ETH,
    DBG_SYS_MLME,              // For MLME/SME
    DBG_SYS_TASK,              // For task level debugging
    DBG_SYS_BUFMGT,            // For buffer management
    DBG_80211_MGMT,        
    DBG_80211_BEACON,
    DBG_80211_PROBE,
    DBG_80211_WEP,
    DBG_80211_WPA,
    DBG_80211_WPA2,
    DBG_80211_QOS,
    DBG_80211_PM,
#ifdef AUTOLINK    
    DBG_AUTOLINK,
#endif    
};
    
#define EVENT_WL_UART_RX_CMD         0x00
#define EVENT_WL_UART_RX_OVERFLOW    0x01
#define EVENT_WL_UART_TX_OVERFLOW    0x02

#endif /* SHELL_H */