/*************************************************************
 *
 *   Timer.h                                                
 *   Copy Right(2003) Marvell Semiconductors, Inc.           
 *
 *
 *   Author(s):    Jiaqi Shen                                 
 *   Date:         2003-06-16                                 
 *   Description:  This file defined a Timer list object 
 *
 *************************************************************
 */
#ifndef timer_h
#define timer_h

#define CALL_BACK 0
#define NO_CALL_BACK 1

typedef struct Timer Timer;

struct Timer
{
    Timer *next;        /*link timers in the list */
    int active;
    int cb;
    unsigned int count;
    unsigned int interval;
    unsigned char *userdata_p;
    void (*callback)(unsigned char *);
};
void TimerFireIn(Timer *me, int act, void *callback, unsigned char *data_p, unsigned int ticks);
void TimerFireEvery(Timer *me, int act, void *callback, unsigned char *data_p, unsigned int ticks);
void TimerDisarm(Timer *me);
void TimerRearm(Timer *me, unsigned int ticks);
void TimerTick(void);
void TimerInit(Timer *me);

#endif
