/******************************************************************************
 *                Copyright 2004, Marvell Semiconductor, Inc.
 * This code contains confidential information of Marvell Semiconductor, Inc.
 * No rights are granted herein under any patent, mask work right or copyright
 * of Marvell or any third party.
 * Marvell reserves the right at its sole discretion to request that this code
 * be immediately returned to Marvell. This code is provided "as is".
 * Marvell makes no warranties, express, implied or otherwise, regarding its
 * accuracy, completeness or performance.
 ******************************************************************************/
#ifndef TRACE_H
#define TRACE_H

#ifdef ENABLE_SYSLOG

#define SYSLOG_PORT  514
extern UINT8 syslogOn;
extern UINT32 slHost;
extern int debug;

#define SetSyslog(x)    (syslogOn = x)
#define SetSyslogIP(x)  (slHost = x)

#define LOG_EMERG   0   /* kernel panic */
#define LOG ALERT   1   /* condition needing immediate attention */
#define LOG_CRIT    2   /* critical conditions */
#define LOG_ERR     3   /* errors */
#define LOG_WARNING 4   /* warning messages */
#define LOG_NOTICE  5   /* not an error, but may need attention */
#define LOG_INFO    6   /* informational messages */
#define LOG_DEBUG   7   /* when debugging a system */

#define MAX_TRACE_LINE  128

extern void syslog(const char *format, ... );
#define SYS_LOG(x)	syslog x
#else
#define SYS_LOG(x)
#endif

#endif  /* TRACE_H */
