/******************** (c) Marvell Semiconductor, Inc., 2001 *******************
* 
* Purpose: 
*    This file contains the implementations of the transmit queue functions. 
* 
* Public Procedures: 

* 
* Private Procedures: 
*      
* 
* Notes: 
*    None. 
* 
****************************************************************************/
#ifndef _TX_SCHED_H_
#define _TX_SCHED_H_

#define MCBC_STN_ID         (MAX_STNS)
#define ISSPACE_AVAIL(qid)  (TRUE)
#define TC0_QID     0
#define TC1_QID     1
#define TC2_QID     2
#define TC3_QID     3
#define TC4_QID     4
#define TC5_QID     5
#define TC6_QID     6
#define TC7_QID     7
#define CM_QID      8    /* Control/management Queue */
#define BW_QID      9    /* Bandwidth Allocation/Request Queue */
#define PS_QID      10
#define CFP_QID     11
#define MCBC_QID    12   /* Multicast/Broadcast queue */
#define DONE_QID    13
#define MAX_QID     14 

#define ENQUE(qid, msgPtr) { DoneQMsg_p = msgPtr; \
               tx80211_SendEvent(tx80211_FRAME_TX_DONE);}
#define DEQUE(qid, msgPtr) {msgPtr = DoneQMsg_p;\
                            DoneQMsg_p = NULL;}


#define MAX_STNS_TOBE_POLLED 1



typedef struct AssocData_t_
{
    IEEEtypes_MacAddr_t MacAddr;
    IEEEtypes_PwrMgmtMode_e PwrSaveMode;
    UINT16 Aid;
    BOOLEAN CfPoll;
    BOOLEAN PollReq;
    BOOLEAN NoPoll;
    BOOLEAN MsduInProg;
}
AssocData_t;



typedef tx80211_MgmtMsg_t pktInfo_t;

typedef struct fragListElem_t
{
    txInfo_t * txInfo_p;
    pktInfo_t *fragBuf;
    struct fragListElem_t * nextThisStn;
    struct fragListElem_t * prevThisStn;
    struct fragListElem_t * nextAnyStn;
    struct fragListElem_t * prevAnyStn;
}
fragListElem_t;


typedef struct txQingInfo_t_
{
    IEEEtypes_MacAddr_t MacAddr;  /* Dest Station's MAC address */
    IEEEtypes_PwrMgmtMode_e PwrMgmtMode;
    UINT32 cbqOutstandCnt;        /* Number of messages in CB Q */
    UINT32 cfqOutstandCnt;        /* Number of messages in CF Q */
    UINT32 msgCnt;               /* Number of messages in the Station's List */
    UINT16 Aid;
    BOOLEAN cfPollDataQd;
#ifdef WMM_PS_SUPPORT
    fragListElem_t *stnFragListHead[4];  /** additional 4 ac **/
    fragListElem_t *stnFragListTail[4];
#else
    fragListElem_t *stnFragListHead;
    fragListElem_t *stnFragListTail;
#endif
    //   fragListElem_t *stnPsFragListHead;
    //   fragListElem_t *stnPsFragListTail;
    UINT32 MaxAge;
    UINT32 TotalMsgCnt;
#ifdef WMM_PS_SUPPORT
   // UINT8 QosInfo;
    UINT32  apsdmsgCnt;
    UINT8 ACforDelivery[4];
    UINT8 Eosp;
    UINT32 triggerframeCnt;
    UINT8 PollPck;
#endif
}
txQingInfo_t;



/******************************************************************************
 *  Polling List functions
 ******************************************************************************/
typedef struct PollListElem_t
{
    UINT16 Aid;
    UINT16 StnId;
    struct PollListElem_t *next;
    struct PollListElem_t *prev;
}
PollListElem_t;

extern WL_STATUS txsched_Init(void);
#if 0
extern WL_STATUS ProcessPsPoll(UINT16 StnId, UINT16 Aid);
#else
extern WL_STATUS ProcessPsPoll(extStaDb_StaInfo_t *StaInfo_p);
#endif
extern WL_STATUS txsched_ScheduleFrame(txInfo_t *txInfo_p);
extern WL_STATUS ProcessCfpEnd(void);
extern WL_STATUS ProcessCfpStart(void);
extern WL_STATUS ProcessTxDone(void);
void txsched_UpdatePktAge();
void FreePowerSaveQueue(UINT32 StnId);
extern void SendMarvellOUIPck(UINT8 *StnMacAddress, UINT16 StnId);
extern void SendMarvellOUIPck2(UINT8 *StnMacAddress, UINT16 StnId);
extern void DetectBAP(void);
#ifdef WMM_PS_SUPPORT
extern UINT32 TriggerFrameCnt(UINT16 ,UINT8 );
extern void SetPollPck(UINT16 ,UINT8 );
#endif
extern BOOLEAN sendNullDataPacketA(UINT8 Rate,UINT16 txParam);

extern BOOLEAN sendNullDataPacketG(UINT8 Rate,UINT16 txParam);
WL_STATUS sendQosNullDataPkt(IEEEtypes_MacAddr_t *,UINT16 , UINT8 , UINT8);
WL_STATUS sendNullTriggerDataPkt(IEEEtypes_MacAddr_t *,UINT16 , UINT8 , UINT8 );



#endif
