#ifndef _USRCFG_H_
#define _USRCFG_H_ 
/*
*                Copyright 2003, Marvell Semiconductor, Inc.
* This code contains confidential information of Marvell Semiconductor, Inc.
* No rights are granted herein under any patent, mask work right or copyright
* of Marvell or any third party.
* Marvell reserves the right at its sole discretion to request that this code
* be immediately returned to Marvell. This code is provided "as is".
* Marvell makes no warranties, express, implied or otherwise, regarding its
* accuracy, completeness or performance.
*/

/*!
 * \file    usrcfg.h
 * \brief   Define structure for user configurable data
 *
 * Author: jshen@marvell.com, created: 4/17/03
 * $Revision: #1 $
 * $Date: 2004/09/10 $
 */

#include "wltypes.h"

typedef struct usr_Cfg_t
{
    UINT32 uc_mfgDataLocation;
    UINT8 uc_gpioSwResetPin;
    UINT8 uc_gpioUtilPin;
}
PACK_END usr_Cfg_t; 

extern usr_Cfg_t usrCfg;

#define mfgDataAddress()    (usrCfg.uc_mfgDataLocation)
#define GPIO_PIN_SW_RESET   (1<<(usrCfg.uc_gpioSwResetPin))
#define GPIO_PIN_SW_UTIL    (1<<(usrCfg.uc_gpioUtilPin))
void usr_Cfg_Init(void);

#endif
