/******************** (c) Marvell Semiconductor, Inc., 2004 *******************
*
* Purpose:
*    This file contains the function prototypes and definitions for the
*    WDS module.
*
* Public Procedures:
*
* Notes:
*    None.
*
*****************************************************************************/
#ifdef WDS_FEATURE
#ifndef __WDS_H__
#define __WDS_H__

#define DS_ROUTER_CHANGE_MIN_TIME       3       //min time for route change
#define MAX_DS_NODES                    100

typedef struct __DSFDescr{
	apio_handle_t porthandle;
	UINT8	*SrcAddr;
	UINT8	*DstAddr;
	UINT16 padding;	//for align,no use
}t_DSFDescr;

//structure used in hash
typedef struct _sDSCargo
{
	apio_handle_t porthandle;
	UINT32 stamp;
	UINT16 firstadd;
} sDSCargo;
#define	HASHcargoName	sDSCargo
#ifndef _DS_H_
typedef struct
{
    UINT32 Key;
    UINT32 totalLen;
#ifdef GATEWAY
    unsigned int interface;/*0 - LAN ;1 - WAN*/
#endif
    UINT8 data[1600];
}
dsQ_LlcData_t;
#endif
typedef struct _t_WDS_Port_CB{
        apio_handle_t wdsxHandle;
        #define WDS_PORT_IN_USE         1
        #define WDS_PORT_NOT_USE        0
        UINT32  status; 
        UINT8 repeaterID[6];
}t_WDS_Port_CB;

extern t_WDS_Port_CB WDS_Port_CB[MAX_WDS_PORT+1];
extern apio_handle_t llcHandle;

/*exported apies in ds block*/
int DSInit(void);
 void addDSNode(sHASH *p);
 void delDSNode(sHASH *p);
int DSForwardPacket(apio_handle_t port_handler,apio_bufdescr_t *pBufDescr);
int	WDSForwardPacketRead(apio_bufdescr_t *pBufDescr);
int	WDSForwardPacketWrite(apio_bufdescr_t *pBufDescr, apio_handle_t *pHandle);
void	WDSLanPacketRead(apio_bufdescr_t *pBufDescr);
inline void CheckDmaDone(void);
int WDSInit();
#define	FORWARD_SUCCESS		0x0
#define FORWARD_ERROR		0x1
#endif
#endif // WDS_FEATURE