#ifndef _WEP_H_
#define _WEP_H_

extern UINT32 g_IV32;
extern UINT16 g_IV16;

void GenerateEncrKey(UINT8 *, UINT8 *, UINT8 *, UINT32,
                     UINT16, IEEEtypes_MacAddr_t *, UINT16 *); // SECTION_ITCM;
void GenerateDecrptKey(IEEEtypes_DataFrame_t *, UINT8 *, UINT8 *, UINT16 *, UINT32);
void InsertIVintoFrmBody(UINT8 *, UINT8 *, UINT32, UINT8);

#ifndef B0_CHIP
inline UINT32 DoTKIPDecrypt(UINT8 *des, UINT8 *src, UINT32 len, UINT8 *key);
inline void DoTKIPEncrypt(UINT8 *des, UINT8 *src, UINT32 len, UINT8 *key);
#else
void DoHWTkipEncrypt(UINT32 Dst,UINT32 Src,UINT32 Len,UINT8 *pEncrKey,
                     UINT8 *pTxMICKey,UINT8 * TaAddr,UINT8 *DesAddr,
                     UINT8 *TSC,UINT8 *SrcAddr,UINT8 Group, UINT32 Prio);

#endif

void (*tkip_encryptFp)(UINT8 *buf, UINT8*, int len, UINT8 *key);
void tkip_encrypt(UINT8 *out_buf, UINT8* in_buf, int len, UINT8 *key) SECTION_ITCM;
WL_STATUS (*tkip_decryptFp)(UINT8 *data, int datalen, UINT8 *key);
WL_STATUS tkip_decrypt(UINT8 *data, int datalen, UINT8 *key) SECTION_ITCM;
WL_STATUS (*tkip_decrypt2Fp)(UINT8 *, UINT8 *, int datalen, UINT8 *key);
WL_STATUS tkip_decrypt2(UINT8 *data, UINT8 *, int datalen, UINT8 *key) SECTION_ITCM;
#ifdef AP_URPTR
void wep_encrypt(unsigned char *buf, int len);
#else
extern void wep_encrypt(unsigned char *buf, int len) __attribute__ ((section (".itcmbuf")));
#endif
//UINT32 Decrypt(rx80211_Frame_t *Src, rx80211_Frame_t *Dst, UINT32 Len);
extern inline UINT32 DoTKIPDecrypt_BChip(UINT8 *des, UINT8 *src, UINT32 len, UINT8 *key);
extern UINT32 DecryptDefrag_BChip(rx80211_Frame_t *Src, rx80211_Frame_t *Dst, UINT32 Len);
#ifdef B0_CHIP
extern UINT32 Decrypt_BChip(rx80211_Frame_t *Src, rx80211_Frame_t *Dst,UINT32 Len);
#endif
extern void DoEncrypt_BChip(UINT32 des, UINT32 src, UINT32 len);
extern UINT8 DoHWTkipDecrypt(UINT32 Dst,UINT32 Src,UINT32 Len,UINT8 *pEncrKey,UINT8 *pRxMICKey,	UINT8 * SrcAddr,UINT8 *DesAddr,UINT8 *TSC,UINT8 fragment, UINT32);
extern UINT16 g_Phase1Key[];
extern void DoEncrypt_BChip(UINT32 des, UINT32 src, UINT32 len);
extern void DoTKIPEncrypt_BChip(UINT8 *des, UINT8 *src, UINT32 len, UINT8 *key);
extern inline void InsertCCMPHdr(UINT8 *pCCMPHdr,  UINT8 keyID, UINT16 IV16, UINT32 IV32);
extern inline void DoCCMPEncrypt(IEEEtypes_Frame_t *pRxPckt,
                          UINT16 data_length, UINT32 *pKey,
                          UINT8 *pSrc,UINT32 Priority,UINT8 AADOffset);

#ifdef SELF_CTS
void crc32forCts(unsigned char *buf, int len);
#endif



#endif
