/*******************************************************************************************
*
* File: mlmeSta.h
*
*        Client Station MLME Module Header
*        Copy Right(2003) Marvell Semiconductors, Inc.
*
*                                                                          
* Author(s):    Binh Tran
* Date:         2004-05-6
* Description:  Implementation of the STA MLME Module Services
*
*******************************************************************************************/

#ifndef WLVMAC_MLME
#define WLVMAC_MLME

/* Maximum number of virtual mac instances */
#define MAX_VMAC_INSTANCE	8


/* Definition of virtual mac id */
typedef SINT8	vmacId_t;

/* Definition of virtual mac entry for each instance */
typedef struct vmacEntry_t
{
	UINT8				active;
	IEEEtypes_MacAddr_t	vmacAddr;
	vmacId_t  			id;  	
	SINT8 				(*mlmeMsgEvt)(UINT8 *data0, UINT8 *data1, UINT8 *info);
	SINT8 				(*dot11MsgEvt)(UINT8 *data0, UINT8 *data1, UINT8 *info);
	UINT8				*info_p;	//can point to either vmacStaInfo_t or vmacApInfo_t
}vmacEntry_t;


/* Extern */
extern vmacEntry_t *vmacTable_p[MAX_VMAC_INSTANCE];

#endif /* WLVMAC_MLME */





