/*
 * Mrvap.c -- Page handler for AP configuration 
 *
 */
/*********************************** Includes *********************************/
#include  "wltypes.h"
#include "oem.h"
#include	"wsIntrn.h"
#ifdef UEMF
    #include	"uemf.h"
#else
    #include	"../basic/basicInternal.h"
#endif
#include "IEEE_types.h" 
#include  "Mrvap.h"
#include "mib.h"
#include "api.h" 
#include  "webs.h"
#include  "buildModes.h"
#include "apflash.h"

#ifdef DCS
#include "Timer.h"
#include "eth_debug.h"
#endif

#ifdef  VOIP_GUI
#include "hs_fwk_socket.h"
#include "hs_voip_sys.h"
#include "hs_voip_oam_if.h"
#include "hs_voip_oam_cli_if.h"
#include "voip_config.h"
#include "hs_voip_dsp_fwk_defines.h"
#include "hs_voip_dsp_fwk_memmgr.h"
#endif

#define websErrorMsg(x) "Error"

#define TEST_REG_RW

#ifdef TEST_REG_RW
unsigned char curReg = 0;
#endif /* TEST_REG_RW */
#ifdef IEEE80211H
UCHAR gSwitchChannel=0;
#endif

#ifdef AP_URPTR
extern UINT8  mib_urMode;
extern UINT8  mib_wbMode;
extern UINT8  mib_urSsid[33];
extern MIB_STA_CFG mib_StaCfg_ur;
#endif
UINT8 GUI_mib_ApMode;
BOOLEAN AP_Mode_Updated =FALSE;
extern void GetWanMac(unsigned char *mac);
extern void GetLanMac(unsigned char *mac);
extern void GetGwLanMac(unsigned char *mac);
extern void GetGwWanMac(unsigned char *mac);
extern void GetWlanMac(unsigned char *mac);
extern void SetWanMac(const unsigned char *mac);
extern void SetLanMac(const unsigned char *mac);
extern void SetGwLanMac(const unsigned char *mac);
extern void SetGwWanMac(const unsigned char *mac);
extern void SetWlanMac(const unsigned char *mac);

extern UINT8 needReboot;
    #define BOOSTER_OFF  0
    #define BOOSTER_ON   1
    #define BOOSTER_AUTO 2

extern int SetWpa(webs_t wp, char_t* query);
extern int ProcessUserData(char * DataFromUser, char * DataToWladrv, char * pTemp); 
#ifdef QOS_FEATURE
extern mib_QAPEDCATable_t mib_QAPEDCATable[4];
#endif
/************************************ Locals **********************************/
typedef struct
{                /* Struct for CGI tasks which have completed */
    webs_t  wp;                 /* pointer to session websRec */
    char_t  *stdIn;             /* file desc. for task's temp input fd */
    char_t  *stdOut;            /* file desc. for task's temp output fd */
    char_t  *cgiPath;           /* path to executable process file */
    char_t  **argp;             /* pointer to buf containing argv tokens */
    char_t  **envp;             /* pointer to array of environment strings */
    int     handle;             /* process handle of the task */
    long    fplacemark;         /* seek location for CGI output file */
} cgiRec;
static cgiRec   **cgiList;      /* hAlloc chain list of wp's to be closed */
static int      cgiMax;         /* Size of hAlloc list */

static UINT8 wpaMode=0;
static UINT8 wpa2MixedMode;
static UINT8 wpa2OnlyMode;
static char DataToWlandrv[DATA_SIZE_TO_WLADRV];
static char DataFromUser[DATA_SIZE_FROM_USER];

UINT8 wepClientType = 0;

#ifdef FLEXMODE_TEST
//int NavOffset=0;
//int FlexModeBeacon=0;
extern UINT8 AGinterval;
extern UINT32 AGintOffset;
#endif

#ifdef DCS
extern UINT8 BkgndScanActive;
extern UINT8 CHSwitchInProgress;
extern API_BGSCAN_BSS_ENTRY    bkgndScanBSSData[BGSCAN_ENTRY_MAX];
extern API_BGSCAN_CH_ENTRY     bkgndScanCHData[IEEEtypes_MAX_CHANNELS+IEEEtypes_MAX_CHANNELS_A];

API_CH_WEIGHT_ENTRY  CHWeightData[IEEEtypes_MAX_CHANNELS+IEEEtypes_MAX_CHANNELS_A];
UINT8   scanChannelList[IEEEtypes_MAX_CHANNELS+IEEEtypes_MAX_CHANNELS_A] =
         {1,2,3,4,5,6,7,8,9,10,11,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
static  UINT8 bestCH = 1;
static  UINT8 bgScanEnable;
static  UINT32 bgScanInterval;
static  UINT32 bgChannelScanTime;
static  UINT32 bgChannelsPerScan;
static  UINT8 bgScanType;
static  UINT8 bgEnableSelfCTS;

static Timer DCSTimer = {active: 0};
static Timer CHSwitchTimer = {active: 0};
static Timer BGScanTimer = {active: 0};

void DCSTimeOut(UINT8 *data);
void CHSwitchTimeout (UINT8 *data);
void BGScanStartTimeout (UINT8 *data);
#endif

/*
typedef unsigned  char UCHAR;
typedef unsigned short USHORT;
typedef unsigned long ULONG;
*/
/************************************* Code ***********************************/
#ifdef TEST_PAGE
DWORD Reg1A, Reg1B, Reg19, Reg21=0x12, Reg22=0x05, Reg26=0x33, Reg23=0x2D, Reg24=0x08;
#endif

/*
 *	Process a form request. Returns 1 always to indicate it handled the URL
 */

void dummy_Mrvap(void) {
}

/*************************************************************************
 *
 * FUNCTION     
 *
 * DESCRIPTION  
 *              ||inHexString|| = 2 *||outHexData||
 *              Len == ||outHexData||, be careful!
 *
 * INPUT        
 *
 * OUTPUT       
 *
 * RETURN       
 *
 * (CALLED BY)  
 *
 * HISTORY      JL  03-xx-2004 1.0      created
 *
 *************************************************************************/
void HexStringToHexDigi(char* outHexData, char* inHexString, USHORT Len)
{
    char    HexString[]="0123456789ABCDEF";
    UCHAR   i, HiNible, LoNible;

    for (i=0; i<Len; ++i)
    {
        HiNible = strchr(HexString, gtoupper(inHexString[2*i])) - HexString;
        LoNible = strchr(HexString, gtoupper(inHexString[2*i+1])) - HexString;
        outHexData[i] = (HiNible << 4) + LoNible;
    }           
}

/*Utility function to convert ascii to hexadecimal by Rahul*/
long atohex(char *number)
{
    long   n = 0, neg = 0;

    while (*number <= ' ' && *number > 0)
        ++number;
/*   if (*number == '-')
   {
      neg = 1;
      ++number;
   }
   else if (*number == '+')
      ++number;*/
    while ((*number>='0' && *number<='9') ||
           (*number>='A' && *number<='F') ||
           (*number>='a' && *number<='f'))
    {
        if (*number>='0' && *number<='9')
        {
            n = (n * 0x10) + ((*number++) - '0');
        }
        else if (*number>='A' && *number<='F')
        {
            n = (n * 0x10) + ((*number++) - 'A' + 10);
        }
        else/* if (*number>='a' && *number<='f')*/
        {
            n = (n * 0x10) + ((*number++) - 'a' + 10);
        }
    }
    //return (neg ? -n : n);
    return n;
}

/*Utility function to convert ascii to decimal integer*/
long atodec(char *number)
{
    long   n = 0, neg = 0;

    while (*number <= ' ' && *number > 0)
        ++number;

    while ((*number>='0' && *number<='9'))
    {
        if (*number>='0' && *number<='9')
        {
            n = (n * 10) + ((*number++) - '0');
        }
    }
    return n;
}


int websMrvHandler(webs_t wp, char_t *urlPrefix, char_t *webDir, int arg, 
                   char_t *url, char_t *path, char_t* query)
{
    int errorNum;

    if (websValidateUrl(wp, path)<0)
    {
        websError(wp, 500, T("Invalid URL %s"), url);
        return 1;
    }

    if (strstr(path, ".gif") || strstr(path, ".asp") || strstr(path, ".js"))
    {
        websDefaultHandler(wp, urlPrefix, webDir, arg, url, path, query);
    }
#ifndef MAIN_PAGE_EVALTOOL
    else if (!strcmp(path, "/index.htm"))
    {
#ifdef AP_URPTR
        websRedirect(wp, T("radio_ur.asp"));
#else
#if defined(FALCON) || defined(PEREGRINE)
        websRedirect(wp, T("radio_g.asp"));
#else  
        websRedirect(wp, T("radio.asp"));
#endif
#endif
    }
#endif
    else if (!strcmp(path, "/SetRadio.htm"))
    {
        errorNum = SetRadio(wp, query);
        Radio(wp, errorNum);
        //websRedirect(wp, T("radio.asp")); 
    }
    else if (!strcmp(path, "/SetWep.htm"))
    {
        //errorNum = SetWep(wp, query);
        errorNum = SetSecurity(wp, query);
        //Wep(wp, errorNum);
        securityConfig(wp, errorNum);

    }
    else if (!strcmp(path, "/wpa.htm"))
    {
        //wpaConfig(wp, 0);
        websRedirect(wp, T("wpa.asp"));
    }
    else if (!strcmp(path, "/SetWpa.htm"))
    {
        errorNum = SetWpa(wp, query); 
        wpaConfig(wp, errorNum);
    }
    else if (!strcmp(path, "/SetBridge.htm"))
    {
        SetBridge(wp, query);
        websRedirect(wp, T("bridge.asp")); 
    }
    else if (!strcmp(path, "/SetIpConfig.htm"))
    {
        errorNum = webSetIpConfig(wp, query);
        if (errorNum == 0)
        {
            asp_show_error_message(wp, "You Have Entered Invalid Data!", "IpConfig.asp");
        }
        else
        {
            UCHAR tmpBuf[16];
            char tmpStrBuf[50];

            SetUserConfig();
            //websRedirect(wp, T("IpConfig.asp"));
            {
                cyg_thread_delay(1000); /* wait 10 seconds for DHCP operation */
                if ( ApCmdGetProc(APCMD_GET_ETH_IP_CONFIG, (char *)tmpBuf) != STATUS_FAIL )
                {
#ifdef AP_URPTR
                    if(mib_urMode)
                    {
                        sprintf(tmpStrBuf,"http://%d.%d.%d.%d/reboot.asp\0",
                        tmpBuf[4],tmpBuf[5],tmpBuf[6],tmpBuf[7]);
                        websRedirect(wp, T(tmpStrBuf));
                    }
                    else
                    {
                        sprintf(tmpStrBuf,"http://%d.%d.%d.%d/confirm.asp\0",
                            tmpBuf[4],tmpBuf[5],tmpBuf[6],tmpBuf[7]);
                        websRedirect(wp, T(tmpStrBuf));
                    }
#else
                    sprintf(tmpStrBuf,"http://%d.%d.%d.%d/confirm.asp\0",
                        tmpBuf[4],tmpBuf[5],tmpBuf[6],tmpBuf[7]);
                    websRedirect(wp, T(tmpStrBuf));
#endif
                }
            }
            //websRedirect(wp, T("reboot.asp"));
        }
    }
    else if (!strcmp(path, "/SetFilterList.htm"))
    {
       if(webSetFilterTable(wp, query) == 1)
       {
           SetUserConfig(); 
           websRedirect(wp, T("filter_list.asp"));  
       }
    }
#ifdef WDS_FEATURE
    else if (!strcmp(path, "/wds.htm"))
    {
        webSetWds(wp, query);
        /*websRedirect(wp, T("reboot.asp"));*/
        apRebooting(wp, "/wds.asp");
    }
#endif
#ifdef QOS_FEATURE
    else if (!strcmp(path, "/qos.htm"))
    {
        SetQos(wp, query);
        websRedirect(wp, T("qos.asp")); 
    }
    else if (!strcmp(path, "/qos_tspec.htm"))
    {
        SetQosTspec(wp, query);
        websRedirect(wp, T("qos.asp")); 
    }
    else if (!strcmp(path, "/stn_qos.htm"))
    {
        SetQosTspec(wp, query);
        websRedirect(wp, T("qos.asp")); 
    }
#endif
#if defined(GATEWAY) || defined(DHCPS)
    else if (!strcmp(path, "/SetDhcpGlobal.htm"))
    {
        errorNum = webSetDHCPSConfig(wp, query,"DhcpGlobal");
        if (errorNum == 0)
        {
            asp_show_error_message(wp, "You Have Entered Invalid Data!", "DhcpGlobal.asp");
        }
        else
        {
            SetUserConfig();
            websRedirect(wp, T("DhcpGlobal.asp"));
        }
    }

        else if (!strcmp(path, "/SetDhcpClientList.htm"))
    {
        errorNum = webSetDHCPSConfig(wp, query, "DhcpClientList");
        if (errorNum == 0)
        {
            asp_show_error_message(wp, "You Have Entered Invalid Data!", "DhcpClientList.asp");
        }
        else
        {
            SetUserConfig();
            websRedirect(wp, T("DhcpClientList.asp"));
        }
    }
#endif

#if defined(GATEWAY)
    else if (!strcmp(path, "/SetLanIpConfig.htm"))
    {
       errorNum = webSetLanIpConfig(wp, query);
       if (errorNum == 0)
       {
            asp_show_error_message(wp, "You Have Entered Invalid Data!", "DhcpSev.asp");
       }

       else
       {
            SetUserConfig();
            websRedirect(wp, T("reboot.asp"));
        //    websRedirect(wp, T("LanIpConfig.asp"));
       }
    }

    else if (!strcmp(path, "/SetWanIpConfig.htm"))
    {
       errorNum = webSetWanIpConfig(wp, query);
       if (errorNum == 0)
       {
            asp_show_error_message(wp, "You Have Entered Invalid Data!", "WanIpConfig.asp");
       }
       else
       {
           SetUserConfig();
           websRedirect(wp, T("WanIpConfig.asp"));
       }
    }
 #endif

#if 0 //bt_test:: upload
    else if (!strcmp(path, "/fw_upgrade.htm"))
    {
        fwUpload(wp);
    }
#endif	
    else if (!strcmp(path, "/Reboot.htm"))
    {
        apRebooting(wp, "/index.htm");
    }
    else if (!strcmp(path, "/reset.htm"))
    {
        ResetToFactorySettings();
        apRebooting(wp, "/index.htm");
    }
#ifdef AUTOLINK
    else if (!strcmp(path, "/autolinkon.htm"))
    {
    	AutoLinkInit();
        websRedirect(wp, T("wep.asp"));
    }
#endif

#ifdef TEST_REG_RW
    else if (!strcmp(path, "/SetReg.htm"))
    {
        SetReg(wp, query);
        regSetting(wp);
    }
    else if (!strcmp(path, "/RegSetting.htm"))
    {
        regSetting(wp);
    }
#endif /* TEST_REG_RW */
#ifdef AP_SITE_SURVEY
    else if (!strcmp(path, "/SetSurvey.htm"))
    {
        if (SetSurvey(wp, query))
        {
            {
                char    chData;
                chData = 1;
                SetUserConfig();
                ApCmdSetProc(APCMD_BSS_START, &chData); 
            }
            websRedirect(wp, T("confirm.asp")); 
        }
        else
        {
            websRedirect(wp, T("sys_survey.asp")); 
        }
    }
#endif /* AP_SITE_SURVEY */
#ifdef FLEXMODE_TEST
    else if (!strcmp(path, "/SetFlexMode.htm"))
    {
        char_t * pValue;
        int nData;
        
        pValue = websGetVar(wp, "nav_offset", T(""));
        if (*pValue){
            AGintOffset = atoi(pValue);
        }
        pValue = websGetVar(wp, "flex_mode_beacon", T(""));
        if (*pValue){
            AGinterval = atoi(pValue);
        }

        {
            char tmpChData = 1;
            ApCmdSetProc(APCMD_BSS_START, &tmpChData); 
        }

        websRedirect(wp, T("flexmode.asp"));
    }
#endif /* FLEXMODE_TEST */
#ifdef IEEE80211H
    else if (!strcmp(path, "/Set802doc11h.htm"))
    {
        UCHAR cData = 0;
        UCHAR cData_old = 0;
        ULONG nData = 0;
        ULONG nData_old = 0;
        ULONG rData = 0;
        ULONG rData_old = 0;
        char_t * pValue;
        BOOLEAN restart = FALSE;
        
        pValue = websGetVar(wp, "SPECTRUM_MGMT", T(""));
        if (*pValue){
            ApCmdGetProc(APCMD_GET_SPECTRUM_MGMT, &cData_old);
            cData=atoi(pValue);
            ApCmdSetProc(APCMD_SET_SPECTRUM_MGMT, &cData);
            restart = (cData_old != cData)?TRUE:FALSE;
        }

        pValue = websGetVar(wp, "MITIGATION", T(""));
        if (*pValue){            
            ApCmdGetProc(APCMD_GET_MITIGATION, (char *)&nData_old);
            nData=(ULONG)atoi(pValue);
            ApCmdSetProc(APCMD_SET_MITIGATION, (char *)&nData);            
            restart |= (nData_old != nData)?TRUE:FALSE;            
        }

        pValue = websGetVar(wp, "REGULATORY_DOMAIN", T(""));
        if (*pValue){
            char **endPtr;
            
            ApCmdGetProc(APCMD_GET_REGULATORY_DOMAIN, (char *)&rData_old);
            rData=(ULONG)strtoul(pValue, endPtr, 16);            
            ApCmdSetProc(APCMD_SET_REGULATORY_DOMAIN, (char *)&rData);            
            restart |= (rData_old != rData)?TRUE:FALSE;            
        }
        
        /* do we have to restart */
        if (restart)
        {            
            char tmpChData = 1;            
            ApCmdSetProc(APCMD_BSS_START, &tmpChData); 
        } 
        else
        {                    
            pValue = websGetVar(wp, "CHANNEL_ANNOUNCEMENT", T(""));
            
            if (*pValue)
            {
                UINT8 *tokenptr;

                tokenptr = strtok(pValue," ");	/* get the first token */
                if (tokenptr != NULL)                   
                   tokenptr = strtok(NULL," ");	/* get next token */
                
                //etherBugSend("channel : %s\n\r", tokenptr);
                if (tokenptr != NULL)
                {
                    cData=atoi(tokenptr);
                    //etherBugSend("channel : %d\n\r", cData);
                    gSwitchChannel=cData;
                    ApCmdSetProc(APCMD_SEND_SWITCH_CHANNEL_ANNOUNCEMENT, &cData);
                }                
            }             
        }
	 SetUserConfig();
        websRedirect(wp, T("ieee80211h.asp"));
    }
#endif
#ifdef DCS
    else if (!strcmp(path, "/bgscan.htm"))
    {
        errorNum = SetBGScan(wp, query);
        if (errorNum == AP_NEEDS_REBOOT)
        {
            SetUserConfig();
            websRedirect(wp, T("reboot.asp"));
        }
        else if (errorNum == SUCCESS)
        {
            websRedirect(wp, T("dcs.asp")); 
        }
        else
        {
#if defined(FALCON) || defined(PEREGRINE)
        websRedirect(wp, T("radio_g.asp"));
#else  
        websRedirect(wp, T("radio.asp"));
#endif
        }
    }
#endif /* DCS */
#ifdef VOIP_GUI
	else if (!strcmp(path, "/SetSip.htm"))
	{
		if ( strstr(query, "Apply") )
		{
			SetSip(wp, query);
	        VOIP_config_set(&hs_voip_cm_params_g);
	        websRedirect(wp, T("reboot.asp"));
		}
		else if ( strstr(query, "Default") )
		{
			// Get default values for configurable parameters
			VOIP_params_defaultCfg(&hs_voip_cm_params_g);
			// Get default values for non-configurable parameters from source code.
			VOIP_params_defaultSrcCode(&hs_voip_cm_params_g);
			websRedirect(wp, T("sip.asp"));
		}
		else	// "Cancel"
		{
			websRedirect(wp, T("sip.asp"));
		}
	}
#endif
    else
    {
        /*websRfTestHandler(wp, urlPrefix, webDir, arg, url, path, query); */
    }

    return 1;
} 

int getMacFromString(unsigned char *macAddr, const char *pStr) {
    int nAddr = 0;
    char * endofstr;

    memset(macAddr, 0, 6);

    
    if (((UINT32)endofstr = strlen(pStr)) > 0)
    {
        (UINT32)endofstr += (UINT32)pStr;
        while ((UINT32)pStr < (UINT32)endofstr)
        {
            if (*pStr=='%' && *(pStr+1)=='3' && (*(pStr+2)=='A' || *(pStr+2)=='a'))
            {
                pStr = pStr+3;
                continue;
            }

            if (*pStr>='A' && *pStr<='F')
            {
                macAddr[nAddr] = *pStr - 'A' + 10;
            }
            else if (*pStr>='a' && *pStr<='f')
            {
                macAddr[nAddr] = *pStr - 'a' + 10;
            }
            else if (*pStr>='0' && *pStr<='9')
            {
                macAddr[nAddr] = *pStr - '0';
            }
            else
            {
                return 0;
            }

            pStr++;

            if (*pStr>='A' && *pStr<='F')
            {
                macAddr[nAddr] = (macAddr[nAddr] << 4) | (*pStr - 'A' + 10);
            }
            else if (*pStr>='a' && *pStr<='f')
            {
                macAddr[nAddr] = (macAddr[nAddr] << 4) | (*pStr - 'a' + 10);
            }
            else if (*pStr>='0' && *pStr<='9')
            {
                macAddr[nAddr] = (macAddr[nAddr] << 4) | (*pStr - '0');
            }
            else
            {
                return 0;
            }

            pStr++;
            nAddr++;
        }

        if(nAddr != 6)
        {
            return 0; /* the length of MAC address isn't valid */
        }
    }
    else
    {
        return 0; /* Null MAC address */
    }

    return 1;
}

int SetRadio(webs_t wp, char_t* query)
{

    char    *pTemp, *pCur, *tmp; 
    int     i;
    char    chData;
    char    bufData[600];
    BOOLEAN SSID_Updated_WPA_Enable;
    USHORT nData;
    ULONG lData;
    UCHAR BurstRate;
    UCHAR   AP_Mode, ucData;
    BURST_INFO BurstInfo;
    UCHAR bRate;
    UCHAR gRate;
    UCHAR MacAddr[6], voidAddr[6];
#ifdef AP_URPTR
    UCHAR ur_ModeChange_Reset = 0;
#endif

    if (query == NULL || strlen(query)==0)
    {
        return 0;
    }
    SSID_Updated_WPA_Enable=FALSE; 

    tmp = malloc(512);

    pCur = strstr(query, "SSID");

    if (pCur != NULL)
    {
        strcpy(tmp, pCur);

        /* Set SSID */
        if ((pTemp = strchr(tmp, '&'))!=NULL)
        {
            *pTemp = '\0';
        }

        if ( (pTemp = strchr(tmp, '='))!=NULL)
        {
            pTemp++; 

            ProcessUserData(DataFromUser, DataToWlandrv, pTemp);         
            if ( (strlen(DataToWlandrv) >32) )
                return SSID_SIZE_ERROR;
            memset(bufData, 0, 50);
            ApCmdGetProc(APCMD_GET_SSID, bufData);      
            if (strcmp(bufData, DataToWlandrv) != 0)
            {
                //
                //SSID updated
                //				
                if (ApCmdGetProc(APCMD_GET_PRIVACY_TBL_RSN_ENABLED, &chData) == STATUS_FAIL)
                {
                    //
                    //If failed, just assume WPA is enabled
                    //
                    SSID_Updated_WPA_Enable=TRUE;
                }
                else
                {
                    if (chData ==1)
                        SSID_Updated_WPA_Enable=TRUE;
                    else
                        SSID_Updated_WPA_Enable=FALSE;                                              
                }


            }
            ApCmdSetProc(APCMD_SET_SSID, DataToWlandrv); 
        }
    }
    pCur = strstr(query, "SSID2");

    if (pCur != NULL)
    {
        strcpy(tmp, pCur);

        // Set SSID
        if ((pTemp = strchr(tmp, '&'))!=NULL)
        {
            *pTemp = '\0';
        }

        if ( (pTemp = strchr(tmp, '='))!=NULL)
        {
            pTemp++; 

            ProcessUserData(DataFromUser, DataToWlandrv, pTemp);         
            if ( (strlen(DataToWlandrv) >32) )
                return SSID_SIZE_ERROR;
            memset(bufData, 0, 50);                         
            ApCmdGetProc(APCMD_GET_SSID, bufData);      
            if (strcmp(bufData, DataToWlandrv) != 0)
            {
                //
                //SSID updated
                //				
                if (ApCmdGetProc(APCMD_GET_PRIVACY_TBL_RSN_ENABLED, &chData) == STATUS_FAIL)
                {
                    //
                    //If failed, just assume WPA is enabled
                    //
                    SSID_Updated_WPA_Enable=TRUE;
                }
                else
                {
                    if (chData ==1)
                        SSID_Updated_WPA_Enable=TRUE;
                    else
                        SSID_Updated_WPA_Enable=FALSE;                                              
                }
                ApCmdSetProc(APCMD_SET_SSID2, DataToWlandrv);               
            }
        }
    }

    pCur = websGetVar(wp, "WDS_UR_MODE_set", T(""));
    if(*pCur)
    {
        APICMDBUF_SET_UREPEATER cmdBuf;        
        cmdBuf.seqNum = 1;
        cmdBuf.cmdCode = APCMD_SET_UREPEATER;
        cmdBuf.cmdBodyLen = sizeof(APICMDBUF_SET_UREPEATER) - 4*sizeof(unsigned short);
        strcpy(tmp, pCur);
#ifdef AP_URPTR
        if (strstr(tmp, "UR Mode")!=NULL)
        {
            cmdBuf.urMode = 1;
            cmdBuf.wbMode = 0;
        }
        else if (strstr(tmp, "WB Mode")!=NULL)
        {
            cmdBuf.urMode = 1;
            cmdBuf.wbMode = 1;
        }
        else if (strstr(tmp, "AP Mode")!=NULL)
        {
            cmdBuf.urMode = 0;
            cmdBuf.wbMode = 0;
        }
        else
        {
            cmdBuf.urMode = 0;
            cmdBuf.wbMode = 0;
        }
        /* If urMode changes then reset. */
        if ((cmdBuf.urMode != mib_urMode) || 
			(cmdBuf.wbMode != mib_wbMode))
        {
            ur_ModeChange_Reset = 1;
        }

        pCur = websGetVar(wp, "WDS_SSID_set", T(""));
        if(*pCur) 
        {
            memcpy(cmdBuf.urSsid, pCur, 32);
        }
        else
            cmdBuf.urSsid[0] = '\0';
        pCur = websGetVar(wp, "WDS_BSSID_set", T(""));
        if(pCur){
            getBssIdFromString(MacAddr, pCur);
            memcpy(cmdBuf.urBssid, MacAddr, 6);
        }else{
            memcpy(cmdBuf.urBssid, voidAddr, 6);
        }
        pCur = websGetVar(wp, "WDS_UR_PREF_BSSID_set", T(""));
        if(pCur)
        {
            strcpy(tmp, pCur);
            if (strstr(tmp, "Enable")!=NULL)
            {
                cmdBuf.urPrefBssid = 1;
            }
            else
            {
                cmdBuf.urPrefBssid = 0;
                /* If preferred Bssid is disabled set Bssid to 0. */
                memset(cmdBuf.urBssid, 0x00, 6);
            }
        }
        apctl((APICMDBUF *)&cmdBuf);
#else
        cmdBuf.urMode = 0;
        cmdBuf.urSsid[0] = "\n";
        for (i=0; i<6; i++) cmdBuf.urBssid[i] = 0; 
#endif
    }

#if defined(WIPOD)
    /* Set WiPod Mode */
    pCur = strstr(query, "wipod_mode");
	if (pCur != NULL)
	{
		strcpy(tmp, pCur);  	
		if ((pTemp = strchr(tmp, '&'))!=NULL) {
			*pTemp = '\0';
		}
		if ( (pTemp = strchr(tmp, '='))!=NULL) {
			pTemp++; 
			memset(bufData, 0, 50);
			strcpy(bufData, pTemp);
	
		  	for (i=0; i<(int)strlen(bufData);i++) {
				if (bufData[i]=='+') {
					bufData[i] = ' ';
				}
			}
            nData = atoi(bufData)? WIPOD_MODE_CLIENT_BRIDGE:WIPOD_MODE_AP;
            ApCmdSetProc(APCMD_SET_WIPOD_MODE, &nData);
		}
	}
#endif /* WIPOD */
    /* Set Broadcast SSID option */
    pCur = strstr(query, "Broadcast");

    chData = (pCur!=NULL)?TRUE:FALSE;

    ApCmdSetProc(APCMD_SET_OPEN_SSID_EN_STATE, &chData);  

#ifdef TURBO_SETUP
    pCur = strstr(query, "AutoLink");

    chData = (pCur!=NULL)?TRUE:FALSE;
    if(chData == TRUE)
    {
        chData = 1;
    }
    else
    {
        chData = 4;
    }

    ApCmdSetProc(APCMD_SET_AUTO_LINK_MODE, &chData);  
#endif    
#if 1 //Set rate for b

    // Set B Rates
    pCur = strstr(query, "rate_b");

    if (pCur!=NULL)
    {
        strcpy(tmp, pCur);
        if ((pTemp = strchr(tmp, '&'))!=NULL)
        {
            *pTemp = '\0';  
        }

        if ((pTemp = strchr(tmp, '='))!=NULL)
        {
            i = 1;
            nData = 0;
            while (*(pTemp+i)!='+' && *(pTemp+i)!='.')
            {
                nData = nData*10 + *(pTemp+i) - '0';
                i++;
            }
            if (i > 4)
            {
                nData = 0;
            }
            else if (nData == 5)
            {
                nData = 11;
            }
            else
            {
                nData = nData * 2;
            }

            //eprintf("set rate_b = %d \n", nData);   
            {
                APICMDBUF_SET_TX_DATA_RATE apicmdbuf_get_tx_data_rate;

                apicmdbuf_get_tx_data_rate.cmdCode = APCMD_SET_TX_DATA_RATE;
                apicmdbuf_get_tx_data_rate.seqNum = 1;
                apicmdbuf_get_tx_data_rate.cmdBodyLen = 1;
                apicmdbuf_get_tx_data_rate.txDataRate = nData;
                apctl(&apicmdbuf_get_tx_data_rate);

            }

        }
    }

    // Set G Rates
    pCur = strstr(query, "rate_g");

    if (pCur!=NULL)
    {
        strcpy(tmp, pCur);
        if ((pTemp = strchr(tmp, '&'))!=NULL)
        {
            *pTemp = '\0';  
        }
        if ((pTemp = strchr(tmp, '='))!=NULL)
        {
            i = 1;
            nData = 0;
            while (*(pTemp+i)!='+' && *(pTemp+i)!='.')
            {
                nData = nData*10 + *(pTemp+i) - '0';
                i++;
            }
            if (i > 4)
            {
                nData = 0;
            }
            else if (nData == 5)
            {
                nData = 11;
            }
            else
            {
                nData = nData * 2;
            }
            //eprintf("set rate_g = %d \n", nData);
            {
                APICMDBUF_SET_TX_DATA_RATE_G apicmdbuf_get_tx_data_rate_g;

                apicmdbuf_get_tx_data_rate_g.cmdCode = APCMD_SET_TX_DATA_RATE_G;
                apicmdbuf_get_tx_data_rate_g.seqNum = 1;
                apicmdbuf_get_tx_data_rate_g.cmdBodyLen = 1;
                apicmdbuf_get_tx_data_rate_g.txDataRate = nData;
                apctl(&apicmdbuf_get_tx_data_rate_g);

            }
        }
    }
#endif//Set B G Rates

    // Set A Rates
    pCur = strstr(query, "rate_a");

    if (pCur!=NULL)
    {
        strcpy(tmp, pCur);
        if ((pTemp = strchr(tmp, '&'))!=NULL)
        {
            *pTemp = '\0';  
        }
        if ((pTemp = strchr(tmp, '='))!=NULL)
        {
            i = 1;
            nData = 0;
            while (*(pTemp+i)!='+' && *(pTemp+i)!='.')
            {
                nData = nData*10 + *(pTemp+i) - '0';
                i++;
            }
            if (i > 4)
            {
                nData = 0;
            }
            else if (nData == 5)
            {
                nData = 11;
            }
            else
            {
                nData = nData * 2;
            }
            ApCmdSetProc(APCMD_SET_TX_DATA_RATE_A, &nData);
        }
    }
    /* Set Tx Power Level */
    pCur = strstr(query, "TxPower");

    if (pCur!=NULL)
    {
        strcpy(tmp, pCur);

        if ((pTemp = strchr(tmp, '&'))!=NULL)
        {
            *pTemp = '\0';  
        }

        /*sscanf(tmp, "TxPower=%d+mW", &i); */

        if ((pTemp = strchr(tmp, '='))!=NULL)
        {
            i = 1;
            nData = 0;

            while (*(pTemp+i)!='+')
            {
                nData = nData*10 + *(pTemp+i) - '0';
                i++;
            }

            ApCmdSetProc(APCMD_SET_TX_POWER_LEVEL, &nData); 

        }
    }

    // Set the Antenna Diversity Mode (SAD Algo)
    pCur = strstr(query, "Ant_mode");

    if (pCur!=NULL)
    {
        strcpy(tmp, pCur);

        if ((pTemp = strchr(tmp, '&'))!=NULL)
        {
            *pTemp = '\0';  
        }

        nData = AP_BOTH_ANTENNA;

        if (strstr(tmp, "Ant+0+only")!=NULL)
        {
            nData = (nData<<8) | AP_ANT_A;
        }
        else if (strstr(tmp, "Ant+1+only")!=NULL)
        {
            nData = (nData<<8) | AP_ANT_B;

        }
        else //if (strstr(tmp, "Both")!=NULL) 
        {
            nData = (nData<<8) | AP_ANT_DIVERSITY;
        }

        ApCmdSetProc(APCMD_SET_ANTENNA_MODE, &nData);  
    }

    /* Set Tx Antenna */
    pCur = strstr(query, "TxAntenna");

    if (pCur!=NULL)
    {
        strcpy(tmp, pCur);

        if ((pTemp = strchr(tmp, '&'))!=NULL)
        {
            *pTemp = '\0';  
        }

        nData = AP_TX_ANTENNA;

        if (strstr(tmp, "Antenna+0")!=NULL)
        {
            nData = (nData<<8) | AP_ANT_A;
        }
        else if (strstr(tmp, "Antenna+1")!=NULL)
        {
            nData = (nData<<8) | AP_ANT_B;
        }
        else /*if (strstr(tmp, "Both")!=NULL) */
        {
            nData = (nData<<8) | AP_ANT_DIVERSITY;
        }

        ApCmdSetProc(APCMD_SET_ANTENNA_MODE, &nData);  
    }

    /* Set Rx Antenna */
    pCur = strstr(query, "RxAntenna");

    if (pCur!=NULL)
    {
        strcpy(tmp, pCur);

        if ((pTemp = strchr(tmp, '&'))!=NULL)
        {
            *pTemp = '\0';  
        }

        nData = AP_RX_ANTENNA;

        if (strstr(tmp, "Antenna+0")!=NULL)
        {
            nData = (nData<<8) | AP_ANT_A;
        }
        else if (strstr(tmp, "Antenna+1")!=NULL)
        {
            nData = (nData<<8) | AP_ANT_B;
        }
        else /*	if (strstr(tmp, "Both")!=NULL) */
        {
            nData = (nData<<8) | AP_ANT_DIVERSITY;
        }

        ApCmdSetProc(APCMD_SET_ANTENNA_MODE, &nData);  
    }

#ifdef BURST_MODE
    //set burst rate
    pCur = strstr(query, "burst_rate"); 

    if (pCur!=NULL)
    {
        strcpy(tmp, pCur);

        if ((pTemp = strchr(tmp, '&'))!=NULL)
        {
            *pTemp = '\0';  
        }

        if ((pTemp = strchr(tmp, '='))!=NULL)
        {
            i = 1;
            BurstRate = 0;

            while (*(pTemp+i)!='\0')
            {
                BurstRate = BurstRate*10 + *(pTemp+i) - '0';
                i++;
            }

        }
        if ( ( BurstRate < 8) || (BurstRate > 16) )
        {
            return BURST_RATE_RANGE_ERROR;
        }
        BurstInfo.BurstRate=BurstRate;
    }

    //set burst mode
    pCur = strstr(query, "burst_mode"); 

    if (pCur!=NULL)
    {
        strcpy(tmp, pCur);

        if ((pTemp = strchr(tmp, '&'))!=NULL)
        {
            *pTemp = '\0';  
        }

        if (strstr(tmp, "Disable")!=NULL)
        {
            BurstInfo.BurstMode= 0;
        }
        else if (strstr(tmp, "Enable")!=NULL)
        {
            BurstInfo.BurstMode = 1;
        }
        ApCmdSetProc(APCMD_SET_BURST_MODE, &BurstInfo);  
    }
#endif
    // Set AP Mode
    pCur = strstr(query, "AP_mode"); 

    AP_Mode_Updated = FALSE;
    if (pCur!=NULL)
    {
        strcpy(tmp, pCur);

        if ((pTemp = strchr(tmp, '&'))!=NULL)
        {
            *pTemp = '\0';  
        }

        if (strstr(tmp, "B+only")!=NULL)
        {
            nData = AP_MODE_B_ONLY;
        }
        else if (strstr(tmp, "G+only")!=NULL)
        {
            nData = AP_MODE_G_ONLY;
        }
        else if (strstr(tmp, "BG+mixed")!=NULL)
        {
            nData = AP_MODE_MIXED;
        }
        else if (strstr(tmp, "A+only")!=NULL)
        {
            nData = AP_MODE_A_ONLY;
        }
        else if (strstr(tmp, "AG+mixed")!=NULL)
        {
            nData = AP_MODE_AandG;
        }


        if (ApCmdGetProc(APCMD_SET_AP_MODE, (char *)&nData) == STATUS_FAIL)
        {
            //
            //If failed, just assume AP_Mode_Updated=TRUE;
            //
            AP_Mode_Updated=TRUE;
            GUI_mib_ApMode = (UINT8)nData;
        }
        else
        {
            if (AP_Mode != (UINT8)nData)
            {
                AP_Mode_Updated=TRUE;
                GUI_mib_ApMode = (UINT8)nData;
            }

        }
        if (AP_Mode_Updated == TRUE)
        {
            ApCmdSetProc(APCMD_SET_AP_MODE, (char *)&nData);
            
            if (nData != AP_MODE_AandG)
                wepClientType = 0;

            if (nData == AP_MODE_G_ONLY)
            {
                bufData[ 0] =  2 | 0x80;
                bufData[ 1] =  4 | 0x80;
                bufData[ 2] = 11 | 0x80;
                bufData[ 3] = 22 | 0x80;
                bufData[ 4] = 12 | 0x80;
                bufData[ 5] = 18;
                bufData[ 6] = 24 | 0x80;
                bufData[ 7] = 36;
                bufData[ 8] = 48 | 0x80;
                bufData[ 9] = 72;
                bufData[10] = 96;
                bufData[11] = 108;
                bufData[12] = 0;
                bufData[13] = 0;                
                bufData[14] = 0;
                bufData[15] = 0;                
            }
            else if ((nData == AP_MODE_A_ONLY) || (nData == AP_MODE_AandG))
            {
                bufData[0]  = 12 | 0x80;
                bufData[1]  = 18;
                bufData[2]  = 24 | 0x80;
                bufData[3]  = 36;
                bufData[4]  = 48 | 0x80;
                bufData[5]  = 72;
                bufData[6]  = 96;
                bufData[7]  = 108;
                bufData[8]  = 144;
                bufData[9]  = 0;
                bufData[10] = 0;
                bufData[11] = 0;
                bufData[12] = 0;
                bufData[13] = 0;
                bufData[14] = 0;
                bufData[15] = 0;
            }
            else if (nData == AP_MODE_MIXED)
            {
                bufData[ 0] =  2 | 0x80;
                bufData[ 1] =  4 | 0x80;
                bufData[ 2] = 11 | 0x80;
                bufData[ 3] = 22 | 0x80;
                bufData[ 4] = 12;
                bufData[ 5] = 18;
                bufData[ 6] = 24;
                bufData[ 7] = 36;
                bufData[ 8] = 48;
                bufData[ 9] = 72;
                bufData[10] = 96;
                bufData[11] = 108;
                bufData[12] = 0;
                bufData[13] = 0;  
                bufData[14] = 0;
                bufData[15] = 0;                
            }
            else if (nData == AP_MODE_B_ONLY)
            {
                bufData[ 0] =  2 | 0x80;
                bufData[ 1] =  4 | 0x80;
                bufData[ 2] = 11 | 0x80;
                bufData[ 3] = 22 | 0x80;
                bufData[ 4] = 0;
                bufData[ 5] = 0;
                bufData[ 6] = 0;
                bufData[ 7] = 0;
                bufData[ 8] = 0;
                bufData[ 9] = 0;
                bufData[10] = 0;
                bufData[11] = 0;
                bufData[12] = 0;
                bufData[13] = 0;  
                bufData[14] = 0;
                bufData[15] = 0;                
            }

        }
        ApCmdSetProc(APCMD_SET_BASIC_DATA_RATES_G, bufData);

    }
    /* Set Channel */
    pCur = strstr(query, "Channel");

    if (pCur!=NULL)
    {
        strcpy(tmp, pCur);

        if ((pTemp = strchr(tmp, '&'))!=NULL)
        {
            *pTemp = '\0';  
        }
#ifdef AUTOCHANNEL
		{
			char *pCurTmp;
    		pCurTmp = strstr(tmp, "Auto");
			if(pCurTmp!=NULL)
			{
            	nData = 0;
				goto  setradio_1;
			}
		}
#endif
        //sscanf(tmp, "Channel=Channel+%d", &i);

        if ((pTemp = strchr(tmp, '+'))!=NULL)
        {
            i = 1;
            nData = 0;

            while (*(pTemp+i)!='\0')
            {
                nData = nData*10 + *(pTemp+i) - '0';
                i++;
            }
setradio_1:
            ApCmdSetProc(APCMD_SET_RF_CHANNEL, &nData); /*SetChannel(i); */

        }
    }
    pCur = strstr(query, "Channel2");

    if (pCur!=NULL)
    {
        strcpy(tmp, pCur);

        if ((pTemp = strchr(tmp, '&'))!=NULL)
        {
            *pTemp = '\0';  
        }
#ifdef AUTOCHANNEL
		{
			char *pCurTmp;
    		pCurTmp = strstr(tmp, "Auto");
			if(pCurTmp!=NULL)
			{
            	nData = 0;
				goto  setradio_2;
			}
		}
#endif

        //sscanf(tmp, "Channel=Channel+%d", &i);

        if ((pTemp = strchr(tmp, '+'))!=NULL)
        {
            i = 1;
            nData = 0;

            while (*(pTemp+i)!='\0')
            {
                nData = nData*10 + *(pTemp+i) - '0';
                i++;
            }
setradio_2:
            ApCmdSetProc(APCMD_SET_RF_CHANNEL2, &nData); //SetChannel(i);
        }
    }



    //set G mode protection
    pCur = strstr(query, "G_mode_protection"); 

    if (pCur!=NULL)
    {
        strcpy(tmp, pCur);

        if ((pTemp = strchr(tmp, '&'))!=NULL)
        {
            *pTemp = '\0';  
        }

        if (strstr(tmp, "CTS+ONLY")!=NULL)
        {
#ifdef SELF_CTS
            nData = 1;
            ApCmdSetProc(APCMD_SET_SELF_CTS, &nData); 
#endif
            nData = 0;
        }
        else if (strstr(tmp, "RTS-CTS")!=NULL)
        {
            nData = 0;
#ifdef SELF_CTS
            ApCmdSetProc(APCMD_SET_SELF_CTS, &nData); 
#endif
        }
        else if (strstr(tmp, "Off")!=NULL)
        {
#ifdef SELF_CTS
            nData = 0;
            ApCmdSetProc(APCMD_SET_SELF_CTS, &nData); 
#endif
            nData = 1;
        }

        ApCmdSetProc(APCMD_SET_FORCE_PROTECTION_MODE, &nData);  
    }
    // Set Beacon Period
    pCur = strstr(query, "Beacon");

    if (pCur!=NULL)
    {
        strcpy(tmp, pCur);

        if ((pTemp = strchr(tmp, '&'))!=NULL)
        {
            *pTemp = '\0';  
        }

        if ((pTemp = strchr(tmp, '='))!=NULL)  // e.g. Beacon=1024
        {
            i = 1;
            lData = 0;

            while (*(pTemp+i)!='\0')
            {
                if ( *(pTemp+i) < '0' || *(pTemp+i) > '9')
                {
                    return BEACON_RANGE_ERROR;
                }

                lData = lData*10 + *(pTemp+i) - '0';
                i++;
            }
            if ( (lData <BEACON_THRESHOLD_MIN) || (lData > BEACON_THRESHOLD_MAX) )
            {
                return BEACON_RANGE_ERROR;
            }
            else
            {
                ApCmdSetProc(APCMD_SET_BEACON_PERIOD, &lData);  

            }


        }
    }

    // Set DTIM Period
    pCur = strstr(query, "DTIM");

    if (pCur!=NULL)
    {
        strcpy(tmp, pCur);

        if ((pTemp = strchr(tmp, '&'))!=NULL)
        {
            *pTemp = '\0';
        }

        if ((pTemp = strchr(tmp, '='))!=NULL)  // e.g. DTIM=1024
        {
            i = 1;
            lData = 0;

            while (*(pTemp+i)!='\0')
            {
                if ( *(pTemp+i) < '0' || *(pTemp+i) > '9')
                {
                    return DTIM_RANGE_ERROR;
                }

                lData = lData*10 + *(pTemp+i) - '0';
                i++;
            }
            if ( (lData < DTIM_THRESHOLD_MIN) || (lData > DTIM_THRESHOLD_MAX) )
            {
                return DTIM_RANGE_ERROR;
            }
            else
            {
                ApCmdSetProc(APCMD_SET_DTIM_PERIOD, &lData); 
            }                
        }
    }

    // Set Preamble option
    pCur = strstr(query, "Preamble");

    if (pCur!=NULL)
    {
        strcpy(tmp, pCur);

        if ((pTemp = strchr(tmp, '&'))!=NULL)
        {
            *pTemp = '\0';  
        }

        if (strstr(tmp, "Auto")!=NULL)
        {
            chData = PREAMBLE_AUTO_SELECT;
        }
        else if (strstr(tmp, "Short")!=NULL)
        {
            chData = PREAMBLE_SHORT;
        }
        else if (strstr(tmp, "Long")!=NULL)
        {
            chData = PREAMBLE_LONG;
        }

        ApCmdSetProc(APCMD_SET_RF_PREAMBLE_OPTION, &chData);  
    }
#ifdef BOOSTER_MODE
	// Set BOOSTER MODE option
 	pCur = strstr(query, "BoosterMode");

 	if (pCur!=NULL)
	{
		strcpy(tmp, pCur);
		
		if ((pTemp = strchr(tmp, '&'))!=NULL)
		{
			*pTemp = '\0';	
		}

		if (strstr(tmp, "Auto")!=NULL) 
		{
			chData = BOOSTER_AUTO;
		}
		else if (strstr(tmp, "On")!=NULL)
		{
			chData = BOOSTER_ON;
		}
		else if (strstr(tmp, "Off")!=NULL)
		{
			chData = BOOSTER_OFF;
		}

 		ApCmdSetProc(APCMD_SET_BOOSTER_MODE, &chData);  
	}
#endif	
    // Set Fragmentation Threshold 
    pCur = strstr(query, "FragThreshold");

    if (pCur!=NULL)
    {
        strcpy(tmp, pCur);

        if ((pTemp = strchr(tmp, '&'))!=NULL)
        {
            *pTemp = '\0';  
        }

        if ((pTemp = strchr(tmp, '='))!=NULL)  // e.g. FragThreshold=1024
        {
            i = 1;
            nData = 0;

            while (*(pTemp+i)!='\0')
            {
                nData = nData*10 + *(pTemp+i) - '0';
                i++;
            }
            if ( (nData < FRAG_THRESHOLD_MIN) || (nData > FRAG_THRESHOLD_MAX) )
            {
                return FRAG_RANGE_ERROR;
            }
            else
            {
                ApCmdSetProc(APCMD_SET_FRAG_THRESHOLD, &nData);  
            }               
        }
    }

    // Set RTS Threshold 
    pCur = strstr(query, "RTSThreshold");

    if (pCur!=NULL)
    {
        strcpy(tmp, pCur);

        if ((pTemp = strchr(tmp, '&'))!=NULL)
        {
            *pTemp = '\0';  
        }

        if ((pTemp = strchr(tmp, '='))!=NULL)  // e.g. RTSThreshold=1024
        {
            i = 1;
            nData = 0;

            while (*(pTemp+i)!='\0')
            {
                if ( *(pTemp+i) < '0' || *(pTemp+i) > '9')
                {
                    return RTS_RANGE_ERROR;
                }

                nData = nData*10 + *(pTemp+i) - '0';
                i++;
            }
            if ( (nData < RTS_THRESHOLD_MIN) || (nData > RTS_THRESHOLD_MAX) )
            {
                return RTS_RANGE_ERROR;
            }
            else
            {
                ApCmdSetProc(APCMD_SET_RTS_THRESHOLD, &nData);  
            }               
        }
    }


    // Set Data Retry Limit
    pCur = strstr(query, "DataRetryLimit");

    if (pCur!=NULL)
    {
        strcpy(tmp, pCur);

        if ((pTemp = strchr(tmp, '&'))!=NULL)
        {
            *pTemp = '\0';  
        }

        if ((pTemp = strchr(tmp, '='))!=NULL)  // e.g. DataRetryLimit=7
        {
            i = 1;
            nData = 0;

            while (*(pTemp+i)!='\0')
            {
                nData = nData*10 + *(pTemp+i) - '0';
                i++;
            }

            ApCmdSetProc(APCMD_SET_DATA_RETRY_LIMIT, &nData);  
        }
    }

    // Set RTS Retry Limit
    pCur = strstr(query, "RTSRetryLimit");

    if (pCur!=NULL)
    {
        strcpy(tmp, pCur);

        if ((pTemp = strchr(tmp, '&'))!=NULL)
        {
            *pTemp = '\0';  
        }

        if ((pTemp = strchr(tmp, '='))!=NULL)  // e.g. RTSRetryLimit=7
        {
            i = 1;
            nData = 0;

            while (*(pTemp+i)!='\0')
            {
                nData = nData*10 + *(pTemp+i) - '0';
                i++;
            }

            ApCmdSetProc(APCMD_SET_RTS_RETRY_LIMIT, &nData);  
        }
    }

#ifdef DCS
	// Set DCS MODE option
 	pCur = strstr(query, "DCSMode");

 	if (pCur!=NULL)
	{
		strcpy(tmp, pCur);
		if ((pTemp = strchr(tmp, '&'))!=NULL)
		{
			*pTemp = '\0';	
		}
		if (strstr(tmp, "Enable-Very+Sensitive")!=NULL) 
		{
			chData = 3;
		}
		else if (strstr(tmp, "Enable-Sensitive")!=NULL)
		{
			chData = 2;
		}
		else if (strstr(tmp, "Enable-Default")!=NULL)
		{
			chData = 1;
		}
		else if (strstr(tmp, "Disable")!=NULL)
		{
			chData = 0;
		}

 		ApCmdSetProc(APCMD_SET_DCS_MODE, &chData);  
	}
#endif	

    pCur = strstr(query, "AgingTime");	
    if (pCur!=NULL)
    {
        strcpy(tmp, pCur);

        if ((pTemp = strchr(tmp, '&'))!=NULL)
        {
            *pTemp = '\0';
        }

        if ((pTemp = strchr(tmp, '='))!=NULL)  
        {
            i = 1;
            lData = 0;

            while (*(pTemp+i)!='\0')
            {
                if ( *(pTemp+i) < '0' || *(pTemp+i) > '9')
                {
                    return AGINGTIME_RANGE_ERROR;
                }

                lData = lData*10 + *(pTemp+i) - '0';
                i++;
            }
            if ( (lData < AGINGTIME_RANGE_MIN) || (lData > AGINGTIME_RANGE_MAX) )
            {
                return AGINGTIME_RANGE_ERROR;
            }
            else
            {
                ApCmdSetProc(APCMD_SET_STA_AGING_TIME_IN_MINUTES, &lData); 
            }                
        }
    } 

/*	
    // Set basic data rates
    pCur = strstr(query, "TXRATE");
    i = 0;

    bufData[ 0] =   2; //  1   Mbps
    bufData[ 1] =   4; //  2   Mbps
    bufData[ 2] =  11; //  5.5 Mbps
    bufData[ 3] =  22; // 11   Mbps
    bufData[ 4] =  12; //  6   Mbps
    bufData[ 5] =  18; //  9   Mbps
    bufData[ 6] =  24; // 12   Mbps
    bufData[ 7] =  36; // 18   Mbps
    bufData[ 8] =  48; // 24   Mbps
    bufData[ 9] =  72; // 36   Mbps
    bufData[10] =  96; // 48   Mbps
    bufData[11] = 108; // 54   Mbps
    bufData[12] =   0;
    bufData[13] =   0;
    bufData[14] =   0;
    bufData[15] =   0;
     
    while (pCur!=NULL)
    {
        strcpy(tmp, pCur);

        if ((pTemp = strchr(tmp, '&'))!=NULL)
        {
            *pTemp = '\0';	
        }
        
        pCur = pTemp+1;
        pTemp = tmp+6;
        nData = 0;

        while (*pTemp >='0' && *pTemp<='9')	// e.g. TXRATE11=ON
        {
            nData = nData*10 + *pTemp - '0';
            pTemp++;	
        }

        if (nData!=0) 
        {
            for (i=0; bufData[i]!=0 && i<16; i++)
            {
                if (bufData[i]== nData)
                {
                    bufData[i] |= 0x80;
                    break;
                }
            }
        }
        
        pCur = strstr(pCur, "TXRATE");
    }
        
    if (i!=0)
    {
        ApCmdSetProc(APCMD_SET_BASIC_DATA_RATES_G, bufData);  
    }
*/
#ifdef AP_URPTR
    /* Perform reboot if mode changes from AP to UR/WB and vice-versa. */
    if (ur_ModeChange_Reset)
    {
        SetUserConfig();
        return AP_NEEDS_REBOOT;
    }
#endif
    chData = 1;
    ApCmdSetProc(APCMD_BSS_START, &chData);
    free(tmp);
    return AP_DATA_SAVED;
}
int checkEmptyKey(WEP_KEY *pWep)
{
    /*UINT8 NullWepKey[13] = {0,0,0,0,0,0,0,0,0,0,0,0,0};*/
    switch (pWep->TxKeyIndex)
    {
    case 0:
        /*if ( memcmp(pWep->keyValue0, NullWepKey, 13)== 0 )*/
        if (pWep->keyType0 == WEP_NOT_SET)
            return(1);
        break;
    case 1:
        /*if ( memcmp(pWep->keyValue1, NullWepKey, 13)== 0 )*/
        if (pWep->keyType1 == WEP_NOT_SET)
            return(1);
        break;
    case 2:
        /*if ( memcmp(pWep->keyValue2, NullWepKey, 13)== 0 )*/
        if (pWep->keyType2 == WEP_NOT_SET)
            return(1);
        break;
    case 3:
        /*if ( memcmp(pWep->keyValue3, NullWepKey, 13)== 0 )*/
        if (pWep->keyType3 == WEP_NOT_SET)
            return(1);
        break;
    }
    return 0;
}

int SetWep(webs_t wp, char_t* query)
{
    char    tmp[400];
    char    *pTemp, *pCur, *pVal; 
    int     i, j;
    unsigned char    chData;
    unsigned char    bufData[100], key40[4][5], key128[16];
    USHORT nData, *pType, keysize;
    WEP_KEY  *pWep;
    unsigned char PrivacyOption, keysetbypassphrase = 0;

    if (query == NULL || strlen(query)==0)
    {
        return 0;
    }
    pCur = strstr(query, "ClientType");
    if (pCur != NULL)
    {
        strcpy(tmp, pCur);

        if ((pTemp = strchr(tmp, '&')) != NULL)
        {
            *pTemp = '\0';  
        }

        if (strstr(tmp, "A+Mode") != NULL)
        {
            wepClientType = 0;
        }
        else if (strstr(tmp, "G+Mode")!=NULL)
        {
            wepClientType = 1;
        }
        else
        {
            wepClientType = 2;
        }
    }

    /* Auth Mode */
    pCur = strstr(query, "AuthMode");

    if (pCur!=NULL)
    {
        strcpy(tmp, pCur);

        if ((pTemp = strchr(tmp, '&'))!=NULL)
        {
            *pTemp = '\0';  
        }

        if (strstr(tmp, "Open")!=NULL)
        {
            chData = OPEN_SYSTEM_ONLY;
        }
        else if ( strstr(tmp, "Shared")!=NULL )
        {
            chData = SHARED_KEY_ONLY;
        }
        else /*if (strstr(tmp, "Both")!=NULL) */
        {
            chData = OPEN_SYSTEM_AND_SHARED_KEY;
        }

        ApCmdSetProc(APCMD_SET_AUTH_MODE, &chData);  
    }
    else
    {
        strcpy(tmp, pCur);

        if ((pTemp = strchr(tmp, '&'))!=NULL)
        {
            *pTemp = '\0';  
        }
        chData = OPEN_SYSTEM_ONLY;
        ApCmdSetProc(APCMD_SET_AUTH_MODE, &chData);
    }
    /* Privacy Option */
    pCur = strstr(query, "PrivacyOption");

    if (pCur!=NULL)
    {
        strcpy(tmp, pCur);

        if ((pTemp = strchr(tmp, '&'))!=NULL)
        {
            *pTemp = '\0';  
        }

        if (strstr(tmp, "Not")!=NULL)
        {
            chData = DATA_ENCRYPT_NOT_REQUIRED;
        }
        else
        {
            chData = FULL_DATA_ENCRYPT_REQUIRED;
        }
        PrivacyOption = chData;
    }

    /* Set Wep Key */
    pWep = malloc(2*sizeof(WEP_KEY));
    memset(pWep, 0 , 2*sizeof(WEP_KEY));

    ApCmdGetProc(APCMD_GET_DEFAULT_WEP_KEYS, pWep);

/*	nSetWepKey = 0; */

    /* Tx Key */
    pCur = strstr(query, "TxKey");

    if (pCur!=NULL)
    {
        strcpy(tmp, pCur);

        if ((pTemp = strchr(tmp, '&'))!=NULL)
        {
            *pTemp = '\0';  
        }

        if ( (pTemp=strchr(tmp, '+'))!=NULL )         /* TxKey=Key+X */
        {
            nData = (USHORT)(*(pTemp+1)-'1'); 

            pWep->TxKeyIndex = nData;
        }
    }

    pCur = strstr(query, "KeySize");

    if ( pCur!=NULL )
    {
        strcpy(tmp, pCur);

        if ( (pTemp = strchr(tmp, '&'))!=NULL )
        {
            *pTemp = '\0';  
        }

        if ( strstr(tmp, "Not")!=NULL )
        {
            keysize = WEP_NOT_SET;
        }
        else if ( strstr(tmp, "40")!=NULL )
        {
            keysize = WEP_40_BIT;
        }
        else
        {
            keysize = WEP_104_BIT;
        }
    }
#ifdef PASSPHRASE_ENABLE
    pCur = strstr(query, "PASSPHRASE");

    if ( pCur != NULL )
    {
        strcpy(tmp, pCur);

        if ( (pTemp = strchr(tmp, '&'))!=NULL )
        {
            *pTemp = '\0';  
        }
        if ( (pTemp = strchr(tmp, '='))!=NULL )
        {
            pTemp++;
            if (*pTemp)
            {
                keysetbypassphrase = 1;
                if (keysize == WEP_40_BIT)
                    gen40bitkeys(pTemp, key40);
                if (keysize == WEP_104_BIT)
                    gen128bitkeys(pTemp,key128);
            }

        }
    }
    if (keysetbypassphrase)
    {
        for ( i= 0; i <4; i++)
        {
            pType = (USHORT*)(&pWep->keyType0 + i*9); /* offset by 18 bytes */
            pVal = (UCHAR*)(pWep->keyValue0 + i*18);
            if (keysize == WEP_40_BIT)
            {
                *pType = WEP_40_BIT;
                memcpy(pVal, key40[i], 5);
            }
            else
            {
                *pType = WEP_104_BIT;
                memcpy(pVal, key128, 16);
            }
        }
    }
    else
#endif

        /* Key value */
        for (i=0; i<4; i++)
        {
            strcpy(bufData, "KeyVal ");
            bufData[6] = (char)('0' + i +1);
            pType = (USHORT*)(&pWep->keyType0 + i*9); /* offset by 18 bytes */
            pVal = (UCHAR*)(pWep->keyValue0 + i*18);

            pCur = strstr(query, bufData);

            if (pCur!=NULL)
            {
                strcpy(tmp, pCur);

                if ((pTemp = strchr(tmp, '&'))!=NULL)
                {
                    *pTemp = '\0';  
                }

                if ((pTemp=strchr(tmp, '='))!=NULL)
                {
                    pTemp++;
                    /*strcpy(pVal, pTemp); */
                    j = 0;
                    while (*pTemp != '\0')
                    {
                        if (*pTemp>='0' && *pTemp<='9')
                        {
                            chData = *pTemp - '0';
                        }
                        else if ( *pTemp>='A' && *pTemp <= 'F' )
                        {
                            chData = *pTemp - 'A' + 10;
                        }
                        else if ( *pTemp>='a' && *pTemp <= 'f' )
                        {
                            chData = *pTemp - 'a' + 10;
                        }
                        else if ( *pTemp == '*' && (strcmp(pTemp,"**********") == 0))
                        {
                            j=0;
                            break;
                        }
                        else
                        {
                            return 11;  // wrong info
                        }

                        chData = chData<<4;

                        pTemp++;

                        if (*pTemp>='0' && *pTemp<='9')
                        {
                            chData += *pTemp - '0';
                        }
                        else if ( *pTemp>='A' && *pTemp <= 'F' )
                        {
                            chData += *pTemp - 'A' + 10;
                        }
                        else if ( *pTemp>='a' && *pTemp <= 'f' )
                        {
                            chData += *pTemp - 'a' + 10;
                        }
                        else
                        {
                            return 11;// wrong info
                        }
                        bufData[j++] = chData; 

                        pTemp++;
                    } 

                    bufData[j] = '\0'; 
                }
				
                switch (j)
                {
                case 5:
                    *pType = WEP_40_BIT;
					if(pWep->TxKeyIndex == i)
                    if (keysize != WEP_40_BIT)
                        return(12);
                    memcpy(pVal, bufData, 5);
                    break;
                case 13:
                    *pType = WEP_104_BIT;
					if(pWep->TxKeyIndex == i)
                    if (keysize != WEP_104_BIT)
                        return(12);
                    memcpy(pVal, bufData, 13);
                    break;
                case 0:
                    *pType = WEP_NOT_SET;
                    memset(pVal, 0, 16);
					if(pWep->TxKeyIndex == i)
                    if (keysize != pWep->keyType0)
                    {
                        return(12);
                    }
                    break;
                default:    
                    if ( PrivacyOption == FULL_DATA_ENCRYPT_REQUIRED )
                        return(11);
                    *pType = WEP_NOT_SET;
                    memset(pVal, 0, 16);
                    break;
                }


            }

        }

    if ( PrivacyOption == FULL_DATA_ENCRYPT_REQUIRED )
        if ( checkEmptyKey(pWep) )
        {
            return(2);
        }
    chData = PrivacyOption;	//chData has been modified

    ApCmdSetProc(APCMD_SET_PRIVACY_OPTION, &chData);  
    ApCmdSetProc(APCMD_SET_DEFAULT_WEP_KEYS, (char*)pWep);  

    free (pWep);


    return AP_DATA_SAVED;
}

int Radio(webs_t wp, int Error)
{
#ifdef AP_URPTR
    static char radioUrl[256] = "radio_ur.asp";
#else
#if defined(FALCON) || defined(PEREGRINE)
    static char radioUrl[256] = "radio_g.asp";
#else  
    static char radioUrl[256] = "radio.asp";
#endif
#endif
    if (Error == BEACON_RANGE_ERROR)
    {
        asp_show_error_message(wp, "Beacon range must be between 20 to 1000 !", radioUrl);
    }
    else if (Error == DTIM_RANGE_ERROR)
    {
        asp_show_error_message(wp, "DTIM range must be between 1 to 255 !", radioUrl);
    }
    else if (Error == RTS_RANGE_ERROR)
    {
        asp_show_error_message(wp, "RTS range must be between 256 to 2432 !", radioUrl);
    }
    else if (Error == FRAG_RANGE_ERROR)
    {
        asp_show_error_message(wp, "Fragmentation range must be between 256 to 2346 !", radioUrl);
    }
    else if (Error == SSID_SIZE_ERROR)
    {
        asp_show_error_message(wp, "SSID size cannot be more than 32 characters !", radioUrl);
    }
    else if (Error == BURST_RATE_RANGE_ERROR)
    {
        asp_show_error_message(wp, "Burst Rate range must be between 8 to 16 !", radioUrl);
    }
    else if (Error == AP_NEEDS_REBOOT)
    {
        websRedirect(wp, T("reboot.asp"));  
        return 0;    
    }
    else if (Error == AP_DATA_SAVED)
    {
        SetUserConfig();
        websRedirect(wp, T("confirm.asp"));  
        return 0;    
    }
    else if (Error == AGINGTIME_RANGE_ERROR)
    {
        asp_show_error_message(wp, "Aging time range must be between 0 to 60 ! 0:disable aging time, 1-60:aging time", radioUrl);
    }
    else
    {
        websRedirect(wp, T(radioUrl));
    }
    return 0;

}
int Wep(webs_t wp, int Error)
{

    if (Error == 1)
    {
        asp_show_error_message(wp, "You Have Entered Invalid WEP Key Value!", "wep.asp");
    }
    else if (Error == 2)
    {
        asp_show_error_message(wp, "You Must Enter WEP Key!", "wep.asp");
    }
    else if (Error == 3)
    {
        asp_show_error_message(wp, "Cannot enable WEP while WPA is enabling!", "wep.asp");
    }
    else if (Error == 4)
    {
        asp_show_error_message(wp, "Data Encription is required for Shared Key Authentication!", "wep.asp");
    }
    else if (Error == AP_NEEDS_REBOOT)
    {
        websRedirect(wp, T("reboot.asp"));  
        return 0;    
    }
    else if (Error == AP_DATA_SAVED)
    {
        SetUserConfig();
        websRedirect(wp, T("confirm.asp"));  
        return 0;    
    }
    else
    {
        websRedirect(wp, T("wep.asp"));
    }
    return 0;

}
#if 1 //bt_test:: upload
void apRebooting(webs_t wp, char_t *path)
{
    char_t *date;
    APICMDBUF *pCmdbuf;

#if 0//def BRIDGE_POLLING_1
    setBridgeTaskToIntDriven();
#endif

#if 1
    websWrite(wp, T("HTTP/1.1 %d %s\r\n"), STATUS_OK, websErrorMsg(STATUS_OK));
    websWrite(wp, T("Server: %s\r\n"), WEBS_NAME);

    if ((date = websGetDateString(NULL)) != NULL)
    {
        websWrite(wp, T("Date: %s\r\n"), date);
        bfree(B_L, date);
    }

    websWrite(wp, T("Pragma: no-cache\r\nCache-Control: no-cache\r\n"));
    websWrite(wp, T("Content-Type: text/html\r\n"));
    websWrite(wp, T("\r\n"));

    websWrite(wp, T("<html><head>\n"));
    websWrite(wp, T("<meta HTTP-EQUIV=\"refresh\" content=\"10;url=%s\">\n"), path);
//	websWrite(wp, T("</head><body>You have successfully flashed the new firmware.\n"));
//	websWrite(wp, T("Please click the Reboot button and then close your browser."));	
//	websWrite(wp, T("You will need to refresh the page manually after the AP rebooted itself.")); 
    websWrite(wp, T("</body>\n"));

    websFooter(wp);

    websDone(wp, 200);
#endif

    if (wpaMode==1)
    {

        APICMDBUF_DEAUTH_STA cmdBuf;

        cmdBuf.seqNum = 1;
        cmdBuf.cmdCode = APCMD_DEAUTH_STA;
        cmdBuf.cmdBodyLen = 6; 
        cmdBuf.staMACAddress[0]=0xff;
        cmdBuf.staMACAddress[1]=0xff;
        cmdBuf.staMACAddress[2]=0xff;
        cmdBuf.staMACAddress[3]=0xff;
        cmdBuf.staMACAddress[4]=0xff;
        cmdBuf.staMACAddress[5]=0xff;
        apctl(&cmdBuf);


    }
    /* Since Bridging task is polling, can not reboot right away */
    /* Since it will not have time to send out this last packet */
    needReboot = 1;

#if 0//def BRIDGE_POLLING_1
    setBridgeTaskToPolling();

    {
        pCmdbuf = malloc(sizeof(APICMDBUF));
        pCmdbuf->cmdStatus = APCTL_CMD_FAILED;
        while (pCmdbuf->cmdStatus != APCTL_OK)
        {
            pCmdbuf->cmdCode = APCMD_FW_SOFT_RESET;
            pCmdbuf->seqNum = 1;
            apctl(pCmdbuf);
        }
        free(pCmdbuf);  
    }
#endif
}

/**************************************************************************
*
*
*
*
**************************************************************************/
void apRequestReboot(webs_t wp, char_t *msq)
{
    char_t *date;
    APICMDBUF *pCmdbuf;

    //WriteHTMLHeader();
    websWrite(wp, T("HTTP/1.1 %d %s\r\n"), STATUS_OK, websErrorMsg(STATUS_OK));
    websWrite(wp, T("Server: %s\r\n"), WEBS_NAME);

    if ((date = websGetDateString(NULL)) != NULL)
    {
        websWrite(wp, T("Date: %s\r\n"), date);
        bfree(B_L, date);
    }



    websWrite(wp, T("Pragma: no-cache\r\nCache-Control: no-cache\r\n"));
    websWrite(wp, T("Content-Type: text/html\r\n"));
    websWrite(wp, T("\r\n"));

    // end of WriteHtmlHeader
    CreateHeader("AP Needs to Reboot");

    websWrite(wp, T("<head>\n"));
//	websWrite(wp, T("<meta HTTP-EQUIV=\"refresh\" content=\"10;url=/index.htm\">\n"));
    websWrite(wp, T("</head><body>%s\n"), msq);
    websWrite(wp, T("<P>Please click the Reboot button and then close your browser."));    
    websWrite(wp, T("You will need to refresh the page manually after the AP rebooted itself.")); 

    websWrite(wp, T("<form method=\"Post\" action=\"Reboot.htm\">"));    
    websWrite(wp, T("<p><input type=\"submit\" value=\"Reboot\" name=\"Submit\">"));
    websWrite(wp, T("</form>"));

    // add GoAhead logo
    websWrite(wp, T("<br><br><br><img border=\"0\" src=\"../Image/GoAhead_Logo.gif\"></font>\r\n"));


    websWrite(wp, T("</body>\n"));

    websFooter(wp);

    websDone(wp, 200);
}


/**************************************************************************
*
*
*
*
**************************************************************************/
void apUpgradeFail(webs_t wp, char_t *path, UINT8 reason)
{
    char_t *date;
    APICMDBUF *pCmdbuf;

#if 0//def BRIDGE_POLLING_1
    setBridgeTaskToIntDriven();
#endif
    //WriteHTMLHeader();
    websWrite(wp, T("HTTP/1.1 %d %s\r\n"), STATUS_OK, websErrorMsg(STATUS_OK));
    websWrite(wp, T("Server: %s\r\n"), WEBS_NAME);

    if ((date = websGetDateString(NULL)) != NULL)
    {
        websWrite(wp, T("Date: %s\r\n"), date);
        bfree(B_L, date);
    }



    websWrite(wp, T("Pragma: no-cache\r\nCache-Control: no-cache\r\n"));
    websWrite(wp, T("Content-Type: text/html\r\n"));
    websWrite(wp, T("\r\n"));

    // end of WriteHtmlHeader
    //CreateHeader("Firmware Upgrade");

    websWrite(wp, T("<head>\n"));
	websWrite(wp, T("<meta HTTP-EQUIV=\"refresh\" content=\"10;url=/fw_upgrade.asp\">\n"));
    switch (reason)
    {
    case 0:
        websWrite(wp, T("</head><body>Failed to upload file to device.\n"));
        break;

    case 1:
        websWrite(wp, T("</head><body>Failed to flash the new firmware.\n"));
        websWrite(wp, T("Check to make sure you have a valid image to do the upgrade.\n"));
        break;

    default:
        websWrite(wp, T("</head><body>Unexpected Error\n"));
        break;
    }
    websWrite(wp, T("Please try again.")); 



    // add GoAhead logo
    //websWrite(wp, T("<br><br><br><img border=\"0\" src=\"../Image/GoAhead_Logo.gif\"></font>\r\n"));


    websWrite(wp, T("</body>\n"));

    //websFooter(wp);

    websDone(wp, 200);
#if 1
    needReboot = 1;
#else
     pCmdbuf = malloc(sizeof(APICMDBUF));
    pCmdbuf->cmdStatus = APCTL_CMD_FAILED;
    while (pCmdbuf->cmdStatus != APCTL_OK)
    {
        pCmdbuf->cmdCode = APCMD_FW_SOFT_RESET;
        pCmdbuf->seqNum = 1;
        apctl(pCmdbuf);
    }
    free(pCmdbuf);  
#endif
}





int fwUpload(webs_t wp)
{
    char buf[50];
    char_t *date;
    USHORT  nBufSize, nCount;
    char    *pBuf, *pChar;

    //WriteHTMLHeader();
    websWrite(wp, T("HTTP/1.1 %d %s\r\n"), STATUS_OK, websErrorMsg(STATUS_OK));
    websWrite(wp, T("Server: %s\r\n"), WEBS_NAME);

    if ((date = websGetDateString(NULL)) != NULL)
    {
        websWrite(wp, T("Date: %s\r\n"), date);
        bfree(B_L, date);
    }

    websWrite(wp, T("Pragma: no-cache\r\nCache-Control: no-cache\r\n"));
    websWrite(wp, T("Content-Type: text/html\r\n"));
    websWrite(wp, T("\r\n"));
#if 1 //bt_test::upload

    // end of WriteHtmlHeader
    CreateHeader("Firmware Upgrade");

    // Get Filter Station List 
#endif //bt_test_end

#if 1 //bt_test:: upload

//    websWrite(wp, T("<html>\r\n"));
//    websWrite(wp, T("<head>\r\n"));
//    websWrite(wp, T("<meta http-equiv=\"Cache-Control\" content=\"no-cache, must-revalidate\">\r\n"));
//    websWrite(wp, T("<meta http-equiv=\"Pragma\" content=\"no-cache\">\r\n"));
//    websWrite(wp, T("<meta http-equiv=\"Expires\" content=\"0\">\r\n"));
//    websWrite(wp, T("<title>File Upload Demo</title>\r\n"));
//    websWrite(wp, T("<!-- Written by: Loh Chee Tim,  5-Mar-2001 -->\r\n"));
//    websWrite(wp, T("</head>\r\n"));
    websWrite(wp, T("<body>\r\n"));
    websWrite(wp, T("<form method=\"post\" action=\"/cgi-bin/upgrade\" enctype=\"multipart/form-data\">\r\n"));
    websWrite(wp, T("Select file: <input type=\"file\" name=\"binary\"><br>\r\n"));
    websWrite(wp, T("<input type=\"submit\" value=\"Upgrade\">\r\n"));
    websWrite(wp, T("<input type=\"reset\" value=\"cancel\">\r\n"));
    websWrite(wp, T("</form>\r\n"));
    websWrite(wp, T("</form>\r\n"));
    websWrite(wp, T("</body>\r\n"));
    websWrite(wp, T("</html>\r\n"));

#endif //bt_test_end


    websDone(wp, STATUS_OK);

    return 1;

}
#endif //bt_test_end
#ifdef WDS_FEATURE
int webSetWds(webs_t wp, char_t* query)
{
    UCHAR *pTmp, *pBuf, *pData;
    UCHAR szTarget[10];
    UCHAR MacAddr[6], voidAddr[6];
    USHORT nIndex, nAddr;
    UCHAR chCnt;

    if (query == NULL || strlen(query)==0)
    {
        return 0;
    }

    pData = malloc(200); // for max 32 MAC address
    pBuf = malloc(50);

    // set wds mode
    memset(pData, 0, 200);
    pTmp = strstr(query, "WdsMode");
    if (pTmp!=NULL)
    {
        strncpy(pData, pTmp, 80);
        pData[80-1] = '\0';

        if ((pTmp = strchr(pData, '&'))!=NULL)
        {
            *pTmp = '\0';   
        }

        if (strstr(pData, "Disable")!=NULL)
        {
            chCnt = WDS_MODE_DISABLE;
        }
        else if (strstr(pData, "Static")!=NULL)
        {
            chCnt = WDS_MODE_STATIC;
        }
        else if (strstr(pData, "Dynamic")!=NULL)
        {
            chCnt = WDS_MODE_DYNAMIC;
        }

        ApCmdSetProc(APCMD_SET_WDS_MODE, &chCnt);
    }

    pTmp = strstr(query, "DisableAssoc");
    chCnt = (pTmp != NULL)? TRUE:FALSE;

    ApCmdSetProc(APCMD_SET_DISABLE_ASSOC, &chCnt);

    pTmp = strstr(query, "WdsOption");
    chCnt = (pTmp != NULL)? TRUE:FALSE;
    ApCmdSetProc(APCMD_SET_WDS_OPTION, &chCnt);

    // set wds ap address list
    memset(voidAddr, 0, 6);
    memset(pData, 0, 200);
    pTmp = query;
    chCnt = 0;
    for (nIndex=0; nIndex<MAX_WDS_AP_LIST; nIndex++)
    {
		sprintf(szTarget, "WdsAp%d", nIndex); 
        if ((pTmp=strstr(query, szTarget)) != NULL)
        {
            memset(MacAddr, 0, 6);
            memset(pBuf, 0, 50);
            memcpy(pBuf, pTmp, 50);

            if ((pTmp=strchr(pBuf, '='))!=NULL)
            {
                nAddr = 0;

                while (nAddr < 6)
                {
                    pTmp++;

                    if (*pTmp=='%' && *(pTmp+1)=='3' && (*(pTmp+2)=='A' || *(pTmp+2)=='a'))
                    {
                        pTmp = pTmp+2;
                        continue;
                    }

                    if (*pTmp>='A' && *pTmp<='F')
                    {
                        MacAddr[nAddr] = *pTmp - 'A' + 10;
                    }
                    else if (*pTmp>='a' && *pTmp<='f')
                    {
                        MacAddr[nAddr] = *pTmp - 'a' + 10;
                    }
                    else if (*pTmp>='0' && *pTmp<='9')
                    {
                        MacAddr[nAddr] = *pTmp - '0';
                    }
                    else
                    {
                        continue;
                    }

                    pTmp++;

                    if (*pTmp>='A' && *pTmp<='F')
                    {
                        MacAddr[nAddr] = (MacAddr[nAddr] << 4) | (*pTmp - 'A' + 10);
                    }
                    else if (*pTmp>='a' && *pTmp<='f')
                    {
                        MacAddr[nAddr] = (MacAddr[nAddr] << 4) | (*pTmp - 'a' + 10);
                    }
                    else if (*pTmp>='0' && *pTmp<='9')
                    {
                        MacAddr[nAddr] = (MacAddr[nAddr] << 4) | (*pTmp - '0');
                    }

                    nAddr++;
                }

                // Get MacAddr, put into list if a valid one
                if (memcmp(MacAddr, voidAddr, 6)==0)
                {
					continue;
                }
                else
                {
					memcpy((UCHAR*)(pData+chCnt*6+2), MacAddr, 6);
                    chCnt ++;
                }
            }
        }
    }

    pData[0] = chCnt;
    pData[1] = 0;
    ApCmdSetProc(APCMD_SET_WDS_LIST, pData);

    free (pBuf);
    free (pData);
    return 1;

}
#endif
int webSetFilterTable(webs_t wp, char_t* query)
{
    UCHAR *pTmp, *pEnd, *pBuf, *pData;
    UCHAR szTarget[10];
    UCHAR MacAddr[6], voidAddr[6];
    USHORT nIndex, nAddr, j;
    char chData, *pCur, *pTemp;
    int mac_valid;

    if (query == NULL || strlen(query)==0)
    {
        return 0;
    }

    pTmp = query;
    
    pData = malloc(strlen(query));
    pBuf = malloc(50);

    memset(voidAddr, 0, 6);
    memset(pData, 0, 200);

    for (nIndex=0; nIndex<MAX_STA_IN_FILTER_LIST; nIndex++)
    {
        sprintf(szTarget, "Sta%d", nIndex+1); 
        if ((pTmp=strstr(query, szTarget)) != NULL)
        {
            memset(MacAddr, 0, 6);
            memset(pBuf, 0, 50);
            memcpy(pBuf, pTmp, 50);

            if ((pTmp=strchr(pBuf, '='))!=NULL)
            {
                pTmp++;

                if ((pEnd=strchr(pTmp, '&')) != NULL)
                {
                    *pEnd = '\0';
                }

                if((mac_valid = getMacFromString(MacAddr, pTmp)) != 1)
                {
                    asp_show_error_message(wp, "Invalid MAC address!", "filter_list.asp");
                    break;
                    
                }

                if (memcmp(MacAddr, voidAddr, 6)==0)
                {
                    break;
                }
                else
                {
                    memcpy((UCHAR*)(pData+nIndex*6+2), MacAddr, 6);
                }
            }
        }
    }

//	memcpy((USHORT*)pData, &nIndex, 2);
    if(mac_valid == 1)
    {
        *pData = 0;
        *(pData+1) = nIndex & 0xFF;
        ApCmdSetProc(APCMD_SET_WLAN_FILTER_LIST, pData);

    
        // Set Filter MODE option
        pCur = strstr(query, "FilterMode");

        if (pCur!=NULL)
        {
            strcpy(pData, pCur);
		
            if ((pTemp = strchr(pData, '&'))!=NULL)
            {
                *pTemp = '\0';	
            }

            if (strstr(pData, "Allow")!=NULL) 
            {
                chData = ACCESS_MODE;
            }
            else if (strstr(pData, "Block")!=NULL)
            {
                chData = FILTER_MODE;
            }
            else if (strstr(pData, "Off")!=NULL)
            {
			    chData = DISABLE_MODE;
            }

 		    ApCmdSetProc(APCMD_SET_WLAN_FILTER_MODE, &chData);  
	    }

    }
    free (pData);
   {
        chData = 1;
        ApCmdSetProc(APCMD_BSS_START, &chData); 
    }
return mac_valid;

}

int webSetIpConfig(webs_t wp, char_t* query)
{
    char    *pTmp, Buf[20], target[10];
    char    *pTemp, *pCur, chData; 
    int     i, j;
    USHORT nData;

    if (query == NULL || strlen(query)==0)
    {
        return 1;
    }

    pTmp = malloc(200);

    memset(pTmp, 0, 200);
    memset(Buf, 0, 20);


    // DHCP option
    pCur = strstr(query, "DHCP");

    if (pCur!=NULL)
    {
        strcpy(pTmp, pCur);

        if ((pTemp = strchr(pTmp, '&'))!=NULL)
        {
            *pTemp = '\0';  
        }

        if (strchr(pTmp, '1')!=NULL) // DHCP enabled
        {
            *((ULONG*)Buf) = 1;
        }
        else
        {
            *((ULONG*)Buf) = 0;
        }
        // get ip address
        strcpy(target, "IPAddr ");

        for (i=1; i<=4; i++)
        {
            target[6] = '0'+i;

            pCur = strstr(query, target);

            if (pCur!=NULL)
            {
                strcpy(pTmp, pCur);

                if ((pTemp = strchr(pTmp, '&'))!=NULL)
                {
                    *pTemp = '\0';  
                }
                else
                {
                    free (pTmp);
                    return 0;
                }


                nData = 0;

                pTemp = pTmp+8;

                while (*pTemp!='\0')
                {
                    if (*pTemp>='0' && *pTemp<='9')
                    {
                        nData = nData*10 + *pTemp - '0';
                        pTemp++;
                    }
                    else
                    {
                        free (pTmp);
                        return 0;
                    }
                }

                if (nData>255)
                {
                    free(pTmp);
                    return 0;
                }

                *(Buf+3+i)=(UCHAR)nData;
            }
            else
            {
                free (pTmp);
                return 0;
            }

        }

        // get subnet mask
        strcpy(target, "Subnet ");

        for (i=1; i<=4; i++)
        {
            target[6] = '0'+i;

            pCur = strstr(query, target);

            if (pCur!=NULL)
            {
                strcpy(pTmp, pCur);

                if ((pTemp = strchr(pTmp, '&'))!=NULL)
                {
                    *pTemp = '\0';  
                }
                else
                {
                    free (pTmp);
                    return 0;
                }


                nData = 0;

                pTemp = pTmp+8;

                while (*pTemp!='\0')
                {
                    if (*pTemp>='0' && *pTemp<='9')
                    {
                        nData = nData*10 + *pTemp - '0';
                        pTemp++;
                    }
                    else
                    {
                        free (pTmp);
                        return 0;
                    }
                }

                if (nData>255)
                {
                    free(pTmp);
                    return 0;
                }

                *(Buf+7+i)=(UCHAR)nData;
            }
            else
            {
                free (pTmp);
                return 0;
            }

        }

        // get gateway
        strcpy(target, "Gateway ");

        for (i=1; i<=4; i++)
        {
            target[7] = '0'+i;

            pCur = strstr(query, target);

            if (pCur!=NULL)
            {
                strcpy(pTmp, pCur);

                if ((pTemp = strchr(pTmp, '&'))!=NULL)
                {
                    *pTemp = '\0';  
                }
                else
                {
                    free (pTmp);
                    return 0;
                }

                j = 1;
                nData = 0;

                pTemp = pTmp + 9;

                while (*pTemp!='\0')
                {
                    if (*pTemp>='0' && *pTemp<='9')
                    {
                        nData = nData*10 + *pTemp - '0';
                        pTemp++;
                    }
                    else
                    {
                        free (pTmp);
                        return 0;
                    }
                }

                if (nData>255)
                {
                    free(pTmp);
                    return 0;
                }

                *(Buf+11+i)=(UCHAR)nData;
            }
            else
            {
                free (pTmp);
                return 0;
            }

        }




        ApCmdSetProc(APCMD_SET_ETH_IP_CONFIG, Buf);  
    }

    free (pTmp);

    {
        char chData = 1;
        ApCmdSetProc(APCMD_BSS_START, &chData); 
    }

    return 1;

}

#ifdef TEST_REG_RW
/**************************************************************************
*
*
*
*
**************************************************************************/
int SetReg(webs_t wp, char_t* query)
{

    char    *pTemp, *pCur, *tmp; 
    int     i;
    char    chData;
    char    bufData[50];
    USHORT setFlag = 0;
    int z;


    APICMDBUF_SET_BB_REG regCmdBuf;

    regCmdBuf.cmdCode = APCMD_SET_BB_REG;
    regCmdBuf.seqNum = 1;
    regCmdBuf.cmdBodyLen = 3;

    tmp = malloc(250);


    if (query == NULL || strlen(query)==0)
    {
        return 0;
    }



    // Set baseband register
    pCur = strstr(query, "reg_num");
    if (pCur != NULL)
    {
        strcpy(tmp, pCur);

        if ((pTemp = strchr(tmp, '&'))!=NULL)
        {
            *pTemp = '\0';
        }

        if ( (pTemp = strchr(tmp, '='))!=NULL)
        {
            pTemp++; 

            memset(bufData, 0, 50);
            strcpy(bufData, pTemp);


            for (i=0; i<(int)strlen(bufData);i++)
            {
                if (bufData[i]=='+')
                {
                    bufData[i] = ' ';
                }
            }

            for (i=0; i<(int)strlen(bufData);i++)
            {
                if (i == 0)
                {
                    if ( (bufData[i] > 0x40) && (bufData[i] < 0x47))
                    {
                        chData = bufData[i] - 'A' + 10;
                    }
                    else if ( (bufData[i] > 0x60) && (bufData[i] < 0x67))
                    {
                        chData = bufData[i] - 'a' + 10;
                    }
                    else
                    {
                        chData = bufData[i] - '0';
                    }
                }
                else if ( i ==1)
                {
                    chData = chData << 4;
                    if ( (bufData[i] > 0x40) && (bufData[i] < 0x47))
                    {
                        chData += bufData[i] - 'A' + 10;
                    }
                    else if ( (bufData[i] > 0x60) && (bufData[i] < 0x67))
                    {
                        chData += bufData[i] - 'a' + 10;
                    }
                    else
                    {
                        chData += bufData[i] - '0';
                    }

                }

            }
            regCmdBuf.regNum = chData;
            curReg = regCmdBuf.regNum;
        }

    }

    pCur = strstr(query, "reg_val");
    if (pCur != NULL)
    {
        strcpy(tmp, pCur);

        if ((pTemp = strchr(tmp, '&'))!=NULL)
        {
            *pTemp = '\0';
        }

        if ( (pTemp = strchr(tmp, '='))!=NULL)
        {
            pTemp++; 

            memset(bufData, 0, 50);
            strcpy(bufData, pTemp);


            for (i=0; i<(int)strlen(bufData);i++)
            {
                if (bufData[i]=='+')
                {
                    bufData[i] = ' ';
                }
            }

            for (i=0; i<(int)strlen(bufData);i++)
            {
                if (i == 0)
                {
                    if ( (bufData[i] > 0x40) && (bufData[i] < 0x47))
                    {
                        chData = bufData[i] - 'A' + 10;
                    }
                    else if ( (bufData[i] > 0x60) && (bufData[i] < 0x67))
                    {
                        chData = bufData[i] - 'a' + 10;
                    }
                    else
                    {
                        chData = bufData[i] - '0';
                    }
                }
                else if ( i ==1)
                {
                    chData= chData << 4;
                    if ( (bufData[i] > 0x40) && (bufData[i] < 0x47))
                    {
                        chData += bufData[i] - 'A' + 10;
                    }
                    else if ( (bufData[i] > 0x60) && (bufData[i] < 0x67))
                    {
                        chData += bufData[i] - 'a' + 10;
                    }
                    else
                    {
                        chData += bufData[i] - '0';
                    }

                }

            }
            regCmdBuf.regVal = chData;

        }

    }

    pCur = strstr(query, "reg_set");    
    if (pCur != NULL)
    {
        strcpy(tmp, pCur);

        // Set SSID
        if ((pTemp = strchr(tmp, '&'))!=NULL)
        {
            *pTemp = '\0';
        }

        if ( (pTemp = strchr(tmp, '='))!=NULL)
        {
            pTemp++; 

            memset(bufData, 0, 50);
            strcpy(bufData, pTemp);


            for (i=0; i<(int)strlen(bufData);i++)
            {
                if (bufData[i]=='+')
                {
                    bufData[i] = ' ';
                }
            }
            setFlag = atoi(bufData);
        }
    }


    if (setFlag)
    {
        apctl(&regCmdBuf);
    }


    free(tmp);

    return 1;

}

/**************************************************************************
*
*
*
*
**************************************************************************/
int regSetting(webs_t wp)
{
    char_t  *date;
    char    buf[50];
    char    *ptr;
    char    chData = TRUE;
    USHORT  nData, i;
    ULONG   lData;
    unsigned char addr[4];



    //WriteHTMLHeader();
    websWrite(wp, T("HTTP/1.1 %d %s\r\n"), STATUS_OK, websErrorMsg(STATUS_OK));
    websWrite(wp, T("Server: %s\r\n"), WEBS_NAME);

    if ((date = websGetDateString(NULL)) != NULL)
    {
        websWrite(wp, T("Date: %s\r\n"), date);
        bfree(B_L, date);
    }

    websWrite(wp, T("Pragma: no-cache\r\nCache-Control: no-cache\r\n"));
    websWrite(wp, T("Content-Type: text/html\r\n"));
    websWrite(wp, T("\r\n"));
    // end of WriteHtmlHeader

    CreateHeader("Baseband Reg Setting");

    websWrite(wp, T("<form method=\"Post\" action=\"SetReg.htm\">"));    
    websWrite(wp, T("<table border=\"0\" width=\"550\">\r\n"));

    //Baseband Register setting
    {
        APICMDBUF_GET_BB_REG regCmdbuf;

        regCmdbuf.cmdCode = APCMD_GET_BB_REG;
        regCmdbuf.seqNum = 1;
        regCmdbuf.cmdBodyLen = 3;
        regCmdbuf.regNum = curReg;
        apctl(&regCmdbuf);

        websWrite(wp, T("<tr>"));
        websWrite(wp, T("<td width=\"35%%\">Operation</td>"));
        websWrite(wp, T("<td width=\"65%%\"><input type=\"radio\" name=\"reg_set\" value=\"0\" size=\"20\" checked>Read     "));
        websWrite(wp, T("<input type=\"radio\" name=\"reg_set\" value=\"1\" size=\"20\">Write"));
        websWrite(wp, T("</td></tr>\r\n"));

        websWrite(wp, T("<tr>"));
        websWrite(wp, T("<td width=\"35%%\">Register Offset</td>"));
        websWrite(wp, T("<td width=\"65%%\"><input type=\"text\" name=\"reg_num\" value=\"%02x\" size=\"2\"> (Hex)"), regCmdbuf.regNum);
        websWrite(wp, T("</td></tr>\r\n"));

        websWrite(wp, T("<tr>"));
        websWrite(wp, T("<td width=\"35%%\">Register Value</td>"));
        websWrite(wp, T("<td width=\"65%%\"><input type=\"text\" name=\"reg_val\" value=\"%02x\" size=\"2\">(Hex)"), regCmdbuf.regVal);
        websWrite(wp, T("</td></tr>\r\n"));
    }


    //End of table
    websWrite(wp, T("</table>"));

    // Apply, Reset, Cancel button
    websWrite(wp, T("<p><input type=\"submit\" value=\"Apply\" name=\"Submit\">"));
    websWrite(wp, T("<input type=\"reset\" value=\"Reset\" name=\"Reset\">"));
    websWrite(wp, T("<input type=\"button\" value=\"Cancel\" name=\"Cancel\"></p>"));
    websWrite(wp, T("</form>"));


    // add GoAhead logo
    websWrite(wp, T("<br><br><br><img border=\"0\" src=\"Image/GoAhead_Logo.gif\"></font>\r\n"));


    //websResponse(wp, STATUS_OK, buf, NULL);
    websDone(wp, STATUS_OK);


    return 1;
}

#endif /* TEST_REG_RW */


int wpaConfig(webs_t wp, int Error)
{
    char_t *date;
    char    chData;
    char    passPhrase[30];
    char    buf[100];
    UINT32  icvErr;
    UINT32  locMicFail;
    UINT32  rmotMicFail;
    UINT32  cntMeasInvk;



    if (Error == 0)
    {
        websRedirect(wp, T("wpa.asp")); 
        return 0;   

    }
    else if (Error == 1)
    {
        asp_show_error_message(wp, "You Have Entered Invalid Pass Phase!", "wpa.asp");
        return 0;    
    }
    else if (Error == 2)
    {
        websRedirect(wp, T("reboot.asp")); 
        //apRequestReboot(wp, "WPA updated Successful. ");
        return 0;       
    }
    else if (Error == 3)
    {
        asp_show_error_message(wp, "Cannot enable WPA while WEP is enabling!", "wpa.asp"); 
    }
    else if (Error == 4)
    {
        asp_show_error_message(wp, "passwords must contain more than 7 and less than 64 characters", "wpa.asp");  
        return 0;   
    }


    if (Error == 2)
    {
        websRedirect(wp, T("reboot.asp")); 
        //websRedirect(wp, T("confirm.asp")); 
        //apRequestReboot(wp, "WPA updated Successful. ");
        return 0;
    }

/*
    // Get WPA mode
    {
        APICMDBUF_GET_PRIVACY_TBL_RSN_ENABLED cmdBuf;

        cmdBuf.seqNum = 1;
        cmdBuf.cmdCode = APCMD_GET_PRIVACY_TBL_RSN_ENABLED;
        cmdBuf.cmdBodyLen = 1;
        apctl(&cmdBuf);
        chData = cmdBuf.Enabled;
    }
    if(chData==1)
        WpaEnabled=TRUE;
    else
        WpaEnabled=FALSE;		   

    websWrite(wp, T("<tr>"));
    websWrite(wp, T("<td width=\"40%c\">WPA Mode</td>"),0x25);
    websWrite(wp, T("<td width=\"60%c\"><select size=\"1\" name=\"wpaMode\">"), 0x25);
    websWrite(wp, T("<option%s>Disabled</option>"), chData==0?" selected":"");
    websWrite(wp, T("<option%s>Enabled</option>"), chData==1?" selected":"");
    websWrite(wp, T("</select></td>"));
    websWrite(wp, T("</tr>"));

    // Get Auth Method
    {
        APICMDBUF_GET_RSN_CFG_AUTH_SUITE cmdBuf;

        cmdBuf.seqNum = 1;
        cmdBuf.cmdCode = APCMD_GET_RSN_CFG_AUTH_SUITE;
        cmdBuf.cmdBodyLen = sizeof(APICMDBUF_GET_RSN_CFG_AUTH_SUITE) - 4*sizeof(unsigned short);
        apctl(&cmdBuf);
        chData = cmdBuf.AuthSuites[3];
    }

    websWrite(wp, T("<tr>"));
    websWrite(wp, T("<td width=\"40%c\">Authentication Method</td>"),0x25);
    websWrite(wp, T("<td width=\"60%c\"><select size=\"1\" name=\"wpaAuthMethod\">"), 0x25);
    websWrite(wp, T("<option%s>Pre-Shared Keys</option>"), (chData==2)?" selected":"");
    websWrite(wp, T("<option%s>802.1x</option>"), (chData==1)?" selected":"");
    websWrite(wp, T("</select></td>"));
    websWrite(wp, T("</tr>"));
    
    // Get Auth Pass Phrase
    //can't read it from API since it's Write only
    strcpy(passPhrase, "**********");
    
    websWrite(wp, T("<tr>"));
    websWrite(wp, T("<td width=\"35%c\">Pass Phrase </td>"),0x25);
    websWrite(wp, T("<td width=\"65%c\"><input type=\"text\" name=\"wpaPhrase\" value=\"%s\" size=\"30\"></td>"),\
                        0x25, passPhrase);

    websWrite(wp, T("<tr>"));
    websWrite(wp, T("<td width=\"100%c\" colspan=\"2\"><font size=\"1\">_________________________________________________________________________________________</font></td>"),0x25);
    websWrite(wp, T("</tr></table>\r\n")); 

    //Get WPA Counter status
    {
        APICMDBUF_GET_RSN_STATS cmdBuf;

        cmdBuf.seqNum = 1;
        cmdBuf.cmdCode = APCMD_GET_RSN_STATS;
        cmdBuf.cmdBodyLen = sizeof(APICMDBUF_GET_RSN_STATS) - 4*sizeof(unsigned short);;
        apctl(&cmdBuf);

        icvErr = cmdBuf.TKIPICVErrors;
        locMicFail = cmdBuf.TKIPLocalMICFailures;
        rmotMicFail = cmdBuf.TKIPRemoteMICFailures;
        cntMeasInvk = cmdBuf.TKIPCounterMeasuresInvoked;
    }

    websWrite(wp, T("<table border=\"0\" width=\"300\">\r\n"));
    websWrite(wp, T("<tr>"));
    websWrite(wp, T("<td width=\"70%c\">ICV Errors:</td>"),0x25);
    websWrite(wp, T("<td width=\"30%c\"> 0x%x"), 0x25, icvErr);
    websWrite(wp, T("</tr>"));
    websWrite(wp, T("<tr>"));
    websWrite(wp, T("<td width=\"70%c\">Local MIC Failures:</td>"),0x25);
    websWrite(wp, T("<td width=\"30%c\"> 0x%x"), 0x25, locMicFail);
    websWrite(wp, T("</tr>"));
    websWrite(wp, T("<tr>"));
    websWrite(wp, T("<td width=\"70%c\">Remote MIC Failures:</td>"),0x25);
    websWrite(wp, T("<td width=\"30%c\"> 0x%x"), 0x25, rmotMicFail);
    websWrite(wp, T("</tr>"));
    websWrite(wp, T("<tr>"));
    websWrite(wp, T("<td width=\"70%c\"><nobr>Counter Measures Invoked:</nobr></td>"),0x25);
    websWrite(wp, T("<td width=\"30%c\"> 0x%x"), 0x25, cntMeasInvk);
    websWrite(wp, T("</tr>"));
    websWrite(wp, T("</table>\r\n")); 
    
    websWrite(wp, T("<br>"));
    websWrite(wp, T("<p><input type=\"submit\" value=\"Apply\" name=\"Submit\">"));
    websWrite(wp, T("<input type=\"reset\" value=\"Reset\" name=\"Reset\">"));
    websWrite(wp, T("<input type=\"button\" value=\"Cancel\" name=\"Cancel\"></p></form>")); 

    websDone(wp, STATUS_OK);

    return 1;
*/
}


int SetWpa(webs_t wp, char_t* query)
{
    char    tmp[400];
    char    *pTemp, *pCur, *pVal; 
    int     i, j;
    unsigned char    chData;
    unsigned char    bufData[200];
    unsigned char    PasswordData[100];
    USHORT nData, *pType;
    WEP_KEY  *pWep;
    unsigned char PrivacyOption;

    //UINT8 wpaMode;

    if (query == NULL || strlen(query)==0)
    {
        return 0;
    }

    // WPA Mode
    pCur = strstr(query, "wpaMode");
    if (pCur!=NULL)
    {
        strcpy(tmp, pCur);

        if ((pTemp = strchr(tmp, '&'))!=NULL)
        {
            *pTemp = '\0';  
        }

        if (strstr(tmp, "Enabled")!=NULL)
        {

            if (WepEnabled==TRUE)
                return 3;
            wpaMode = 1;
        }
        else
        {
            wpaMode = 0;
        }

        if (wpaMode==1)
            WpaEnabled=TRUE;
        else
            WpaEnabled=FALSE;       

        //set Wpa Mode
        {
            APICMDBUF_SET_PRIVACY_TBL_RSN_ENABLED cmdBuf;

            cmdBuf.seqNum = 1;
            cmdBuf.cmdCode = APCMD_SET_PRIVACY_TBL_RSN_ENABLED;
            cmdBuf.cmdBodyLen = 1;
            cmdBuf.Enabled = wpaMode;
            apctl(&cmdBuf);
        }
    }

    // WPA Auth Method
    pCur = strstr(query, "wpaAuthMethod");
    if (pCur!=NULL)
    {
        strcpy(tmp, pCur);

        if ((pTemp = strchr(tmp, '&'))!=NULL)
        {
            *pTemp = '\0';  
        }

        if (strstr(tmp, "802.1x")!=NULL)
        {
            chData = 1;
        }
        else
        {
            chData = 2;
        }

        //set Wpa Auth Meth
        {
            APICMDBUF_SET_RSN_CFG_AUTH_SUITE cmdBuf;

            cmdBuf.seqNum = 1;
            cmdBuf.cmdCode = APCMD_SET_RSN_CFG_AUTH_SUITE;
            cmdBuf.cmdBodyLen = sizeof(APICMDBUF_SET_RSN_CFG_AUTH_SUITE) - 4*sizeof(unsigned short);
            cmdBuf.AuthSuites[0] = 0x0;
            cmdBuf.AuthSuites[1] = 0x50;
            cmdBuf.AuthSuites[2] = 0xf2;
            cmdBuf.AuthSuites[3] = chData;
            cmdBuf.Enabled = wpaMode;
            apctl(&cmdBuf);
        }
    }


    //WPA Pass Phrase
    pCur = strstr(query, "wpaPhrase");
    if (pCur != NULL)
    {
        strcpy(tmp, pCur);
        if ((pTemp = strchr(tmp, '&'))!=NULL)
        {
            *pTemp = '\0';
        }

        if ( (pTemp = strchr(tmp, '='))!=NULL)
        {
            pTemp++; 

            memset(bufData, 0, 200);
            memset(PasswordData, 0, 100);
            strcpy(bufData, pTemp);


            for (i=0; i<(int)strlen(bufData);i++)
            {
                if (bufData[i]=='+')
                {
                    bufData[i] = ' ';
                }
            }                        

            for (i=0,j=0; i<(int)strlen(bufData);i++,j++)
            {

                if (bufData[i]=='%')
                {
                    if (bufData[i+1]== '2')
                    {

                        switch (bufData[i+2])
                        {
                        case '0':
                            PasswordData[j]=' ';
                            break;                                  

                        case '1':
                            PasswordData[j]='!';
                            break;      

                        case '2':
                            PasswordData[j]='"';
                            break;  

                        case '3':
                            PasswordData[j]='#';
                            break;  

                        case '4':
                            PasswordData[j]='$';
                            break;  

                        case '5':
                            PasswordData[j]='%';
                            break;  

                        case '6':
                            PasswordData[j]='&';
                            break;  

                        case '7':
                            PasswordData[j]='\'';
                            break;  

                        case '8':
                            PasswordData[j]='(';
                            break;  

                        case '9':
                            PasswordData[j]=')';
                            break;  

                        case 'A':
                            PasswordData[j]='*';
                            break;  

                        case 'B':
                            PasswordData[j]='+';
                            break;  

                        case 'C':
                            PasswordData[j]=',';
                            break;

                        case 'D':
                            PasswordData[j]='-';
                            break;  

                        case 'E':
                            PasswordData[j]='.';
                            break;  

                        case 'F':
                            PasswordData[j]='/';
                            break;                                                                          

                        default:
                            break;                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  
                        }
                        i +=2;                                                                                              
                    }
                    else if (bufData[i+1]== '3')
                    {
                        switch (bufData[i+2])
                        {
                        case 'A':
                            PasswordData[j]=':';
                            break;  

                        case 'B':
                            PasswordData[j]=';';
                            break;  

                        case 'C':
                            PasswordData[j]='<';
                            break;

                        case 'D':
                            PasswordData[j]='=';
                            break;  

                        case 'E':
                            PasswordData[j]='>';
                            break;  

                        case 'F':
                            PasswordData[j]='?';
                            break;                                                                          

                        default:
                            break;  
                        }
                        i +=2;                                                                      
                    }
                    //no need to detect '@'
                    else if (bufData[i+1]== '5')
                    {

                        switch (bufData[i+2])
                        {
                        
                        case 'B':
                            PasswordData[j]='[';
                            break;  

                        case 'C':
                            PasswordData[j]='\\';
                            break;

                        case 'D':
                            PasswordData[j]=']';
                            break;  

                        case 'E':
                            PasswordData[j]='^';
                            break;  

                        case 'F':
                            PasswordData[j]='_';
                            break;                                                                          

                        default:
                            break;      
                        }
                        i +=2;                                                      
                    }
                    else if (bufData[i+1]== '6')
                    {
                        switch (bufData[i+2])
                        {
                        
                        case '0':
                            PasswordData[j]='`';
                            break;                                                                          

                        default:
                            break;                              
                        }
                        i +=2;
                    }
                    else if (bufData[i+1]== '7')
                    {
                        switch (bufData[i+2])
                        {
                        case 'B':
                            PasswordData[j]='{';
                            break;  

                        case 'C':
                            PasswordData[j]='|';
                            break;

                        case 'D':
                            PasswordData[j]='}';
                            break;  

                        case 'E':
                            PasswordData[j]='~';
                            break;                                                                                                          

                        default:
                            break;      
                        }
                        i +=2;                                                      
                    }
                }
                else
                {
                    PasswordData[j]=bufData[i];
                }

            }   

            if ( (strlen(PasswordData) <=7) || (strlen(PasswordData) >= 64) )
                return 4;
            // if(strcmp(bufData, "**********") != 0)
            if (strcmp(PasswordData, "**********") != 0)
            {
                //Set Pass Phrase
                {
                    APICMDBUF_SET_PSK_PASSPHRASE cmdBuf;

                    cmdBuf.seqNum = 1;
                    cmdBuf.cmdCode = APCMD_SET_PSK_PASSPHRASE;
                    cmdBuf.cmdBodyLen = sizeof(APICMDBUF_SET_PSK_PASSPHRASE) - 4*sizeof(unsigned short);;
                    strcpy(cmdBuf.passphrase, PasswordData);
                    apctl(&cmdBuf);
                }
            }

        }
    }

    pCur = strstr(query, "wpaGrpReKeyTime");
    if (pCur != NULL)
    {
        strcpy(tmp, pCur);
        if ((pTemp = strchr(tmp, '&'))!=NULL)
        {
            *pTemp = '\0';
        }

        if ( (pTemp = strchr(tmp, '='))!=NULL)
        {
            pTemp++; 

            memset(bufData, 0, 200);
            memset(PasswordData, 0, 100);
            strcpy(bufData, pTemp);


            for (i=0; i<(int)strlen(bufData);i++)
            {
                if (bufData[i]=='+')
                {
                    bufData[i] = 0;/*null terminator*/
                }
            }
            //Set Grp Rekey Timeout time
            {
                APICMDBUF_SET_GRP_REKEY_TIME cmdBuf;

                cmdBuf.seqNum = 1;
                cmdBuf.cmdCode = APCMD_SET_GRP_REKEY_TIME;
                cmdBuf.cmdBodyLen = sizeof(APICMDBUF_SET_GRP_REKEY_TIME) - 4*sizeof(unsigned short);;
                cmdBuf.rekey_time = atol(bufData);
                apctl(&cmdBuf);
            }
        }
    }

    {
        char    chData;
        chData = 1;
        ApCmdSetProc(APCMD_BSS_START, &chData); 
    }
    if (wpaMode == 1)
    {
        return 2;           
    }
    else
    {
        {
            APICMDBUF_DEAUTH_STA cmdBuf;

            cmdBuf.seqNum = 1;
            cmdBuf.cmdCode = APCMD_DEAUTH_STA;
            cmdBuf.cmdBodyLen = 6; 
            cmdBuf.staMACAddress[0]=0xff;
            cmdBuf.staMACAddress[1]=0xff;
            cmdBuf.staMACAddress[2]=0xff;
            cmdBuf.staMACAddress[3]=0xff;
            cmdBuf.staMACAddress[4]=0xff;
            cmdBuf.staMACAddress[5]=0xff;
            apctl(&cmdBuf);

        }               
        //chData = 1;
        //ApCmdSetProc(APCMD_BSS_START, &chData); 			
        return 0;
    }
}

/* String Names of Bridge MAC Address in Web Pages */
static char bridgeMacNames[][16] ={
    "WanMac",
    "LanMac",
    "GwWanMac",
    "GwLanMac",
    "WlanMac"
};
static int bridgeMacNum = sizeof(bridgeMacNames) / sizeof(bridgeMacNames[0]);

/* Function Pointer Array to Set Bridge MAC Address */
typedef void (*mac_set_function)(const unsigned char*);
#if 0
static mac_set_function macSetFunctions[] = {
    &SetWanMac,
    &SetLanMac,
    &SetGwWanMac,
    &SetGwLanMac,
    &SetWlanMac
};
#endif
int SetBridge(webs_t wp, char_t* query) {
    UCHAR *pTmp, *pEnd, *pBuf;
    UCHAR MacAddr[6];
    USHORT nIndex;

    if (query == NULL || strlen(query)==0)
    {
        return 0;
    }
#if 0
    pBuf = malloc(50);
    pTmp = query;

    for (nIndex=0; nIndex<bridgeMacNum; nIndex++)
    {
        if ((pTmp=strstr(query, bridgeMacNames[nIndex])) != NULL)
        {
            memset(pBuf, 0, 50);
            memcpy(pBuf, pTmp, 50);

            if ((pTmp=strchr(pBuf, '='))!=NULL)
            {
                pTmp++;

                if ((pEnd=strchr(pTmp, '&')) != NULL)
                {
                    *pEnd = '\0';
                }

                getMacFromString(MacAddr, pTmp);
                macSetFunctions[nIndex](MacAddr);
            }
        }
    }

    free (pBuf);

#endif
    return 1;   
}

int securityConfig(webs_t wp, int Error)
{
    char_t *date;
    char    chData;
    char    passPhrase[30];
    char    buf[100];
    UINT32  icvErr;
    UINT32  locMicFail;
    UINT32  rmotMicFail;
    UINT32  cntMeasInvk;

    if (Error == 0)
    {
        websRedirect(wp, T("wep.asp")); 
        return 0;   
    }
    else if (Error == 1)
    {
        asp_show_error_message(wp, "You have entered invalid Passphrase!", "wep.asp");
        return 0;    
    }
    else if (Error == AP_NEEDS_REBOOT)//error number=8
    {
        SetUserConfig();
        websRedirect(wp, T("reboot.asp")); 
        //apRequestReboot(wp, "WPA updated Successful. ");
        return 0;       
    }
    else if (Error == AP_DATA_SAVED)
    {
        SetUserConfig();
        websRedirect(wp, T("confirm.asp"));  
        return 0;    
    }
    else if (Error == 3)
    {
        asp_show_error_message(wp, "Cannot enable WPA while WEP is enabled!", "wep.asp"); 
    }
    else if (Error == 4)
    {
        asp_show_error_message(wp, "Passwords must contain more than 8 and less than 64 characters!", "wep.asp");  
        return 0;   
    }
    else if (Error == 5)
    {
        asp_show_error_message(wp, "Invalid 64 Hex key", "wep.asp");  
        return 0;   
    }
    else if (Error == 11)
    {
        asp_show_error_message(wp, "You have entered invalid WEP Key Value!", "wep.asp");
    }
    else if (Error == 12)
    {
        asp_show_error_message(wp, "WEP Key Size selected does not match the Key Value length!", "wep.asp");
    }
#ifdef AUTOLINK
    else if (Error == 13)
    {
        asp_show_error_message(wp, "AutoLink Low Transmit Power allowed in AP mode only", "wep.asp");  
    }
    else if (Error == 14)
    {
        asp_show_error_message(wp, "User defined Pass Phrase allowed in AP mode only", "wep.asp");  
    }
#endif
}

int IsHexKey( char* keyStr )
{
    while (*keyStr != '\0')
    {
        if ( (*keyStr>='0' && *keyStr<='9') || ( *keyStr>='A' && *keyStr <= 'F' )
             || ( *keyStr>='a' && *keyStr <= 'f' )
           )
        {
            keyStr++;
            continue;
        }
        else
            return 0;
    } 
    return 1;
}

int SetSecurity(webs_t wp, char_t* query)
{
    char    tmp[400];
    char    *pTemp, *pCur, *pVal; 
    int     i, j;
    unsigned char    chData, chData1;
    unsigned char    bufData[200];
    unsigned char    PasswordData[100];
    unsigned char DataToWlandrv[100];
    unsigned char DataFromUser[200];        
    USHORT nData, *pType;
    WEP_KEY  *pWep;
    unsigned char PrivacyOption;
    char setResult = 0;
#ifdef AUTOLINK
    unsigned long lData;
    unsigned char chAutoLinkEnable;
#endif

    static struct{
     UCHAR  enable;
     UCHAR  caWPAHex[32];
    }WPAHex, WPA2Hex;
    
    //UINT8 wpaMode;

    if (query == NULL || strlen(query)==0)
    {
        return 0;
    }

#if defined(TURBO_SETUP)
    pCur = strstr(query, "AutoLink");

    chData1 = (pCur!=NULL)?TRUE:FALSE;
    if(chData1 == TRUE)
    {
        chData1 = 1;
    }
    else
    {
        chData1 = 4;
    }

/*    ApCmdSetProc(APCMD_SET_AUTO_LINK_MODE, &chData1);*/  
#elif defined(AUTOLINK)

    pCur = strstr(query, "ALEnable");
    chData = (pCur!=NULL)?TRUE:FALSE;
    chAutoLinkEnable = chData;

    //if (chAutoLinkEnable == TRUE) /* AutoLink has been enabled then reset all settings and start fresh */
    //    ResetToFactorySettings();

	{
	APICMDBUF_SET_AL_ENABLE_STATE cmdBuf;
	cmdBuf.cmdCode = APCMD_SET_AL_ENABLE_STATE;
    cmdBuf.cmdBodyLen = sizeof(APICMDBUF_SET_AL_ENABLE_STATE)- 4*sizeof(unsigned short);
    cmdBuf.seqNum = 1;
	cmdBuf.ALEnable = chData;
	apctl(&cmdBuf);
	}

    pCur = strstr(query, "ALLowPower");
    chData = (pCur!=NULL)?TRUE:FALSE;
	{
#if defined(AP_URPTR)
		if (chData && (mib_urMode != 1 && mib_wbMode != 1)) /* Setting allowed in AP mode only*/
#endif
		{
			APICMDBUF_SET_AL_LOW_POWER_STATE cmdBuf;
			cmdBuf.cmdCode = APCMD_SET_AL_LOW_POWER_STATE;
		    cmdBuf.cmdBodyLen = sizeof(APICMDBUF_SET_AL_LOW_POWER_STATE)- 4*sizeof(unsigned short);
		    cmdBuf.seqNum = 1;
			cmdBuf.ALLowTxPowerEnable = chData;
			apctl(&cmdBuf);
		}
#if defined(AP_URPTR)
		else if (chData)
			return 13; /* return AutoLink Low Transmit Power allowed in AP mode only */			
#endif
	}

    /*Set AutoLink security mode*/
    chData = 0;
    pCur = strstr(query, "ALSecMode");
    if (pCur != NULL)
    {
        strcpy(tmp, pCur);

        if ((pTemp = strchr(tmp, '&'))!=NULL)
        {
            *pTemp = '\0';  
        }

        if (strstr(tmp, "WPA-TKIP")!=NULL)
        {
            chData = 1;
        }
        else if (strstr(tmp, "WPA2-AES")!=NULL)
        {
            chData = 5;
        }

		{
        APICMDBUF_SET_AL_SEC_MODE cmdBuf;
		cmdBuf.cmdCode = APCMD_SET_AL_SEC_MODE;
	    cmdBuf.cmdBodyLen = sizeof(APICMDBUF_SET_AL_SEC_MODE)- 4*sizeof(unsigned short);
    	cmdBuf.seqNum = 1;
		cmdBuf.ALSecMode = chData;
		apctl(&cmdBuf);
		}
    }

    /* Set AutoLink ON time */
    pCur = strstr(query, "ALONTime");
    if (pCur!=NULL)
    {
        strcpy(tmp, pCur);
        if ((pTemp = strchr(tmp, '&'))!=NULL)
        {
            *pTemp = '\0';  
        }

        if ((pTemp = strchr(tmp, '='))!=NULL)
        {
			pTemp ++;
	        if (strstr(pTemp, "120")!=NULL)
	        {
	            lData = 120;
	        }
	        else if (strstr(pTemp, "40")!=NULL)
	        {
	            lData = 40;
	        }
	        else if (strstr(pTemp, "60")!=NULL)
	        {
	            lData = 60;
	        }
	        else if (strstr(pTemp, "20")!=NULL)
	        {
	            lData = 20;
	        }
        }
		{
		APICMDBUF_SET_AL_ON_TIME cmdBuf;
		cmdBuf.cmdCode = APCMD_SET_AL_ON_TIME;
	    cmdBuf.cmdBodyLen = sizeof(APICMDBUF_SET_AL_ON_TIME)- 4*sizeof(unsigned short);
    	cmdBuf.seqNum = 1;
		cmdBuf.ALONTime = lData;
		apctl(&cmdBuf);
		}
    }

    /* Set AutoLink User defined pass phrase enable */
    pCur = strstr(query, "ALPassPhrase");
    chData = (pCur!=NULL)?TRUE:FALSE;
	{
#if defined(AP_URPTR)
		if (chData && (mib_urMode != 1 && mib_wbMode != 1)) //Setting allowed in AP mode only
#endif
		{
			APICMDBUF_SET_AL_PP_ENABLE_STATE cmdBuf;
			cmdBuf.cmdCode = APCMD_SET_AL_PP_ENABLE_STATE;
		    cmdBuf.cmdBodyLen = sizeof(APICMDBUF_SET_AL_PP_ENABLE_STATE)- 4*sizeof(unsigned short);
		    cmdBuf.seqNum = 1;
			cmdBuf.ALPPEnable = chData;
			apctl(&cmdBuf);
		}
#if defined(AP_URPTR)
		else if (chData)
			return 14; /* return: User defined Pass Phrase allowed in AP mode only */
#endif
	}

    /* Set value of AutoLink user defined pass phrase */
	if (chData == TRUE) //if user defined passphrase has been enabled
	{
    //WPA Pass Phrase
    pCur = strstr(query, "ALwpaPhrase");
    if (pCur != NULL)
    {
        strcpy(tmp, pCur);
        if ((pTemp = strchr(tmp, '&'))!=NULL)
        {
            *pTemp = '\0';
        }

        if ( (pTemp = strchr(tmp, '='))!=NULL)
        {
            pTemp++; 

            ProcessUserData(DataFromUser, DataToWlandrv, pTemp);         
            if ((strlen(DataToWlandrv) <=7) || (strlen(DataToWlandrv) > 63))
	            return 4;
            if (strcmp(DataToWlandrv, "**********") != 0)
            {
                //Set Pass Phrase
                {
                    APICMDBUF_SET_PSK_PASSPHRASE cmdBuf;
                    cmdBuf.seqNum = 1;
                    cmdBuf.cmdCode = APCMD_SET_PSK_PASSPHRASE;
                    cmdBuf.cmdBodyLen = sizeof(APICMDBUF_SET_PSK_PASSPHRASE) - 4*sizeof(unsigned short);;
                    strcpy(cmdBuf.passphrase, DataToWlandrv);
                    apctl(&cmdBuf);

                    WPAHex.enable=0;
                    ApCmdSetProc(APCMD_SET_WPA_PSK_VALUE, (char *)&WPAHex);
                }    
            }
        }
    }
	}

    if (chAutoLinkEnable == TRUE)
        return AP_NEEDS_REBOOT;
#endif /*AUTOLINK*/

#if 1
	// WPA Mode
 	pCur = strstr(query, "wpaMode");
 	if (pCur!=NULL)
	{
		strcpy(tmp, pCur);
		
		if ((pTemp = strchr(tmp, '&'))!=NULL)
		{
			*pTemp = '\0';	
		}
			
		if (strstr(tmp, "WPA_Only")!=NULL) 
		{
			wpaMode = 1;
            wpa2MixedMode = 0;
            wpa2OnlyMode = 0;
		}
        else if (strstr(tmp, "WPA_WPA2_Mixed")!=NULL) 
		{
			wpaMode = 1;
            wpa2MixedMode = 1;
            wpa2OnlyMode = 0;
		}
        else if (strstr(tmp, "WPA2_Only")!=NULL) 
		{
			wpaMode = 1;
            wpa2MixedMode = 0;
            wpa2OnlyMode = 1;
		}
        else
		{
			wpaMode = 0;
            wpa2MixedMode = 0;
            wpa2OnlyMode = 0;
		}

		if(wpaMode==1)
			WpaEnabled=TRUE;
		else
			WpaEnabled=FALSE;		
			  
		//set Wpa Mode
        {
            APICMDBUF_SET_PRIVACY_TBL_RSN_ENABLED cmdBuf;

            cmdBuf.seqNum = 1;
            cmdBuf.cmdCode = APCMD_SET_PRIVACY_TBL_RSN_ENABLED; //APCMD_GUI_SET_PRIVACY_TBL_RSN_ENABLED;
            cmdBuf.cmdBodyLen = 1;
            cmdBuf.Enabled = wpaMode;
            apctl(&cmdBuf);

			if(WpaEnabled==TRUE)
			{
                /* Force Open System */
                unsigned char forceAuthMode = OPEN_SYSTEM_ONLY;
	            unsigned char forceEncrypt = DATA_ENCRYPT_NOT_REQUIRED;

                ApCmdSetProc(APCMD_SET_AUTH_MODE, &forceAuthMode);  
                ApCmdSetProc(APCMD_SET_PRIVACY_OPTION, &forceEncrypt); 
                ApCmdSetProc(APCMD_SET_AUTH_MODE_G, &forceAuthMode);  
                ApCmdSetProc(APCMD_SET_PRIVACY_OPTION_G, &forceEncrypt);
                //chData = DATA_ENCRYPT_NOT_REQUIRED;
                //ApCmdSetProc(APCMD_SET_PRIVACY_OPTION, &chData);

			}
        }
#ifdef AP_WPA2
        //set Wpa2 Mixed Mode
        {
            APICMDBUF_SET_WPA2_ENABLED cmdBuf;

            cmdBuf.seqNum = 1;
            cmdBuf.cmdCode = APCMD_SET_WPA2_ENABLED;
            cmdBuf.cmdBodyLen = 1;
            cmdBuf.Enabled = wpa2MixedMode;
            apctl(&cmdBuf);
        }

        //set Wpa2 Only Mode
        {
            APICMDBUF_SET_WPA2ONLY_ENABLED cmdBuf;

            cmdBuf.seqNum = 1;
            cmdBuf.cmdCode = APCMD_SET_WPA2ONLY_ENABLED;
            cmdBuf.cmdBodyLen = 1;
            cmdBuf.Enabled = wpa2OnlyMode;
            apctl(&cmdBuf);
        }
#endif

	}

	// Get WPA Cipher suite
    if (wpaMode || wpa2MixedMode) 
    {
     	pCur = strstr(query, "wpaCipherSuite");
     	if (pCur!=NULL)
    	{
    		strcpy(tmp, pCur);
    		
    		if ((pTemp = strchr(tmp, '&'))!=NULL)
    		{
    			*pTemp = '\0';	
    		}
    			
            //set Wpa Unicast Cipher
            {
                APICMDBUF_SET_RSN_CFG_UNICAST_CIPHER cmdBuf;

                cmdBuf.seqNum = 1;
                cmdBuf.cmdCode = APCMD_SET_RSN_CFG_UNICAST_CIPHER;
                cmdBuf.cmdBodyLen = sizeof(APICMDBUF_SET_RSN_CFG_UNICAST_CIPHER) - 4*sizeof(unsigned short);
                cmdBuf.UnicastCipher[0] = 0x0;
                cmdBuf.UnicastCipher[1] = 0x50;
                cmdBuf.UnicastCipher[2] = 0xf2;
                if (strstr(tmp, "AES")!=NULL) 
                    cmdBuf.UnicastCipher[3] = 4;
                else
                    cmdBuf.UnicastCipher[3] = 2;
                cmdBuf.Enabled = 1;
                apctl(&cmdBuf);
            }
            //set Wpa Multicast Cipher
            {
                APICMDBUF_SET_RSN_CFG_MULTICAST_CIPHERS cmdBuf;

                cmdBuf.seqNum = 1;
                cmdBuf.cmdCode = APCMD_SET_RSN_CFG_MULTICAST_CIPHERS;
                cmdBuf.cmdBodyLen = sizeof(APICMDBUF_SET_RSN_CFG_MULTICAST_CIPHERS) - 4*sizeof(unsigned short);
                cmdBuf.MulticastCipher[0] = 0x0;
                cmdBuf.MulticastCipher[1] = 0x50;
                cmdBuf.MulticastCipher[2] = 0xf2;
                if (strstr(tmp, "AES")!=NULL) 
                    cmdBuf.MulticastCipher[3] = 4;
                else
                    cmdBuf.MulticastCipher[3] = 2;
                //cmdBuf.MulticastCipher[3] = chData;
                apctl(&cmdBuf);
            }
            //set Wpa2 Multicast Cipher
            {
                APICMDBUF_SET_RSN_CFG_WPA2_MULTICAST_CIPHERS cmdBuf;

                cmdBuf.seqNum = 1;
                cmdBuf.cmdCode = APCMD_SET_RSN_CFG_WPA2_MULTICAST_CIPHERS;
                cmdBuf.cmdBodyLen = sizeof(APICMDBUF_SET_RSN_CFG_WPA2_MULTICAST_CIPHERS) - 4*sizeof(unsigned short);
                cmdBuf.MulticastCipher[0] = 0x0;
                cmdBuf.MulticastCipher[1] = 0x0f;
                cmdBuf.MulticastCipher[2] = 0xac;
                if (strstr(tmp, "AES")!=NULL) 
                    cmdBuf.MulticastCipher[3] = 4;
                else
                    cmdBuf.MulticastCipher[3] = 2;
                //cmdBuf.MulticastCipher[3] = chData;
                apctl(&cmdBuf);
            }
        
        }
    }
#ifdef AP_WPA2
	// Get WPA2 Cipher suite
    if (wpa2OnlyMode || wpa2MixedMode) 
    {
     	pCur = strstr(query, "wpa2CipherSuite");
     	if (pCur!=NULL)
    	{
    		strcpy(tmp, pCur);
    		
    		if ((pTemp = strchr(tmp, '&'))!=NULL)
    		{
    			*pTemp = '\0';	
    		}
    			
            {   // cipher1
                APICMDBUF_SET_RSN_CFG_WPA2_UNICAST_CIPHER cmdBuf;

                cmdBuf.seqNum = 1;
                cmdBuf.cmdCode = APCMD_SET_RSN_CFG_WPA2_UNICAST_CIPHER;
                cmdBuf.cmdBodyLen = sizeof(APICMDBUF_SET_RSN_CFG_WPA2_UNICAST_CIPHER) - 4*sizeof(unsigned short);
                cmdBuf.UnicastCipher[0] = 0x0;
                cmdBuf.UnicastCipher[1] = 0x0f;
                cmdBuf.UnicastCipher[2] = 0xac;
                cmdBuf.UnicastCipher[3] = 4;
                cmdBuf.Enabled = 1;
                apctl(&cmdBuf);
            }
            
            {   // cipher2
                APICMDBUF_SET_RSN_CFG_WPA2_UNICAST_CIPHER2 cmdBuf;

                cmdBuf.seqNum = 1;
                cmdBuf.cmdCode = APCMD_SET_RSN_CFG_WPA2_UNICAST_CIPHER2;
                cmdBuf.cmdBodyLen = sizeof(APICMDBUF_SET_RSN_CFG_WPA2_UNICAST_CIPHER2) - 4*sizeof(unsigned short);
                cmdBuf.UnicastCipher[0] = 0x0;
                cmdBuf.UnicastCipher[1] = 0x0f;
                cmdBuf.UnicastCipher[2] = 0xac;
                if (strstr(tmp, "AES_Only")!=NULL)
                    cmdBuf.UnicastCipher[3] = 4;
                else
                    cmdBuf.UnicastCipher[3] = 2;
                cmdBuf.Enabled = 1;
                apctl(&cmdBuf);
            }
            
            if (wpa2OnlyMode)
            {
                //set Wpa Multicast Cipher
                {
                    APICMDBUF_SET_RSN_CFG_MULTICAST_CIPHERS cmdBuf;

                    cmdBuf.seqNum = 1;
                    cmdBuf.cmdCode = APCMD_SET_RSN_CFG_MULTICAST_CIPHERS;
                    cmdBuf.cmdBodyLen = sizeof(APICMDBUF_SET_RSN_CFG_MULTICAST_CIPHERS) - 4*sizeof(unsigned short);
                    cmdBuf.MulticastCipher[0] = 0x0;
                    cmdBuf.MulticastCipher[1] = 0x50;
                    cmdBuf.MulticastCipher[2] = 0xf2;
                    cmdBuf.MulticastCipher[3] = 4;
                    apctl(&cmdBuf);
                }
                //set Wpa2 Multicast Cipher
                {
                    APICMDBUF_SET_RSN_CFG_WPA2_MULTICAST_CIPHERS cmdBuf;

                    cmdBuf.seqNum = 1;
                    cmdBuf.cmdCode = APCMD_SET_RSN_CFG_WPA2_MULTICAST_CIPHERS;
                    cmdBuf.cmdBodyLen = sizeof(APICMDBUF_SET_RSN_CFG_WPA2_MULTICAST_CIPHERS) - 4*sizeof(unsigned short);
                    cmdBuf.MulticastCipher[0] = 0x0;
                    cmdBuf.MulticastCipher[1] = 0x0f;
                    cmdBuf.MulticastCipher[2] = 0xac;
                    cmdBuf.MulticastCipher[3] = 4;
                    apctl(&cmdBuf);
                }
            }
        }
    }
#endif
    // WPA Auth Method
 	pCur = strstr(query, "wpaAuthMethod");
 	if (pCur!=NULL)
	{
		strcpy(tmp, pCur);
		
		if ((pTemp = strchr(tmp, '&'))!=NULL)
		{
			*pTemp = '\0';	
		}
			
		if (strstr(tmp, "802.1x")!=NULL) 
		{
			chData = 1;
		}
		else
		{
			chData = 2;
		}

		//set Wpa Auth Meth
        {
            APICMDBUF_SET_RSN_CFG_AUTH_SUITE cmdBuf;

            cmdBuf.seqNum = 1;
            cmdBuf.cmdCode = APCMD_SET_RSN_CFG_AUTH_SUITE;
            cmdBuf.cmdBodyLen = sizeof(APICMDBUF_SET_RSN_CFG_AUTH_SUITE) - 4*sizeof(unsigned short);
            cmdBuf.AuthSuites[0] = 0x0;
            cmdBuf.AuthSuites[1] = 0x50;
            cmdBuf.AuthSuites[2] = 0xf2;
            cmdBuf.AuthSuites[3] = chData;
            cmdBuf.Enabled = wpaMode;
            apctl(&cmdBuf);
        }
	}

#else
    // WPA Mode
    pCur = strstr(query, "wpaMode");
    if (pCur!=NULL)
    {
        strcpy(tmp, pCur);

        if ((pTemp = strchr(tmp, '&'))!=NULL)
		{
            *pTemp = '\0';  
		}
        if (strstr(tmp, "WPA-PSK")!=NULL)
		{
            chData =  2;
			wpaMode = 1;
		}
        else if (strstr(tmp, "WPA-802.1x")!=NULL)
		{
            chData =  1;
			wpaMode = 1;
		}
        else
		{
			wpaMode = 0;
		}

        if (wpaMode==1)
            WpaEnabled=TRUE;
        else
            WpaEnabled=FALSE;       

        //set Wpa Mode
        {
            APICMDBUF_SET_PRIVACY_TBL_RSN_ENABLED cmdBuf;

            cmdBuf.seqNum = 1;
            cmdBuf.cmdCode = APCMD_SET_PRIVACY_TBL_RSN_ENABLED;
            cmdBuf.cmdBodyLen = 1;
            cmdBuf.Enabled = wpaMode;
            apctl(&cmdBuf);


        }
        //set Wpa Auth Meth
        if (WpaEnabled==TRUE)
        {
            APICMDBUF_SET_RSN_CFG_AUTH_SUITE cmdBuf;

            cmdBuf.seqNum = 1;
            cmdBuf.cmdCode = APCMD_SET_RSN_CFG_AUTH_SUITE;
            cmdBuf.cmdBodyLen = sizeof(APICMDBUF_SET_RSN_CFG_AUTH_SUITE) - 4*sizeof(unsigned short);
            cmdBuf.AuthSuites[0] = 0x0;
            cmdBuf.AuthSuites[1] = 0x50;
            cmdBuf.AuthSuites[2] = 0xf2;
            cmdBuf.AuthSuites[3] = chData;
            cmdBuf.Enabled = wpaMode;
            apctl(&cmdBuf);
        }
    }

    // WPA Auth Method
    pCur = strstr(query, "wpaDataEncryption");
    if (pCur!=NULL)
    {
        strcpy(tmp, pCur);

        if ((pTemp = strchr(tmp, '&'))!=NULL)
        {
            *pTemp = '\0';  
        }

        if (strstr(tmp, "TKIP")!=NULL)
        {
            chData = 2;
        }
        else if (strstr(tmp, "AES")!=NULL)
        {
            chData = 4;
        }
        else
        {
            chData = 0;
        }

        //set Wpa Unicast Cipher
        {
            APICMDBUF_SET_RSN_CFG_UNICAST_CIPHER cmdBuf;

            cmdBuf.seqNum = 1;
            cmdBuf.cmdCode = APCMD_SET_RSN_CFG_UNICAST_CIPHER;
            cmdBuf.cmdBodyLen = sizeof(APICMDBUF_SET_RSN_CFG_UNICAST_CIPHER) - 4*sizeof(unsigned short);
            cmdBuf.UnicastCipher[0] = 0x0;
            cmdBuf.UnicastCipher[1] = 0x50;
            cmdBuf.UnicastCipher[2] = 0xf2;
            cmdBuf.UnicastCipher[3] = chData;
            cmdBuf.Enabled = wpaMode;
            apctl(&cmdBuf);
        }
        //set Wpa Multicast Cipher
        {
            APICMDBUF_SET_RSN_CFG_MULTICAST_CIPHERS cmdBuf;

            cmdBuf.seqNum = 1;
            cmdBuf.cmdCode = APCMD_SET_RSN_CFG_MULTICAST_CIPHERS;
            cmdBuf.cmdBodyLen = sizeof(APICMDBUF_SET_RSN_CFG_MULTICAST_CIPHERS) - 4*sizeof(unsigned short);
            cmdBuf.MulticastCipher[0] = 0x0;
            cmdBuf.MulticastCipher[1] = 0x50;
            cmdBuf.MulticastCipher[2] = 0xf2;
            cmdBuf.MulticastCipher[3] = chData;
            apctl(&cmdBuf);
        }
    }
#endif

    if (WpaEnabled==TRUE)
    {
        chData = DATA_ENCRYPT_NOT_REQUIRED;
        ApCmdSetProc(APCMD_SET_PRIVACY_OPTION, &chData);
    }

    //WPA Pass Phrase
    pCur = strstr(query, "wpaPhrase");
    if (pCur != NULL)
    {
        strcpy(tmp, pCur);
        if ((pTemp = strchr(tmp, '&'))!=NULL)
        {
            *pTemp = '\0';
        }

        if ( (pTemp = strchr(tmp, '='))!=NULL)
        {
            pTemp++; 

            ProcessUserData(DataFromUser, DataToWlandrv, pTemp);         
            if ( (strlen(DataToWlandrv) <=7) || (strlen(DataToWlandrv) > 64) )
                return 4;

            if((strlen(DataToWlandrv) == 64))
            {
                if (!IsHexKey(DataToWlandrv))
                    return 5;
                memset(WPAHex.caWPAHex, 0, 32);
                HexStringToHexDigi(WPAHex.caWPAHex, DataToWlandrv, 32);
                WPAHex.enable=1;
                ApCmdSetProc(APCMD_SET_WPA_PSK_VALUE, (char *)&WPAHex);
            }
            else if (strcmp(DataToWlandrv, "**********") != 0)
            //if (strcmp(DataToWlandrv, "**********") != 0)
            {
                //Set Pass Phrase
                {
                    APICMDBUF_SET_PSK_PASSPHRASE cmdBuf;

                    cmdBuf.seqNum = 1;
                    cmdBuf.cmdCode = APCMD_SET_PSK_PASSPHRASE;
                    cmdBuf.cmdBodyLen = sizeof(APICMDBUF_SET_PSK_PASSPHRASE) - 4*sizeof(unsigned short);;
                    strcpy(cmdBuf.passphrase, DataToWlandrv);
                    apctl(&cmdBuf);

                    WPAHex.enable=0;
                    ApCmdSetProc(APCMD_SET_WPA_PSK_VALUE, (char *)&WPAHex);
                }    
            }

        }
    }

#ifdef AP_WPA2
    //WPA2 Pass Phrase
    pCur = strstr(query, "wpa2Phrase");
    if (pCur != NULL)
    {
        strcpy(tmp, pCur);
        if ((pTemp = strchr(tmp, '&'))!=NULL)
        {
            *pTemp = '\0';
        }

        if ( (pTemp = strchr(tmp, '='))!=NULL)
        {
            pTemp++; 

            ProcessUserData(DataFromUser, DataToWlandrv, pTemp);         
            if ( (strlen(DataToWlandrv) <=7) || (strlen(DataToWlandrv) > 64) )
                return 4;

            if((strlen(DataToWlandrv) == 64))
            {
                if (!IsHexKey(DataToWlandrv))
                    return 5;
                memset(WPA2Hex.caWPAHex, 0, 32);
                HexStringToHexDigi(WPA2Hex.caWPAHex, DataToWlandrv, 32);
                WPA2Hex.enable=1;
                ApCmdSetProc(APCMD_SET_WPA2_PSK_VALUE, (char *)&WPA2Hex);
            }
            else if (strcmp(DataToWlandrv, "**********") != 0)
            //if (strcmp(DataToWlandrv, "**********") != 0)
            {
                //Set Pass Phrase for WPA2
                {
                    APICMDBUF_SET_RSN_CFG_WPA2_TBL cmdBuf;
               
                    cmdBuf.seqNum = 1;
                    cmdBuf.cmdCode = APCMD_SET_RSN_CFG_WPA2_TBL;
                    cmdBuf.cmdBodyLen = sizeof(APICMDBUF_SET_RSN_CFG_WPA2_TBL) - 4*sizeof(unsigned short);;
                    strcpy(cmdBuf.PSKPassPhrase, DataToWlandrv);
                    apctl(&cmdBuf);

                    WPA2Hex.enable=0;
                    ApCmdSetProc(APCMD_SET_WPA2_PSK_VALUE, (char *)&WPA2Hex);
                }
            }

        }
    }
#endif        

    pCur = strstr(query, "wpaGrpReKeyTime");
    if (pCur != NULL)
    {
        strcpy(tmp, pCur);
        if ((pTemp = strchr(tmp, '&'))!=NULL)
        {
            *pTemp = '\0';
        }

        if ( (pTemp = strchr(tmp, '='))!=NULL)
        {
            pTemp++; 

            ProcessUserData(DataFromUser, DataToWlandrv, pTemp);         

            if (atol(DataToWlandrv) != 0)
            {
                //Set Grp Rekey Timeout time
                {
                    APICMDBUF_SET_GRP_REKEY_TIME cmdBuf;

                    cmdBuf.seqNum = 1;
                    cmdBuf.cmdCode = APCMD_SET_GRP_REKEY_TIME;
                    cmdBuf.cmdBodyLen = sizeof(APICMDBUF_SET_GRP_REKEY_TIME) - 4*sizeof(unsigned short);;
                    cmdBuf.rekey_time = atol(DataToWlandrv);
                    apctl(&cmdBuf);
                }            
            }

        }
    }

/* Add WEP Setting */
    if (!wpaMode)
    {
        setResult = SetWep(wp, query);
#ifdef TURBO_SETUP
        ApCmdSetProc(APCMD_SET_AUTO_LINK_MODE, &chData1);  
#endif    
        if (setResult != 0)
        {
            chData = 1;
            ApCmdSetProc(APCMD_BSS_START, &chData); 
            return setResult;
        }
    }
    else
    {
#ifdef TURBO_SETUP
        ApCmdSetProc(APCMD_SET_AUTO_LINK_MODE, &chData1);  
#endif    
    }
/* Add WEP Setting end */

    {
        char    chData;
        chData = 1;
        ApCmdSetProc(APCMD_BSS_START, &chData); 
    }
    {
        APICMDBUF_DEAUTH_STA cmdBuf;

        cmdBuf.seqNum = 1;
        cmdBuf.cmdCode = APCMD_DEAUTH_STA;
        cmdBuf.cmdBodyLen = 6; 
        cmdBuf.staMACAddress[0]=0xff;
        cmdBuf.staMACAddress[1]=0xff;
        cmdBuf.staMACAddress[2]=0xff;
        cmdBuf.staMACAddress[3]=0xff;
        cmdBuf.staMACAddress[4]=0xff;
        cmdBuf.staMACAddress[5]=0xff;
        apctl(&cmdBuf);

    }           
    //return AP_NEEDS_REBOOT; 
#ifdef GUEST_ACCESS
    {
        APICMDBUF_GET_GUEST_ACCESS getbuf;
        APICMDBUF_SET_GUEST_ACCESS setbuf;
        
        webApiCmd(APCMD_GET_GUEST_ACCESS, &getbuf, sizeof(APICMDBUF_GET_GUEST_ACCESS)-BUF_HDR_LEN);
        memcpy(&setbuf, &getbuf, sizeof(APICMDBUF_SET_GUEST_ACCESS));
        pVal = websGetVar(wp, "GuestAccessEnable", T(""));
        if (*pVal)      // Enable GUEST_ACCESS
        {
            setbuf.GuestAccessEnable = 1;
            pVal = websGetVar(wp, "GuestAccessPassPhrase", T(""));
            
            if (*pVal)
            {
                if ( (strlen(pVal) <=7) || (strlen(pVal) > 64) )
                    return 4;
                    
                memset(setbuf.GuestAccessPassPhrase, 0, 64);
                if((strlen(pVal) == 64))
                {
                    if (!IsHexKey(pVal))
                        return 5;                    
                    HexStringToHexDigi(setbuf.GuestAccessPassPhrase, pVal, 32);
                    // Use GuestAccessPassPhrase[63] to indicate 64 HEX
                    setbuf.GuestAccessPassPhrase[63] = GUEST_ACCESS_WITH_64HEX;
                }
                else if (strcmp(pVal, "**********") != 0)
                {
                    strcpy(setbuf.GuestAccessPassPhrase, pVal);
                }
            }
            pVal = websGetVar(wp, "GuestAccessPassPhrase2", T(""));
            if (*pVal)
            {
                if ( (strlen(pVal) <=7) || (strlen(pVal) > 64) )
                    return 4;
                    
                memset(setbuf.GuestAccessPassPhrase2, 0, 64);
                if((strlen(pVal) == 64))
                {
                    if (!IsHexKey(pVal))
                        return 5;                    
                    HexStringToHexDigi(setbuf.GuestAccessPassPhrase2, pVal, 32);
                    // Use GuestAccessPassPhrase2[63] to indicate 64 HEX
                    setbuf.GuestAccessPassPhrase2[63] = GUEST_ACCESS_WITH_64HEX;
                }
                else if (strcmp(pVal, "**********") != 0)
                {
                    strcpy(setbuf.GuestAccessPassPhrase2, pVal);
                }
            }
        }
        else            // Disable GUEST_ACCESS
        {
            setbuf.GuestAccessEnable = 0;
        }
        webApiCmd(APCMD_SET_GUEST_ACCESS, &setbuf, sizeof(APICMDBUF_SET_GUEST_ACCESS)-BUF_HDR_LEN);
    }
#endif
    return AP_DATA_SAVED; 
/*	
    if(wpaMode == 1)
    {
        return 2;			
    }
    else
    {
       {
            APICMDBUF_DEAUTH_STA cmdBuf;

            cmdBuf.seqNum = 1;
            cmdBuf.cmdCode = APCMD_DEAUTH_STA;
            cmdBuf.cmdBodyLen = 6; 
            cmdBuf.staMACAddress[0]=0xff;
            cmdBuf.staMACAddress[1]=0xff;
            cmdBuf.staMACAddress[2]=0xff;
            cmdBuf.staMACAddress[3]=0xff;
            cmdBuf.staMACAddress[4]=0xff;
            cmdBuf.staMACAddress[5]=0xff;
            apctl(&cmdBuf);
           
        }    			
        //chData = 1;
        //ApCmdSetProc(APCMD_BSS_START, &chData); 			
        return 0;
    }		 
*/  
}

int ProcessUserData(char * DataFromUser, char * DataToWlandrv, char * pTemp)
{
    unsigned short i,j;

    memset(DataFromUser, 0, DATA_SIZE_FROM_USER);
    memset(DataToWlandrv, 0, DATA_SIZE_TO_WLADRV);
    strcpy(DataFromUser, pTemp);    

    for (i=0; i<(int)strlen(DataFromUser);i++)
    {
        if (DataFromUser[i]=='+')
        {
            DataFromUser[i] = ' ';
        }
    }                        

    for (i=0,j=0; i<(int)strlen(DataFromUser);i++,j++)
    {

        if (DataFromUser[i]=='%')
        {
            if (DataFromUser[i+1]== '2')
            {

                switch (DataFromUser[i+2])
                {
                case '0':
                    DataToWlandrv[j]=' ';
                    break;                                  

                case '1':
                    DataToWlandrv[j]='!';
                    break;      

                case '2':
                    DataToWlandrv[j]='"';
                    break;  

                case '3':
                    DataToWlandrv[j]='#';
                    break;  

                case '4':
                    DataToWlandrv[j]='$';
                    break;  

                case '5':
                    DataToWlandrv[j]='%';
                    break;  

                case '6':
                    DataToWlandrv[j]='&';
                    break;  

                case '7':
                    DataToWlandrv[j]='\'';
                    break;  

                case '8':
                    DataToWlandrv[j]='(';
                    break;  

                case '9':
                    DataToWlandrv[j]=')';
                    break;  

                case 'A':
                    DataToWlandrv[j]='*';
                    break;  

                case 'B':
                    DataToWlandrv[j]='+';
                    break;  

                case 'C':
                    DataToWlandrv[j]=',';
                    break;

                case 'D':
                    DataToWlandrv[j]='-';
                    break;  

                case 'E':
                    DataToWlandrv[j]='.';
                    break;  

                case 'F':
                    DataToWlandrv[j]='/';
                    break;                                                                          

                default:
                    break;                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  
                }
                i +=2;                                                                                              
            }
            else if (DataFromUser[i+1]== '3')
            {
                switch (DataFromUser[i+2])
                {
                case 'A':
                    DataToWlandrv[j]=':';
                    break;  

                case 'B':
                    DataToWlandrv[j]=';';
                    break;  

                case 'C':
                    DataToWlandrv[j]='<';
                    break;

                case 'D':
                    DataToWlandrv[j]='=';
                    break;  

                case 'E':
                    DataToWlandrv[j]='>';
                    break;  

                case 'F':
                    DataToWlandrv[j]='?';
                    break;                                                                          

                default:
                    break;  
                }
                i +=2;                                                                      
            }
            //no need to detect '@'
            else if (DataFromUser[i+1]== '5')
            {

                switch (DataFromUser[i+2])
                {
                
                case 'B':
                    DataToWlandrv[j]='[';
                    break;  

                case 'C':
                    DataToWlandrv[j]='\\';
                    break;

                case 'D':
                    DataToWlandrv[j]=']';
                    break;  

                case 'E':
                    DataToWlandrv[j]='^';
                    break;  

                case 'F':
                    DataToWlandrv[j]='_';
                    break;                                                                          

                default:
                    break;      
                }
                i +=2;                                                      
            }
            else if (DataFromUser[i+1]== '6')
            {
                switch (DataFromUser[i+2])
                {
                
                case '0':
                    DataToWlandrv[j]='`';
                    break;                                                                          

                default:
                    break;                              
                }
                i +=2;
            }
            else if (DataFromUser[i+1]== '7')
            {
                switch (DataFromUser[i+2])
                {
                case 'B':
                    DataToWlandrv[j]='{';
                    break;  

                case 'C':
                    DataToWlandrv[j]='|';
                    break;

                case 'D':
                    DataToWlandrv[j]='}';
                    break;  

                case 'E':
                    DataToWlandrv[j]='~';
                    break;                                                                                                          

                default:
                    break;      
                }
                i +=2;                                                      
            }
        }
        else
        {
            DataToWlandrv[j]=DataFromUser[i];
        }

    }               
    return 0;
}

#ifdef AP_SITE_SURVEY
/**************************************************************************
*
*
*
*
**************************************************************************/
int SetSurvey(webs_t wp, char_t* query)
{

    char    *pTemp, *pCur, *pChan, *pIbss, *pMode;
    unsigned char *tmp; 
    int     i;
    char    chData;
    char    joinAction = 0;
    char    bufData[50];
    unsigned char bssidAddr[6];
    UINT16 AP_Mode = 0;
    UINT8 nData   = 0;
    UINT8 Chan    = 0;
    UINT8 Ibss    = 0;
    char  Mode    = 0;


    if (query == NULL || strlen(query)==0)
    {
        return 0;
    }

    if ((tmp = malloc(250)) == NULL)
    {
        return 0;
    }

    pCur = strstr(query, "action");
    if (pCur != NULL)
    {
        strcpy(tmp, pCur);

        // Set SSID
        if ((pTemp = strchr(tmp, '&'))!=NULL)
        {
            *pTemp = '\0';
        }

        if ( (pTemp = strchr(tmp, '='))!=NULL)
        {
            pTemp++; 

            memset(bufData, 0, 50);
            strcpy(bufData, pTemp);


            for (i=0; i<(int)strlen(bufData);i++)
            {
                if (bufData[i]=='+')
                {
                    bufData[i] = ' ';
                }
            }
            if (memcmp(bufData, "Join", 4) == 0)
            {
                joinAction = 1;
            }
        }
    }
    if (joinAction)
    {

        pCur = strstr(query, "peer");
        if (pCur != NULL)
        {
            strcpy(tmp, pCur);

            /* Set SSID */
            if ((pTemp = strchr(tmp, '&'))!=NULL)
            {
                *pTemp = '\0';
            }

            if ( (pTemp = strchr(tmp, '='))!=NULL)
            {
                pTemp++;
                /* Get Channel */
                pChan = strchr(pTemp, '+');
                *(pChan++) = 0;
                /* Get IBSS mode */
                pIbss = strchr(pChan, '+');
                *(pIbss++) = 0;
                /* Get AP mode */
                pMode = strchr(pIbss, '+');
                *(pMode++) = 0;
                /* Convert channel, Ibss and Mode. */
                Chan =  (UINT8) atodec(pChan);
                Ibss =  (UINT8) atodec(pIbss);
                Mode = *pMode;         
                if ( (strlen(pTemp) >32) )
                {
                    free(tmp);
                    return 0;
                }
            }
        }
        else
        {
            /* No join parameters */
            joinAction = 0;
        }
    }

    free(tmp);

    if (joinAction)
    {
#ifdef AP_URPTR
        util_CopyList(mib_StaCfg_ur.DesiredSsId, pTemp, IEEEtypes_SSID_SIZE);
        util_CopyList(mib_urSsid, pTemp, IEEEtypes_SSID_SIZE);
#endif
        ApCmdSetProc(APCMD_SET_RF_CHANNEL, &Chan);

        AP_Mode_Updated = FALSE;

        if (Mode == 'B')
        {
            nData = AP_MODE_MIXED;
        }
        else if (Mode == 'G')
        {
            nData = AP_MODE_G_ONLY;
        }
        else if (Mode == 'A')
        {
            nData = AP_MODE_A_ONLY;
        }
        else
            nData = AP_MODE_G_ONLY;


        if (ApCmdGetProc(APCMD_GET_AP_MODE, &AP_Mode) == STATUS_FAIL)
        {
            //
            //If failed, just assume AP_Mode_Updated=TRUE;
            //
            AP_Mode_Updated=TRUE;
        }
        else
        {
            /* Check if AP_Mode and current mode are equal, if not then update. */
            if (AP_Mode != (UINT8)nData)
                AP_Mode_Updated=TRUE;
        }
        if (AP_Mode_Updated == TRUE)
        {
            ApCmdSetProc(APCMD_SET_AP_MODE, (char *)&nData);

            if (nData == AP_MODE_G_ONLY)
            {
                bufData[ 0] =  2 | 0x80;
                bufData[ 1] =  4 | 0x80;
                bufData[ 2] = 11 | 0x80;
                bufData[ 3] = 22 | 0x80;
                bufData[ 4] = 12 | 0x80;
                bufData[ 5] = 18;
                bufData[ 6] = 24 | 0x80;
                bufData[ 7] = 36;
                bufData[ 8] = 48 | 0x80;
                bufData[ 9] = 72;
                bufData[10] = 96;
                bufData[11] = 108;
                bufData[12] = 0;
                bufData[13] = 0;                
                bufData[14] = 0;
                bufData[15] = 0;                
            }
            else if (nData == AP_MODE_A_ONLY)
            {
                bufData[0]  = 12 | 0x80;
                bufData[1]  = 18;
                bufData[2]  = 24 | 0x80;
                bufData[3]  = 36;
                bufData[4]  = 48 | 0x80;
                bufData[5]  = 72;
                bufData[6]  = 96;
                bufData[7]  = 108;
                bufData[8]  = 144;
                bufData[9]  = 0;
                bufData[10] = 0;
                bufData[11] = 0;
                bufData[12] = 0;
                bufData[13] = 0;
                bufData[14] = 0;
                bufData[15] = 0;
            }
            else if (nData == AP_MODE_MIXED)
            {
                bufData[ 0] =  2 | 0x80;
                bufData[ 1] =  4 | 0x80;
                bufData[ 2] = 11 | 0x80;
                bufData[ 3] = 22 | 0x80;
                bufData[ 4] = 12;
                bufData[ 5] = 18;
                bufData[ 6] = 24;
                bufData[ 7] = 36;
                bufData[ 8] = 48;
                bufData[ 9] = 72;
                bufData[10] = 96;
                bufData[11] = 108;
                bufData[12] = 0;
                bufData[13] = 0;  
                bufData[14] = 0;
                bufData[15] = 0;                
            }
            else if (nData == AP_MODE_B_ONLY)
            {
                bufData[ 0] =  2 | 0x80;
                bufData[ 1] =  4 | 0x80;
                bufData[ 2] = 11 | 0x80;
                bufData[ 3] = 22 | 0x80;
                bufData[ 4] = 0;
                bufData[ 5] = 0;
                bufData[ 6] = 0;
                bufData[ 7] = 0;
                bufData[ 8] = 0;
                bufData[ 9] = 0;
                bufData[10] = 0;
                bufData[11] = 0;
                bufData[12] = 0;
                bufData[13] = 0;  
                bufData[14] = 0;
                bufData[15] = 0;                
            }
            ApCmdSetProc(APCMD_SET_BASIC_DATA_RATES_G, bufData);
        }
    }
    else
    {
        ApCmdSetProc(APCMD_SET_SURVEY_SCAN, &chData);
    }

    return joinAction;

}
#endif /* AP_SITE_SURVEY */

#ifdef TURBO_SETUP_TEST
int SetAutolinkRate(webs_t wp, char_t* query)
{

    char    tmp[400];
	char	*pTemp, *pCur; 
	int		i;
	char	chData;
	char    bufData[50];
	USHORT nData;
	ULONG lData;
	UCHAR AutolinkRate;
	UCHAR	AP_Mode, ucData;
	BURST_INFO BurstInfo;

	if (query == NULL || strlen(query)==0)
	{
		return 0;
	}
  	pCur = strstr(query, "rate_autolink");

 	if (pCur!=NULL)
	{
		strcpy(tmp, pCur);
		if ((pTemp = strchr(tmp, '&'))!=NULL)
		{
			*pTemp = '\0';	
		}
		if ((pTemp = strchr(tmp, '='))!=NULL)
		{
			i = 1;
			nData = 0;
			while (*(pTemp+i)!='+' && *(pTemp+i)!='.')
			{
				nData = nData*10 + *(pTemp+i) - '0';
				i++;
			} 			
			if(nData == 5)
			{
				nData = 11;
			} 
			else
			{
				nData = nData * 2;
			}
            switch(nData)
            {
            case 2:
                AutolinkRate = 0;
                break;
            case 4:
                AutolinkRate = 1;
                break;
            case 11:
                AutolinkRate = 2;
                break;
            case 22:
                AutolinkRate = 3;
                break;
            case 12:
                AutolinkRate = 5;
                break;
            case 18:
                AutolinkRate = 6;
                break;
            case 24:
                AutolinkRate = 7;
                break;
            case 36:
                AutolinkRate = 8;
                break;
            case 48:
                AutolinkRate=9;
                break;
            case 72:
                AutolinkRate=10;
                break;
            case 96:
                AutolinkRate=11;
                break;
            case 108:
                AutolinkRate=12;
                break;
            case 144:
                AutolinkRate=13;
                break;
            }

            apiSetAutolinkRate(AutolinkRate);

    	       chData = 1;
		      ApCmdSetProc(APCMD_BSS_START, &chData); 			
		}
	}
    return 0;
}

int AutolinkRate(webs_t wp, int Error)
{

    websRedirect(wp, T("ts.asp"));
    return 0;

}
#endif

void websResetAP(void)
{
    APICMDBUF *pCmdbuf;

    pCmdbuf = malloc(sizeof(APICMDBUF));
    pCmdbuf->cmdStatus = APCTL_CMD_FAILED;
    while (pCmdbuf->cmdStatus != APCTL_OK)
    {
        pCmdbuf->cmdCode = APCMD_FW_SOFT_RESET;
        pCmdbuf->seqNum = 1;
        apctl(pCmdbuf);
    }
    free(pCmdbuf);  
}
#ifdef QOS_FEATURE
UINT8* ParseMacAddr(UINT8 *pCur, UINT8 *pMacAddr)
{
    UINT8 val;
    UINT8 *pBegin, *pEnd;

    pBegin = pCur;
    pEnd = strchr(pBegin,'-');
    val = atohex(pBegin);
    pMacAddr[0] = val;

    pBegin = pEnd + 1;
    pEnd = strchr(pBegin,'-');
    val = atohex(pBegin);
    pMacAddr[1] = val;  

    pBegin = pEnd + 1;
    pEnd = strchr(pBegin,'-');
    val = atohex(pBegin);
    pMacAddr[2] = val;  

    pBegin = pEnd + 1;
    pEnd = strchr(pBegin,'-');
    val = atohex(pBegin);
    pMacAddr[3] = val;

    pBegin = pEnd + 1;
    pEnd = strchr(pBegin,'-');
    val = atohex(pBegin);
    pMacAddr[4] = val;

    pBegin = pEnd + 1;
    //pEnd = strchr(pBegin,'.');
    val = atohex(pBegin);
    pMacAddr[5] = val;  
    return strchr(pBegin,'-');
}

int SetQos(webs_t wp, char_t* query)
{
    UINT32 EDCAData[5], i;
    char    *pTemp, *pCur, chData; 
    unsigned char    qos_enabled;

    if (query == NULL || strlen(query)==0)
    {
        return 0;
    }

    //QOS Mode
    pCur = strstr(query, "qosMode");
    if (pCur!=NULL)
    {

        if (pTemp = strchr(pCur, '&'))
        {
            *pTemp = '\0';  
        }

        if (strstr(pCur, "Enabled"))
        {
            qos_enabled = 1;
        }
        else
        {
            qos_enabled = 0;
        }
        
        //set QoS mode
        {
            APICMDBUF_SET_QOS_MODE cmdBuf;

            cmdBuf.seqNum = 1;
            cmdBuf.cmdCode = APCMD_SET_QOS_MODE;
            cmdBuf.cmdBodyLen = sizeof(APICMDBUF_SET_QOS_MODE) - 4*sizeof(unsigned short);
            cmdBuf.qos_mode = qos_enabled;
            apctl(&cmdBuf);
        }

    }

    /* Add QOS Setting end */
    SetUserConfig();
    chData = 1;

    /* Enable/Disable QoS needs SW reset for now */
    apRebooting(wp, "/qos.asp");
    // ApCmdSetProc(APCMD_BSS_START, &chData);
    return 0; 
}

void SetQosTspec(webs_t wp, char_t* query)
{
    char    tmp[400];
    UINT32 EDCAData[5], i;
    char    *pTemp, *pCur, chData; 
    unsigned char    noack_enabled;

    if (query == NULL || strlen(query)==0)
    {
        return 0;
    }

//NoAck Mode
    pCur = strstr(query, "noAckMode");
    strcpy(tmp, pCur);
    if (pCur!=NULL)
    {

        if (pTemp = strchr(tmp, '&'))
        {
            *pTemp = '\0';  
        }

        if (strstr(tmp, "Enabled"))
        {
            noack_enabled = 1;
        }
        else
        {
            noack_enabled = 0;
        }
        
        //set QoS mode
        {
            APICMDBUF_SET_NOACK_MODE cmdBuf;

            cmdBuf.seqNum = 1;
            cmdBuf.cmdCode = APCMD_SET_NOACK_MODE;
            cmdBuf.cmdBodyLen = sizeof(APICMDBUF_SET_NOACK_MODE) - 4*sizeof(unsigned short);
            cmdBuf.noack_mode = noack_enabled;
            apctl(&cmdBuf);
        }

    }

    //QOS Mode
    //Process only of QoS Mode is emabled
    pCur = strstr(query, "UpdateEDCA");
	if(pCur != NULL)
    {
        pCur = strchr(pCur,'=');
        pCur++;
        if (!strncmp(pCur, "Update_EDCA", 11))
        {
            //Update the EDCA parameters.
			UpdateEdca(query);
            UserConfigModified();
            SaveUserConfig();

        }
	}
    pCur = strstr(query, "UpdateStnEDCA");
	if(pCur != NULL)
    {
        pCur = strchr(pCur,'=');
        pCur++;
        if(!strncmp(pCur, "Update_Stn_EDCA", 15))
        {
            //Update the EDCA parameters.
			UpdateStnEdca(query);
            UserConfigModified();
            SaveUserConfig();
        }
	}
    pCur = strstr(query, "DelTspec");
	if(pCur != NULL)
    {
        pCur = strchr(pCur,'=');
        pCur++;
        if (!strncmp(pCur, "Del_Tspec", 9))
        {//Delete Tspec
            IEEEtypes_MacAddr_t StaAddr;
            unsigned int TsId;

            pCur = strstr(query, "peer");
            pCur = strchr(pCur, '=');
            pCur++;
            pCur = ParseMacAddr(pCur, (UINT8*)&StaAddr);
            pCur++;
            TsId = atoi(pCur);
            SendDelTS(&StaAddr, TsId);//Send the DelTs packet
            ProcessDELTSRequest(&StaAddr, TsId);//delete the entry from Data base
        }
    }
}
UINT32 GetIntegerValueOf(char_t *query, char_t *param,char_t **nextParam)
{
   
    UINT32 EDCAData[5], i,Val=0;
    char    *pTemp, *pCur, chData; 

	{
   pTemp = query;
         pCur = strstr(query, param);
        
         if (pCur!=NULL)
		 {

              if (pTemp = strchr(pCur, '&'))
			  {
                  *pTemp = '\0';  
			  }

             
              if((pTemp = strchr(pCur, '='))!=NULL)
               {
                        i=1;
                         Val = 0;
                         while(*(pTemp+i)!='\0')
                          {
                                Val = Val*10 + *(pTemp+i) - '0';
                                i++;
                            }
						 *nextParam = pTemp+i+1;
                 }
			  else
				  Val = 0;

		 }
		 return Val;
	}
}
UpdateEdca(char_t* query)
{
    char    tmp[400];
    UINT32 EDCAData[6], i;
    char    *pTemp, *pCur, chData; 
	
	
	strcpy(tmp,query);
	pTemp = tmp;
	for(i = 0; i <4; i++)
	{
		/* the following logic is used because, in the GUI BK is first, where as in the MIB BE is
		 * first in the table */
		if ( i == 0)  /* first set is for BK , ACI is 1*/
            EDCAData[0] = 1;
		else if( i == 1)  /* second set for BE, ACI is 0 */ 
			EDCAData[0] = 0;
		else
			EDCAData[0] = i;
		EDCAData[1] = GetIntegerValueOf(pTemp,"WME_CWMin",&pTemp);
		EDCAData[2] = GetIntegerValueOf(pTemp,"WME_CWMax",&pTemp);
		EDCAData[3] = GetIntegerValueOf(pTemp,"WME_AIFS",&pTemp);
		EDCAData[4] = GetIntegerValueOf(pTemp,"WME_TxOpLimitB",&pTemp)/32;
        EDCAData[5] = GetIntegerValueOf(pTemp,"WME_TxOpLimit",&pTemp)/32;

        //Call the API command to update the EDCA Parameters.
        ApCmdSetProc(APCMD_SET_EDCA_PARAM, &EDCAData[0]);
	}
}
UpdateStnEdca(char_t* query)
{
    char    tmp[400];
    UINT32 EDCAData[7], i;
    char    *pTemp, *pCur, chData; 
	
	
	strcpy(tmp,query);
	pTemp = tmp;
	for(i = 4; i <8; i++)
	{
		if ( i == 4)  /* first set is for BK , ACI is 1*/
            EDCAData[0] = 5;
		else if( i == 5)  /* second set for BE, ACI is 0 */ 
			EDCAData[0] = 4;
		else
			EDCAData[0] = i;
		EDCAData[1] = GetIntegerValueOf(pTemp,"WME_CWMin",&pTemp);
		EDCAData[2] = GetIntegerValueOf(pTemp,"WME_CWMax",&pTemp);
		EDCAData[3] = GetIntegerValueOf(pTemp,"WME_AIFS",&pTemp);
		EDCAData[4] = GetIntegerValueOf(pTemp,"WME_TxOpLimitB",&pTemp)/32;
		EDCAData[5] = GetIntegerValueOf(pTemp,"WME_TxOpLimit",&pTemp)/32;
		EDCAData[6] = GetIntegerValueOf(pTemp,"WME_ACM",&pTemp);
        //Call the API command to update the EDCA Parameters.
        ApCmdSetProc(APCMD_SET_EDCA_PARAM, &EDCAData[0]);
	}
}

#endif
#if defined(GATEWAY) || defined(DHCPS)
int webSetDHCPSConfig(webs_t wp, char_t* query, char_t* pageName)
{
    char    *pTmp, Buf[100]={0}, target[13]={0};
    char    *pTemp, *pCur;
    char        inputName[3][13]={"StartIPAddr","EndIPAddr"/*,"Gateway","PDNS","SDNS"*/,"NewIPAddr"};
    int     i, j, k;
    int                index=0,indexBuf=0,len=0;
    ULONG   nData;
    char pStr[12]={0};
    UCHAR MacAddr[6]={0}, voidAddr[6]={0};
    UCHAR pBuf[1360];

    if (query == NULL || strlen(query)==0)
    {
    return 1;
    }

    pTmp = malloc(400);

    memset(pTmp, 0, 400);
    memset(Buf, 0, 100);

    if ( ApCmdGetProc(APCMD_GET_ETH_DHCPS_CONFIG, (char*)pBuf) == STATUS_FAIL )
    {
       memset(pBuf, 0, sizeof(pBuf));
    }
     memcpy(Buf,pBuf,16);

    // Get DHCP Sever option
    pCur = strstr(query, "DHCPServer");


    //pCur = NULL;
    if (pCur!=NULL)
    {
      strcpy(pTmp, pCur);

      if ((pTemp = strchr(pTmp, '&'))!=NULL)
      {
          *pTemp = '\0';
      }
      else
      {
              free (pTmp);
              return 0;
      }

      if (strchr(pTmp, 'on')!=NULL) // DHCP enabled
      {
          *((ULONG*)Buf) = 1;
      }
      else
      {
          *((ULONG*)Buf) = 0;
      }
    }

    else{
        if(!strcmp(pageName, "DhcpGlobal")){
         // if the checkbox is unchecked we will not get the DHCPServer string in the query
          *((ULONG*)Buf) = 0;
        }
    }


    // Get IP Address parameters
    for(k=0; k<3; k++){
       strcpy(target, inputName[k]);

       if(strcmp(inputName[k], "StartIPAddr")==0){
           indexBuf = 3;
           index = 11;
       }
       else{
           if(strcmp(inputName[k], "EndIPAddr")==0){
               indexBuf = 7;
               index = 9;
           }
           else{
             if(strcmp(inputName[k], "NewIPAddr")==0){
                 indexBuf = 19; //31
                 index = 9;
             }
           }
      }

      for (i=1; i<=4; i++)
      {
          target[index] = '0'+i;
          for(j=(index+1);j<13;j++){
          target[j] = 0;
          }

          pCur = strstr(query, target);

          if (pCur!=NULL)
          {
              strcpy(pTmp, pCur);

              if ((pTemp = strchr(pTmp, '&'))!=NULL)
              {
                   *pTemp = '\0';
              }
              else
              {
                   free (pTmp);
                   return 0;
              }


              nData = 0;

              pTemp = pTmp+(index+2); // Set the pTemp pointer to the value (after the name and the '=')

              while (*pTemp!='\0')
              {
                   if (*pTemp>='0' && *pTemp<='9')
                   {
                           nData = nData*10 + *pTemp - '0';
                           pTemp++;
                   }
                   else
                   {
                           free (pTmp);
                           return 0;
                   }
              }

              if (nData>255)
              {
                   free(pTmp);
                   return 0;
              }

              *(Buf+indexBuf+i)=(UCHAR)nData;
        }
     }
    }

	{  
		ULONG endIp = inet_address (*((ULONG *)&Buf[8]));
		ULONG startIp = inet_address (*((ULONG *)&Buf[4]));
		if (endIp <= startIp)
		{
			return 0;
		}
	}

    // Get GlobalLeaseTime Parameter
    pCur = strstr(query, "GlobalLeaseTime");

    if (pCur!=NULL)
    {
       strcpy(pTmp, pCur);

       /*if ((pTemp = strchr(pTmp, '&'))!=NULL)
       {
           *pTemp = '\0';
       }
       else
       {
               free (pTmp);
               return 0;
       } */

       i = 0;
       nData = 0;
       pTemp = pTmp+16; //GlobalLeaseTime value presented as seconds

       while (*(pTemp+i)!='\0')
       {
           if ( *(pTemp+i) < '0' || *(pTemp+i) > '9')
           {
               return 0;
           }

           nData = nData*10 + *(pTemp+i) - '0';
           i++;
       }
       memcpy((ULONG*)(Buf+12), &nData, 4);
    }


    // Get State Parameter
    pCur = strstr(query, "State");

    if (pCur!=NULL)
    {
        strcpy(pTmp, pCur);
        /*if ((pTemp = strchr(pTmp, '&'))!=NULL)
        {
            *pTemp = '\0';
        }
        else
        {
                free (pTmp);
                return 0;
        }*/

        pTemp = pTmp+6;
	
		if (strchr(pTemp, '0')!=NULL) // Delete
        {
            *((ULONG*)(Buf+16)) = 0;
        }
        else        
        {
			if (strchr(pTemp, '1')!=NULL){ //Reserved
				*((ULONG*)(Buf+16)) = 1;
			}            
			else
				*((ULONG*)(Buf+16)) = 2; //Dynamic
        }

    //    *(Buf+16)=*pTemp;
    }

    // Get MAC Parameter
    memset(target, 0, 13);
    strcpy(target, "MAC");
    index=3;
    indexBuf=24;

    for (i=1; i<=6; i++)
    {
            target[index] = '0'+i;

            pCur = strstr(query, target);

            if (pCur!=NULL)
            {
                    strcpy(pTmp, pCur);

                    if ((pTemp = strchr(pTmp, '&'))!=NULL)
                    {
                            *pTemp = '\0';
                    }
                    else
                    {
                            free (pTmp);
                            return 0;
                    }

                    pTemp = pTmp+5;

                    strcat(pStr, pTemp);
            }
     }

    getMacFromString(MacAddr, pStr);

    if (memcmp(MacAddr, voidAddr, 6)!=0)
    {
        memcpy((UCHAR*)(Buf+indexBuf), MacAddr, 6);
    }

    ApCmdSetProc(APCMD_SET_ETH_DHCPS_CONFIG, Buf);

    return 1;
}
#endif

#if defined(GATEWAY) 
int webSetLanIpConfig(webs_t wp, char_t* query)
{
    char    *pTmp, Buf[8]={0}, target[13]={0};
    char    *pTemp, *pCur;
    char    inputName[2][8]={"IPAddr","Mask"};
    int     i, j, k;
    int     index=0,indexBuf=0,len=0;
    ULONG   nData;

    if (query == NULL || strlen(query)==0)
    {
    return 1;
    }

    pTmp = malloc(100);

    memset(pTmp, 0, 100);
    memset(Buf, 0, 8);

    // Get IP Address and Mask parameters
    for(k=0; k<2; k++){
            strcpy(target, inputName[k]);


            if(strcmp(inputName[k], "IPAddr")==0){
                    indexBuf = 0;
                    index = 6;
            }
            else{
                    if(strcmp(inputName[k], "Mask")==0){
                            indexBuf = 4;
                            index = 4;
                    }
            }

            for (i=1; i<=4; i++)
            {
                    target[index] = '0'+i;
                    for(j=(index+1);j<8;j++){
                            target[j] = 0;
                    }

                    pCur = strstr(query, target);

                    if (pCur!=NULL)
                    {
                            strcpy(pTmp, pCur);
                            //if(!(strcmp(target, "Mask4"))){
                                    if ((pTemp = strchr(pTmp, '&'))!=NULL)
                                    {
                                            *pTemp = '\0';
                                    }
                                    else
                                    {
                                            free (pTmp);
                                            return 0;
                                    }
                    //        }

                            nData = 0;

                            pTemp = pTmp+(index+2); // Set the pTemp pointer to the value (after the name and the '=')

                            while (*pTemp!='\0')
                            {
                                    if (*pTemp>='0' && *pTemp<='9')
                                    {
                                            nData = nData*10 + *pTemp - '0';
                                            pTemp++;
                                    }
                                    else
                                    {
                                            free (pTmp);
                                            return 0;
                                    }
                            }

                            if (nData>255)
                            {
                                    free(pTmp);
                                    return 0;
                            }

                            *(Buf+indexBuf+i-1)=(UCHAR)nData;
                    }
            }
    }

    ApCmdSetProc(APCMD_SET_ETH_LAN_IP_CONFIG, Buf);

    return 1;
}


int webSetWanIpConfig(webs_t wp, char_t* query)
{
    char    *pTmp, Buf[24]={0}, target[13]={0};
    char    *pTemp, *pCur;
    char    inputName[5][8]={"IPAddr","Mask", "Gateway", "PDNS", "SDNS"};
    int     i, j, k;
    int     index=0,indexBuf=0,len=0;
    ULONG   nData;

    if (query == NULL || strlen(query)==0)
    {
    return 1;
    }

    pTmp = malloc(240);

    memset(pTmp, 0, 240);
    memset(Buf, 0, 24);


    // Get DHCP Enabled option
    pCur = strstr(query, "DHCP");


    //pCur = NULL;
    if (pCur!=NULL)
    {
      strcpy(pTmp, pCur);

      if ((pTemp = strchr(pTmp, '&'))!=NULL)
      {
          *pTemp = '\0';
      }
      else
      {
              free (pTmp);
              return 0;
      }

          pTemp = pTmp+5;


                if (strchr(pTemp, '1')!=NULL) // DHCP enabled
        {
            *((ULONG*)Buf) = 1;
        }
        else
        {
            *((ULONG*)Buf) = 0;
        }




    }

   // Get IP Address, Mask, Gateway, Primary DNS and Secondary DNS parameters
   for(k=0; k<5; k++){
           strcpy(target, inputName[k]);


           if(strcmp(inputName[k], "IPAddr")==0){
                   indexBuf = 4;
                   index = 6;
           }
           else{
                   if(strcmp(inputName[k], "Mask")==0){
                           indexBuf = 8;
                           index = 4;
                   }
                   else{
                           if(strcmp(inputName[k], "Gateway")==0){
                                   indexBuf = 12;
                                   index = 7;
                           }
                           else{
                                   if(strcmp(inputName[k], "PDNS")==0){
                                           indexBuf = 16;
                                           index = 4;
                                   }
                                   else{
                                           if(strcmp(inputName[k], "SDNS")==0){
                                                   indexBuf = 20;
                                                   index = 4;
                                           }
                                   }
                           }
                   }

           }

           for (i=1; i<=4; i++)
           {
                   target[index] = '0'+i;
                   for(j=(index+1);j<8;j++){
                           target[j] = 0;
                   }

                   pCur = strstr(query, target);

                   if (pCur!=NULL)
                   {
                           strcpy(pTmp, pCur);
                           //if(!(strcmp(target, "Mask4"))){
                                   if ((pTemp = strchr(pTmp, '&'))!=NULL)
                                   {
                                           *pTemp = '\0';
                                   }
                                   else
                                   {
                                           free (pTmp);
                                           return 0;
                                   }
                   //        }

                           nData = 0;

                           pTemp = pTmp+(index+2); // Set the pTemp pointer to the value (after the name and the '=')

                           while (*pTemp!='\0')
                           {
                                   if (*pTemp>='0' && *pTemp<='9')
                                   {
                                           nData = nData*10 + *pTemp - '0';
                                           pTemp++;
                                   }
                                   else
                                   {
                                           free (pTmp);
                                           return 0;
                                   }
                           }

                           if (nData>255)
                           {
                                   free(pTmp);
                                   return 0;
                           }

                           *(Buf+indexBuf+i-1)=(UCHAR)nData;
                   }
           }
   }

   ApCmdSetProc(APCMD_SET_ETH_WAN_IP_CONFIG, Buf);

   return 1;
}
#endif

void getBssIdFromString(unsigned char *macAddr, const char *pStr) {
    int nAddr = 0;

    memset(macAddr, 0, 6);

    if (strlen(pStr) > 0)
    {
        while (nAddr < 6)
        {
            if (strlen(pStr)==0)
            {
                memset(&macAddr[nAddr], 0, 6-nAddr);
                return; 
            }

            if (*pStr==':')
            {
                pStr = pStr+1;
                continue;
            }


            if (*pStr>='A' && *pStr<='F')
            {
                macAddr[nAddr] = *pStr - 'A' + 10;
            }
            else if (*pStr>='a' && *pStr<='f')
            {
                macAddr[nAddr] = *pStr - 'a' + 10;
            }
            else if (*pStr>='0' && *pStr<='9')
            {
                macAddr[nAddr] = *pStr - '0';
            }
            else
            {
                continue;
            }

            pStr++;

            if (*pStr>='A' && *pStr<='F')
            {
                macAddr[nAddr] = (macAddr[nAddr] << 4) | (*pStr - 'A' + 10);
            }
            else if (*pStr>='a' && *pStr<='f')
            {
                macAddr[nAddr] = (macAddr[nAddr] << 4) | (*pStr - 'a' + 10);
            }
            else if (*pStr>='0' && *pStr<='9')
            {
                macAddr[nAddr] = (macAddr[nAddr] << 4) | (*pStr - '0');
            }

            pStr++;
            nAddr++;
        }
    }
    else
        memset(macAddr, 0, 6);
}

#ifdef DCS
int SetBGScan(webs_t wp, char_t* query)
{
    UINT8 i;
    UINT8 chData, chOldData;
    char    *pTemp, *pCur;
    char    tmp[400];
    UINT8 dcsMode;
    UINT16 timeoutVal;
    
    if (query == NULL || strlen(query)==0)
    {
        return 0;
    }

    pCur = strstr(query, "DCSEnable");
    chData = dcsMode = (pCur!=NULL)?TRUE:FALSE;
	{
	APICMDBUF_GET_DCS_MODE cmdBuf;
	cmdBuf.cmdCode = APCMD_GET_DCS_MODE;
    cmdBuf.seqNum = 1;
    cmdBuf.cmdBodyLen = sizeof(APICMDBUF_SET_DCS_MODE)- APICMDHEADERLEN;
	apctl(&cmdBuf);
    chOldData = cmdBuf.DCSMode;
	}
	{
	APICMDBUF_SET_DCS_MODE cmdBuf;
	cmdBuf.cmdCode = APCMD_SET_DCS_MODE;
    cmdBuf.seqNum = 1;
    cmdBuf.cmdBodyLen = sizeof(APICMDBUF_SET_DCS_MODE)- APICMDHEADERLEN;
	cmdBuf.DCSMode = chData;
	apctl(&cmdBuf);
	}

    /* If DCS is enabled then also enable Spectrum management and vice versa*/
    {
    	APICMDBUF_SET_SPECTRUM_MGMT cmdBuf;
    	cmdBuf.cmdCode = APCMD_SET_SPECTRUM_MGMT;
        cmdBuf.seqNum = 1;
        cmdBuf.cmdBodyLen = 1;
        cmdBuf.isEnable = (chData?TRUE:FALSE);
        apctl(&cmdBuf);
    }

    /* If DCS enabled for the first time reboot and then setup BG Scan */
    if (chOldData != chData)
        return AP_NEEDS_REBOOT;

    pCur = strstr(query, "BGScanEnable");
    bgScanEnable = (pCur!=NULL)?TRUE:FALSE;

    pCur = strstr(query, "ScanInterval"); 
    if (pCur!=NULL)
    {
        strcpy(tmp, pCur);
        if ((pTemp = strchr(tmp, '&'))!=NULL)
        {
            *pTemp = '\0';  
        }
        if ((pTemp = strchr(tmp, '='))!=NULL)
        {
            i = 1;
            bgScanInterval = 0;
            while (*(pTemp+i)!='\0')
            {
                bgScanInterval = bgScanInterval*10 + *(pTemp+i) - '0';
                i++;
            }
        }
    }

    pCur = strstr(query, "ChannelsPerScan"); 
    if (pCur!=NULL)
    {
        strcpy(tmp, pCur);
        if ((pTemp = strchr(tmp, '&'))!=NULL)
        {
            *pTemp = '\0';  
        }
        if ((pTemp = strchr(tmp, '='))!=NULL)
        {
            i = 1;
            bgChannelsPerScan = 0;
            while (*(pTemp+i)!='\0')
            {
                bgChannelsPerScan = bgChannelsPerScan*10 + *(pTemp+i) - '0';
                i++;
            }
        }
    }
    
    pCur = strstr(query, "ChannelScanTime"); 
    if (pCur!=NULL)
    {
        strcpy(tmp, pCur);
        if ((pTemp = strchr(tmp, '&'))!=NULL)
        {
            *pTemp = '\0';  
        }
        if ((pTemp = strchr(tmp, '='))!=NULL)
        {
            i = 1;
            bgChannelScanTime = 0;
            while (*(pTemp+i)!='\0')
            {
                bgChannelScanTime = bgChannelScanTime*10 + *(pTemp+i) - '0';
                i++;
            }
        }
    }

    pCur = strstr(query, "ScanType"); 
    if (pCur!=NULL)
    {
        strcpy(tmp, pCur);
        if ((pTemp = strchr(tmp, '&'))!=NULL)
        {
            *pTemp = '\0';  
        }
        if (strstr(tmp, "Active")!=NULL)
        {
            bgScanType = 2;
        }
        else if (strstr(tmp, "Passive")!=NULL)
        {
            bgScanType = 1;
        }
    }

    pCur = strstr(query, "EnableSelfCTS");
    bgEnableSelfCTS = (pCur!=NULL)?TRUE:FALSE;

    /* Setup timer to evaluate current channel status and switch if required: DCS */
    if (mib_dcsMode)
    {
        memset(CHWeightData, 0, sizeof(API_CH_WEIGHT_ENTRY)*(IEEEtypes_MAX_CHANNELS+IEEEtypes_MAX_CHANNELS_A));

        if (!DCSTimer.active)
        {
           TimerInit(&DCSTimer);
           /* current value */     
           TimerFireIn(&DCSTimer, 1, &DCSTimeOut, NULL, 20); /* Every 2 secs */
        }
        else
        {
            TimerRearm(&DCSTimer,  20 );
        }
    }

    {
        APICMDBUF_SET_BKGND_SCAN apicmdbuf_set_bkgnd_scan;
        apicmdbuf_set_bkgnd_scan.cmdCode = APCMD_SET_BKGND_SCAN;
        apicmdbuf_set_bkgnd_scan.seqNum = 1;
        apicmdbuf_set_bkgnd_scan.cmdBodyLen = (sizeof(APICMDBUF_SET_BKGND_SCAN) - APICMDHEADERLEN);
        apicmdbuf_set_bkgnd_scan.enable = bgScanEnable;
        apicmdbuf_set_bkgnd_scan.scanInterval = bgScanInterval * 10;
        apicmdbuf_set_bkgnd_scan.channelScanTime = bgChannelScanTime * 10;
        apicmdbuf_set_bkgnd_scan.channelsPerScan = bgChannelsPerScan;
        apicmdbuf_set_bkgnd_scan.scanType = bgScanType;
        apicmdbuf_set_bkgnd_scan.enableCTS = bgEnableSelfCTS;

        memset(&apicmdbuf_set_bkgnd_scan.channelList[0], 0, IEEEtypes_MAX_CHANNELS+IEEEtypes_MAX_CHANNELS_A);
        for (i=0; (i < IEEEtypes_MAX_CHANNELS+IEEEtypes_MAX_CHANNELS_A); i++ ) {
            apicmdbuf_set_bkgnd_scan.channelList[i] = scanChannelList[i];
        }
        apctl(&apicmdbuf_set_bkgnd_scan);
    }
    return SUCCESS;   
}


void DCSTimeOut(UINT8 *data)
{
    UINT8 curCH = PhyDSSSTable_p->CurrChan;
    UINT8 curCHNoiseFloor;
    UINT32 curCHerrorBytesRecd;
    UINT32 curCHbytesRecd;
    UINT32 curCHFramesRecd;
    UINT32 curCHFCSErrRecd;
    UINT8 curCHWeight;
    static UINT8 curCHFailCount=0;
    APICMDBUF_GET_BB_REG regCmdBuf;
    UINT8 curRegVal;
    UINT8 i;
   
    /* Evaluate current channel status if Bkgnd scan  is inactive*/
    if (!BkgndScanActive)
    {
        /* Read Noise Floor */
        regCmdBuf.cmdCode = APCMD_GET_BB_REG;
        regCmdBuf.seqNum = 1;
        regCmdBuf.cmdBodyLen = 3;
        regCmdBuf.regNum = 0x3D;
        apctl(&regCmdBuf);
        curCHNoiseFloor = (regCmdBuf.regVal + 5);

        /* Read errorbytesRecd and total bytesrecvd */
        curCHbytesRecd = Rx_Traffic_Cnt();
        curCHerrorBytesRecd = Rx_Traffic_Err_Cnt();

        /* check for current channel degradation */
        eprintf("current CH noise %d\n",curCHNoiseFloor);
        eprintf("current CH error bytes %d\n",curCHerrorBytesRecd);
        eprintf("current CH bytes %d\n",curCHbytesRecd);

        if (curCHNoiseFloor < 60 || (curCHerrorBytesRecd > (3*curCHbytesRecd)) 
                || (curCHerrorBytesRecd == 0) || (curCHbytesRecd == 0))
        {
            curCHFailCount ++;
            eprintf("current CH fail count %d\n",curCHFailCount);
            if (curCHFailCount > 1)
            {

                //memset(CHWeightData, 0, sizeof(API_CH_WEIGHT_ENTRY)*(IEEEtypes_MAX_CHANNELS+IEEEtypes_MAX_CHANNELS_A));
                
                for (i=1; (bkgndScanCHData[i].channel > 0 && i <(IEEEtypes_MAX_CHANNELS+IEEEtypes_MAX_CHANNELS_A)); i++)
                {
                    if (bkgndScanCHData[i].dirty)
                    {
                        CHWeightData[i].CHWeight = 100 - bkgndScanCHData[i].NoiseFloor;
                        
                        if ((bkgndScanCHData[i].errorBytesRecd == 0) || (bkgndScanCHData[i].bytesRecd == 0))
                            CHWeightData[i].CHWeight += 15; /*deduct cost of bytes not recvd */   
                        else if (bkgndScanCHData[i].errorBytesRecd > bkgndScanCHData[i].bytesRecd)
                            CHWeightData[i].CHWeight += (bkgndScanCHData[i].errorBytesRecd / bkgndScanCHData[i].bytesRecd);

                        CHWeightData[i].Channel = bkgndScanCHData[i].channel;
                    }
                }

                /* Choose the best channel */
                bestCH = curCH;
                
                curCHWeight = 100 - curCHNoiseFloor;
                if (curCHerrorBytesRecd == 0 || curCHbytesRecd == 0)
                    curCHWeight += 15; /*deduct cost of bytes not recvd */   
                else if (curCHerrorBytesRecd > curCHbytesRecd)
                    curCHWeight += (curCHerrorBytesRecd / curCHbytesRecd);
                
                for (i=1; i < (IEEEtypes_MAX_CHANNELS+IEEEtypes_MAX_CHANNELS_A); i++)
                {
                    if (CHWeightData[i].CHWeight > 0) /* Check if this is a valid channel that has been scanned and weighed */
                    {
                        eprintf("CH %d Weight %d\n",CHWeightData[i].Channel, CHWeightData[i].CHWeight);
                        if (CHWeightData[i].CHWeight < curCHWeight)
                            bestCH = CHWeightData[i].Channel;
                    }
                }

                eprintf("best channel = %d\n",bestCH);

                if (bestCH != curCH)
                {
                    {
                    APICMDBUF_SET_BKGND_SCAN apicmdbuf_set_bkgnd_scan;
                    apicmdbuf_set_bkgnd_scan.cmdCode = APCMD_SET_BKGND_SCAN;
                    apicmdbuf_set_bkgnd_scan.seqNum = 1;
                    apicmdbuf_set_bkgnd_scan.cmdBodyLen = (sizeof(APICMDBUF_SET_BKGND_SCAN) - APICMDHEADERLEN);
                    apicmdbuf_set_bkgnd_scan.enable = 0;
                    apicmdbuf_set_bkgnd_scan.scanInterval = 0;
                    apicmdbuf_set_bkgnd_scan.channelScanTime = 0;
                    apicmdbuf_set_bkgnd_scan.channelsPerScan = 0;
                    apicmdbuf_set_bkgnd_scan.scanType = 0;
                    memset(&apicmdbuf_set_bkgnd_scan.channelList[0], 0, IEEEtypes_MAX_CHANNELS+IEEEtypes_MAX_CHANNELS_A);
                    apctl(&apicmdbuf_set_bkgnd_scan);
                    }

                    ApCmdSetProc(APCMD_SET_DCS_CHANNEL, &bestCH);
    #if 0
                    /* Setup Channel switch timer */
                    if (!CHSwitchTimer.active)
                    {
                        TimerInit(&CHSwitchTimer);
                        TimerFireIn(&CHSwitchTimer, 1, &CHSwitchTimeout, NULL, 100);
                    }
                    else
                        TimerRearm(&CHSwitchTimer, 100);
                    
                    /* Stop DCS Application timeout */
                    TimerDisarm(&DCSTimer);
    #endif                
                    if (!BGScanTimer.active)
                    {
                        TimerInit(&BGScanTimer);
                        TimerFireIn(&BGScanTimer, 1, &BGScanStartTimeout, NULL, 50);
                    }
                    else
                        TimerRearm(&BGScanTimer, 50);

                    curCHFailCount = 0;
                    return;
                }
            }
        }
        else
        {
            curCHFailCount = 0;
        }
    } 
    
    /* Setup DCS timer to evaluate again */
    if (mib_dcsMode)
    {
        if (DCSTimer.active)
            TimerRearm(&DCSTimer, 20);
        else
            TimerFireIn(&DCSTimer, 1, &DCSTimeOut, NULL, 20);
    }
}

void CHSwitchTimeout (UINT8 *data)
{
    /* Setup timer to restart BG Scan */
    if (!BGScanTimer.active)
    {
        TimerInit(&BGScanTimer);
        TimerFireIn(&BGScanTimer, 1, &BGScanStartTimeout, NULL, 50);
    }
    else
        TimerRearm(&BGScanTimer, 50);

}

void BGScanStartTimeout (UINT8 *data)
{
    UINT8 i;
    APICMDBUF_SET_BKGND_SCAN apicmdbuf_set_bkgnd_scan;
    apicmdbuf_set_bkgnd_scan.cmdCode = APCMD_SET_BKGND_SCAN;
    apicmdbuf_set_bkgnd_scan.seqNum = 1;
    apicmdbuf_set_bkgnd_scan.cmdBodyLen = (sizeof(APICMDBUF_SET_BKGND_SCAN) - APICMDHEADERLEN);
    apicmdbuf_set_bkgnd_scan.enable = bgScanEnable;
    apicmdbuf_set_bkgnd_scan.scanInterval = bgScanInterval * 10;
    apicmdbuf_set_bkgnd_scan.channelScanTime = bgChannelScanTime * 10;
    apicmdbuf_set_bkgnd_scan.channelsPerScan = bgChannelsPerScan;
    apicmdbuf_set_bkgnd_scan.scanType = bgScanType;
    apicmdbuf_set_bkgnd_scan.enableCTS = bgEnableSelfCTS;

    memset(&apicmdbuf_set_bkgnd_scan.channelList[0], 0, IEEEtypes_MAX_CHANNELS+IEEEtypes_MAX_CHANNELS_A);
    for (i=0; (i < IEEEtypes_MAX_CHANNELS+IEEEtypes_MAX_CHANNELS_A); i++ )
    {
        apicmdbuf_set_bkgnd_scan.channelList[i] = scanChannelList[i];
    }
    apctl(&apicmdbuf_set_bkgnd_scan);

    /* Setup DCS timer to evaluate again */
    if (mib_dcsMode)
    {
        if (DCSTimer.active)
            TimerRearm(&DCSTimer, 20);
        else
            TimerFireIn(&DCSTimer, 1, &DCSTimeOut, NULL, 20);
    }
}
#endif /* DCS */
#ifdef VOIP_GUI
int SetSip(webs_t wp, char_t* query)
{
    char    tmp[400];
    char    *pTemp, *pCur; 
    unsigned char    chData;
    unsigned char Data[100];
    unsigned char DataFromUser[200];        
    unsigned int sipOption, port, port2;                  
	hs_voip_codec_t  list[HS_VOIP_MAX_CODECS];
	int codec_n, i;


    if (query == NULL || strlen(query)==0)
    {
        return 0;
    }

     // Handset ID
    pCur = strstr(query, "txtHandsetId");
    if (pCur != NULL)
    {
        strcpy(tmp, pCur);
        if ((pTemp = strchr(tmp, '&'))!=NULL)
        {
            *pTemp = '\0';
        }
        if ( (pTemp = strchr(tmp, '='))!=NULL)
        {
            pTemp++; 
            ProcessUserData(DataFromUser, Data, pTemp);         
			hs_voip_cm_set_endpoint_user_map(0, Data);
        }
    }

    // Handset name
    pCur = strstr(query, "txtHandsetName");
    if (pCur != NULL)
    {
        strcpy(tmp, pCur);
        if ((pTemp = strchr(tmp, '&'))!=NULL)
        {
            *pTemp = '\0';
        }
        if ( (pTemp = strchr(tmp, '='))!=NULL)
        {
            pTemp++; 
            ProcessUserData(DataFromUser, Data, pTemp);         
			hs_voip_cm_set_endpoint_device_name(0, Data);
        }
    }

	// Sip Proxy option
	pCur = strstr(query, "opProxy");
    if (pCur != NULL)
    {
        strcpy(tmp, pCur);
        if ((pTemp = strchr(tmp, '&'))!=NULL)
        {
            *pTemp = '\0';
        }
        if ( (pTemp = strchr(tmp, '='))!=NULL)
        {
            pTemp++; 
            ProcessUserData(DataFromUser, Data, pTemp);         
			if (0 == strcmp(Data, "yes"))	sipOption = 1;
			else	sipOption = 0;
        }
    }
	else	sipOption = 0;
	port = 5060;	//default
	Data[0] = 0;
	if (sipOption)
	{
		// Sip Proxy port
		pCur = strstr(query, "txtProxyPort");
	    if (pCur != NULL)
	    {
	        strcpy(tmp, pCur);
	        if ((pTemp = strchr(tmp, '&'))!=NULL)
	        {
	            *pTemp = '\0';
	        }
	        if ( (pTemp = strchr(tmp, '='))!=NULL)
	        {
	            pTemp++; 
	            ProcessUserData(DataFromUser, Data, pTemp);         
				port = strtol(Data, Data+strlen(Data), 10);
	        }
	    }
		// Sip Proxy IP
		pCur = strstr(query, "txtProxyIp");
	    if (pCur != NULL)
	    {
	        strcpy(tmp, pCur);
	        if ((pTemp = strchr(tmp, '&'))!=NULL)
	        {
	            *pTemp = '\0';
	        }
	        if ( (pTemp = strchr(tmp, '='))!=NULL)
	        {
	            pTemp++; 
	            ProcessUserData(DataFromUser, Data, pTemp);         
	        }
	    }
	}
	hs_voip_cm_set_sip_proxy(Data, port);

    // Proxy authentication user name
    pCur = strstr(query, "txtProxyUsername");
    if (pCur != NULL)
    {
        strcpy(tmp, pCur);
        if ((pTemp = strchr(tmp, '&'))!=NULL)
        {
            *pTemp = '\0';
        }
        if ( (pTemp = strchr(tmp, '='))!=NULL)
        {
            pTemp++; 

            ProcessUserData(DataFromUser, Data, pTemp);         
			hs_voip_cm_set_user_name(Data);
        }
    }

    // Proxy authentication password
    pCur = strstr(query, "txtProxyPassword");
    if (pCur != NULL)
    {
        strcpy(tmp, pCur);
        if ((pTemp = strchr(tmp, '&'))!=NULL)
        {
            *pTemp = '\0';
        }
        if ( (pTemp = strchr(tmp, '='))!=NULL)
        {
            pTemp++; 

            ProcessUserData(DataFromUser, Data, pTemp);         
			hs_voip_cm_set_sip_password(Data);
        }
    }

	// SIP Registrar option
	pCur = strstr(query, "opRegistrar");
    if (pCur != NULL)
    {
        strcpy(tmp, pCur);
        if ((pTemp = strchr(tmp, '&'))!=NULL)
        {
            *pTemp = '\0';
        }
        if ( (pTemp = strchr(tmp, '='))!=NULL)
        {
            pTemp++; 
            ProcessUserData(DataFromUser, Data, pTemp);         
			if (0 == strcmp(Data, "yes"))	sipOption = 1;
			else	sipOption = 0;
        }
    }
	else	sipOption = 0;
	port = 5060;	//default
	Data[0] = 0;
	if (sipOption)
	{
		// SIP Registrar port
		pCur = strstr(query, "txtRegistrarPort");
	    if (pCur != NULL)
	    {
	        strcpy(tmp, pCur);
	        if ((pTemp = strchr(tmp, '&'))!=NULL)
	        {
	            *pTemp = '\0';
	        }
	        if ( (pTemp = strchr(tmp, '='))!=NULL)
	        {
	            pTemp++; 
	            ProcessUserData(DataFromUser, Data, pTemp);         
				port = strtol(Data, Data+strlen(Data), 10);
	        }
	    }
		// SIP Registrar ip
		pCur = strstr(query, "txtRegistrarIp");
	    if (pCur != NULL)
	    {
	        strcpy(tmp, pCur);
	        if ((pTemp = strchr(tmp, '&'))!=NULL)
	        {
	            *pTemp = '\0';
	        }
	        if ( (pTemp = strchr(tmp, '='))!=NULL)
	        {
	            pTemp++; 
	            ProcessUserData(DataFromUser, Data, pTemp);         
	        }
	    }
	}
	hs_voip_cm_set_sip_registrar(Data, port);

	// Preferred Encoder
	codec_n = 0;
	Data[0] = 0;
	pCur = strstr(query, "opPreferredEnc");
    if (pCur != NULL)
    {
        strcpy(tmp, pCur);
        if ((pTemp = strchr(tmp, '&'))!=NULL)
        {
            *pTemp = '\0';
        }
        if ( (pTemp = strchr(tmp, '='))!=NULL)
        {
            pTemp++; 
            ProcessUserData(DataFromUser, Data, pTemp);
        }
		if (0 == strcmp(Data, "g711a"))
			list[0] = HS_VOIP_CODEC_PCMA;
		else if (0 == strcmp(Data, "g711u"))
			list[0] = HS_VOIP_CODEC_PCMU;
		else if (0 == strcmp(Data, "g729a"))
		{
			list[0] = HS_VOIP_CODEC_G729A;
			if ( G729_MODULE == FALSE )
		    {
				list[0] = HS_VOIP_CODEC_PCMA;
			}
		}


		else if (0 == strcmp(Data, "g723_53"))
		{
			list[0] = HS_VOIP_CODEC_G723;
			hs_voip_cm_params_g.codec_rate = 1; 
			if ( G723_MODULE == FALSE )
		    {
				list[0] = HS_VOIP_CODEC_PCMA;
			}

		}
		else if (0 == strcmp(Data, "g723_63"))
		{
			list[0] = HS_VOIP_CODEC_G723;
			hs_voip_cm_params_g.codec_rate = 2; 
			if ( G723_MODULE == FALSE )
		    {
				list[0] = HS_VOIP_CODEC_PCMA;
			}

		}
		else if (0 == strcmp(Data, "g726_16"))
		{
			list[0] = HS_VOIP_CODEC_G726_16;
			if ( G726_MODULE == FALSE )
		    {
				list[0] = HS_VOIP_CODEC_PCMA;
			}
		}
		else if (0 == strcmp(Data, "g726_24"))
		{
			list[0] = HS_VOIP_CODEC_G726_24;
			if ( G726_MODULE == FALSE )
		    {
				list[0] = HS_VOIP_CODEC_PCMA;
			}		}
		else if (0 == strcmp(Data, "g726_32"))
		{
			list[0] = HS_VOIP_CODEC_G726_32;
			if ( G726_MODULE == FALSE )
		    {
				list[0] = HS_VOIP_CODEC_PCMA;
			}
		}
		else if (0 == strcmp(Data, "g726_40"))
		{	
		    list[0] = HS_VOIP_CODEC_G726_40;
			if ( G726_MODULE == FALSE )
		    {
				list[0] = HS_VOIP_CODEC_PCMA;
			}
		}
		else
			list[0] = HS_VOIP_CODEC_PCMA;	//default preferred encoder
		codec_n++;


		   if (list[0] !=HS_VOIP_CODEC_PCMU)
		   {    		
		      list[codec_n++] = HS_VOIP_CODEC_PCMU;
		   }

			   if (list[0] !=HS_VOIP_CODEC_PCMA)
		   {    		
		      list[codec_n++] = HS_VOIP_CODEC_PCMA;
		   }



        if ( G729_MODULE == TRUE )
		{
		   if (list[0] !=HS_VOIP_CODEC_G729A)
		   {    		
		      list[codec_n++] = HS_VOIP_CODEC_G729A;
		   }
        }
	    if ( G723_MODULE == TRUE )
		{
	    	if (list[0] !=HS_VOIP_CODEC_G723)
	     	{    		
	    	   list[codec_n++] = HS_VOIP_CODEC_G723;
			   //   to change the setting to G726  6.3K one must 
			   //   write  hs_voip_cm_params_g.codec_rate = 2; 

	    	}


        }  
        if ( G726_MODULE == TRUE )
		{

	    	if (list[0] !=HS_VOIP_CODEC_G726_32)
		   { 
		     	list[codec_n++] = HS_VOIP_CODEC_G726_32;
		   }


		   if (list[0] !=HS_VOIP_CODEC_G726_16)
		   { 
		    	list[codec_n++] = HS_VOIP_CODEC_G726_16;
		   }


		   if (list[0] !=HS_VOIP_CODEC_G726_40)
		   { 
		    	list[codec_n++] = HS_VOIP_CODEC_G726_40;
		   }

    		if (list[0] !=HS_VOIP_CODEC_G726_24)
	    	{ 
	 	    	list[codec_n++] = HS_VOIP_CODEC_G726_24;
		    }
        }

 	   	 
		hs_voip_cm_params_g.usable_codec_list_len = codec_n;
		for (i=0; i<codec_n; i++)
			hs_voip_cm_params_g.usable_codec_list[i] = list[i];
    }



	// DTMF Relay
	pCur = strstr(query, "opDtmfRelay");
    if (pCur != NULL)
    {
        strcpy(tmp, pCur);
        if ((pTemp = strchr(tmp, '&'))!=NULL)
        {
            *pTemp = '\0';
        }
        if ( (pTemp = strchr(tmp, '='))!=NULL)
        {
            pTemp++; 
            ProcessUserData(DataFromUser, Data, pTemp);         
			if (0 == strcmp(Data, "yes"))	
			{
				hs_voip_cm_params_g.support_2833_flag = 1;
				//hs_voip_cm_set_dtmf_on_rtp_flag(1);
			}
			else
			{
				hs_voip_cm_params_g.support_2833_flag = 0;
				//hs_voip_cm_set_dtmf_on_rtp_flag(0);
			}
			if (0 == strcmp(Data, "yes"))	(1);
			else	(0);
        }
    }

	// VAD option
	pCur = strstr(query, "opVad");
    if (pCur != NULL)
    {
        strcpy(tmp, pCur);
        if ((pTemp = strchr(tmp, '&'))!=NULL)
        {
            *pTemp = '\0';
        }
        if ( (pTemp = strchr(tmp, '='))!=NULL)
        {
            pTemp++; 
            ProcessUserData(DataFromUser, Data, pTemp);         
			if (0 == strcmp(Data, "yes"))	
			{
				hs_voip_cm_params_g.ep_info[0].vad_flag = 1;
				//hs_voip_cm_set_endpoint_vad_flag(0, 1);
			}
			else
			{
				hs_voip_cm_params_g.ep_info[0].vad_flag = 0;
				//hs_voip_cm_set_endpoint_vad_flag(0, 0);
			}
        }
    }

	// RTP start port
	port = 16000; // default
	pCur = strstr(query, "txtRtpStartPort");
    if (pCur != NULL)
    {
        strcpy(tmp, pCur);
        if ((pTemp = strchr(tmp, '&'))!=NULL)
        {
            *pTemp = '\0';
        }
        if ( (pTemp = strchr(tmp, '='))!=NULL)
        {
            pTemp++; 
            ProcessUserData(DataFromUser, Data, pTemp);         
			port = strtol(Data, Data+strlen(Data), 10);
        }
    }
	// RTP stop port
	port2 = 16020;	// default
	pCur = strstr(query, "txtRtpStopPort");
    if (pCur != NULL)
    {
        strcpy(tmp, pCur);
        if ((pTemp = strchr(tmp, '&'))!=NULL)
        {
            *pTemp = '\0';
        }
        if ( (pTemp = strchr(tmp, '='))!=NULL)
        {
            pTemp++; 
            ProcessUserData(DataFromUser, Data, pTemp);         
			port2 = strtol(Data, Data+strlen(Data), 10);
        }
    }
	//hs_voip_cm_set_rtp_port_limits(port, port2);
	hs_voip_cm_params_g.rtp_port_base  = port;
	hs_voip_cm_params_g.rtp_port_limit = port2;
	//hs_voip_cm_get_rtp_port_limits(&port, &port2);
	*(&port) = hs_voip_cm_params_g.rtp_port_base;      \
	*(&port2) = hs_voip_cm_params_g.rtp_port_limit;     \

/*    // Email id
    pCur = strstr(query, "txtEmailId");
    if (pCur != NULL)
    {
        strcpy(tmp, pCur);
        if ((pTemp = strchr(tmp, '&'))!=NULL)
        {
            *pTemp = '\0';
        }
        if ( (pTemp = strchr(tmp, '='))!=NULL)
        {
            pTemp++; 
            ProcessUserData(DataFromUser, Data, pTemp);         
			hs_voip_cm_set_email_id(Data);
        }
    }
*/

    return 0; 

}
#endif

